package biga.color;

/**
 * @author Nicolas Barradeau
 */

class Color 
{

	public function new() 
	{
		
	}
	
	static public function hsv_rgb( hsv:HSV ):Int
	{
		return hsv2rgb( hsv.hue, hsv.saturation, hsv.value );
	}
	
	static public function hsv2rgb( hue:Float, sat:Float, val:Float ):Int
	{
		var red:Float = 0, grn:Float = 0, blu:Float = 0, i:Float, f:Float, p:Float, q:Float, t:Float;
		hue %= 360;
		
		if (val == 0) return 0;
		
		sat/=100;
		val/=100;
		hue/=60;
		
		i = Math.floor(hue);
		
		f = hue-i;
		
		p = val * (1 - sat);
		
		q = val * (1 - (sat * f));
		
		t = val * (1 - (sat * (1 - f)));
		
		if (i == 0) { red = val; grn = t; blu = p; }
		
		else if (i == 1) { red = q; grn = val; blu = p; }
		
		else if (i == 2) { red = p; grn = val; blu = t; }
		
		else if (i == 3) { red = p; grn = q; blu = val; }
		
		else if (i == 4) { red = t; grn = p; blu = val; }
		
		else if (i == 5) { red = val; grn = p; blu = q; }
		
		
		red = Math.floor(red * 255);
		grn = Math.floor(grn * 255);
		blu = Math.floor(blu * 255);
		
		return Std.int( red  )<< 16 | Std.int( grn ) << 8 | Std.int( blu );
		
	}
	
	static public function rgb_hsv( color:Int ):HSV
	{
		return rgb2hsv( color >> 16, color >> 8, color );
	}
	
	static public function rgb2hsv(red:Float, grn:Float, blu:Float):HSV
	{
		
		var x:Float, val:Float, f:Float, i:Float, hue:Float, sat:Float;
		red /= 0xFF;
		grn /= 0xFF;
		blu /= 0xFF;
		
		x = Math.min(Math.min(red, grn), blu);
		val = Math.max(Math.max(red, grn), blu);
		
		if (x == val)
		{
			return  new HSV( 0, 0, val*100 );
		}
		
		f = (red == x) ? grn-blu : ((grn == x) ? blu-red : red-grn);
		i = (red == x) ? 3 : ((grn == x) ? 5 : 1);
		
		hue = Math.floor((i - f / (val - x)) * 60) % 360;
		sat = Math.floor(((val - x) / val) * 100);
		val = Math.floor(val * 100);
		
		return new HSV( hue, sat, val );
		
	}
}
