package biga.distribution;
import nme.Vector;
using nme.Vector;
import nme.geom.Point;
/**
 * @author Nicolas Barradeau
 * http://en.nicoptere.net
 */
class Circular extends Distribution
{
	private var _center:Point;
	private var _radiusX:Float;
	private var _radiusY:Float;
	
	public function new( center:Point, radiusX:Float, radiusY:Float ) 
	{
		super();
		this.center = center;
		this.radiusX = radiusX;
		this.radiusY = radiusY;
	}
	public function distribute( count:Int, shuffle:Bool = false, jitter:Float = 0 ):Vector<Point> 
	{ 
		
		var i:Int = count, angleStep:Float, dx:Float, dy:Float;
		angleStep = ( Math.PI * 2 ) / i;
		var points:Vector<Point> = new Vector<Point>();
		while( i > 0 )
		{
			var p:Point = new Point( 	center.x +	Math.cos( i * angleStep ) * radiusX, 
										center.y +	Math.sin( i * angleStep ) * radiusY );
			points.push( p );
			i--;
		}
		if ( shuffle ) points.sort( shuffleSort );
		if ( jitter != 0 )jitterPoints( points, jitter );
		return points;
	}
	
	private function get_center():Point 
	{
		return _center;
	}
	
	private function set_center(value:Point):Point 
	{
		return _center = value;
	}
	
	public var center(get_center, set_center):Point;
	
	private function get_radiusX():Float 
	{
		return _radiusX;
	}
	
	private function set_radiusX(value:Float):Float 
	{
		return _radiusX = value;
	}
	
	public var radiusX(get_radiusX, set_radiusX):Float;
	
	private function get_radiusY():Float 
	{
		return _radiusY;
	}
	
	private function set_radiusY(value:Float):Float 
	{
		return _radiusY = value;
	}
	
	public var radiusY(get_radiusY, set_radiusY):Float;
}