package biga.distribution;
import nme.Vector;
using nme.Vector;
import nme.geom.Point;
/**
 * @author Nicolas Barradeau
 * http://en.nicoptere.net
 */
class Disc extends Circular
{
	
	public var innerRadiusX:Float;
	public var innerRadiusY:Float;
	
	public function new( center:Point, radiusX:Float, radiusY:Float, innerRadiusX:Float = 0, innerRadiusY:Float = 0 ) 
	{
		super( center, radiusX, radiusY );
		
		this.innerRadiusX = innerRadiusX;
		this.innerRadiusY = innerRadiusY;
		
	}
	
	override public function distribute( count:Int, shuffle:Bool = false, jitter:Float = 0 ):Vector<Point>
	{
		var p:Point;
		var points:Vector<Point> = new Vector<Point>();
		var length:Int = count;
		if ( jitter == 0 ) length = Std.int( length *.5 );
		
		var i:Int, angle:Float, depart:Float, angleStep:Float, offsetX:Float, offsetY:Float, dx:Float, dy:Float;
		
		offsetX = radiusX - innerRadiusX;
		offsetY = radiusY - innerRadiusY;
		angleStep = ( Math.PI * 2 ) / length;
		for ( i in 0... length )
		{
			angle = i * angleStep;
			if ( jitter != 0 )
			{
				p = new Point( 0, 0 );
				p.x = center.x + Math.cos( angle ) * ( innerRadiusX + Math.random() * offsetX );
				p.y = center.y + Math.sin( angle ) * ( innerRadiusY + Math.random() * offsetY );
				points.push( p );
			}
			else
			{
				p = new Point();
				p.x = center.x + Math.cos( angle ) * radiusX;
				p.y = center.y + Math.sin( angle ) * radiusY;
				points.push( p );
				p = new Point();
				p.x = center.x + Math.cos( angle ) * innerRadiusX;
				p.y = center.y + Math.sin( angle ) * innerRadiusY;
				points.push( p );
			}
		}
		if ( shuffle ) 	points.sort( shuffleSort );
		if ( jitter != 0 )	jitterPoints(points, jitter );
		return points;
	}
	
}