package biga.distribution;
import nme.Vector;
using nme.Vector;
import nme.geom.Rectangle;
import nme.geom.Point;
/**
 * @author Nicolas Barradeau
 * http://en.nicoptere.net
 */
class Grid extends Distribution
{
	private var rows:Int;
	private var columns:Int;
	public var rect:Rectangle;
	
	public function new( rect:Rectangle, columns:Int = 1, rows:Int = 1 ) 
	{
		
		super();
		this.rect = rect;
		this.columns = columns;
		this.rows = rows;
		
	}
	
	public function distribute( asFrame:Bool = false, shuffle:Bool = false, jitter:Float = 0 ):Vector<Point>
	{
		
		var p:Point;
		var points:Vector<Point> = new Vector<Point>();
		
		for ( i in 0...columns+1 )
		{
			for ( j in 0...rows+1 )
			{
				p = new Point( 	rect.x + i * rect.width / columns,
								rect.y + j * rect.height / rows );
				if ( asFrame )
				{
					if( i == 0 || i == columns || j == 0 || j == rows )	points.push( p );
				}
				else points.push( p );
			}
		}
		
		if ( shuffle ) points.sort( shuffleSort );
		if ( jitter != 0 )jitterPoints( points, jitter );
		return points;
	}
	
}