package biga.distribution;
import nme.geom.Point;
import nme.Vector;

/**
 * @author Nicolas Barradeau 
 */

class Star extends Distribution
{
	private var center:Point;
	private var innerRadius:Float;
	private var outerRadius:Float;

	public function new( center:Point, innerRadius:Float, outerRadius:Float ) 
	{
		super();
		
		this.center = center;
		this.innerRadius = innerRadius;
		this.outerRadius = outerRadius;
		
	}
	
	public function distribute( branchCount:Int, shuffle:Bool = false, jitter:Float = 0 ) :Vector<Point>
	{
		var points:Vector<Point> = new Vector<Point>();
		branchCount = Std.int( Math.max( 3, branchCount ) );
		var delta:Float = ( Math.PI * 2 ) / ( branchCount * 2 );
		var i:Int = 0;
		while( i < Std.int( branchCount * 2) )
		{
			
			var a0:Float = i * delta + Math.PI * .5;
			points.push( new Point( center.x + Math.cos( a0 ) * innerRadius,
									center.y + Math.sin( a0 ) * innerRadius ) );
			
			var a1:Float = ( i+1 ) * delta + Math.PI * .5;
			points.push( new Point( center.x + Math.cos( a1 ) * outerRadius, 
									center.y + Math.sin( a1 ) * outerRadius ) );
			i += 2;
			
		}
		if ( shuffle ) points.sort( shuffleSort );
		if ( jitter != 0 )jitterPoints( points, jitter );
		return points;
	}	
	
}