package biga.shapes2d;
import biga.utils.GeomUtils;
import nme.display.Graphics;
import nme.geom.Point;
/**
 * @author Nicolas Barradeau
 * http://en.nicoptere.net
 */
class Line
{
	private var _strokeWidth:Float = 0;
	private var _strokeColor:Float = 0x808080;
	private var _strokeAlpha:Float = 1;
	private var _start:Float = 0;
	private var _end:Float = 0;
	private var _angle:Float;
	private var _length:Float;
	private var _p0:Point;
	private var _p1:Point;
	public function new( p0:Point, p1:Point ) 
	{
		this.p0 = p0;
		this.p1 = p1;
	}
	public function draw( graphics:Graphics ):Void
	{
		graphics.moveTo( 	p0.x + Math.cos( angle ) * ( length * start ), 
							p0.y + Math.sin( angle ) * ( length * start ) );
		graphics.lineTo( 	p1.x + Math.cos( angle ) * ( length * end ), 
							p1.y + Math.sin( angle ) * ( length * end ) );
	}
	public var p0( get_p0, set_p0 ):Point;
	public function get_p0():Point { return _p0; }
	public function set_p0(value:Point):Point 
	{
		_p0 = value;
		if ( p1 != null )
		{
			angle = GeomUtils.angle( p0, p1 );
			length = GeomUtils.distance( p0, p1 );
			return p0;
	}
	}
	public var p1( get_p1, set_p1 ):Point;
	public function get_p1():Point { return _p1; }
	public function set_p1(value:Point):Point 
	{
		_p1 = value;
		if ( p1 != null )
		{
			angle = GeomUtils.angle( p0, p1 );
			length = GeomUtils.distance( p0, p1 );
			return p1;
	}
	}
	/**
	 * retourne un point de la ligne situe à T : 0 <= T <= 1 = sur le segment, T < 0 avant A, T > 1 apres B
	 * @param	t
	 * @return
	 */
	public function getPointAt( t:Float ):Point
	{
		return new Point( 	p0.x + Math.cos( angle ) * ( length * t ), 
							p0.y + Math.sin( angle ) * ( length * t ) );
	}
	public var start( get_start, set_start ):Float;
	public function get_start():Float { return _start; }
	public function set_start(value:Float):Float 
	{
		_start = value;
		return start;
	}
	public var end( get_end, set_end ):Float;
	public function get_end():Float { return _end; }
	public function set_end(value:Float):Float 
	{
		_end = value;
		return end;
	}
	public var angle( get_angle, set_angle ):Float;
	public function get_angle():Float { return _angle; }
	public function set_angle(value:Float):Float 
	{
		_angle = value;
		return angle;
	}
	public var length( get_length, set_length ):Float;
	public function get_length():Float { return _length; }
	public function set_length(value:Float):Float 
	{
		_length = value;
		return length;
	}
}