package biga.shapes2d;
import nme.Vector;
import biga.utils.GeomUtils;
import nme.display.Graphics;
import nme.geom.Point;
/**
 * @author Nicolas Barradeau
 * http://en.nicoptere.net
 */
class Triangle
{
	private var _p0:Point;
	private var _p1:Point;
	private var _p2:Point;
	private var _edges:Vector<Edge>;
	public function new( p0:Point = null, p1:Point = null, p2:Point = null ) 
	{
		_p0 = ( p0 == null ) ? new Point() : p0;
		_p1 = ( p1 == null ) ? new Point() : p1;
		_p2 = ( p2 == null ) ? new Point() : p2;
		_edges = Vector<Edge>( [	new Edge( p0, p1 ),
									new Edge( p1, p2 ),
									new Edge( p2, p0 ) 	] );
	}
	public function contains( p:Point ):Bool
	{
		return (	 GeomUtils.isLeft( p, p0, p1 ) 
					== 	GeomUtils.isLeft( p, p1, p2 )
					== 	GeomUtils.isLeft( p, p2, p0 )
					== 	culling );
	}
	public var culling( get_culling, null ):Bool;
	public function get_culling():Bool 
	{ 
		return GeomUtils.determinant( p0, p1, p2 ) >= 0; 
	}
	public var p0( get_p0, set_p0 ):Point;
	public function get_p0():Point { return _p0; }
	public function set_p0(value:Point):Point 
	{
		_p0 = value;
		return p0;
	}
	public var p1( get_p1, set_p1 ):Point;
	public function get_p1():Point { return _p1; }
	public function set_p1(value:Point):Point 
	{
		_p1 = value;
		return p1;
	}
	public var p2( get_p2, set_p2 ):Point;
	public function get_p2():Point { return _p2; }
	public function set_p2(value:Point):Point 
	{
		_p2 = value;
		return p2;
	}
	public var edges( get_edges, set_edges ):Vector;
	public function get_edges():Vector<Edge> 
	{
		return _edges; 
	}
	public function set_edges(value:Vector<Edge>):Vector 
	{
		_edges = value;
		return edges;
	}
	public function draw( graphics:Graphics = null ):Void 
	{ 
		graphics.drawTriangles( Vector<Float>( [ p0.x, p0.y, p1.x, p1.y, p2.x, p2.y ] ) );
	}
}