package biga.test;
import nme.Vector;
import biga.utils.Delaunay;
import biga.utils.PRNG;
import nme.display.Sprite;
import nme.display.StageAlign;
import nme.display.StageScaleMode;
import nme.events.MouseEvent;
import nme.geom.Point;
/**
 * @author Nicolas Barradeau
 * @website http://en.nicoptere.net
 */
class DelaunayTest extends Sprite 
{
	private var delaunay:Delaunay;
	private var indices:Vector<Int>;
	private var points:Vector<Point>;
	public function new() 
	{
		stage.scaleMode = StageScaleMode.NO_SCALE;
		stage.align = StageAlign.TOP_LEFT;
		delaunay = new Delaunay();
		points = new Vector<Point>();
		stage.addEventListener( MouseEvent.MOUSE_DOWN, onMouseDownHandler );
		reset();
	}
	private function onMouseDownHandler(e:MouseEvent):Void 
	{
		reset();
	}
	private function reset():Void 
	{
		graphics.clear();
		for (i in 0 ... 100) 
		{
			var p:Point = new Point( PRNG.random() * stage.stageWidth, PRNG.random() * stage.stageHeight );
			points.push( p );
			graphics.drawCircle( p.x, p.y, 2 );
		}
		indices = delaunay.compute( points );
		graphics.lineStyle( 0, 0xDDDDDD );
		delaunay.render( graphics, points, indices );
		/*
		//alternate rendering
		var vertices:Vector<Float> = new Vector<Float>();
		for (i in 0 ... points.length) vertices.push( points[ i ].x, points[ i ].y );
		graphics.drawTriangles( vertices, indices );
		**/
		graphics.lineStyle(0, 0, 0);
		graphics.beginFill( 0xCC0000 );
		for ( i in 0... points.length) 
		{
			graphics.drawCircle( points[ i ].x, points[ i ].y, 2 );
		}
		graphics.endFill();
	}
}