package biga.test;
import nme.Vector;
import biga.utils.Delaunay;
import biga.utils.PRNG;
import nme.display.Sprite;
import nme.display.StageAlign;
import nme.display.StageScaleMode;
import nme.events.MouseEvent;
import nme.geom.Point;
import biga.utils.Voronoi;
/**
 * @author Nicolas Barradeau
 * @website http://en.nicoptere.net
 */
class VoronoiTest extends Sprite 
{
	private var voronoi:Voronoi;
	private var indices:Vector<Int>;
	private var points:Vector<Point>;
	public function new() 
	{
		stage.scaleMode = StageScaleMode.NO_SCALE;
		stage.align = StageAlign.TOP_LEFT;
		voronoi = new Voronoi();
		points = new Vector<Point>();
		stage.addEventListener( MouseEvent.MOUSE_DOWN, onMouseDownHandler );
		reset();
	}
	private function onMouseDownHandler(e:MouseEvent):Void 
	{
		reset();
	}
	private function reset():Void 
	{
		graphics.clear();
		graphics.beginFill( 0xCC0000 );
		for (i in 0 ... 100) 
		{
			var p:Point = new Point( PRNG.random() * stage.stageWidth, PRNG.random() * stage.stageHeight );
			points.push( p );
			graphics.drawCircle( p.x, p.y, 2 );
		}
		graphics.endFill();
		graphics.lineStyle( 0, 0x0066DD );
		voronoi.render( graphics, voronoi.compute( points ) );
	}
}