package ;
import nme.Vector;
import nme.display.Sprite;
import nme.events.MouseEvent;
import nme.geom.Rectangle;
import customitems.CustomItem;
import treemap.TreemapConstants;
import treemap.ITreeMapItem;
import treemap.TreeMap;
import treemap.TreeMapItem;
/**
 * @author Nicolas Barradeau
 * http://en.nicoptere.net
 */
class CustomItemSample extends Sprite 
{
	private var values:Vector<TreeMapItem>;
	public function new() 
	{
		//create a map, passes the rectangle where we want to draw
 var map:TreeMap = new TreeMap( new Rectangle( 10, 10, 480, 480 ) );
		//create values
 values = new Vector<TreeMapItem>;
		//populate the values with basics items
		var item:CustomItem;
		for (i in 0 ... 50 ) 
		{
			item = new CustomItem( Math.random(), this, 'abc_' + i );
			values.push( item );
		}
		//compute the map
		values = map.compute( values );
		//render
		renderCustomItems()
		//listen for a click
		stage.addEventListener( MouseEvent.MOUSE_DOWN, getCustomMessage );
	}
	private function renderCustomItems():Void 
	{
		for ( var item:ITreeMapItem in values )
		{
			( item as CustomItem ).render( graphics );
		}
	}
	private function getCustomMessage(e:MouseEvent):Void 
	{
		graphics.clear();
		for ( var item:ITreeMapItem in values )
		{
			if ( item.rect.contains( mouseX, mouseY ) )
			{
				trace( 'item clicked message -> ', ( item as CustomItem ).message );
				( item as CustomItem ).color = 0xFFFFFF;
			}
			( item as CustomItem ).render( graphics );
		}
	}
}