package customitems;
import nme.display.DisplayObjectContainer;
import nme.display.Graphics;
import nme.geom.Rectangle;
import nme.text.AntiAliasType;
import nme.text.TextField;
import nme.text.TextFieldAutoSize;
import nme.text.TextFormat;
import treemap.ITreeMapItem;
import treemap.TreeMapItem;
/**
 * @author Nicolas Barradeau
 * http://en.nicoptere.net
 */
class CustomItem extends TreeMapItem
{
	private var _message:String;
	private var _parent:DisplayObjectContainer;
	private var txt:TextField;
	private var _color:Int;
	public function new( weight:Float, parent:DisplayObjectContainer, message:String = null ) 
	{
		//passing itself as the data
		super( weight );
		//stores custom data
		this._parent = parent;
		this._message = message;
		color = Math.random() * 0x808080 + 0x808080;
		//do some stuff
		txt = new TextField();
		txt.wordWrap = true;
		txt.multiline = true;
		txt.selectable = false;
		txt.defaultTextFormat = new TextFormat( "Verdana", (.5 + weight) * 15, 0, true, null, null, null, null, TextFieldAutoSize.CENTER );
		txt.antiAliasType = AntiAliasType.ADVANCED;
		txt.text = weight.toFixed(2);
		_parent.addChild( txt );
 } 
	override public function clone():ITreeMapItem
	{
		var item:CustomItem = new CustomItem( weight, _parent, _message );
		item.area = area;
		if ( rect != null )	item.rect = rect.clone();
		else				item.rect = new Rectangle();
		return item;
	}
	public function render(graphics:Graphics):Void 
	{
		graphics.beginFill( color );
		graphics.drawRect( rect.x, rect.y, rect.width, rect.height );
		txt.x = rect.x;
		txt.y = rect.y;
		txt.width = rect.width;
		txt.height = rect.height;
	}
	public var message( get_message, set_message ):String;
	public function get_message():String { return _message; }
	public function set_message(value:String):String 
	{
		_message = value;
		return message;
	}
	public var color( get_color, set_color ):Int;
	public function get_color():Int { return _color; }
	public function set_color(value:Int):Int 
	{
		_color = value;
		return color;
	}
}