package treemap.layouts;
import nme.Vector;
import treemap.TreemapConstants;
import treemap.TreeMapItem;
import nme.geom.Rectangle;
/**
 * @author Nicolas Barradeau
 * http://en.nicoptere.net
 */
class SliceDiceLayout extends LayoutManager 
{
	private var _direction:String;
	private var offset:Float;
	private var _rect:Rectangle;
	private var _totalWeight:Float;
	public function new( rect:Rectangle, totalWeight:Float ) 
	{
		this.rect = rect;
		offset = 0;
		_totalWeight = totalWeight;
	}
 override public function createMap( list:Vector<TreeMapItem> ):Vector<TreeMapItem>
	{
		var results:Vector<TreeMapItem> = new Vector<TreeMapItem>();
		var mapItem:TreeMapItem;
		if( direction == TreemapConstants.DIRECTION_HORIZONTAL )
		{
			for( mapItem in list )
			{
				var height:Float = ( mapItem.weight / _totalWeight ) * _rect.height;
				mapItem.rect = new Rectangle( _rect.x, _rect.y + offset, _rect.width, height );
				offset += height;
				results.push( mapItem );
			}
		}
		else
		{
			for( mapItem in list )
			{
				var width:Float = ( mapItem.weight / _totalWeight ) * _rect.width;
				mapItem.rect = new Rectangle( _rect.x + offset, _rect.y, width, _rect.height );
				offset += width;
				results.push( mapItem );
			}
		}
		return results
 }
	public var direction( get_direction, set_direction ):String;
	public function get_direction():String { return _direction; }
	public function set_direction(value:String):String 
	{
		_direction = value;
		return direction;
	}
	public var rect( get_rect, set_rect ):Rectangle;
	public function get_rect():Rectangle { return _rect; }
	public function set_rect(value:Rectangle):Rectangle 
	{
		_rect = value;
		return rect;
	}
}