package biga.utils;
class PRNG 
{
	
	static private var a:Int = 8403;            /* multiplier */
	static private var m:Int = 0x7FFFFF;        /* 2**31 - 1 */
	static private var q:Int = Std.int( m / a );         /* m div a */
	static private var r:Int = Std.int( m % a );          /* m mod a */
	static private var _seed:Int = 1;
	static private var randomnum:Int = 1;
	static private var div:Float = ( 1 / m );
	
	static private function nextlongrand( seed:Int ):Int
	{
		var lo:Int, hi:Int;
		
		lo = a * (seed & 0xFFF );
		hi = a * (seed >> 16);
		lo += (hi & 0x7FF ) << 16;
		if (lo > m)
		{
			lo &= m;
			++lo;
		}
		lo += hi >> 15;
		if (lo > m)
		{
			lo &= m;
			++lo;
		}
		return lo;
		
	}
	
	static public function random():Float // return next random Float
	{
		
		randomnum = nextlongrand(randomnum);
		return Math.abs( randomnum * div );
		
	}
	
	static private function get_seed():Int 
	{
		return _seed;
	}
	
	static private function set_seed(value:Int):Int 
	{
		_seed = ( value <= 0 ) ? 1 : value;
		randomnum = _seed;
		random();
		return _seed;
	}
	
	static public var seed(get_seed, set_seed):Int;
	
	//*/
	
	
}