package h3d;
import h3d.core.Scene;
import h3d.material.Solid;
import h3d.material.WireFrame;
import h3d.models.Model;
import h3d.models.SolidFactory;
import h3d.renderer.LineRenderer;
import haxe.Timer;
import nme.events.Event;
import nme.events.MouseEvent;
import nme.Lib;
/**
 * @author Nicolas Barradeau
 * http://en.nicoptere.net
 */
class InteractiveScene extends Scene 
{
	private var mouseDown:Bool;
	private var cub:Model;
	private var cam:Model;
	private var mod:Model;
	
	private var ico:Model;
	
	private var targetRotationX:Float	= 0;
	private var targetRotationY:Float 	= 0;
	private var cameraDistance:Float 	= 0;
	private var tmpRotationY:Float 		= 0;
	
	public function new( width:Float, height:Float ) 
	{
		super( width, height );
		//renderer = new LineRenderer();
		init();
	}
	
	public function init():Void
	{
		/*
		ico = SolidFactory.icosahedron( null, 50 );
		ico.material = new Solid( 0xFFFFFF, 0.5 );
		addChild( ico );
		
		ico.derivateNormals();
		
		cameraDistance = 1000;
		addListeners();
		//*/
	}
	
	public function addListeners():Void
	{
		Lib.stage.addEventListener( Event.ENTER_FRAME, onEnterFrame );
		Lib.stage.addEventListener( MouseEvent.MOUSE_WHEEL, onMouseHandler );
		Lib.stage.addEventListener( MouseEvent.MOUSE_DOWN, onMouseHandler );
		Lib.stage.addEventListener( MouseEvent.MOUSE_UP, onMouseHandler );
	}
	
	public function removeListeners():Void
	{
		Lib.stage.removeEventListener( Event.ENTER_FRAME, onEnterFrame );
		Lib.stage.removeEventListener( MouseEvent.MOUSE_WHEEL, onMouseHandler );
		Lib.stage.removeEventListener( MouseEvent.MOUSE_DOWN, onMouseHandler );
		Lib.stage.removeEventListener( MouseEvent.MOUSE_UP, onMouseHandler );
	}
	
	public function onMouseHandler(e:MouseEvent):Void 
	{
		
		if( e.type == MouseEvent.MOUSE_WHEEL 	) 	cameraDistance -= e.delta * 10;
		if( e.type ==  MouseEvent.MOUSE_DOWN 	)	mouseDown = true;
		if( e.type ==   MouseEvent.MOUSE_UP 	) 	mouseDown = false;
		
	}
	
	public function onEnterFrame(e:Event):Void 
	{
		/*
		var t:Float = Timer.stamp();
		//ico.x = Math.cos( t* 2 ) * 50;
		//ico.z = Math.sin( t* 2 ) * 50;
		//ico.rotationX += 1;
		//ico.rotationY += 5;
		//ico.rotationZ += 1;
		
		if ( mouseDown )
		{
			
			targetRotationX += ( viewport.mouseY > viewport.viewHeight * .5 ) ? -1 : 1;
			targetRotationY += ( viewport.mouseX > viewport.viewWidth * .5  ) ? -1 : 1;
			camera.target = ico;
			
		}
		else 
		{
			
			camera.target = null;
			
		}
		ico.rotationX += ( targetRotationX - ico.rotationX ) * .1;
		ico.rotationY += ( targetRotationY - ico.rotationY ) * .1;
		
		camera.z += ( cameraDistance - camera.z ) * .1;
		render();
		//*/
	}
}