package h3d.camera.lenses;
import h3d.utils.Constants3D;
import h3d.utils.PerspectiveMatrix3D;
import nme.geom.Vector3D;
import nme.Vector;
import nme.geom.Matrix3D;
/**
 * @author Nicolas Barradeau
 * http://en.nicoptere.net
 */
class Lens extends PerspectiveMatrix3D 
{
	private var _fov:Float = 3200;
	private var _width:Float = 16;
	private var _height:Float = 9;
	private var _near:Float = 1;
	private var _far:Float = 500;
	
	public function new( fov:Float = 60, width:Float = 16, height:Float = 9, near:Float = 1, far:Float = 200 ) 
	{
		
		super();
		
		_fov = fov;
		_width = width;
		_height = height;
		_near = near;
		_far = far;
		
		reset();
		
	}
	
	public function get_fov():Float 
	{
		return _fov;
	}
	public function set_fov(value:Float):Float 
	{
		_fov = value;
		reset();
		return _fov;
	}
	public var fov( get_fov, set_fov ):Float;
	
	public var near( get_near, set_near ):Float;
	public function get_near():Float 
	{
		return _near;
	}
	public function set_near(value:Float):Float 
	{
		_near = value;
		reset();
		return _near;
	}
	
	public var far( get_far, set_far ):Float;
	public function get_far():Float 
	{
		return _far;
	}
	public function set_far(value:Float):Float 
	{
		_far = value;
		reset();
		return _far;
	}
	
	
	private function get_width():Float 
	{
		return _width;
	}
	private function set_width(value:Float):Float 
	{
		_width = value;
		reset();
		return _width = value;
	}
	public var width(get_width, set_width):Float;
	
	
	private function get_height():Float 
	{
		return _height;
	}
	private function set_height(value:Float):Float 
	{
		_height = value;
		reset();
		return _height = value;
	}
	public var height(get_height, set_height):Float;
	
	
	public function reset():Void
	{
		
		identity();
		
		perspectiveFieldOfViewLH( fov * Math.PI / 180, width / height, near, far );
		
		//orthoLH(  width, height, near, far );
		
	}
	
}