package h3d.core;
import nme.geom.Vector3D;

/**
 * ...
 * @author Nicolas Barradeau 
 */

class Object3DContainer extends Object3D
{
	private var _children:Array<Object3D>;

	public function new( position:Vector3D = null, rotation:Vector3D = null, scale:Vector3D = null ) 
	{
		
		super();
		
		if ( position != null )this.position = position;
		if ( rotation != null )this.rotation = rotation;
		if ( scale != null ) this.scale = scale;
		
		children = new Array<Object3D>();
		
	}
	
	public function addChild( obj:Object3D ):Object3DContainer
	{
		obj.parent = this;
		children.push( obj );
		return this;
		
	}
	
	public function removeChild( obj:Object3D ):Object3DContainer
	{
		for ( i in 0...children.length )
		{
			if ( children[ i ] == obj ) 
			{
				children[ i ].parent = null;
				children.splice( i, 1 );
				return this;
			}
		}
		return this;
	}
	
	private function get_children():Array<Object3D> 
	{
		return _children;
	}
	
	private function set_children(value:Array<Object3D>):Array<Object3D> 
	{
		return _children = value;
	}
	
	public var children(get_children, set_children):Array<Object3D>;
	
}