package h3d.core;
import nme.display.Sprite;
import nme.events.Event;
import nme.geom.Point;
import nme.geom.Rectangle;

/**
 * @author Nicolas Barradeau 
 */

class Viewport extends Sprite
{

	private var backgroundColor:Int = 0x202020;//0xFFFFFF;// 
	private var _size:Point;
	
	public function new( width:Float, height:Float ) 
	{
		
		super();
		_size = new Point( width, height );
		
	}
	
	public function clear() 
	{
		
		graphics.clear();
		graphics.beginFill( backgroundColor );
		graphics.drawRect( 0, 0, _size.x, _size.y );
		graphics.endFill();
		
	}
	
	private function get_viewWidth():Float 
	{
		return size.x;
	}
	
	private function set_viewWidth(value:Float):Float 
	{
		setSize( value, _size.y );
		return value;
	}
	
	public var viewWidth(get_viewWidth, set_viewWidth):Float;
	
	private function get_viewHeight():Float 
	{
		return size.y;
	}
	
	private function set_viewHeight(value:Float):Float 
	{
		setSize( _size.x, value );
		return value;
	}
	public var viewHeight(get_viewHeight, set_viewHeight):Float;
	
	private function get_size():Point 
	{
		return _size;
	}
	
	private function set_size(value:Point):Point 
	{
		setSize( value.x, value.y );
		return value;
	}
	
	public var size(get_size, set_size):Point;
	
	public function setSize( width:Float, height:Float ):Void
	{
		_size.x = width;
		_size.y = height;
		dispatchEvent( new Event( Event.RESIZE ) );
	}
	
}