package h3d.material;
import h3d.core.Viewport;
import h3d.material.IMaterial;

/**
 * @author Nicolas Barradeau 
 */

class Solid implements IMaterial
{
	
	private var _color:Int;
	private var _alpha:Float;

	public function new( color:Int = 0, alpha:Float = 1 ) 
	{
		this.color = color;
		this.alpha = alpha;
	}
	
	public function prepareContext(viewport:Viewport):Void 
	{
		viewport.graphics.beginFill( color, alpha );
	}
	
	public function clearContext(viewport:Viewport):Void 
	{
		viewport.graphics.endFill();
	}
	
	public function clone():IMaterial 
	{
		return new Solid( color, alpha );
	}
	
	//PROPERTIES
	
	private function get_color():Int 
	{
		return _color;
	}
	
	private function set_color(value:Int):Int 
	{
		return _color = value;
	}
	
	public var color(get_color, set_color):Int;
	
	private function get_alpha():Float 
	{
		return _alpha;
	}
	
	private function set_alpha(value:Float):Float 
	{
		return _alpha = value;
	}
	
	public var alpha(get_alpha, set_alpha):Float;
	
}