package h3d.models.sparse;
import nme.display.BitmapData;
import nme.Vector;
using nme.Vector;
/**
 * @author Nicolas Barradeau 
 */


class Preprocessor
{
	public function new( ) 
	{
	}
	
	static public function processBitmap( bd:BitmapData ):Vector<Int> 
	{
		
		var edges:Array<Int> = new Array<Int>();
		
		bd.lock();
		for( i in 0...bd.width )
		{
			for ( j in 0...bd.height ) 
			{
				if ( 0xFF<< 24 | bd.getPixel( i, j ) != 0xFFFFFFFF ) 
				{
					edges.push( i );
					edges.push( j );
				}
			}
		}
		bd.unlock();
		
		return processData( edges );
		
	}
	
	static public function processData( edges:Array<Int> ):Vector<Int> 
	{
		
		var indices:Vector<Int> = new Vector<Int>();
		
		var tmp:Array<Int> = edges.concat( [] );
		tmp.sort( function( a:Int, b:Int ):Int { return a <= b ? - 1 : 1; } );
		
		var value:Int = tmp[ 0 ];
		
		var total:Int = 0;
		var cor:IntHash<Int> = new IntHash<Int>();
		cor.set( tmp[ 0 ], total );
		
		for( i in 0...tmp.length )
		{
			if ( value != tmp[ i ] ) 
			{
				total++;
				cor.set( tmp[ i ], total );
				value = tmp[ i ];
			}
		}
		
		var i:Int = 0;
		while ( i < edges.length )
		{
			
			if ( edges[ i ] == edges[ i + 1 ] ) 
			{
				i += 2;
				continue;
			}
			
			indices.push( cor.get( edges[ i ] 		) 	);
			indices.push( cor.get( edges[ i + 1 ]  	)	);
			
			i += 2;
			
		}
		
		total++;
		indices.push( total );
		return indices;
		
	}
	
	
	static public function processIndices(indices:Vector<Int>):Array<Int>
	{
		
		var i:Int = 0;
		var j:Int = 0;
		var id:Int = 0;
		var id0:Int  = 0;
		var id1:Int  = 0;
		var id2:Int  = 0;
		
		var hash:Vector<Vector<Int>> = new Vector<Vector<Int>>();
		var currentHash:Vector<Int> = new Vector<Int>();
		
		while( i < Std.int( indices.length ) )
		{
			if ( Std.int( hash.length ) < indices[ i ] )
			{
				j = Std.int( hash.length );
				while ( j < indices[ i ] + 1 )
				{
					hash.push( new Vector<Int>() );
					j++;
				}
			}
			i++;
		}
		
		//create list with unique edges
		i = 0;
		while( i < Std.int( hash.length ) )
		{
			currentHash = hash[ i ];
			id =  i;
			j = 0;
			while( j < Std.int( indices.length ) )
			{
				
				id0 = indices[ j ];
				id1 = indices[ j + 1 ];
				id2 = indices[ j + 2 ];
				
				if ( id != id0 && id != id1 && id != id2 )
				{
					j += 3;
					continue;
				}
				
				if ( id == id0 )
				{
					addEdge( currentHash, id1 );
					addEdge( currentHash, id2 );
				}
				if ( id == id1 )
				{
					addEdge( currentHash, id0 );
					addEdge( currentHash, id2 );
				}
				if ( id == id2 )
				{
					addEdge( currentHash, id0 );
					addEdge( currentHash, id1 );
				}
				j += 3;
			}
			i++;
		}
		
		//creates a linear array of edges
		
		var data:Array<Int> = new Array<Int>();
		
		for ( i in 0...hash.length )
		{
			for ( id in hash[ i ] )
			{
				if ( id == i ) continue;
				
				if ( id < i && contains( hash[ id ], i  ) ) continue;
				
				data.push( id );
				data.push( i );
				
			}
		}		
		
		return data;
		
	}
	
	static private function contains( list:Vector<Int>, id:Int ):Bool
	{
		for ( i in list ) if ( i == id ) return true;
		return false;
	}
	
	static private function addEdge( list:Vector<Int>, idToAdd:Int ):Void
	{
		if ( !contains( list, idToAdd ) )
		{
			list.push( idToAdd );
		}
	}
}

