package h3d.renderer;
import h3d.core.Object3DContainer;
import h3d.core.Viewport;
import h3d.models.Model;
import nme.display.GraphicsPath;
import nme.display.TriangleCulling;
import nme.geom.Matrix3D;
import nme.geom.Point;
import nme.Vector;

/**
 * @author Nicolas Barradeau 
 */

class WireFrameRenderer implements IRenderer
{
	private var projection:Vector<Float>;
	private var normals:Vector<Float>;
	private var indices:Vector<Int>;
	
	private var _culling:TriangleCulling;
	
	private var commands:Vector<Int>;
	private var data:Vector<Float>;
	
	public function new() 
	{
	}
	
	public function render( viewport:Viewport, model:Model ):Void
	{
		
		projection = model.projection;
		indices = model.indices;
		
		model.material.prepareContext( viewport );
		
		#if !flash
			
			var i:Int = 0, idn:Int = 0, id1:Int, id2:Int, id3:Int;
			while( i < Std.int( model.indices.length ) )
			{
				
				id1 = Std.int( indices[ i ] 	* 2	);
				id2 = Std.int( indices[ i + 1 ] * 2	);
				id3 = Std.int( indices[ i + 2 ] * 2	);
				
				viewport.graphics.moveTo( projection[ id1 ], projection[ id1 + 1 ] ); 
				viewport.graphics.lineTo( projection[ id2 ], projection[ id2 + 1 ] ); 
				viewport.graphics.lineTo( projection[ id3 ], projection[ id3 + 1 ] ); 
				viewport.graphics.lineTo( projection[ id1 ], projection[ id1 + 1 ] ); 
				
				/*
				commands.push( 1 );//moveTo
				commands.push( 2 );//lineTo
				commands.push( 2 );//lineTo
				commands.push( 2 );//lineTo
				
				data.push( projection[ id1 ] );		//X0
				data.push( projection[ id1 + 1 ] );	//Y0
				
				data.push( projection[ id2 ] );		//X1
				data.push( projection[ id2 + 1 ] ); //Y1
				
				data.push( projection[ id3 ] );     //X2
				data.push( projection[ id3 + 1 ] ); //Y2
				
				data.push( projection[ id1 ] );     //X0
				data.push( projection[ id1 + 1 ] ); //Y0
				//*/
				
				i += 3;
			}
			
			//viewport.graphics.drawPath( commands, data );
			
		#else
			
			viewport.graphics.drawTriangles( projection, indices, null, culling );
			
		#end
		
		model.material.clearContext( viewport );
		
	}
	
	//PROPERTIES
	private function get_culling():TriangleCulling 
	{
		return _culling;
	}
	
	private function set_culling(value:TriangleCulling):TriangleCulling 
	{
		return _culling = value;
	}
	
	public var culling(get_culling, set_culling):TriangleCulling;
	
}