package nape.constraint;
import zpp_nape.ID;
import zpp_nape.Config;
import zpp_nape.Const;
import zpp_nape.dynamics.SpaceArbiterList;
import zpp_nape.dynamics.InteractionGroup;
import zpp_nape.dynamics.InteractionFilter;
import zpp_nape.dynamics.Contact;
import zpp_nape.space.SweepPhase;
import zpp_nape.dynamics.Arbiter;
import zpp_nape.space.DynAABBPhase;
import zpp_nape.space.Broadphase;
import zpp_nape.shape.Polygon;
import zpp_nape.shape.Circle;
import zpp_nape.shape.Edge;
import zpp_nape.shape.Shape;
import zpp_nape.util.Circular;
import zpp_nape.util.Flags;
import zpp_nape.util.Names;
import zpp_nape.space.Space;
import zpp_nape.util.HaxeMacros;
import zpp_nape.util.FastHash;
import zpp_nape.util.Array2;
import zpp_nape.util.Queue;
import zpp_nape.util.RBTree;
import zpp_nape.util.WrapLists;
import zpp_nape.util.Debug;
import zpp_nape.util.Math;
import zpp_nape.util.UserData;
import zpp_nape.util.DisjointSetForest;
import zpp_nape.util.Pool;
import zpp_nape.geom.MatMath;
import zpp_nape.geom.Vec3;
import zpp_nape.geom.Mat23;
import zpp_nape.geom.Convex;
import zpp_nape.util.Lists;
import zpp_nape.geom.Simple;
import zpp_nape.geom.Triangular;
import zpp_nape.geom.Geom;
import zpp_nape.geom.VecMath;
import zpp_nape.geom.PartitionedPoly;
import zpp_nape.geom.Cutter;
import zpp_nape.geom.Simplify;
import zpp_nape.geom.Ray;
import zpp_nape.geom.Distance;
import zpp_nape.geom.Monotone;
import zpp_nape.geom.PolyIter;
import zpp_nape.geom.AABB;
import zpp_nape.geom.MarchingSquares;
import zpp_nape.geom.Vec2;
import zpp_nape.geom.MatMN;
import zpp_nape.geom.GeomPoly;
import zpp_nape.callbacks.CbSetPair;
import zpp_nape.callbacks.CbSet;
import zpp_nape.geom.Collide;
import zpp_nape.callbacks.Callback;
import zpp_nape.callbacks.Listener;
import zpp_nape.callbacks.CbType;
import zpp_nape.phys.FluidProperties;
import zpp_nape.callbacks.OptionType;
import zpp_nape.phys.FeatureMix;
import zpp_nape.phys.Compound;
import zpp_nape.phys.Interactor;
import zpp_nape.phys.Material;
import zpp_nape.constraint.DistanceJoint;
import zpp_nape.phys.Body;
import zpp_nape.constraint.WeldJoint;
import zpp_nape.constraint.MotorJoint;
import zpp_nape.constraint.Constraint;
import zpp_nape.constraint.AngleJoint;
import zpp_nape.constraint.LinearJoint;
import zpp_nape.constraint.UserConstraint;
import zpp_nape.constraint.LineJoint;
import nape.dynamics.FluidArbiter;
import nape.dynamics.ContactList;
import zpp_nape.constraint.PivotJoint;
import nape.dynamics.Arbiter;
import nape.dynamics.InteractionGroupList;
import nape.dynamics.ArbiterType;
import nape.dynamics.ArbiterIterator;
import nape.dynamics.ContactIterator;
import nape.dynamics.InteractionGroupIterator;
import nape.dynamics.InteractionGroup;
import nape.dynamics.InteractionFilter;
import nape.dynamics.ArbiterList;
import nape.dynamics.CollisionArbiter;
import nape.dynamics.Contact;
import nape.space.Broadphase;
import nape.shape.ShapeType;
import nape.shape.ShapeList;
import nape.space.Space;
import nape.shape.Polygon;
import nape.shape.EdgeList;
import nape.shape.ShapeIterator;
import nape.shape.Circle;
import nape.shape.Edge;
import nape.shape.EdgeIterator;
import nape.shape.Shape;
import nape.util.Debug;
import nape.util.BitmapDebug;
import nape.geom.GeomPolyIterator;
import nape.util.ShapeDebug;
import nape.geom.Vec3;
import nape.geom.RayResultIterator;
import nape.geom.GeomPolyList;
import nape.geom.Winding;
import nape.geom.RayResultList;
import nape.geom.Geom;
import nape.geom.Vec2Iterator;
import nape.geom.GeomVertexIterator;
import nape.geom.Mat23;
import nape.geom.Ray;
import nape.geom.RayResult;
import nape.geom.MarchingSquares;
import nape.geom.AABB;
import nape.geom.MatMN;
import nape.geom.Vec2;
import nape.geom.Vec2List;
import nape.callbacks.ListenerList;
import nape.callbacks.ListenerType;
import nape.callbacks.InteractionType;
import nape.callbacks.ConstraintCallback;
import nape.callbacks.CbTypeIterator;
import nape.callbacks.BodyCallback;
import nape.geom.GeomPoly;
import nape.callbacks.Callback;
import nape.callbacks.OptionType;
import nape.callbacks.ListenerIterator;
import nape.callbacks.PreFlag;
import nape.callbacks.Listener;
import nape.callbacks.PreCallback;
import nape.callbacks.CbType;
import nape.callbacks.ConstraintListener;
import nape.callbacks.PreListener;
import nape.callbacks.InteractionCallback;
import nape.callbacks.BodyListener;
import nape.callbacks.CbEvent;
import nape.callbacks.CbTypeList;
import nape.phys.InertiaMode;
import nape.phys.FluidProperties;
import nape.phys.CompoundIterator;
import nape.phys.BodyType;
import nape.callbacks.InteractionListener;
import nape.phys.BodyList;
import nape.phys.GravMassMode;
import nape.phys.MassMode;
import nape.phys.Interactor;
import nape.phys.Compound;
import nape.phys.CompoundList;
import nape.phys.InteractorIterator;
import nape.phys.Material;
import nape.phys.InteractorList;
import nape.phys.BodyIterator;
import nape.constraint.DistanceJoint;
import nape.constraint.WeldJoint;
import nape.constraint.MotorJoint;
import nape.constraint.ConstraintIterator;
import nape.constraint.AngleJoint;
import nape.constraint.ConstraintList;
import nape.constraint.LinearJoint;
import nape.constraint.UserConstraint;
import nape.phys.Body;
import nape.constraint.LineJoint;
import nape.constraint.PivotJoint;
#if nape_swc@:keep#end
 class Constraint{
    public var zpp_inner:ZPP_Constraint;
    public var userData(get_userData,never):Dynamic<Dynamic>;
    inline function get_userData():Dynamic<Dynamic>{
        if(zpp_inner.userData==null){
            zpp_inner.userData=cast{};
        }
        return zpp_inner.userData;
    }
    public var compound(get_compound,set_compound):Null<Compound>;
    inline function get_compound():Null<Compound>{
        return if(zpp_inner.compound==null)null else zpp_inner.compound.outer;
    }
    inline function set_compound(compound:Null<Compound>):Null<Compound>{
        {
            if(this.compound!=compound){
                if(this.compound!=null){
                    this.compound.constraints.remove(this);
                }
                if(compound!=null){
                    compound.constraints.add(this);
                }
            }
        }
        return this.compound;
    }
    public var space(get_space,set_space):Null<Space>;
    inline function get_space():Null<Space>{
        return if(zpp_inner.space==null)null else zpp_inner.space.outer;
    }
    inline function set_space(space:Null<Space>):Null<Space>{
        {
            #if(!NAPE_RELEASE_BUILD)if(zpp_inner.compound!=null){
                throw "Error: Cannot set the space of a Constraint belonging to"+" a Compound, only the root Compound space can be set";
            }
            #end
 if(this.space!=space){
                if(zpp_inner.component!=null)zpp_inner.component.woken=false;
                zpp_inner.clearcache();
                if(zpp_inner.space!=null){
                    zpp_inner.space.outer.constraints.remove(this);
                }
                if(space!=null){
                    space.constraints.add(this);
                }
                else{
                    zpp_inner.space=null;
                }
            }
        }
        return this.space;
    }
    public var isSleeping(get_isSleeping,never):Bool;
    inline function get_isSleeping():Bool{
        #if(!NAPE_RELEASE_BUILD)if(zpp_inner.space==null||!zpp_inner.active){
            throw "Error: isSleeping only makes sense if constraint is"+" active and inside a space";
        }
        #end
 return zpp_inner.component.sleeping;
    }
    public var active(get_active,set_active):Bool;
    inline function get_active():Bool{
        return zpp_inner.active;
    }
    inline function set_active(active:Bool):Bool{
        {
            if(this.active!=active){
                if(zpp_inner.component!=null)zpp_inner.component.woken=false;
                zpp_inner.clearcache();
                if(active){
                    zpp_inner.active=active;
                    zpp_inner.activate();
                    if(zpp_inner.space!=null){
                        if(zpp_inner.component!=null)zpp_inner.component.sleeping=true;
                        zpp_inner.space.wake_constraint(zpp_inner,true);
                    }
                }
                else{
                    if(zpp_inner.space!=null){
                        zpp_inner.wake();
                        zpp_inner.space.live_constraints.remove(zpp_inner);
                    }
                    zpp_inner.active=active;
                    zpp_inner.deactivate();
                }
            }
        }
        return this.active;
    }
    public var ignore(get_ignore,set_ignore):Bool;
    inline function get_ignore():Bool{
        return zpp_inner.ignore;
    }
    inline function set_ignore(ignore:Bool):Bool{
        {
            if(this.ignore!=ignore){
                zpp_inner.ignore=ignore;
                zpp_inner.wake();
            }
        }
        return this.ignore;
    }
    public var stiff(get_stiff,set_stiff):Bool;
    inline function get_stiff():Bool{
        return zpp_inner.stiff;
    }
    inline function set_stiff(stiff:Bool):Bool{
        {
            if(this.stiff!=stiff){
                zpp_inner.stiff=stiff;
                zpp_inner.wake();
            }
        }
        return this.stiff;
    }
    public var frequency(get_frequency,set_frequency):Float;
    inline function get_frequency():Float{
        return zpp_inner.frequency;
    }
    inline function set_frequency(frequency:Float):Float{
        {
            #if(!NAPE_RELEASE_BUILD)if((frequency!=frequency)){
                throw "Error: Constraint::Frequency cannot be NaN";
            }
            if(frequency<=0){
                throw "Error: Constraint::Frequency must be >0";
            }
            #end
 if(this.frequency!=frequency){
                zpp_inner.frequency=frequency;
                if(!zpp_inner.stiff){
                    zpp_inner.wake();
                }
            }
        }
        return this.frequency;
    }
    public var damping(get_damping,set_damping):Float;
    inline function get_damping():Float{
        return zpp_inner.damping;
    }
    inline function set_damping(damping:Float):Float{
        {
            #if(!NAPE_RELEASE_BUILD)if((damping!=damping)){
                throw "Error: Constraint::Damping cannot be Nan";
            }
            if(damping<0){
                throw "Error: Constraint::Damping must be >=0";
            }
            #end
 if(this.damping!=damping){
                zpp_inner.damping=damping;
                if(!zpp_inner.stiff){
                    zpp_inner.wake();
                }
            }
        }
        return this.damping;
    }
    public var maxForce(get_maxForce,set_maxForce):Float;
    inline function get_maxForce():Float{
        return zpp_inner.maxForce;
    }
    inline function set_maxForce(maxForce:Float):Float{
        {
            #if(!NAPE_RELEASE_BUILD)if((maxForce!=maxForce)){
                throw "Error: Constraint::maxForce cannot be NaN";
            }
            if(maxForce<0){
                throw "Error: Constraint::maxForce must be >=0";
            }
            #end
 if(this.maxForce!=maxForce){
                zpp_inner.maxForce=maxForce;
                zpp_inner.wake();
            }
        }
        return this.maxForce;
    }
    public var maxError(get_maxError,set_maxError):Float;
    inline function get_maxError():Float{
        return zpp_inner.maxError;
    }
    inline function set_maxError(maxError:Float):Float{
        {
            #if(!NAPE_RELEASE_BUILD)if((maxError!=maxError)){
                throw "Error: Constraint::maxError cannot be NaN";
            }
            if(maxError<0){
                throw "Error: Constraint::maxError must be >=0";
            }
            #end
 if(this.maxError!=maxError){
                zpp_inner.maxError=maxError;
                zpp_inner.wake();
            }
        }
        return this.maxError;
    }
    public var breakUnderForce(get_breakUnderForce,set_breakUnderForce):Bool;
    inline function get_breakUnderForce():Bool{
        return zpp_inner.breakUnderForce;
    }
    inline function set_breakUnderForce(breakUnderForce:Bool):Bool{
        {
            if(this.breakUnderForce!=breakUnderForce){
                zpp_inner.breakUnderForce=breakUnderForce;
                zpp_inner.wake();
            }
        }
        return this.breakUnderForce;
    }
    public var breakUnderError(get_breakUnderError,set_breakUnderError):Bool;
    inline function get_breakUnderError():Bool{
        return zpp_inner.breakUnderError;
    }
    inline function set_breakUnderError(breakUnderError:Bool):Bool{
        {
            if(this.breakUnderError!=breakUnderError){
                zpp_inner.breakUnderError=breakUnderError;
                zpp_inner.wake();
            }
        }
        return this.breakUnderError;
    }
    public var removeOnBreak(get_removeOnBreak,set_removeOnBreak):Bool;
    inline function get_removeOnBreak():Bool{
        return zpp_inner.removeOnBreak;
    }
    inline function set_removeOnBreak(removeOnBreak:Bool):Bool{
        {
            zpp_inner.removeOnBreak=removeOnBreak;
        }
        return this.removeOnBreak;
    }
    public function impulse():MatMN{
        return null;
    }
    public function bodyImpulse(body:Body):Vec3{
        return null;
    }
    public function visitBodies(lambda:Body->Void):Void{}
    public var cbTypes(get_cbTypes,never):CbTypeList;
    inline function get_cbTypes():CbTypeList{
        if(zpp_inner.wrap_cbTypes==null){
            zpp_inner.setupcbTypes();
        }
        return zpp_inner.wrap_cbTypes;
    }
    public function new(){
        zpp_inner.insert_cbtype(CbType.ANY_CONSTRAINT.zpp_inner);
        #if(!NAPE_RELEASE_BUILD)throw "Error: Constraint cannot be instantiated derp!";
        #end

    }
    @:keep public function toString():String{
        return "{Constraint}";
    }
    public function copy():Constraint{
        return zpp_inner.copy();
    }
}
