package nape.constraint;
import zpp_nape.ID;
import zpp_nape.Config;
import zpp_nape.Const;
import zpp_nape.dynamics.SpaceArbiterList;
import zpp_nape.dynamics.InteractionGroup;
import zpp_nape.dynamics.InteractionFilter;
import zpp_nape.dynamics.Contact;
import zpp_nape.space.SweepPhase;
import zpp_nape.dynamics.Arbiter;
import zpp_nape.space.DynAABBPhase;
import zpp_nape.space.Broadphase;
import zpp_nape.shape.Polygon;
import zpp_nape.shape.Circle;
import zpp_nape.shape.Edge;
import zpp_nape.shape.Shape;
import zpp_nape.util.Circular;
import zpp_nape.util.Flags;
import zpp_nape.util.Names;
import zpp_nape.space.Space;
import zpp_nape.util.HaxeMacros;
import zpp_nape.util.FastHash;
import zpp_nape.util.Array2;
import zpp_nape.util.Queue;
import zpp_nape.util.RBTree;
import zpp_nape.util.WrapLists;
import zpp_nape.util.Debug;
import zpp_nape.util.Math;
import zpp_nape.util.UserData;
import zpp_nape.util.DisjointSetForest;
import zpp_nape.util.Pool;
import zpp_nape.geom.MatMath;
import zpp_nape.geom.Vec3;
import zpp_nape.geom.Mat23;
import zpp_nape.geom.Convex;
import zpp_nape.util.Lists;
import zpp_nape.geom.Simple;
import zpp_nape.geom.Triangular;
import zpp_nape.geom.Geom;
import zpp_nape.geom.VecMath;
import zpp_nape.geom.PartitionedPoly;
import zpp_nape.geom.Cutter;
import zpp_nape.geom.Simplify;
import zpp_nape.geom.Ray;
import zpp_nape.geom.Distance;
import zpp_nape.geom.Monotone;
import zpp_nape.geom.PolyIter;
import zpp_nape.geom.AABB;
import zpp_nape.geom.MarchingSquares;
import zpp_nape.geom.Vec2;
import zpp_nape.geom.MatMN;
import zpp_nape.geom.GeomPoly;
import zpp_nape.callbacks.CbSetPair;
import zpp_nape.callbacks.CbSet;
import zpp_nape.geom.Collide;
import zpp_nape.callbacks.Callback;
import zpp_nape.callbacks.Listener;
import zpp_nape.callbacks.CbType;
import zpp_nape.phys.FluidProperties;
import zpp_nape.callbacks.OptionType;
import zpp_nape.phys.FeatureMix;
import zpp_nape.phys.Compound;
import zpp_nape.phys.Interactor;
import zpp_nape.phys.Material;
import zpp_nape.constraint.DistanceJoint;
import zpp_nape.phys.Body;
import zpp_nape.constraint.WeldJoint;
import zpp_nape.constraint.MotorJoint;
import zpp_nape.constraint.Constraint;
import zpp_nape.constraint.AngleJoint;
import zpp_nape.constraint.LinearJoint;
import zpp_nape.constraint.UserConstraint;
import zpp_nape.constraint.LineJoint;
import nape.dynamics.FluidArbiter;
import nape.dynamics.ContactList;
import zpp_nape.constraint.PivotJoint;
import nape.dynamics.Arbiter;
import nape.dynamics.InteractionGroupList;
import nape.dynamics.ArbiterType;
import nape.dynamics.ArbiterIterator;
import nape.dynamics.ContactIterator;
import nape.dynamics.InteractionGroupIterator;
import nape.dynamics.InteractionGroup;
import nape.dynamics.InteractionFilter;
import nape.dynamics.ArbiterList;
import nape.dynamics.CollisionArbiter;
import nape.dynamics.Contact;
import nape.space.Broadphase;
import nape.shape.ShapeType;
import nape.shape.ShapeList;
import nape.space.Space;
import nape.shape.Polygon;
import nape.shape.EdgeList;
import nape.shape.ShapeIterator;
import nape.shape.Circle;
import nape.shape.Edge;
import nape.shape.EdgeIterator;
import nape.shape.Shape;
import nape.util.Debug;
import nape.util.BitmapDebug;
import nape.geom.GeomPolyIterator;
import nape.util.ShapeDebug;
import nape.geom.Vec3;
import nape.geom.RayResultIterator;
import nape.geom.GeomPolyList;
import nape.geom.Winding;
import nape.geom.RayResultList;
import nape.geom.Geom;
import nape.geom.Vec2Iterator;
import nape.geom.GeomVertexIterator;
import nape.geom.Mat23;
import nape.geom.Ray;
import nape.geom.RayResult;
import nape.geom.MarchingSquares;
import nape.geom.AABB;
import nape.geom.MatMN;
import nape.geom.Vec2;
import nape.geom.Vec2List;
import nape.callbacks.ListenerList;
import nape.callbacks.ListenerType;
import nape.callbacks.InteractionType;
import nape.callbacks.ConstraintCallback;
import nape.callbacks.CbTypeIterator;
import nape.callbacks.BodyCallback;
import nape.geom.GeomPoly;
import nape.callbacks.Callback;
import nape.callbacks.OptionType;
import nape.callbacks.ListenerIterator;
import nape.callbacks.PreFlag;
import nape.callbacks.Listener;
import nape.callbacks.PreCallback;
import nape.callbacks.CbType;
import nape.callbacks.ConstraintListener;
import nape.callbacks.PreListener;
import nape.callbacks.InteractionCallback;
import nape.callbacks.BodyListener;
import nape.callbacks.CbEvent;
import nape.callbacks.CbTypeList;
import nape.phys.InertiaMode;
import nape.phys.FluidProperties;
import nape.phys.CompoundIterator;
import nape.phys.BodyType;
import nape.callbacks.InteractionListener;
import nape.phys.BodyList;
import nape.phys.GravMassMode;
import nape.phys.MassMode;
import nape.phys.Interactor;
import nape.phys.Compound;
import nape.phys.CompoundList;
import nape.phys.InteractorIterator;
import nape.phys.Material;
import nape.phys.InteractorList;
import nape.phys.BodyIterator;
import nape.constraint.DistanceJoint;
import nape.constraint.WeldJoint;
import nape.constraint.MotorJoint;
import nape.constraint.Constraint;
import nape.constraint.ConstraintIterator;
import nape.constraint.AngleJoint;
import nape.constraint.ConstraintList;
import nape.constraint.LinearJoint;
import nape.phys.Body;
import nape.constraint.LineJoint;
import nape.constraint.PivotJoint;
#if nape_swc@:keep#end
 class UserConstraint extends Constraint{
    public var zpp_inner_zn:ZPP_UserConstraint;
    public function bindVec2():Vec2{
        var ret=new Vec2();
        ret.zpp_inner._inuse=true;
        ret.zpp_inner._invalidate=zpp_inner_zn.bindVec2_invalidate;
        return ret;
    }
    public function __copy():UserConstraint{
        #if(!NAPE_RELEASE_BUILD)throw "Error: UserConstraint::__copy must be overriden";
        #end
 return null;
    }
    public function __destroy():Void{}
    public function __validate():Void{}
    public function __draw(debug:Debug):Void{}
    public function __prepare():Void{}
    public function __position(err:#if flash10 flash.Vector<Float>#else Array<Float>#end
):Void{
        #if(!NAPE_RELEASE_BUILD)throw "Error: UserConstraint::__position must be overriden";
        #end

    }
    public function __velocity(err:#if flash10 flash.Vector<Float>#else Array<Float>#end
):Void{
        #if(!NAPE_RELEASE_BUILD)throw "Error: Userconstraint::__velocity must be overriden";
        #end

    }
    public function __eff_mass(eff:#if flash10 flash.Vector<Float>#else Array<Float>#end
):Void{
        #if(!NAPE_RELEASE_BUILD)throw "Error: UserConstraint::__eff_mass must be overriden";
        #end

    }
    public function __clamp(jAcc:#if flash10 flash.Vector<Float>#else Array<Float>#end
):Void{}
    public function __impulse(imp:#if flash10 flash.Vector<Float>#else Array<Float>#end
,body:Body,out:Vec3):Void{
        #if(!NAPE_RELEASE_BUILD)throw "Error: UserConstraint::__impulse must be overriden";
        #end

    }
    #if flib@:keep function flibopts_1(){}
    #end
 public function new(dimensions:Int,velocityOnly:Bool=false){
        #if(!NAPE_RELEASE_BUILD)if(dimensions<1){
            throw "Error: Constraint dimension must be at least 1";
        }
        #end
 zpp_inner_zn=new ZPP_UserConstraint(dimensions,velocityOnly);
        zpp_inner=zpp_inner_zn;
        zpp_inner.outer=this;
        zpp_inner_zn.outer_zn=this;
        #if(!NAPE_RELEASE_BUILD)try{
            super();
        }
        catch(e:Dynamic){}
        #end
#if NAPE_RELEASE_BUILD super();
        #end

    }
    public override function impulse():MatMN{
        var ret=new MatMN(zpp_inner_zn.dim,1);
        for(i in 0...zpp_inner_zn.dim){
            ret.setx(i,0,zpp_inner_zn.jAcc[i]+zpp_inner_zn.pjAcc[i]);
        }
        return ret;
    }
    public override function bodyImpulse(body:Body):Vec3{
        #if(!NAPE_RELEASE_BUILD)if(body==null){
            throw "Error: Cannot evaluate impulse on null body";
        }
        var found=false;
        for(b in zpp_inner_zn.bodies){
            if(b.body==body.zpp_inner){
                found=true;
                break;
            }
        }
        if(!found){
            throw "Error: Body is not linked to this constraint";
        }
        #end
 if(!active){
            return Vec3.get();
        }
        else{
            return zpp_inner_zn.bodyImpulse(body.zpp_inner);
        }
    }
    public override function visitBodies(lambda:Body->Void):Void{
        var i:#if flash10 UInt#else Int#end
=0;
        var nbodies=zpp_inner_zn.bodies.length;
        while(i<nbodies){
            var b=zpp_inner_zn.bodies[i];
            if(b.body!=null){
                var found=false;
                for(j in(i+1)...nbodies){
                    var c=zpp_inner_zn.bodies[j];
                    if(c.body==b.body){
                        found=true;
                        break;
                    }
                }
                if(!found){
                    lambda(b.body.outer);
                }
            }
            i++;
        }
    }
    public function invalidate():Void{
        zpp_inner.immutable_midstep("UserConstraint::invalidate()");
        if(active&&space!=null){
            zpp_inner.wake();
        }
    }
    public function registerBody(oldBody:Body,newBody:Body):Body{
        zpp_inner.immutable_midstep("UserConstraint::registerBody(..)");
        if(oldBody!=newBody){
            if(oldBody!=null){
                if(!zpp_inner_zn.remBody(oldBody.zpp_inner)){
                    #if(!NAPE_RELEASE_BUILD)throw "Error: oldBody is not registered to the cosntraint";
                    #end

                }
                if(active&&space!=null){
                    oldBody.zpp_inner.wake();
                }
            }
            if(newBody!=null){
                zpp_inner_zn.addBody(newBody.zpp_inner);
            }
            zpp_inner.wake();
            if(newBody!=null){
                newBody.zpp_inner.wake();
            }
        }
        return newBody;
    }
}
