package nape.dynamics;
import zpp_nape.ID;
import zpp_nape.Config;
import zpp_nape.Const;
import zpp_nape.dynamics.SpaceArbiterList;
import zpp_nape.dynamics.InteractionGroup;
import zpp_nape.dynamics.InteractionFilter;
import zpp_nape.dynamics.Contact;
import zpp_nape.space.SweepPhase;
import zpp_nape.dynamics.Arbiter;
import zpp_nape.space.DynAABBPhase;
import zpp_nape.space.Broadphase;
import zpp_nape.shape.Polygon;
import zpp_nape.shape.Circle;
import zpp_nape.shape.Edge;
import zpp_nape.shape.Shape;
import zpp_nape.util.Circular;
import zpp_nape.util.Flags;
import zpp_nape.util.Names;
import zpp_nape.space.Space;
import zpp_nape.util.HaxeMacros;
import zpp_nape.util.FastHash;
import zpp_nape.util.Array2;
import zpp_nape.util.Queue;
import zpp_nape.util.RBTree;
import zpp_nape.util.WrapLists;
import zpp_nape.util.Debug;
import zpp_nape.util.Math;
import zpp_nape.util.UserData;
import zpp_nape.util.DisjointSetForest;
import zpp_nape.util.Pool;
import zpp_nape.geom.MatMath;
import zpp_nape.geom.Vec3;
import zpp_nape.geom.Mat23;
import zpp_nape.geom.Convex;
import zpp_nape.util.Lists;
import zpp_nape.geom.Simple;
import zpp_nape.geom.Triangular;
import zpp_nape.geom.Geom;
import zpp_nape.geom.VecMath;
import zpp_nape.geom.PartitionedPoly;
import zpp_nape.geom.Cutter;
import zpp_nape.geom.Simplify;
import zpp_nape.geom.Ray;
import zpp_nape.geom.Distance;
import zpp_nape.geom.Monotone;
import zpp_nape.geom.PolyIter;
import zpp_nape.geom.AABB;
import zpp_nape.geom.MarchingSquares;
import zpp_nape.geom.Vec2;
import zpp_nape.geom.MatMN;
import zpp_nape.geom.GeomPoly;
import zpp_nape.callbacks.CbSetPair;
import zpp_nape.callbacks.CbSet;
import zpp_nape.geom.Collide;
import zpp_nape.callbacks.Callback;
import zpp_nape.callbacks.Listener;
import zpp_nape.callbacks.CbType;
import zpp_nape.phys.FluidProperties;
import zpp_nape.callbacks.OptionType;
import zpp_nape.phys.FeatureMix;
import zpp_nape.phys.Compound;
import zpp_nape.phys.Interactor;
import zpp_nape.phys.Material;
import zpp_nape.constraint.DistanceJoint;
import zpp_nape.phys.Body;
import zpp_nape.constraint.WeldJoint;
import zpp_nape.constraint.MotorJoint;
import zpp_nape.constraint.Constraint;
import zpp_nape.constraint.AngleJoint;
import zpp_nape.constraint.LinearJoint;
import zpp_nape.constraint.UserConstraint;
import zpp_nape.constraint.LineJoint;
import nape.dynamics.FluidArbiter;
import nape.dynamics.ContactList;
import zpp_nape.constraint.PivotJoint;
import nape.dynamics.InteractionGroupList;
import nape.dynamics.ArbiterType;
import nape.dynamics.ArbiterIterator;
import nape.dynamics.ContactIterator;
import nape.dynamics.InteractionGroupIterator;
import nape.dynamics.InteractionGroup;
import nape.dynamics.InteractionFilter;
import nape.dynamics.ArbiterList;
import nape.dynamics.CollisionArbiter;
import nape.dynamics.Contact;
import nape.space.Broadphase;
import nape.shape.ShapeType;
import nape.shape.ShapeList;
import nape.space.Space;
import nape.shape.Polygon;
import nape.shape.EdgeList;
import nape.shape.ShapeIterator;
import nape.shape.Circle;
import nape.shape.Edge;
import nape.shape.EdgeIterator;
import nape.shape.Shape;
import nape.util.Debug;
import nape.util.BitmapDebug;
import nape.geom.GeomPolyIterator;
import nape.util.ShapeDebug;
import nape.geom.Vec3;
import nape.geom.RayResultIterator;
import nape.geom.GeomPolyList;
import nape.geom.Winding;
import nape.geom.RayResultList;
import nape.geom.Geom;
import nape.geom.Vec2Iterator;
import nape.geom.GeomVertexIterator;
import nape.geom.Mat23;
import nape.geom.Ray;
import nape.geom.RayResult;
import nape.geom.MarchingSquares;
import nape.geom.AABB;
import nape.geom.MatMN;
import nape.geom.Vec2;
import nape.geom.Vec2List;
import nape.callbacks.ListenerList;
import nape.callbacks.ListenerType;
import nape.callbacks.InteractionType;
import nape.callbacks.ConstraintCallback;
import nape.callbacks.CbTypeIterator;
import nape.callbacks.BodyCallback;
import nape.geom.GeomPoly;
import nape.callbacks.Callback;
import nape.callbacks.OptionType;
import nape.callbacks.ListenerIterator;
import nape.callbacks.PreFlag;
import nape.callbacks.Listener;
import nape.callbacks.PreCallback;
import nape.callbacks.CbType;
import nape.callbacks.ConstraintListener;
import nape.callbacks.PreListener;
import nape.callbacks.InteractionCallback;
import nape.callbacks.BodyListener;
import nape.callbacks.CbEvent;
import nape.callbacks.CbTypeList;
import nape.phys.InertiaMode;
import nape.phys.FluidProperties;
import nape.phys.CompoundIterator;
import nape.phys.BodyType;
import nape.callbacks.InteractionListener;
import nape.phys.BodyList;
import nape.phys.GravMassMode;
import nape.phys.MassMode;
import nape.phys.Interactor;
import nape.phys.Compound;
import nape.phys.CompoundList;
import nape.phys.InteractorIterator;
import nape.phys.Material;
import nape.phys.InteractorList;
import nape.phys.BodyIterator;
import nape.constraint.DistanceJoint;
import nape.constraint.WeldJoint;
import nape.constraint.MotorJoint;
import nape.constraint.Constraint;
import nape.constraint.ConstraintIterator;
import nape.constraint.AngleJoint;
import nape.constraint.ConstraintList;
import nape.constraint.LinearJoint;
import nape.constraint.UserConstraint;
import nape.phys.Body;
import nape.constraint.LineJoint;
import nape.constraint.PivotJoint;
#if nape_swc@:keep#end
 class Arbiter{
    public var zpp_inner:ZPP_Arbiter;
    public var id(get_id,never):Int;
    inline function get_id():Int{
        #if(!NAPE_RELEASE_BUILD)if(zpp_inner.inactiveme())throw "Error: Arbiter not currently in use";
        #end
 return zpp_inner.id;
    }
    public var active(get_active,never):Bool;
    inline function get_active():Bool return zpp_inner.active public var isSleeping(get_isSleeping,never):Bool;
    inline function get_isSleeping():Bool{
        #if(!NAPE_RELEASE_BUILD)if(zpp_inner.inactiveme())throw "Error: Arbiter not currently in use";
        #end
 return zpp_inner.sleeping;
    }
    public var type(get_type,never):ArbiterType;
    inline function get_type():ArbiterType{
        return[ArbiterType.COLLISION,ArbiterType.FLUID,ArbiterType.SENSOR][zpp_inner.type];
    }
    #if nape_swc@:keep#end
 public function isCollisionArbiter(){
        return zpp_inner.type==ZPP_Arbiter.COL;
    }
    #if nape_swc@:keep#end
 public function isFluidArbiter(){
        return zpp_inner.type==ZPP_Arbiter.FLUID;
    }
    #if nape_swc@:keep#end
 public function isSensorArbiter(){
        return zpp_inner.type==ZPP_Arbiter.SENSOR;
    }
    public var collisionArbiter(get_collisionArbiter,never):CollisionArbiter;
    inline function get_collisionArbiter():CollisionArbiter{
        return if(isCollisionArbiter())zpp_inner.colarb.outer_zn else null;
    }
    public var fluidArbiter(get_fluidArbiter,never):FluidArbiter;
    inline function get_fluidArbiter():FluidArbiter{
        return if(isFluidArbiter())zpp_inner.fluidarb.outer_zn else null;
    }
    public var shape1(get_shape1,never):Shape;
    inline function get_shape1():Shape{
        #if(!NAPE_RELEASE_BUILD)if(zpp_inner.inactiveme())throw "Error: Arbiter not currently in use";
        #end
 return(zpp_inner.ws1.id>zpp_inner.ws2.id)?zpp_inner.ws2.outer:zpp_inner.ws1.outer;
    }
    public var shape2(get_shape2,never):Shape;
    inline function get_shape2():Shape{
        #if(!NAPE_RELEASE_BUILD)if(zpp_inner.inactiveme())throw "Error: Arbiter not currently in use";
        #end
 return(zpp_inner.ws1.id>zpp_inner.ws2.id)?zpp_inner.ws1.outer:zpp_inner.ws2.outer;
    }
    public var body1(get_body1,never):Body;
    inline function get_body1():Body{
        #if(!NAPE_RELEASE_BUILD)if(zpp_inner.inactiveme())throw "Error: Arbiter not currently in use";
        #end
 return(zpp_inner.ws1.id>zpp_inner.ws2.id)?zpp_inner.b2.outer:zpp_inner.b1.outer;
    }
    public var body2(get_body2,never):Body;
    inline function get_body2():Body{
        #if(!NAPE_RELEASE_BUILD)if(zpp_inner.inactiveme())throw "Error: Arbiter not currently in use";
        #end
 return(zpp_inner.ws1.id>zpp_inner.ws2.id)?zpp_inner.b1.outer:zpp_inner.b2.outer;
    }
    public var state(get_state,never):PreFlag;
    inline function get_state():PreFlag{
        #if(!NAPE_RELEASE_BUILD)if(zpp_inner.inactiveme())throw "Error: Arbiter not currently in use";
        #end
 return switch(zpp_inner.immState){
            case ZPP_Flags.id_ImmState_ACCEPT|ZPP_Flags.id_ImmState_ALWAYS:PreFlag.ACCEPT;
            case ZPP_Flags.id_ImmState_ACCEPT:PreFlag.ACCEPT_ONCE;
            case ZPP_Flags.id_ImmState_IGNORE|ZPP_Flags.id_ImmState_ALWAYS:PreFlag.IGNORE;
            default:PreFlag.IGNORE_ONCE;
        }
    }
    #if nape_swc@:keep#end
 public function totalImpulse(body:Body=null,freshOnly:Bool=false){
        #if(!NAPE_RELEASE_BUILD)if(zpp_inner.inactiveme())throw "Error: Arbiter not currently in use";
        #end
#if(!NAPE_RELEASE_BUILD)if(body!=null&&body!=body1&&body!=body2)throw "Error: Arbiter does not relate to body";
        #end
 return Vec3.get(0,0,0);
    }
    public function new(){
        if(!ZPP_Arbiter.internal){
            #if(!NAPE_RELEASE_BUILD)throw "Error: Cannot instantiate Arbiter derp!";
            #end

        }
    }
    @:keep public function toString(){
        var ret=if(isCollisionArbiter())"CollisionArbiter";
        else if(isFluidArbiter())"FluidArbiter";
        else "SensorArbiter";
        #if NAPE_POOL_STATS ret+="#"+zpp_inner.arbid;
        #end
 if(zpp_inner.cleared)return ret+"(object-pooled)";
        else return ret+"("+shape1.toString()+"|"+shape2.toString()+")"+(isCollisionArbiter()?"["+["SD","DD"][zpp_inner.colarb.stat?0:1]+"]":"")+"<-"+state.toString();
    }
}
