package nape.dynamics;
import zpp_nape.ID;
import zpp_nape.Config;
import zpp_nape.Const;
import zpp_nape.dynamics.SpaceArbiterList;
import zpp_nape.dynamics.InteractionGroup;
import zpp_nape.dynamics.InteractionFilter;
import zpp_nape.dynamics.Contact;
import zpp_nape.space.SweepPhase;
import zpp_nape.dynamics.Arbiter;
import zpp_nape.space.DynAABBPhase;
import zpp_nape.space.Broadphase;
import zpp_nape.shape.Polygon;
import zpp_nape.shape.Circle;
import zpp_nape.shape.Edge;
import zpp_nape.shape.Shape;
import zpp_nape.util.Circular;
import zpp_nape.util.Flags;
import zpp_nape.util.Names;
import zpp_nape.space.Space;
import zpp_nape.util.HaxeMacros;
import zpp_nape.util.FastHash;
import zpp_nape.util.Array2;
import zpp_nape.util.Queue;
import zpp_nape.util.RBTree;
import zpp_nape.util.WrapLists;
import zpp_nape.util.Debug;
import zpp_nape.util.Math;
import zpp_nape.util.UserData;
import zpp_nape.util.DisjointSetForest;
import zpp_nape.util.Pool;
import zpp_nape.geom.MatMath;
import zpp_nape.geom.Vec3;
import zpp_nape.geom.Mat23;
import zpp_nape.geom.Convex;
import zpp_nape.util.Lists;
import zpp_nape.geom.Simple;
import zpp_nape.geom.Triangular;
import zpp_nape.geom.Geom;
import zpp_nape.geom.VecMath;
import zpp_nape.geom.PartitionedPoly;
import zpp_nape.geom.Cutter;
import zpp_nape.geom.Simplify;
import zpp_nape.geom.Ray;
import zpp_nape.geom.Distance;
import zpp_nape.geom.Monotone;
import zpp_nape.geom.PolyIter;
import zpp_nape.geom.AABB;
import zpp_nape.geom.MarchingSquares;
import zpp_nape.geom.Vec2;
import zpp_nape.geom.MatMN;
import zpp_nape.geom.GeomPoly;
import zpp_nape.callbacks.CbSetPair;
import zpp_nape.callbacks.CbSet;
import zpp_nape.geom.Collide;
import zpp_nape.callbacks.Callback;
import zpp_nape.callbacks.Listener;
import zpp_nape.callbacks.CbType;
import zpp_nape.phys.FluidProperties;
import zpp_nape.callbacks.OptionType;
import zpp_nape.phys.FeatureMix;
import zpp_nape.phys.Compound;
import zpp_nape.phys.Interactor;
import zpp_nape.phys.Material;
import zpp_nape.constraint.DistanceJoint;
import zpp_nape.phys.Body;
import zpp_nape.constraint.WeldJoint;
import zpp_nape.constraint.MotorJoint;
import zpp_nape.constraint.Constraint;
import zpp_nape.constraint.AngleJoint;
import zpp_nape.constraint.LinearJoint;
import zpp_nape.constraint.UserConstraint;
import zpp_nape.constraint.LineJoint;
import nape.dynamics.FluidArbiter;
import nape.dynamics.ContactList;
import zpp_nape.constraint.PivotJoint;
import nape.dynamics.Arbiter;
import nape.dynamics.InteractionGroupList;
import nape.dynamics.ArbiterType;
import nape.dynamics.ArbiterIterator;
import nape.dynamics.ContactIterator;
import nape.dynamics.InteractionGroupIterator;
import nape.dynamics.InteractionGroup;
import nape.dynamics.InteractionFilter;
import nape.dynamics.ArbiterList;
import nape.dynamics.Contact;
import nape.space.Broadphase;
import nape.shape.ShapeType;
import nape.shape.ShapeList;
import nape.space.Space;
import nape.shape.Polygon;
import nape.shape.EdgeList;
import nape.shape.ShapeIterator;
import nape.shape.Circle;
import nape.shape.Edge;
import nape.shape.EdgeIterator;
import nape.shape.Shape;
import nape.util.Debug;
import nape.util.BitmapDebug;
import nape.geom.GeomPolyIterator;
import nape.util.ShapeDebug;
import nape.geom.Vec3;
import nape.geom.RayResultIterator;
import nape.geom.GeomPolyList;
import nape.geom.Winding;
import nape.geom.RayResultList;
import nape.geom.Geom;
import nape.geom.Vec2Iterator;
import nape.geom.GeomVertexIterator;
import nape.geom.Mat23;
import nape.geom.Ray;
import nape.geom.RayResult;
import nape.geom.MarchingSquares;
import nape.geom.AABB;
import nape.geom.MatMN;
import nape.geom.Vec2;
import nape.geom.Vec2List;
import nape.callbacks.ListenerList;
import nape.callbacks.ListenerType;
import nape.callbacks.InteractionType;
import nape.callbacks.ConstraintCallback;
import nape.callbacks.CbTypeIterator;
import nape.callbacks.BodyCallback;
import nape.geom.GeomPoly;
import nape.callbacks.Callback;
import nape.callbacks.OptionType;
import nape.callbacks.ListenerIterator;
import nape.callbacks.PreFlag;
import nape.callbacks.Listener;
import nape.callbacks.PreCallback;
import nape.callbacks.CbType;
import nape.callbacks.ConstraintListener;
import nape.callbacks.PreListener;
import nape.callbacks.InteractionCallback;
import nape.callbacks.BodyListener;
import nape.callbacks.CbEvent;
import nape.callbacks.CbTypeList;
import nape.phys.InertiaMode;
import nape.phys.FluidProperties;
import nape.phys.CompoundIterator;
import nape.phys.BodyType;
import nape.callbacks.InteractionListener;
import nape.phys.BodyList;
import nape.phys.GravMassMode;
import nape.phys.MassMode;
import nape.phys.Interactor;
import nape.phys.Compound;
import nape.phys.CompoundList;
import nape.phys.InteractorIterator;
import nape.phys.Material;
import nape.phys.InteractorList;
import nape.phys.BodyIterator;
import nape.constraint.DistanceJoint;
import nape.constraint.WeldJoint;
import nape.constraint.MotorJoint;
import nape.constraint.Constraint;
import nape.constraint.ConstraintIterator;
import nape.constraint.AngleJoint;
import nape.constraint.ConstraintList;
import nape.constraint.LinearJoint;
import nape.constraint.UserConstraint;
import nape.phys.Body;
import nape.constraint.LineJoint;
import nape.constraint.PivotJoint;
#if nape_swc@:keep#end
 class CollisionArbiter extends Arbiter{
    public var contacts(get_contacts,never):ContactList;
    inline function get_contacts():ContactList{
        #if(!NAPE_RELEASE_BUILD)if(zpp_inner.inactiveme())throw "Error: Arbiter not currently in use";
        #end
 if(zpp_inner.colarb.wrap_contacts==null)zpp_inner.colarb.setupcontacts();
        return zpp_inner.colarb.wrap_contacts;
    }
    public var normal(get_normal,set_normal):Vec2;
    inline function get_normal():Vec2{
        #if(!NAPE_RELEASE_BUILD)if(zpp_inner.inactiveme())throw "Error: Arbiter not currently in use";
        #end
 if(zpp_inner.colarb.wrap_normal==null)zpp_inner.colarb.getnormal();
        return zpp_inner.colarb.wrap_normal;
    }
    inline function set_normal(normal:Vec2):Vec2{
        {
            #if(!NAPE_RELEASE_BUILD)if(!zpp_inner.colarb.mutable)throw "Error: CollisionArbiter::normal is only mutable during a pre-handler";
            #end
#if(!NAPE_RELEASE_BUILD)if(normal==null)throw "Error: CollisionArbiter::normal cannot be null";
            #end
 this.normal.set(normal);
        }
        return this.normal;
    }
    public var radius(get_radius,set_radius):Float;
    inline function get_radius():Float{
        #if(!NAPE_RELEASE_BUILD)if(zpp_inner.inactiveme())throw "Error: Arbiter not currently in use";
        #end
 return zpp_inner.colarb.radius;
    }
    inline function set_radius(radius:Float):Float{
        {
            #if(!NAPE_RELEASE_BUILD)if(!zpp_inner.colarb.mutable)throw "Error: CollisionArbiter::radius is only mutable during a pre-handler";
            #end
#if(!NAPE_RELEASE_BUILD)if((radius!=radius))throw "Error: CollisionArbiter::radius cannot be null";
            #end
 zpp_inner.colarb.radius=radius;
        }
        return this.radius;
    }
    #if nape_swc@:keep#end
 public function normalImpulse(body:Body=null,freshOnly:Bool=false){
        #if(!NAPE_RELEASE_BUILD)if(zpp_inner.inactiveme())throw "Error: Arbiter not currently in use";
        #end
#if(!NAPE_RELEASE_BUILD)if(body!=null&&body!=body1&&body!=body2)throw "Error: Arbiter does not relate to body";
        #end
 var retx:Float=0;
        var rety:Float=0;
        {
            #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                !((retx!=retx));
            };
            if(!res)throw "assert("+"!assert_isNaN(retx)"+") :: "+("vec_new(in n: "+"ret"+",in x: "+"0"+",in y: "+"0"+")");
            #end

        };
        {
            #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                !((rety!=rety));
            };
            if(!res)throw "assert("+"!assert_isNaN(rety)"+") :: "+("vec_new(in n: "+"ret"+",in x: "+"0"+",in y: "+"0"+")");
            #end

        };
        var retz:Float=0;
        var colarb=zpp_inner.colarb;
        {
            if(!freshOnly||colarb.oc1.fresh){
                var imp=colarb.oc1.wrapper().normalImpulse(body);
                {
                    var t=(1);
                    {
                        var t=(t);
                        {
                            #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                                !((t!=t));
                            };
                            if(!res)throw "assert("+"!assert_isNaN(t)"+") :: "+("vec_addeq(in a: "+"ret"+",in b: "+"imp."+",in s: "+"t"+")");
                            #end

                        };
                        retx+=imp.x*t;
                        rety+=imp.y*t;
                    };
                    retz+=imp.z*t;
                };
                imp.dispose();
            }
        };
        if(colarb.hc2){
            if(!freshOnly||colarb.oc2.fresh){
                var imp=colarb.oc2.wrapper().normalImpulse(body);
                {
                    var t=(1);
                    {
                        var t=(t);
                        {
                            #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                                !((t!=t));
                            };
                            if(!res)throw "assert("+"!assert_isNaN(t)"+") :: "+("vec_addeq(in a: "+"ret"+",in b: "+"imp."+",in s: "+"t"+")");
                            #end

                        };
                        retx+=imp.x*t;
                        rety+=imp.y*t;
                    };
                    retz+=imp.z*t;
                };
                imp.dispose();
            }
        };
        return Vec3.get(retx,rety,retz);
    }
    #if nape_swc@:keep#end
 public function tangentImpulse(body:Body=null,freshOnly:Bool=false){
        #if(!NAPE_RELEASE_BUILD)if(zpp_inner.inactiveme())throw "Error: Arbiter not currently in use";
        #end
#if(!NAPE_RELEASE_BUILD)if(body!=null&&body!=body1&&body!=body2)throw "Error: Arbiter does not relate to body";
        #end
 var retx:Float=0;
        var rety:Float=0;
        {
            #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                !((retx!=retx));
            };
            if(!res)throw "assert("+"!assert_isNaN(retx)"+") :: "+("vec_new(in n: "+"ret"+",in x: "+"0"+",in y: "+"0"+")");
            #end

        };
        {
            #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                !((rety!=rety));
            };
            if(!res)throw "assert("+"!assert_isNaN(rety)"+") :: "+("vec_new(in n: "+"ret"+",in x: "+"0"+",in y: "+"0"+")");
            #end

        };
        var retz:Float=0;
        var colarb=zpp_inner.colarb;
        {
            if(!freshOnly||colarb.oc1.fresh){
                var imp=colarb.oc1.wrapper().tangentImpulse(body);
                {
                    var t=(1);
                    {
                        var t=(t);
                        {
                            #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                                !((t!=t));
                            };
                            if(!res)throw "assert("+"!assert_isNaN(t)"+") :: "+("vec_addeq(in a: "+"ret"+",in b: "+"imp."+",in s: "+"t"+")");
                            #end

                        };
                        retx+=imp.x*t;
                        rety+=imp.y*t;
                    };
                    retz+=imp.z*t;
                };
                imp.dispose();
            }
        };
        if(colarb.hc2){
            if(!freshOnly||colarb.oc2.fresh){
                var imp=colarb.oc2.wrapper().tangentImpulse(body);
                {
                    var t=(1);
                    {
                        var t=(t);
                        {
                            #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                                !((t!=t));
                            };
                            if(!res)throw "assert("+"!assert_isNaN(t)"+") :: "+("vec_addeq(in a: "+"ret"+",in b: "+"imp."+",in s: "+"t"+")");
                            #end

                        };
                        retx+=imp.x*t;
                        rety+=imp.y*t;
                    };
                    retz+=imp.z*t;
                };
                imp.dispose();
            }
        };
        return Vec3.get(retx,rety,retz);
    }
    #if nape_swc@:keep#end
 public override function totalImpulse(body:Body=null,freshOnly:Bool=false){
        #if(!NAPE_RELEASE_BUILD)if(zpp_inner.inactiveme())throw "Error: Arbiter not currently in use";
        #end
#if(!NAPE_RELEASE_BUILD)if(body!=null&&body!=body1&&body!=body2)throw "Error: Arbiter does not relate to body";
        #end
 var retx:Float=0;
        var rety:Float=0;
        {
            #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                !((retx!=retx));
            };
            if(!res)throw "assert("+"!assert_isNaN(retx)"+") :: "+("vec_new(in n: "+"ret"+",in x: "+"0"+",in y: "+"0"+")");
            #end

        };
        {
            #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                !((rety!=rety));
            };
            if(!res)throw "assert("+"!assert_isNaN(rety)"+") :: "+("vec_new(in n: "+"ret"+",in x: "+"0"+",in y: "+"0"+")");
            #end

        };
        var retz:Float=0;
        var colarb=zpp_inner.colarb;
        {
            if(!freshOnly||colarb.oc1.fresh){
                var imp=colarb.oc1.wrapper().totalImpulse(body);
                {
                    var t=(1);
                    {
                        var t=(t);
                        {
                            #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                                !((t!=t));
                            };
                            if(!res)throw "assert("+"!assert_isNaN(t)"+") :: "+("vec_addeq(in a: "+"ret"+",in b: "+"imp."+",in s: "+"t"+")");
                            #end

                        };
                        retx+=imp.x*t;
                        rety+=imp.y*t;
                    };
                    retz+=imp.z*t;
                };
                imp.dispose();
            }
        };
        if(colarb.hc2){
            if(!freshOnly||colarb.oc2.fresh){
                var imp=colarb.oc2.wrapper().totalImpulse(body);
                {
                    var t=(1);
                    {
                        var t=(t);
                        {
                            #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                                !((t!=t));
                            };
                            if(!res)throw "assert("+"!assert_isNaN(t)"+") :: "+("vec_addeq(in a: "+"ret"+",in b: "+"imp."+",in s: "+"t"+")");
                            #end

                        };
                        retx+=imp.x*t;
                        rety+=imp.y*t;
                    };
                    retz+=imp.z*t;
                };
                imp.dispose();
            }
        };
        return Vec3.get(retx,rety,retz);
    }
    #if nape_swc@:keep#end
 public function rollingImpulse(body:Body=null,freshOnly:Bool=false){
        #if(!NAPE_RELEASE_BUILD)if(zpp_inner.inactiveme())throw "Error: Arbiter not currently in use";
        #end
#if(!NAPE_RELEASE_BUILD)if(body!=null&&body!=body1&&body!=body2)throw "Error: Arbiter does not relate to body";
        #end
 var colarb=zpp_inner.colarb;
        if(!freshOnly||colarb.oc1.fresh)return colarb.oc1.wrapper().rollingImpulse(body);
        else return 0.0;
    }
    public var restitution(get_restitution,never):Float;
    inline function get_restitution():Float{
        #if(!NAPE_RELEASE_BUILD)if(zpp_inner.inactiveme())throw "Error: Arbiter not currently in use";
        #end
 var colarb=zpp_inner.colarb;
        colarb.validate_props();
        return colarb.restitution;
    }
    public var dynamicFriction(get_dynamicFriction,never):Float;
    inline function get_dynamicFriction():Float{
        #if(!NAPE_RELEASE_BUILD)if(zpp_inner.inactiveme())throw "Error: Arbiter not currently in use";
        #end
 var colarb=zpp_inner.colarb;
        colarb.validate_props();
        return colarb.dyn_fric;
    }
    public var staticFriction(get_staticFriction,never):Float;
    inline function get_staticFriction():Float{
        #if(!NAPE_RELEASE_BUILD)if(zpp_inner.inactiveme())throw "Error: Arbiter not currently in use";
        #end
 var colarb=zpp_inner.colarb;
        colarb.validate_props();
        return colarb.stat_fric;
    }
    public var rollingFriction(get_rollingFriction,never):Float;
    inline function get_rollingFriction():Float{
        #if(!NAPE_RELEASE_BUILD)if(zpp_inner.inactiveme())throw "Error: Arbiter not currently in use";
        #end
 var colarb=zpp_inner.colarb;
        colarb.validate_props();
        return colarb.rfric;
    }
    public function new(){
        #if(!NAPE_RELEASE_BUILD)if(!ZPP_Arbiter.internal)throw "Error: Cannot instantiate CollisionArbiter derp!";
        #end
 super();
    }
}
