package nape.dynamics;
import zpp_nape.ID;
import zpp_nape.Config;
import zpp_nape.Const;
import zpp_nape.dynamics.SpaceArbiterList;
import zpp_nape.dynamics.InteractionGroup;
import zpp_nape.dynamics.InteractionFilter;
import zpp_nape.dynamics.Contact;
import zpp_nape.space.SweepPhase;
import zpp_nape.dynamics.Arbiter;
import zpp_nape.space.DynAABBPhase;
import zpp_nape.space.Broadphase;
import zpp_nape.shape.Polygon;
import zpp_nape.shape.Circle;
import zpp_nape.shape.Edge;
import zpp_nape.shape.Shape;
import zpp_nape.util.Circular;
import zpp_nape.util.Flags;
import zpp_nape.util.Names;
import zpp_nape.space.Space;
import zpp_nape.util.HaxeMacros;
import zpp_nape.util.FastHash;
import zpp_nape.util.Array2;
import zpp_nape.util.Queue;
import zpp_nape.util.RBTree;
import zpp_nape.util.WrapLists;
import zpp_nape.util.Debug;
import zpp_nape.util.Math;
import zpp_nape.util.UserData;
import zpp_nape.util.DisjointSetForest;
import zpp_nape.util.Pool;
import zpp_nape.geom.MatMath;
import zpp_nape.geom.Vec3;
import zpp_nape.geom.Mat23;
import zpp_nape.geom.Convex;
import zpp_nape.util.Lists;
import zpp_nape.geom.Simple;
import zpp_nape.geom.Triangular;
import zpp_nape.geom.Geom;
import zpp_nape.geom.VecMath;
import zpp_nape.geom.PartitionedPoly;
import zpp_nape.geom.Cutter;
import zpp_nape.geom.Simplify;
import zpp_nape.geom.Ray;
import zpp_nape.geom.Distance;
import zpp_nape.geom.Monotone;
import zpp_nape.geom.PolyIter;
import zpp_nape.geom.AABB;
import zpp_nape.geom.MarchingSquares;
import zpp_nape.geom.Vec2;
import zpp_nape.geom.MatMN;
import zpp_nape.geom.GeomPoly;
import zpp_nape.callbacks.CbSetPair;
import zpp_nape.callbacks.CbSet;
import zpp_nape.geom.Collide;
import zpp_nape.callbacks.Callback;
import zpp_nape.callbacks.Listener;
import zpp_nape.callbacks.CbType;
import zpp_nape.phys.FluidProperties;
import zpp_nape.callbacks.OptionType;
import zpp_nape.phys.FeatureMix;
import zpp_nape.phys.Compound;
import zpp_nape.phys.Interactor;
import zpp_nape.phys.Material;
import zpp_nape.constraint.DistanceJoint;
import zpp_nape.phys.Body;
import zpp_nape.constraint.WeldJoint;
import zpp_nape.constraint.MotorJoint;
import zpp_nape.constraint.Constraint;
import zpp_nape.constraint.AngleJoint;
import zpp_nape.constraint.LinearJoint;
import zpp_nape.constraint.UserConstraint;
import zpp_nape.constraint.LineJoint;
import nape.dynamics.FluidArbiter;
import nape.dynamics.ContactList;
import zpp_nape.constraint.PivotJoint;
import nape.dynamics.Arbiter;
import nape.dynamics.InteractionGroupList;
import nape.dynamics.ArbiterType;
import nape.dynamics.ArbiterIterator;
import nape.dynamics.ContactIterator;
import nape.dynamics.InteractionGroupIterator;
import nape.dynamics.InteractionGroup;
import nape.dynamics.InteractionFilter;
import nape.dynamics.ArbiterList;
import nape.dynamics.CollisionArbiter;
import nape.space.Broadphase;
import nape.shape.ShapeType;
import nape.shape.ShapeList;
import nape.space.Space;
import nape.shape.Polygon;
import nape.shape.EdgeList;
import nape.shape.ShapeIterator;
import nape.shape.Circle;
import nape.shape.Edge;
import nape.shape.EdgeIterator;
import nape.shape.Shape;
import nape.util.Debug;
import nape.util.BitmapDebug;
import nape.geom.GeomPolyIterator;
import nape.util.ShapeDebug;
import nape.geom.Vec3;
import nape.geom.RayResultIterator;
import nape.geom.GeomPolyList;
import nape.geom.Winding;
import nape.geom.RayResultList;
import nape.geom.Geom;
import nape.geom.Vec2Iterator;
import nape.geom.GeomVertexIterator;
import nape.geom.Mat23;
import nape.geom.Ray;
import nape.geom.RayResult;
import nape.geom.MarchingSquares;
import nape.geom.AABB;
import nape.geom.MatMN;
import nape.geom.Vec2;
import nape.geom.Vec2List;
import nape.callbacks.ListenerList;
import nape.callbacks.ListenerType;
import nape.callbacks.InteractionType;
import nape.callbacks.ConstraintCallback;
import nape.callbacks.CbTypeIterator;
import nape.callbacks.BodyCallback;
import nape.geom.GeomPoly;
import nape.callbacks.Callback;
import nape.callbacks.OptionType;
import nape.callbacks.ListenerIterator;
import nape.callbacks.PreFlag;
import nape.callbacks.Listener;
import nape.callbacks.PreCallback;
import nape.callbacks.CbType;
import nape.callbacks.ConstraintListener;
import nape.callbacks.PreListener;
import nape.callbacks.InteractionCallback;
import nape.callbacks.BodyListener;
import nape.callbacks.CbEvent;
import nape.callbacks.CbTypeList;
import nape.phys.InertiaMode;
import nape.phys.FluidProperties;
import nape.phys.CompoundIterator;
import nape.phys.BodyType;
import nape.callbacks.InteractionListener;
import nape.phys.BodyList;
import nape.phys.GravMassMode;
import nape.phys.MassMode;
import nape.phys.Interactor;
import nape.phys.Compound;
import nape.phys.CompoundList;
import nape.phys.InteractorIterator;
import nape.phys.Material;
import nape.phys.InteractorList;
import nape.phys.BodyIterator;
import nape.constraint.DistanceJoint;
import nape.constraint.WeldJoint;
import nape.constraint.MotorJoint;
import nape.constraint.Constraint;
import nape.constraint.ConstraintIterator;
import nape.constraint.AngleJoint;
import nape.constraint.ConstraintList;
import nape.constraint.LinearJoint;
import nape.constraint.UserConstraint;
import nape.phys.Body;
import nape.constraint.LineJoint;
import nape.constraint.PivotJoint;
#if nape_swc@:keep#end
 class Contact{
    public var zpp_inner:ZPP_Contact;
    public var active(get_active,never):Bool;
    inline function get_active():Bool{
        return zpp_inner.active&&zpp_inner.arbiter!=null&&zpp_inner.arbiter.active;
    }
    public var arbiter(get_arbiter,never):CollisionArbiter;
    inline function get_arbiter():CollisionArbiter{
        return if(zpp_inner.arbiter==null)null else zpp_inner.arbiter.outer.collisionArbiter;
    }
    public var penetration(get_penetration,set_penetration):Float;
    inline function get_penetration():Float{
        #if(!NAPE_RELEASE_BUILD)if(zpp_inner.inactiveme())throw "Error: Contact not currently in use";
        #end
 return(-zpp_inner.dist);
    }
    inline function set_penetration(penetration:Float):Float{
        {
            #if(!NAPE_RELEASE_BUILD)if(!zpp_inner.arbiter.colarb.mutable)throw "Error: Contact::penetration is only mutable within a pre-handler";
            #end
#if(!NAPE_RELEASE_BUILD)if((penetration!=penetration))throw "Error: Contact::penetration cannot be NaN";
            #end
#if(!NAPE_RELEASE_BUILD)if(penetration<=0||penetration==Math.POSITIVE_INFINITY)throw "Error: Contact::penetration must be stritly positive and non-infinite";
            #end
 zpp_inner.dist=-penetration;
        }
        return this.penetration;
    }
    public var position(get_position,set_position):Vec2;
    inline function get_position():Vec2{
        #if(!NAPE_RELEASE_BUILD)if(zpp_inner.inactiveme())throw "Error: Contact not currently in use";
        #end
 if(zpp_inner.wrap_position==null)zpp_inner.getposition();
        return zpp_inner.wrap_position;
    }
    inline function set_position(position:Vec2):Vec2{
        {
            #if(!NAPE_RELEASE_BUILD)if(!zpp_inner.arbiter.colarb.mutable)throw "Error: Contact::position is only mutable within a pre-handler";
            #end
#if(!NAPE_RELEASE_BUILD)if(position==null)throw "Error: Contact::position cannot be null";
            #end
 this.position.set(position);
        }
        return this.position;
    }
    public var fresh(get_fresh,never):Bool;
    inline function get_fresh():Bool{
        #if(!NAPE_RELEASE_BUILD)if(zpp_inner.inactiveme())throw "Error: Contact not currently in use";
        #end
 return zpp_inner.fresh;
    }
    #if nape_swc@:keep#end
 public function normalImpulse(body:Body=null){
        #if(!NAPE_RELEASE_BUILD)if(zpp_inner.inactiveme())throw "Error: Contact not currently in use";
        #end
 var colarb=zpp_inner.arbiter.colarb;
        var cin=zpp_inner.inner;
        var jnAcc=cin.jnAcc+zpp_inner.pjnAcc;
        if(body==null)return Vec3.get(colarb.nx*jnAcc,colarb.ny*jnAcc);
        else{
            #if(!NAPE_RELEASE_BUILD)if(body!=colarb.b1.outer&&body!=colarb.b2.outer)throw "Error: Contact does not relate to the given body";
            #end
 if(body==colarb.b1.outer)return Vec3.get(colarb.nx*-jnAcc,colarb.ny*-jnAcc,-(colarb.ny*cin.r1x-colarb.nx*cin.r1y)*jnAcc);
            else return Vec3.get(colarb.nx*jnAcc,colarb.ny*jnAcc,(colarb.ny*cin.r2x-colarb.nx*cin.r2y)*jnAcc);
        }
    }
    #if nape_swc@:keep#end
 public function tangentImpulse(body:Body=null){
        #if(!NAPE_RELEASE_BUILD)if(zpp_inner.inactiveme())throw "Error: Contact not currently in use";
        #end
 var colarb=zpp_inner.arbiter.colarb;
        var cin=zpp_inner.inner;
        var jtAcc=cin.jtAcc+zpp_inner.pjtAcc;
        if(body==null)return Vec3.get(-colarb.ny*jtAcc,colarb.nx*jtAcc);
        else{
            #if(!NAPE_RELEASE_BUILD)if(body!=colarb.b1.outer&&body!=colarb.b2.outer)throw "Error: Contact does not relate to the given body";
            #end
 if(body==colarb.b1.outer)return Vec3.get(colarb.ny*jtAcc,-colarb.nx*jtAcc,-(cin.r1x*colarb.nx+cin.r1y*colarb.ny)*jtAcc);
            else return Vec3.get(-colarb.ny*jtAcc,colarb.nx*jtAcc,(cin.r2x*colarb.nx+cin.r2y*colarb.ny)*jtAcc);
        }
    }
    #if nape_swc@:keep#end
 public function rollingImpulse(body:Body=null){
        #if(!NAPE_RELEASE_BUILD)if(zpp_inner.inactiveme())throw "Error: Contact not currently in use";
        #end
 var colarb=zpp_inner.arbiter.colarb;
        var jrAcc=zpp_inner.arbiter.colarb.jrAcc+zpp_inner.arbiter.colarb.pjrAcc;
        if(body==null)return jrAcc;
        else{
            #if(!NAPE_RELEASE_BUILD)if(body!=colarb.b1.outer&&body!=colarb.b2.outer)throw "Error: Contact does not relate to the given body";
            #end
 if(body==colarb.b1.outer)return-jrAcc;
            else return jrAcc;
        }
    }
    #if nape_swc@:keep#end
 public function totalImpulse(body:Body=null){
        #if(!NAPE_RELEASE_BUILD)if(zpp_inner.inactiveme())throw "Error: Contact not currently in use";
        #end
 var colarb=zpp_inner.arbiter.colarb;
        var cin=zpp_inner.inner;
        var jnAcc=cin.jnAcc+zpp_inner.pjnAcc;
        var jtAcc=cin.jtAcc+zpp_inner.pjtAcc;
        var jrAcc=colarb.jrAcc+colarb.pjrAcc;
        if(body==null){
            return Vec3.get(colarb.nx*jnAcc-colarb.ny*jtAcc,colarb.ny*jnAcc+colarb.nx*jtAcc,jrAcc);
        }
        else{
            #if(!NAPE_RELEASE_BUILD)if(body!=colarb.b1.outer&&body!=colarb.b2.outer)throw "Error: Contact does not relate to the given body";
            #end
 var jx:Float=colarb.nx*jnAcc-colarb.ny*jtAcc;
            var jy:Float=colarb.ny*jnAcc+colarb.nx*jtAcc;
            {
                #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                    !((jx!=jx));
                };
                if(!res)throw "assert("+"!assert_isNaN(jx)"+") :: "+("vec_new(in n: "+"j"+",in x: "+"colarb.nx*jnAcc-colarb.ny*jtAcc"+",in y: "+"colarb.ny*jnAcc+colarb.nx*jtAcc"+")");
                #end

            };
            {
                #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                    !((jy!=jy));
                };
                if(!res)throw "assert("+"!assert_isNaN(jy)"+") :: "+("vec_new(in n: "+"j"+",in x: "+"colarb.nx*jnAcc-colarb.ny*jtAcc"+",in y: "+"colarb.ny*jnAcc+colarb.nx*jtAcc"+")");
                #end

            };
            if(body==colarb.b1.outer)return Vec3.get(-jx,-jy,-(jy*cin.r1x-jx*cin.r1y)-jrAcc);
            else return Vec3.get(jx,jy,(jy*cin.r2x-jx*cin.r2y)+jrAcc);
        }
    }
    public var restitution(get_restitution,never):Float;
    inline function get_restitution():Float{
        #if(!NAPE_RELEASE_BUILD)if(zpp_inner.inactiveme())throw "Error: Contact not currently in use";
        #end
 return zpp_inner.elasticity;
    }
    public var friction(get_friction,never):Float;
    inline function get_friction():Float{
        #if(!NAPE_RELEASE_BUILD)if(zpp_inner.inactiveme())throw "Error: Contact not currently in use";
        #end
 return zpp_inner.inner.friction;
    }
    public var rollingFriction(get_rollingFriction,never):Float;
    inline function get_rollingFriction():Float{
        #if(!NAPE_RELEASE_BUILD)if(zpp_inner.inactiveme())throw "Error: Contact not currently in use";
        #end
 return zpp_inner.arbiter.colarb.rfric;
    }
    public function new(){
        #if(!NAPE_RELEASE_BUILD)if(!ZPP_Contact.internal)throw "Error: Cannot instantiate Contact derp!";
        #end

    }
    @:keep public function toString(){
        if(zpp_inner.arbiter==null||zpp_inner.arbiter.cleared)return "{object-pooled}";
        else return "{Contact}";
    }
}
