package nape.geom;
import zpp_nape.ID;
import zpp_nape.Config;
import zpp_nape.Const;
import zpp_nape.dynamics.SpaceArbiterList;
import zpp_nape.dynamics.InteractionGroup;
import zpp_nape.dynamics.InteractionFilter;
import zpp_nape.dynamics.Contact;
import zpp_nape.space.SweepPhase;
import zpp_nape.dynamics.Arbiter;
import zpp_nape.space.DynAABBPhase;
import zpp_nape.space.Broadphase;
import zpp_nape.shape.Polygon;
import zpp_nape.shape.Circle;
import zpp_nape.shape.Edge;
import zpp_nape.shape.Shape;
import zpp_nape.util.Circular;
import zpp_nape.util.Flags;
import zpp_nape.util.Names;
import zpp_nape.space.Space;
import zpp_nape.util.HaxeMacros;
import zpp_nape.util.FastHash;
import zpp_nape.util.Array2;
import zpp_nape.util.Queue;
import zpp_nape.util.RBTree;
import zpp_nape.util.WrapLists;
import zpp_nape.util.Debug;
import zpp_nape.util.Math;
import zpp_nape.util.UserData;
import zpp_nape.util.DisjointSetForest;
import zpp_nape.util.Pool;
import zpp_nape.geom.MatMath;
import zpp_nape.geom.Vec3;
import zpp_nape.geom.Mat23;
import zpp_nape.geom.Convex;
import zpp_nape.util.Lists;
import zpp_nape.geom.Simple;
import zpp_nape.geom.Triangular;
import zpp_nape.geom.Geom;
import zpp_nape.geom.VecMath;
import zpp_nape.geom.PartitionedPoly;
import zpp_nape.geom.Cutter;
import zpp_nape.geom.Simplify;
import zpp_nape.geom.Ray;
import zpp_nape.geom.Distance;
import zpp_nape.geom.Monotone;
import zpp_nape.geom.PolyIter;
import zpp_nape.geom.AABB;
import zpp_nape.geom.MarchingSquares;
import zpp_nape.geom.Vec2;
import zpp_nape.geom.MatMN;
import zpp_nape.geom.GeomPoly;
import zpp_nape.callbacks.CbSetPair;
import zpp_nape.callbacks.CbSet;
import zpp_nape.geom.Collide;
import zpp_nape.callbacks.Callback;
import zpp_nape.callbacks.Listener;
import zpp_nape.callbacks.CbType;
import zpp_nape.phys.FluidProperties;
import zpp_nape.callbacks.OptionType;
import zpp_nape.phys.FeatureMix;
import zpp_nape.phys.Compound;
import zpp_nape.phys.Interactor;
import zpp_nape.phys.Material;
import zpp_nape.constraint.DistanceJoint;
import zpp_nape.phys.Body;
import zpp_nape.constraint.WeldJoint;
import zpp_nape.constraint.MotorJoint;
import zpp_nape.constraint.Constraint;
import zpp_nape.constraint.AngleJoint;
import zpp_nape.constraint.LinearJoint;
import zpp_nape.constraint.UserConstraint;
import zpp_nape.constraint.LineJoint;
import nape.dynamics.FluidArbiter;
import nape.dynamics.ContactList;
import zpp_nape.constraint.PivotJoint;
import nape.dynamics.Arbiter;
import nape.dynamics.InteractionGroupList;
import nape.dynamics.ArbiterType;
import nape.dynamics.ArbiterIterator;
import nape.dynamics.ContactIterator;
import nape.dynamics.InteractionGroupIterator;
import nape.dynamics.InteractionGroup;
import nape.dynamics.InteractionFilter;
import nape.dynamics.ArbiterList;
import nape.dynamics.CollisionArbiter;
import nape.dynamics.Contact;
import nape.space.Broadphase;
import nape.shape.ShapeType;
import nape.shape.ShapeList;
import nape.space.Space;
import nape.shape.Polygon;
import nape.shape.EdgeList;
import nape.shape.ShapeIterator;
import nape.shape.Circle;
import nape.shape.Edge;
import nape.shape.EdgeIterator;
import nape.shape.Shape;
import nape.util.Debug;
import nape.util.BitmapDebug;
import nape.geom.GeomPolyIterator;
import nape.util.ShapeDebug;
import nape.geom.Vec3;
import nape.geom.RayResultIterator;
import nape.geom.GeomPolyList;
import nape.geom.Winding;
import nape.geom.RayResultList;
import nape.geom.Geom;
import nape.geom.Vec2Iterator;
import nape.geom.GeomVertexIterator;
import nape.geom.Mat23;
import nape.geom.Ray;
import nape.geom.RayResult;
import nape.geom.MarchingSquares;
import nape.geom.AABB;
import nape.geom.MatMN;
import nape.geom.Vec2;
import nape.geom.Vec2List;
import nape.callbacks.ListenerList;
import nape.callbacks.ListenerType;
import nape.callbacks.InteractionType;
import nape.callbacks.ConstraintCallback;
import nape.callbacks.CbTypeIterator;
import nape.callbacks.BodyCallback;
import nape.callbacks.Callback;
import nape.callbacks.OptionType;
import nape.callbacks.ListenerIterator;
import nape.callbacks.PreFlag;
import nape.callbacks.Listener;
import nape.callbacks.PreCallback;
import nape.callbacks.CbType;
import nape.callbacks.ConstraintListener;
import nape.callbacks.PreListener;
import nape.callbacks.InteractionCallback;
import nape.callbacks.BodyListener;
import nape.callbacks.CbEvent;
import nape.callbacks.CbTypeList;
import nape.phys.InertiaMode;
import nape.phys.FluidProperties;
import nape.phys.CompoundIterator;
import nape.phys.BodyType;
import nape.callbacks.InteractionListener;
import nape.phys.BodyList;
import nape.phys.GravMassMode;
import nape.phys.MassMode;
import nape.phys.Interactor;
import nape.phys.Compound;
import nape.phys.CompoundList;
import nape.phys.InteractorIterator;
import nape.phys.Material;
import nape.phys.InteractorList;
import nape.phys.BodyIterator;
import nape.constraint.DistanceJoint;
import nape.constraint.WeldJoint;
import nape.constraint.MotorJoint;
import nape.constraint.Constraint;
import nape.constraint.ConstraintIterator;
import nape.constraint.AngleJoint;
import nape.constraint.ConstraintList;
import nape.constraint.LinearJoint;
import nape.constraint.UserConstraint;
import nape.phys.Body;
import nape.constraint.LineJoint;
import nape.constraint.PivotJoint;
#if nape_swc@:keep#end
 class GeomPoly{
    public var zpp_inner:ZPP_GeomPoly;
    public#if NAPE_NO_INLINE#else inline#end
 function empty():Bool{
        return(zpp_inner.vertices==null);
    }
    public function size():Int{
        return({
            var ret=0;
            {
                var F=zpp_inner.vertices;
                var L=zpp_inner.vertices;
                if(F!=null){
                    var nite=F;
                    do{
                        var i=nite;
                        {
                            ret++;
                        }
                        nite=nite.next;
                    }
                    while(nite!=L);
                }
            };
            ret;
        });
    }
    public#if NAPE_NO_INLINE#else inline#end
 function iterator():GeomVertexIterator{
        return ZPP_GeomVertexIterator.get(zpp_inner.vertices,true);
    }
    public#if NAPE_NO_INLINE#else inline#end
 function forward_iterator():GeomVertexIterator{
        return ZPP_GeomVertexIterator.get(zpp_inner.vertices,true);
    }
    public#if NAPE_NO_INLINE#else inline#end
 function backwards_iterator():GeomVertexIterator{
        return ZPP_GeomVertexIterator.get(zpp_inner.vertices,false);
    }
    public#if NAPE_NO_INLINE#else inline#end
 function current(){
        #if(!NAPE_RELEASE_BUILD)if(empty()){
            throw "Error: GeomPoly is empty";
        }
        #end
 return zpp_inner.vertices.wrapper();
    }
    public function push(x:Vec2){
        {
            #if(!NAPE_RELEASE_BUILD)if(x!=null&&x.zpp_disp)throw "Error: "+"Vec2"+" has been disposed and cannot be used!";
            #end

        };
        #if(!NAPE_RELEASE_BUILD)if(x==null){
            throw "Error: Cannot push null vertex";
        }
        #end
 zpp_inner.vertices={
            var obj=ZPP_GeomVert.get(x.x,x.y);
            if(zpp_inner.vertices==null)zpp_inner.vertices=obj.prev=obj.next=obj;
            else{
                obj.prev=zpp_inner.vertices;
                obj.next=zpp_inner.vertices.next;
                zpp_inner.vertices.next.prev=obj;
                zpp_inner.vertices.next=obj;
            }
            obj;
        };
        ({
            if(({
                x.zpp_inner.weak;
            })){
                x.dispose();
                true;
            }
            else{
                false;
            }
        });
        return this;
    }
    public function pop(){
        #if(!NAPE_RELEASE_BUILD)if((zpp_inner.vertices==null)){
            throw "Error: Cannot pop from empty polygon";
        }
        #end
 var retv=zpp_inner.vertices;
        zpp_inner.vertices={
            {
                #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                    !(zpp_inner.vertices==null);
                };
                if(!res)throw "assert("+"!(zpp_inner.vertices==null)"+") :: "+("can't pop from empty list derpiderp");
                #end

            };
            if((zpp_inner.vertices!=null&&zpp_inner.vertices.prev==zpp_inner.vertices)){
                zpp_inner.vertices.next=zpp_inner.vertices.prev=null;
                {};
                null;
            }
            else{
                var retnodes=zpp_inner.vertices.prev;
                zpp_inner.vertices.prev.next=zpp_inner.vertices.next;
                zpp_inner.vertices.next.prev=zpp_inner.vertices.prev;
                zpp_inner.vertices.next=zpp_inner.vertices.prev=null;
                {};
                zpp_inner.vertices=null;
                retnodes;
            }
        };
        {
            var o=retv;
            {
                #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                    o!=null;
                };
                if(!res)throw "assert("+"o!=null"+") :: "+("Free(in T: "+"ZPP_GeomVert"+", in obj: "+"retv"+")");
                #end

            };
            o.free();
            o.next=ZPP_GeomVert.zpp_pool;
            ZPP_GeomVert.zpp_pool=o;
            #if NAPE_POOL_STATS ZPP_GeomVert.POOL_CNT++;
            ZPP_GeomVert.POOL_SUB++;
            #end

        };
        return this;
    }
    public function unshift(x:Vec2){
        {
            #if(!NAPE_RELEASE_BUILD)if(x!=null&&x.zpp_disp)throw "Error: "+"Vec2"+" has been disposed and cannot be used!";
            #end

        };
        #if(!NAPE_RELEASE_BUILD)if(x==null){
            throw "Error: Cannot unshift null vertex";
        }
        #end
 zpp_inner.vertices={
            var obj=ZPP_GeomVert.get(x.x,x.y);
            if(zpp_inner.vertices==null)zpp_inner.vertices=obj.prev=obj.next=obj;
            else{
                obj.next=zpp_inner.vertices;
                obj.prev=zpp_inner.vertices.prev;
                zpp_inner.vertices.prev.next=obj;
                zpp_inner.vertices.prev=obj;
            }
            obj;
        };
        ({
            if(({
                x.zpp_inner.weak;
            })){
                x.dispose();
                true;
            }
            else{
                false;
            }
        });
        return this;
    }
    public function shift(){
        #if(!NAPE_RELEASE_BUILD)if((zpp_inner.vertices==null)){
            throw "Error: Cannot shift from empty polygon";
        }
        #end
 var retv=zpp_inner.vertices;
        zpp_inner.vertices={
            {
                #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                    !(zpp_inner.vertices==null);
                };
                if(!res)throw "assert("+"!(zpp_inner.vertices==null)"+") :: "+("can't pop from empty list herpaderp");
                #end

            };
            if((zpp_inner.vertices!=null&&zpp_inner.vertices.prev==zpp_inner.vertices)){
                zpp_inner.vertices.next=zpp_inner.vertices.prev=null;
                {};
                zpp_inner.vertices=null;
            }
            else{
                var retnodes=zpp_inner.vertices.next;
                zpp_inner.vertices.prev.next=zpp_inner.vertices.next;
                zpp_inner.vertices.next.prev=zpp_inner.vertices.prev;
                zpp_inner.vertices.next=zpp_inner.vertices.prev=null;
                {};
                zpp_inner.vertices=null;
                retnodes;
            }
        };
        {
            var o=retv;
            {
                #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                    o!=null;
                };
                if(!res)throw "assert("+"o!=null"+") :: "+("Free(in T: "+"ZPP_GeomVert"+", in obj: "+"retv"+")");
                #end

            };
            o.free();
            o.next=ZPP_GeomVert.zpp_pool;
            ZPP_GeomVert.zpp_pool=o;
            #if NAPE_POOL_STATS ZPP_GeomVert.POOL_CNT++;
            ZPP_GeomVert.POOL_SUB++;
            #end

        };
        return this;
    }
    public function skip_forward(times:Int){
        if(!(zpp_inner.vertices==null)){
            if(times>0){
                while(times-->0)zpp_inner.vertices=zpp_inner.vertices.next;
            }
            else if(times<0){
                while(times++<0)zpp_inner.vertices=zpp_inner.vertices.prev;
            }
        }
        return this;
    }
    public#if NAPE_NO_INLINE#else inline#end
 function skip_backwards(times:Int){
        return skip_forward(-times);
    }
    public function erase(count:Int){
        while(count!=0&&!(zpp_inner.vertices==null)){
            var retv=zpp_inner.vertices;
            if(count>0){
                zpp_inner.vertices={
                    {
                        #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                            !(zpp_inner.vertices==null);
                        };
                        if(!res)throw "assert("+"!(zpp_inner.vertices==null)"+") :: "+("can't pop from empty list herpaderp");
                        #end

                    };
                    if((zpp_inner.vertices!=null&&zpp_inner.vertices.prev==zpp_inner.vertices)){
                        zpp_inner.vertices.next=zpp_inner.vertices.prev=null;
                        {};
                        zpp_inner.vertices=null;
                    }
                    else{
                        var retnodes=zpp_inner.vertices.next;
                        zpp_inner.vertices.prev.next=zpp_inner.vertices.next;
                        zpp_inner.vertices.next.prev=zpp_inner.vertices.prev;
                        zpp_inner.vertices.next=zpp_inner.vertices.prev=null;
                        {};
                        zpp_inner.vertices=null;
                        retnodes;
                    }
                };
                count--;
            }
            else if(count<0){
                zpp_inner.vertices={
                    {
                        #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                            !(zpp_inner.vertices==null);
                        };
                        if(!res)throw "assert("+"!(zpp_inner.vertices==null)"+") :: "+("can't pop from empty list derpiderp");
                        #end

                    };
                    if((zpp_inner.vertices!=null&&zpp_inner.vertices.prev==zpp_inner.vertices)){
                        zpp_inner.vertices.next=zpp_inner.vertices.prev=null;
                        {};
                        null;
                    }
                    else{
                        var retnodes=zpp_inner.vertices.prev;
                        zpp_inner.vertices.prev.next=zpp_inner.vertices.next;
                        zpp_inner.vertices.next.prev=zpp_inner.vertices.prev;
                        zpp_inner.vertices.next=zpp_inner.vertices.prev=null;
                        {};
                        zpp_inner.vertices=null;
                        retnodes;
                    }
                };
                count++;
            }
            {
                var o=retv;
                {
                    #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                        o!=null;
                    };
                    if(!res)throw "assert("+"o!=null"+") :: "+("Free(in T: "+"ZPP_GeomVert"+", in obj: "+"retv"+")");
                    #end

                };
                o.free();
                o.next=ZPP_GeomVert.zpp_pool;
                ZPP_GeomVert.zpp_pool=o;
                #if NAPE_POOL_STATS ZPP_GeomVert.POOL_CNT++;
                ZPP_GeomVert.POOL_SUB++;
                #end

            };
        }
        return this;
    }
    public function clear():GeomPoly{
        {
            while(!(zpp_inner.vertices==null)){
                var tmp=zpp_inner.vertices;
                zpp_inner.vertices={
                    {
                        #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                            !(zpp_inner.vertices==null);
                        };
                        if(!res)throw "assert("+"!(zpp_inner.vertices==null)"+") :: "+("can't pop from empty list herpaderp");
                        #end

                    };
                    if((zpp_inner.vertices!=null&&zpp_inner.vertices.prev==zpp_inner.vertices)){
                        zpp_inner.vertices.next=zpp_inner.vertices.prev=null;
                        {};
                        zpp_inner.vertices=null;
                    }
                    else{
                        var retnodes=zpp_inner.vertices.next;
                        zpp_inner.vertices.prev.next=zpp_inner.vertices.next;
                        zpp_inner.vertices.next.prev=zpp_inner.vertices.prev;
                        zpp_inner.vertices.next=zpp_inner.vertices.prev=null;
                        {};
                        zpp_inner.vertices=null;
                        retnodes;
                    }
                };
                {
                    var o=tmp;
                    {
                        #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                            o!=null;
                        };
                        if(!res)throw "assert("+"o!=null"+") :: "+("Free(in T: "+"ZPP_GeomVert"+", in obj: "+"tmp"+")");
                        #end

                    };
                    o.free();
                    o.next=ZPP_GeomVert.zpp_pool;
                    ZPP_GeomVert.zpp_pool=o;
                    #if NAPE_POOL_STATS ZPP_GeomVert.POOL_CNT++;
                    ZPP_GeomVert.POOL_SUB++;
                    #end

                };
            }
        };
        return this;
    }
    public function copy():GeomPoly{
        var ret=new GeomPoly();
        {
            var F=zpp_inner.vertices;
            var L=zpp_inner.vertices;
            if(F!=null){
                var nite=F;
                do{
                    var v=nite;
                    {
                        {
                            ret.zpp_inner.vertices={
                                var obj=ZPP_GeomVert.get(v.x,v.y);
                                if(ret.zpp_inner.vertices==null)ret.zpp_inner.vertices=obj.prev=obj.next=obj;
                                else{
                                    obj.prev=ret.zpp_inner.vertices;
                                    obj.next=ret.zpp_inner.vertices.next;
                                    ret.zpp_inner.vertices.next.prev=obj;
                                    ret.zpp_inner.vertices.next=obj;
                                }
                                obj;
                            };
                        };
                    }
                    nite=nite.next;
                }
                while(nite!=L);
            }
        };
        return ret;
    }
    public function new(vertices:Dynamic=null){
        zpp_inner=new ZPP_GeomPoly(this);
        if(vertices!=null){
            {
                if(Std.is(vertices,Array)){
                    var lv:Array<Dynamic>=vertices;
                    for(vite in lv){
                        #if(!NAPE_RELEASE_BUILD)if(vite==null)throw "Error: Array<Vec2> contains null objects";
                        #end
#if(!NAPE_RELEASE_BUILD)if(!Std.is(vite,Vec2))throw "Error: Array<Vec2> contains non Vec2 objects";
                        #end
 var v:Vec2=vite;
                        {
                            #if(!NAPE_RELEASE_BUILD)if(v!=null&&v.zpp_disp)throw "Error: "+"Vec2"+" has been disposed and cannot be used!";
                            #end

                        };
                        {
                            zpp_inner.vertices={
                                var obj=ZPP_GeomVert.get(v.x,v.y);
                                if(zpp_inner.vertices==null)zpp_inner.vertices=obj.prev=obj.next=obj;
                                else{
                                    obj.prev=zpp_inner.vertices;
                                    obj.next=zpp_inner.vertices.next;
                                    zpp_inner.vertices.next.prev=obj;
                                    zpp_inner.vertices.next=obj;
                                }
                                obj;
                            };
                        };
                    }
                }
                else if(#if flash10 Std.is(vertices,ZPP_Const.vec2vector)#else false#end
){
                    #if flash10 var lv:flash.Vector<Vec2>=vertices;
                    for(vite in lv){
                        #if(!NAPE_RELEASE_BUILD)if(vite==null)throw "Error: flash.Vector<Vec2> contains null objects";
                        #end
 var v:Vec2=vite;
                        {
                            #if(!NAPE_RELEASE_BUILD)if(v!=null&&v.zpp_disp)throw "Error: "+"Vec2"+" has been disposed and cannot be used!";
                            #end

                        };
                        {
                            zpp_inner.vertices={
                                var obj=ZPP_GeomVert.get(v.x,v.y);
                                if(zpp_inner.vertices==null)zpp_inner.vertices=obj.prev=obj.next=obj;
                                else{
                                    obj.prev=zpp_inner.vertices;
                                    obj.next=zpp_inner.vertices.next;
                                    zpp_inner.vertices.next.prev=obj;
                                    zpp_inner.vertices.next=obj;
                                }
                                obj;
                            };
                        };
                    }
                    #end

                }
                else if(Std.is(vertices,Vec2List)){
                    var lv:Vec2List=vertices;
                    for(v in lv){
                        #if(!NAPE_RELEASE_BUILD)if(v==null)throw "Error: Vec2List contains null objects";
                        #end
{
                            #if(!NAPE_RELEASE_BUILD)if(v!=null&&v.zpp_disp)throw "Error: "+"Vec2"+" has been disposed and cannot be used!";
                            #end

                        };
                        {
                            zpp_inner.vertices={
                                var obj=ZPP_GeomVert.get(v.x,v.y);
                                if(zpp_inner.vertices==null)zpp_inner.vertices=obj.prev=obj.next=obj;
                                else{
                                    obj.prev=zpp_inner.vertices;
                                    obj.next=zpp_inner.vertices.next;
                                    zpp_inner.vertices.next.prev=obj;
                                    zpp_inner.vertices.next=obj;
                                }
                                obj;
                            };
                        };
                    }
                }
                else if(Std.is(vertices,GeomPoly)){
                    var lv:GeomPoly=vertices;
                    var verts:ZPP_GeomVert=lv.zpp_inner.vertices;
                    if(verts!=null){
                        var vite=verts;
                        do{
                            var v=Vec2.get(vite.x,vite.y);
                            vite=vite.next;
                            {
                                zpp_inner.vertices={
                                    var obj=ZPP_GeomVert.get(v.x,v.y);
                                    if(zpp_inner.vertices==null)zpp_inner.vertices=obj.prev=obj.next=obj;
                                    else{
                                        obj.prev=zpp_inner.vertices;
                                        obj.next=zpp_inner.vertices.next;
                                        zpp_inner.vertices.next.prev=obj;
                                        zpp_inner.vertices.next=obj;
                                    }
                                    obj;
                                };
                            };
                            v.dispose();
                        }
                        while(vite!=verts);
                    }
                }
                else{
                    #if(!NAPE_RELEASE_BUILD)throw "Error: Invalid type for polygon object, should be Array<Vec2>, Vec2List, GeomPoly or for flash10+ flash.Vector<Vec2>";
                    #end

                }
            };
            {
                if(Std.is(vertices,Array)){
                    var lv:Array<Vec2>=vertices;
                    var i=0;
                    while(i<lv.length){
                        var cur=lv[i];
                        if(({
                            if(({
                                cur.zpp_inner.weak;
                            })){
                                cur.dispose();
                                true;
                            }
                            else{
                                false;
                            }
                        })){
                            lv.splice(i,1);
                            continue;
                        }
                        i++;
                    }
                }
                else if(#if flash10 Std.is(vertices,ZPP_Const.vec2vector)#else false#end
){
                    #if flash10 var lv:flash.Vector<Vec2>=vertices;
                    if(!lv.fixed){
                        var i:UInt=0;
                        while(i<lv.length){
                            var cur=lv[i];
                            if(({
                                if(({
                                    cur.zpp_inner.weak;
                                })){
                                    cur.dispose();
                                    true;
                                }
                                else{
                                    false;
                                }
                            })){
                                lv.splice(i,1);
                                continue;
                            }
                            i++;
                        }
                    }
                    #end

                }
                else if(Std.is(vertices,Vec2List)){
                    var lv:Vec2List=vertices;
                    if(lv.zpp_inner._validate!=null)lv.zpp_inner._validate();
                    var ins=lv.zpp_inner.inner;
                    var pre=null;
                    var cur=ins.begin();
                    while(cur!=null){
                        var x=cur.elem();
                        if(({
                            x.outer.zpp_inner.weak;
                        })){
                            cur=ins.erase(pre);
                            ({
                                if(({
                                    x.outer.zpp_inner.weak;
                                })){
                                    x.outer.dispose();
                                    true;
                                }
                                else{
                                    false;
                                }
                            });
                        }
                        else{
                            pre=cur;
                            cur=cur.next;
                        }
                    }
                }
            };
        }
    }
    @:keep public function toString():String{
        var ret="GeomPoly[";
        {
            {
                var F=zpp_inner.vertices;
                var L=zpp_inner.vertices;
                if(F!=null){
                    var nite=F;
                    do{
                        var v=nite;
                        {
                            {
                                if(v!=zpp_inner.vertices)ret+=",";
                                ret+="{"+v.x+","+v.y+"}";
                            };
                        }
                        nite=nite.next;
                    }
                    while(nite!=L);
                }
            };
        }
        return ret+"]";
    }
    public function area():Float{
        return if(({
            zpp_inner.vertices==null||zpp_inner.vertices.next==null||zpp_inner.vertices.prev==zpp_inner.vertices.next;
        }))0.0 else({
            var ret=({
                {
                    #if NAPE_ASSERT if(({
                        var ret=0;
                        {
                            var F=zpp_inner.vertices;
                            var L=zpp_inner.vertices;
                            if(F!=null){
                                var nite=F;
                                do{
                                    var i=nite;
                                    {
                                        ret++;
                                    }
                                    nite=nite.next;
                                }
                                while(nite!=L);
                            }
                        };
                        ret;
                    })<3){
                        throw "Error: Method requires that polygon has atleast 3 vertices";
                    }
                    #end

                };
                var area=0.0;
                {
                    var F=zpp_inner.vertices;
                    var L=zpp_inner.vertices;
                    if(F!=null){
                        var nite=F;
                        do{
                            var v=nite;
                            {
                                {
                                    area+=v.x*(v.next.y-v.prev.y);
                                };
                            }
                            nite=nite.next;
                        }
                        while(nite!=L);
                    }
                };
                area;
            });
            if(ret<0)(-ret)else ret;
        });
    }
    public function winding():Winding{
        if(({
            zpp_inner.vertices==null||zpp_inner.vertices.next==null||zpp_inner.vertices.prev==zpp_inner.vertices.next;
        })){
            return Winding.UNDEFINED;
        }
        else{
            var area=({
                {
                    #if NAPE_ASSERT if(({
                        var ret=0;
                        {
                            var F=zpp_inner.vertices;
                            var L=zpp_inner.vertices;
                            if(F!=null){
                                var nite=F;
                                do{
                                    var i=nite;
                                    {
                                        ret++;
                                    }
                                    nite=nite.next;
                                }
                                while(nite!=L);
                            }
                        };
                        ret;
                    })<3){
                        throw "Error: Method requires that polygon has atleast 3 vertices";
                    }
                    #end

                };
                var area=0.0;
                {
                    var F=zpp_inner.vertices;
                    var L=zpp_inner.vertices;
                    if(F!=null){
                        var nite=F;
                        do{
                            var v=nite;
                            {
                                {
                                    area+=v.x*(v.next.y-v.prev.y);
                                };
                            }
                            nite=nite.next;
                        }
                        while(nite!=L);
                    }
                };
                area;
            });
            return if(area>0)Winding.CLOCKWISE else if(area==0)Winding.UNDEFINED else Winding.ANTICLOCKWISE;
        }
    }
    public function contains(point:Vec2):Bool{
        {
            #if(!NAPE_RELEASE_BUILD)if(point!=null&&point.zpp_disp)throw "Error: "+"Vec2"+" has been disposed and cannot be used!";
            #end

        };
        #if(!NAPE_RELEASE_BUILD)if(point==null){
            throw "Error: GeomPoly::contains point cannot be null";
        }
        #end
 var ret=({
            var x=point.x;
            var y=point.y;
            var ret=false;
            {
                var F=zpp_inner.vertices;
                var L=zpp_inner.vertices;
                if(F!=null){
                    var nite=F;
                    do{
                        var p=nite;
                        {
                            {
                                var q=p.prev;
                                if((p.y<y&&q.y>=y||q.y<y&&p.y>=y)&&(p.x<=x||q.x<=x)){
                                    if((p.x+(y-p.y)/(q.y-p.y)*(q.x-p.x))<x){
                                        ret=!ret;
                                    }
                                }
                            };
                        }
                        nite=nite.next;
                    }
                    while(nite!=L);
                }
            };
            ret;
        });
        ({
            if(({
                point.zpp_inner.weak;
            })){
                point.dispose();
                true;
            }
            else{
                false;
            }
        });
        return ret;
    }
    public function isClockwise():Bool{
        return winding()==Winding.CLOCKWISE;
    }
    public function isConvex():Bool{
        return if(({
            zpp_inner.vertices==null||zpp_inner.vertices.next==null||zpp_inner.vertices.prev==zpp_inner.vertices.next;
        }))true else({
            {
                #if NAPE_ASSERT if(({
                    var ret=0;
                    {
                        var F=zpp_inner.vertices;
                        var L=zpp_inner.vertices;
                        if(F!=null){
                            var nite=F;
                            do{
                                var i=nite;
                                {
                                    ret++;
                                }
                                nite=nite.next;
                            }
                            while(nite!=L);
                        }
                    };
                    ret;
                })<3){
                    throw "Error: Method requires that polygon has atleast 3 vertices";
                }
                #end

            };
            var neg=false;
            var pos=false;
            var ret=true;
            {
                var F=zpp_inner.vertices;
                var L=zpp_inner.vertices;
                if(F!=null){
                    var nite=F;
                    do{
                        var v=nite;
                        {
                            {
                                var u=v.prev;
                                var w=v.next;
                                var ax:Float;
                                var ay:Float;
                                {
                                    ax=w.x-v.x;
                                    ay=w.y-v.y;
                                };
                                var bx:Float;
                                var by:Float;
                                {
                                    bx=v.x-u.x;
                                    by=v.y-u.y;
                                };
                                var dot=(by*ax-bx*ay);
                                if(dot>0.0){
                                    pos=true;
                                }
                                else if(dot<0.0){
                                    neg=true;
                                }
                                if(pos&&neg){
                                    ret=false;
                                    break;
                                }
                            };
                        }
                        nite=nite.next;
                    }
                    while(nite!=L);
                }
            };
            ret;
        });
    }
    public function isSimple():Bool{
        return if(({
            zpp_inner.vertices==null||zpp_inner.vertices.next==null||zpp_inner.vertices.prev==zpp_inner.vertices.next;
        }))true else ZPP_Simple.isSimple(zpp_inner.vertices);
    }
    public function isMonotone():Bool{
        return if(({
            zpp_inner.vertices==null||zpp_inner.vertices.next==null||zpp_inner.vertices.prev==zpp_inner.vertices.next;
        }))true else ZPP_Monotone.isMonotone(zpp_inner.vertices);
    }
    public function isDegenerate():Bool{
        return if(({
            zpp_inner.vertices==null||zpp_inner.vertices.next==null||zpp_inner.vertices.prev==zpp_inner.vertices.next;
        }))true else area()<ZPP_Const.EPSILON;
    }
    public function simplify(epsilon:Float):GeomPoly{
        #if(!NAPE_RELEASE_BUILD)if(epsilon<=0.0){
            throw "Error: Epsilon should be > 0 for simplifying a GeomPoly";
        }
        #end
 if(({
            zpp_inner.vertices==null||zpp_inner.vertices.next==null||zpp_inner.vertices.prev==zpp_inner.vertices.next;
        })){
            return copy();
        }
        else{
            var x=ZPP_Simplify.simplify(zpp_inner.vertices,epsilon);
            var ret=new GeomPoly();
            ret.zpp_inner.vertices=x;
            return ret;
        }
    }
    public function simple_decomposition():GeomPolyList{
        #if(!NAPE_RELEASE_BUILD)if(({
            zpp_inner.vertices==null||zpp_inner.vertices.next==null||zpp_inner.vertices.prev==zpp_inner.vertices.next;
        })){
            throw "Error: Cannot decompose a degenerate polygon";
        }
        #end
 var MPs=ZPP_Simple.decompose(zpp_inner.vertices);
        var ret=new GeomPolyList();
        while(!MPs.empty()){
            var MP=MPs.pop_unsafe();
            var x=new GeomPoly();
            x.zpp_inner.vertices=MP;
            ret.add(x);
        }
        return ret;
    }
    public function monotone_decomposition():GeomPolyList{
        #if(!NAPE_RELEASE_BUILD)if(({
            zpp_inner.vertices==null||zpp_inner.vertices.next==null||zpp_inner.vertices.prev==zpp_inner.vertices.next;
        })){
            throw "Error: Cannot decompose a degenerate polygon";
        }
        #end
 var MPs=ZPP_Monotone.decompose(zpp_inner.vertices).extract();
        var ret=new GeomPolyList();
        while(!MPs.empty()){
            var MP=MPs.pop_unsafe();
            var x=new GeomPoly();
            x.zpp_inner.vertices=MP;
            ret.add(x);
            {
                #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                    x.isMonotone();
                };
                if(!res)throw "assert("+"x.isMonotone()"+") :: "+("monotone decomposition gave non-monotone output?");
                #end

            };
        }
        return ret;
    }
    public function convex_decomposition():GeomPolyList{
        #if(!NAPE_RELEASE_BUILD)if(({
            zpp_inner.vertices==null||zpp_inner.vertices.next==null||zpp_inner.vertices.prev==zpp_inner.vertices.next;
        })){
            throw "Error: Cannot decompose a degenerate polygon";
        }
        #end
 var MPs=ZPP_Monotone.decompose(zpp_inner.vertices).extract_partitions();
        var ret=new GeomPolyList();
        while(!MPs.empty()){
            var MP=MPs.pop_unsafe();
            ZPP_Triangular.triangulate(MP);
            ZPP_Convex.optimise(MP);
            var MQs=MP.extract();
            while(!MQs.empty()){
                var MQ=MQs.pop_unsafe();
                var x=new GeomPoly();
                x.zpp_inner.vertices=MQ;
                ret.add(x);
                {
                    #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                        x.isConvex();
                    };
                    if(!res)throw "assert("+"x.isConvex()"+") :: "+("convex decomposition gave non-convex output?");
                    #end

                };
            }
        }
        return ret;
    }
    public function triangular_decomposition():GeomPolyList{
        #if(!NAPE_RELEASE_BUILD)if(({
            zpp_inner.vertices==null||zpp_inner.vertices.next==null||zpp_inner.vertices.prev==zpp_inner.vertices.next;
        })){
            throw "Error: Cannot decompose a degenerate polygon";
        }
        #end
 var MPs=ZPP_Monotone.decompose(zpp_inner.vertices).extract_partitions();
        var ret=new GeomPolyList();
        while(!MPs.empty()){
            var MP=MPs.pop_unsafe();
            var MQs=ZPP_Triangular.triangulate(MP).extract();
            while(!MQs.empty()){
                var MQ=MQs.pop_unsafe();
                var x=new GeomPoly();
                x.zpp_inner.vertices=MQ;
                ret.add(x);
                {
                    #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                        x.size()==3;
                    };
                    if(!res)throw "assert("+"x.size()==3"+") :: "+("triangular decomosition gave non-triangle output?");
                    #end

                };
            }
        }
        return ret;
    }
    public function cut(start:Vec2,end:Vec2,bounded_start:Bool=false,bounded_end:Bool=false):GeomPolyList{
        #if(!NAPE_RELEASE_BUILD)if(!isSimple()){
            throw "Error: Cut requires a truly simple polygon";
        }
        if(start==null||end==null){
            throw "Error: Cannot cut with null start/end's";
        }
        #end
{
            #if(!NAPE_RELEASE_BUILD)if(start!=null&&start.zpp_disp)throw "Error: "+"Vec2"+" has been disposed and cannot be used!";
            #end

        };
        {
            #if(!NAPE_RELEASE_BUILD)if(end!=null&&end.zpp_disp)throw "Error: "+"Vec2"+" has been disposed and cannot be used!";
            #end

        };
        var ret=ZPP_Cutter.run(zpp_inner.vertices,start,end,bounded_start,bounded_end);
        ({
            if(({
                start.zpp_inner.weak;
            })){
                start.dispose();
                true;
            }
            else{
                false;
            }
        });
        ({
            if(({
                end.zpp_inner.weak;
            })){
                end.dispose();
                true;
            }
            else{
                false;
            }
        });
        return ret;
    }
    public function transform(matrix:Mat23):GeomPoly{
        #if(!NAPE_RELEASE_BUILD)if(matrix==null){
            throw "Error: Cannot transform by null matrix";
        }
        #end
{
            var F=zpp_inner.vertices;
            var L=zpp_inner.vertices;
            if(F!=null){
                var nite=F;
                do{
                    var v=nite;
                    {
                        {
                            {
                                var t=matrix.a*v.x+matrix.b*v.y+matrix.tx;
                                v.y=matrix.c*v.x+matrix.d*v.y+matrix.ty;
                                v.x=t;
                            };
                        };
                    }
                    nite=nite.next;
                }
                while(nite!=L);
            }
        };
        return this;
    }
    public function bounds():AABB{
        #if(!NAPE_RELEASE_BUILD)if(empty()){
            throw "Error: empty GeomPoly has no defineable bounds";
        }
        #end
 var minx:Float=ZPP_Const.FMAX;
        var miny:Float=ZPP_Const.FMAX;
        {
            #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                !((minx!=minx));
            };
            if(!res)throw "assert("+"!assert_isNaN(minx)"+") :: "+("vec_new(in n: "+"min"+",in x: "+"ZPP_Const.FMAX"+",in y: "+"ZPP_Const.FMAX"+")");
            #end

        };
        {
            #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                !((miny!=miny));
            };
            if(!res)throw "assert("+"!assert_isNaN(miny)"+") :: "+("vec_new(in n: "+"min"+",in x: "+"ZPP_Const.FMAX"+",in y: "+"ZPP_Const.FMAX"+")");
            #end

        };
        var maxx:Float=-ZPP_Const.FMAX;
        var maxy:Float=-ZPP_Const.FMAX;
        {
            #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                !((maxx!=maxx));
            };
            if(!res)throw "assert("+"!assert_isNaN(maxx)"+") :: "+("vec_new(in n: "+"max"+",in x: "+"-ZPP_Const.FMAX"+",in y: "+"-ZPP_Const.FMAX"+")");
            #end

        };
        {
            #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                !((maxy!=maxy));
            };
            if(!res)throw "assert("+"!assert_isNaN(maxy)"+") :: "+("vec_new(in n: "+"max"+",in x: "+"-ZPP_Const.FMAX"+",in y: "+"-ZPP_Const.FMAX"+")");
            #end

        };
        {
            var F=zpp_inner.vertices;
            var L=zpp_inner.vertices;
            if(F!=null){
                var nite=F;
                do{
                    var v=nite;
                    {
                        {
                            if(v.x<minx)minx=v.x;
                            if(v.y<miny)miny=v.y;
                            if(v.x>maxx)maxx=v.x;
                            if(v.y>maxy)maxy=v.y;
                        };
                    }
                    nite=nite.next;
                }
                while(nite!=L);
            }
        };
        return new AABB(minx,miny,maxx-minx,maxy-miny);
    }
    public function top():Vec2{
        #if(!NAPE_RELEASE_BUILD)if(empty()){
            throw "Error: empty GeomPoly has no defineable topmost vertex";
        }
        #end
 var min=zpp_inner.vertices;
        {
            var F=zpp_inner.vertices.next;
            var L=zpp_inner.vertices;
            if(F!=null){
                var nite=F;
                do{
                    var v=nite;
                    {
                        if(v.y<min.y)min=v;
                    }
                    nite=nite.next;
                }
                while(nite!=L);
            }
        };
        return min.wrapper();
    }
    public function bottom():Vec2{
        #if(!NAPE_RELEASE_BUILD)if(empty()){
            throw "Error: empty GeomPoly has no defineable bottommost vertex";
        }
        #end
 var max=zpp_inner.vertices;
        {
            var F=zpp_inner.vertices.next;
            var L=zpp_inner.vertices;
            if(F!=null){
                var nite=F;
                do{
                    var v=nite;
                    {
                        if(v.y>max.y)max=v;
                    }
                    nite=nite.next;
                }
                while(nite!=L);
            }
        };
        return max.wrapper();
    }
    public function left():Vec2{
        #if(!NAPE_RELEASE_BUILD)if(empty()){
            throw "Error: empty GeomPoly has no defineable leftmost vertex";
        }
        #end
 var min=zpp_inner.vertices;
        {
            var F=zpp_inner.vertices.next;
            var L=zpp_inner.vertices;
            if(F!=null){
                var nite=F;
                do{
                    var v=nite;
                    {
                        if(v.x<min.x)min=v;
                    }
                    nite=nite.next;
                }
                while(nite!=L);
            }
        };
        return min.wrapper();
    }
    public function right():Vec2{
        #if(!NAPE_RELEASE_BUILD)if(empty()){
            throw "Error: empty GeomPoly has no defineable rightmmost vertex";
        }
        #end
 var max=zpp_inner.vertices;
        {
            var F=zpp_inner.vertices.next;
            var L=zpp_inner.vertices;
            if(F!=null){
                var nite=F;
                do{
                    var v=nite;
                    {
                        if(v.x>max.x)max=v;
                    }
                    nite=nite.next;
                }
                while(nite!=L);
            }
        };
        return max.wrapper();
    }
}
