package nape.geom;
import zpp_nape.ID;
import zpp_nape.Config;
import zpp_nape.Const;
import zpp_nape.dynamics.SpaceArbiterList;
import zpp_nape.dynamics.InteractionGroup;
import zpp_nape.dynamics.InteractionFilter;
import zpp_nape.dynamics.Contact;
import zpp_nape.space.SweepPhase;
import zpp_nape.dynamics.Arbiter;
import zpp_nape.space.DynAABBPhase;
import zpp_nape.space.Broadphase;
import zpp_nape.shape.Polygon;
import zpp_nape.shape.Circle;
import zpp_nape.shape.Edge;
import zpp_nape.shape.Shape;
import zpp_nape.util.Circular;
import zpp_nape.util.Flags;
import zpp_nape.util.Names;
import zpp_nape.space.Space;
import zpp_nape.util.HaxeMacros;
import zpp_nape.util.FastHash;
import zpp_nape.util.Array2;
import zpp_nape.util.Queue;
import zpp_nape.util.RBTree;
import zpp_nape.util.WrapLists;
import zpp_nape.util.Debug;
import zpp_nape.util.Math;
import zpp_nape.util.UserData;
import zpp_nape.util.DisjointSetForest;
import zpp_nape.util.Pool;
import zpp_nape.geom.MatMath;
import zpp_nape.geom.Vec3;
import zpp_nape.geom.Mat23;
import zpp_nape.geom.Convex;
import zpp_nape.util.Lists;
import zpp_nape.geom.Simple;
import zpp_nape.geom.Triangular;
import zpp_nape.geom.Geom;
import zpp_nape.geom.VecMath;
import zpp_nape.geom.PartitionedPoly;
import zpp_nape.geom.Cutter;
import zpp_nape.geom.Simplify;
import zpp_nape.geom.Ray;
import zpp_nape.geom.Distance;
import zpp_nape.geom.Monotone;
import zpp_nape.geom.PolyIter;
import zpp_nape.geom.AABB;
import zpp_nape.geom.MarchingSquares;
import zpp_nape.geom.Vec2;
import zpp_nape.geom.MatMN;
import zpp_nape.geom.GeomPoly;
import zpp_nape.callbacks.CbSetPair;
import zpp_nape.callbacks.CbSet;
import zpp_nape.geom.Collide;
import zpp_nape.callbacks.Callback;
import zpp_nape.callbacks.Listener;
import zpp_nape.callbacks.CbType;
import zpp_nape.phys.FluidProperties;
import zpp_nape.callbacks.OptionType;
import zpp_nape.phys.FeatureMix;
import zpp_nape.phys.Compound;
import zpp_nape.phys.Interactor;
import zpp_nape.phys.Material;
import zpp_nape.constraint.DistanceJoint;
import zpp_nape.phys.Body;
import zpp_nape.constraint.WeldJoint;
import zpp_nape.constraint.MotorJoint;
import zpp_nape.constraint.Constraint;
import zpp_nape.constraint.AngleJoint;
import zpp_nape.constraint.LinearJoint;
import zpp_nape.constraint.UserConstraint;
import zpp_nape.constraint.LineJoint;
import nape.dynamics.FluidArbiter;
import nape.dynamics.ContactList;
import zpp_nape.constraint.PivotJoint;
import nape.dynamics.Arbiter;
import nape.dynamics.InteractionGroupList;
import nape.dynamics.ArbiterType;
import nape.dynamics.ArbiterIterator;
import nape.dynamics.ContactIterator;
import nape.dynamics.InteractionGroupIterator;
import nape.dynamics.InteractionGroup;
import nape.dynamics.InteractionFilter;
import nape.dynamics.ArbiterList;
import nape.dynamics.CollisionArbiter;
import nape.dynamics.Contact;
import nape.space.Broadphase;
import nape.shape.ShapeType;
import nape.shape.ShapeList;
import nape.space.Space;
import nape.shape.Polygon;
import nape.shape.EdgeList;
import nape.shape.ShapeIterator;
import nape.shape.Circle;
import nape.shape.Edge;
import nape.shape.EdgeIterator;
import nape.shape.Shape;
import nape.util.Debug;
import nape.util.BitmapDebug;
import nape.geom.GeomPolyIterator;
import nape.util.ShapeDebug;
import nape.geom.Vec3;
import nape.geom.RayResultIterator;
import nape.geom.GeomPolyList;
import nape.geom.Winding;
import nape.geom.RayResultList;
import nape.geom.Geom;
import nape.geom.Vec2Iterator;
import nape.geom.GeomVertexIterator;
import nape.geom.Ray;
import nape.geom.RayResult;
import nape.geom.MarchingSquares;
import nape.geom.AABB;
import nape.geom.MatMN;
import nape.geom.Vec2;
import nape.geom.Vec2List;
import nape.callbacks.ListenerList;
import nape.callbacks.ListenerType;
import nape.callbacks.InteractionType;
import nape.callbacks.ConstraintCallback;
import nape.callbacks.CbTypeIterator;
import nape.callbacks.BodyCallback;
import nape.geom.GeomPoly;
import nape.callbacks.Callback;
import nape.callbacks.OptionType;
import nape.callbacks.ListenerIterator;
import nape.callbacks.PreFlag;
import nape.callbacks.Listener;
import nape.callbacks.PreCallback;
import nape.callbacks.CbType;
import nape.callbacks.ConstraintListener;
import nape.callbacks.PreListener;
import nape.callbacks.InteractionCallback;
import nape.callbacks.BodyListener;
import nape.callbacks.CbEvent;
import nape.callbacks.CbTypeList;
import nape.phys.InertiaMode;
import nape.phys.FluidProperties;
import nape.phys.CompoundIterator;
import nape.phys.BodyType;
import nape.callbacks.InteractionListener;
import nape.phys.BodyList;
import nape.phys.GravMassMode;
import nape.phys.MassMode;
import nape.phys.Interactor;
import nape.phys.Compound;
import nape.phys.CompoundList;
import nape.phys.InteractorIterator;
import nape.phys.Material;
import nape.phys.InteractorList;
import nape.phys.BodyIterator;
import nape.constraint.DistanceJoint;
import nape.constraint.WeldJoint;
import nape.constraint.MotorJoint;
import nape.constraint.Constraint;
import nape.constraint.ConstraintIterator;
import nape.constraint.AngleJoint;
import nape.constraint.ConstraintList;
import nape.constraint.LinearJoint;
import nape.constraint.UserConstraint;
import nape.phys.Body;
import nape.constraint.LineJoint;
import nape.constraint.PivotJoint;
#if nape_swc@:keep#end
 class Mat23{
    public var zpp_inner:ZPP_Mat23;
    public var a(get_a,set_a):Float;
    inline function get_a():Float{
        return zpp_inner.a;
    }
    inline function set_a(a:Float):Float{
        {
            #if(!NAPE_RELEASE_BUILD)if((a!=a)){
                throw "Error: Mat23::"+"a"+" cannot be NaN";
            }
            #end
 zpp_inner.a=a;
            zpp_inner.invalidate();
        }
        return this.a;
    }
    public var b(get_b,set_b):Float;
    inline function get_b():Float{
        return zpp_inner.b;
    }
    inline function set_b(b:Float):Float{
        {
            #if(!NAPE_RELEASE_BUILD)if((b!=b)){
                throw "Error: Mat23::"+"b"+" cannot be NaN";
            }
            #end
 zpp_inner.b=b;
            zpp_inner.invalidate();
        }
        return this.b;
    }
    public var tx(get_tx,set_tx):Float;
    inline function get_tx():Float{
        return zpp_inner.tx;
    }
    inline function set_tx(tx:Float):Float{
        {
            #if(!NAPE_RELEASE_BUILD)if((tx!=tx)){
                throw "Error: Mat23::"+"tx"+" cannot be NaN";
            }
            #end
 zpp_inner.tx=tx;
            zpp_inner.invalidate();
        }
        return this.tx;
    }
    public var c(get_c,set_c):Float;
    inline function get_c():Float{
        return zpp_inner.c;
    }
    inline function set_c(c:Float):Float{
        {
            #if(!NAPE_RELEASE_BUILD)if((c!=c)){
                throw "Error: Mat23::"+"c"+" cannot be NaN";
            }
            #end
 zpp_inner.c=c;
            zpp_inner.invalidate();
        }
        return this.c;
    }
    public var d(get_d,set_d):Float;
    inline function get_d():Float{
        return zpp_inner.d;
    }
    inline function set_d(d:Float):Float{
        {
            #if(!NAPE_RELEASE_BUILD)if((d!=d)){
                throw "Error: Mat23::"+"d"+" cannot be NaN";
            }
            #end
 zpp_inner.d=d;
            zpp_inner.invalidate();
        }
        return this.d;
    }
    public var ty(get_ty,set_ty):Float;
    inline function get_ty():Float{
        return zpp_inner.ty;
    }
    inline function set_ty(ty:Float):Float{
        {
            #if(!NAPE_RELEASE_BUILD)if((ty!=ty)){
                throw "Error: Mat23::"+"ty"+" cannot be NaN";
            }
            #end
 zpp_inner.ty=ty;
            zpp_inner.invalidate();
        }
        return this.ty;
    }
    public function new(a:Float=1.0,b:Float=0.0,c:Float=0.0,d:Float=1.0,tx:Float=0.0,ty:Float=0.0){
        zpp_inner=ZPP_Mat23.get();
        zpp_inner.outer=this;
        this.a=a;
        this.b=b;
        this.tx=tx;
        this.c=c;
        this.d=d;
        this.ty=ty;
    }
    #if nape_swc@:keep#end
 public function copy(){
        return new Mat23(a,b,c,d,tx,ty);
    }
    public function set(matrix:Mat23):Void{
        #if(!NAPE_RELEASE_BUILD)if(matrix==null){
            throw "Error: Cannot set form null matrix";
        }
        #end
 zpp_inner.set(matrix.zpp_inner);
        zpp_inner.invalidate();
    }
    public function setAs(a:Float=1.0,b:Float=0.0,c:Float=0.0,d:Float=1.0,tx:Float=0.0,ty:Float=0.0){
        zpp_inner.setas(a,b,c,d,tx,ty);
        zpp_inner.invalidate();
    }
    public#if NAPE_NO_INLINE#else inline#end
 function reset():Void{
        setAs();
    }
    #if(flash9||nme)#if nape_swc@:keep#end
 public static function fromMatrix(m:flash.geom.Matrix):Mat23{
        return new Mat23(m.a,m.c,m.b,m.d,m.tx,m.ty);
    }
    #if nape_swc@:keep#end
 public function toMatrix():flash.geom.Matrix{
        return new flash.geom.Matrix(a,c,b,d,tx,ty);
    }
    #end
#if nape_swc@:keep#end
 public static function rotation(angle:Float):Mat23{
        #if(!NAPE_RELEASE_BUILD)if((angle!=angle)){
            throw "Error: Cannot create rotation matrix with NaN angle";
        }
        #end
 var cos=Math.cos(angle);
        var sin=Math.sin(angle);
        return new Mat23(cos,-sin,sin,cos,0,0);
    }
    #if nape_swc@:keep#end
 public static function translation(tx:Float,ty:Float):Mat23{
        return new Mat23(1,0,0,1,tx,ty);
    }
    #if nape_swc@:keep#end
 public static function scale(sx:Float,sy:Float):Mat23{
        return new Mat23(sx,0,0,sy,0,0);
    }
    public var determinant(get_determinant,never):Float;
    inline function get_determinant():Float{
        return(a*d)-(b*c);
    }
    #if nape_swc@:keep#end
 public function singular():Bool{
        var d=determinant;
        return(d*d)<ZPP_Const.EPSILON;
    }
    #if nape_swc@:keep#end
 public function inverse():Mat23{
        #if(!NAPE_RELEASE_BUILD)if(singular()){
            throw "Error: Matrix is singular and cannot be inverted";
        }
        #end
 var idet=1.0/determinant;
        return new Mat23((d*idet),(-b*idet),(-c*idet),(a*idet),((b*ty)-(d*tx))*idet,((c*tx)-(a*ty))*idet);
    }
    #if nape_swc@:keep#end
 public function transpose():Mat23{
        return new Mat23(a,c,b,d,tx,ty);
    }
    #if nape_swc@:keep#end
 public function concat(matrix:Mat23):Mat23{
        #if(!NAPE_RELEASE_BUILD)if(matrix==null){
            throw "Error: Cannot concatenate with null Mat23";
        }
        #end
 return new Mat23(((matrix.a*a)+(matrix.b*c)),((matrix.a*b)+(matrix.b*d)),((matrix.c*a)+(matrix.d*c)),((matrix.c*b)+(matrix.d*d)),(matrix.a*tx)+(matrix.b*ty)+matrix.tx,(matrix.c*tx)+(matrix.d*ty)+matrix.ty);
    }
    #if nape_swc@:keep#end
 public function transform(point:Vec2,noTranslation:Bool=false,weak:Bool=false):Vec2{
        {
            #if(!NAPE_RELEASE_BUILD)if(point!=null&&point.zpp_disp)throw "Error: "+"Vec2"+" has been disposed and cannot be used!";
            #end

        };
        #if(!NAPE_RELEASE_BUILD)if(point==null){
            throw "Error: Cannot transform null Vec2";
        }
        #end
 var ret:Vec2;
        if(noTranslation){
            ret=Vec2.get((point.x*a)+(point.y*b),(point.x*c)+(point.y*d),weak);
        }
        else{
            ret=Vec2.get((point.x*a)+(point.y*b)+tx,(point.x*c)+(point.y*d)+ty,weak);
        }
        ({
            if(({
                point.zpp_inner.weak;
            })){
                point.dispose();
                true;
            }
            else{
                false;
            }
        });
        return ret;
    }
    #if nape_swc@:keep#end
 public function inverseTransform(point:Vec2,noTranslation:Bool=false,weak:Bool=false):Vec2{
        {
            #if(!NAPE_RELEASE_BUILD)if(point!=null&&point.zpp_disp)throw "Error: "+"Vec2"+" has been disposed and cannot be used!";
            #end

        };
        #if(!NAPE_RELEASE_BUILD)if(point==null){
            throw "Error: Cannot transform null Vec2";
        }
        if(singular()){
            throw "Error: Matrix is singular and inverse transformation cannot be performed";
        }
        #end
 var idet=1.0/determinant;
        var ret:Vec2;
        if(noTranslation){
            ret=Vec2.get(((point.x*d)-(point.y*b))*idet,((point.y*a)-(point.x*c))*idet,weak);
        }
        else{
            var dx=point.x-tx;
            var dy=point.y-ty;
            ret=Vec2.get(((dx*d)-(dy*b))*idet,((dy*a)-(dx*c))*idet,weak);
        }
        ({
            if(({
                point.zpp_inner.weak;
            })){
                point.dispose();
                true;
            }
            else{
                false;
            }
        });
        return ret;
    }
    @:keep public function toString():String{
        return "{ a: "+a+" b: "+b+" c: "+c+" d: "+d+" tx: "+tx+" ty: "+ty+" }";
    }
    #if nape_swc@:keep#end
 public function equiorthogonal():Bool{
        if(singular()){
            return false;
        }
        else{
            var x=(a*b)+(c*d);
            if((x*x)<ZPP_Const.EPSILON){
                var y=(a*a)+(b*b)-(c*c)-(d*d);
                return(y*y)<ZPP_Const.EPSILON;
            }
            else{
                return false;
            }
        }
    }
    #if nape_swc@:keep#end
 public function orthogonal():Bool{
        var x=(a*b)+(c*d);
        if((x*x)<ZPP_Const.EPSILON){
            var y=(a*a)+(b*b)-1;
            var z=(c*c)+(d*d)-1;
            return(y*y)<ZPP_Const.EPSILON&&(z*z)<ZPP_Const.EPSILON;
        }
        else{
            return false;
        }
    }
    #if nape_swc@:keep#end
 public function equiorthogonalise():Mat23{
        if(!equiorthogonal()){
            var k1=Math.sqrt((a*a)+(c*c));
            var k2=Math.sqrt((b*b)+(d*d));
            #if(!NAPE_RELEASE_BUILD)if((k1*k1)<ZPP_Const.EPSILON||(k2*k2)<ZPP_Const.EPSILON){
                throw "Error: Matrix is singular and cannot be "+"equiorthogonal"+"ised";
            }
            #end
 var k=(k1+k2)/2;
            k1=k/k1;
            k2=k/k2;
            a*=k1;
            c*=k1;
            b*=k2;
            d*=k2;
            var dot=(a*b)+(c*d);
            var ang=0.25*Math.PI-0.5*Math.acos(dot/(k*k));
            if(determinant>0){
                ang=-ang;
            }
            var sin=Math.sin(ang);
            var cos=Math.cos(ang);
            var a2=(a*cos)-(c*sin);
            var b2=(b*cos)+(d*sin);
            c=(c*cos)+(a*sin);
            a=a2;
            d=(d*cos)-(b*sin);
            b=b2;
            zpp_inner.invalidate();
        }
        return this;
    }
    #if nape_swc@:keep#end
 public function orthogonalise():Mat23{
        if(!orthogonal()){
            var k1=Math.sqrt((a*a)+(c*c));
            var k2=Math.sqrt((b*b)+(d*d));
            #if(!NAPE_RELEASE_BUILD)if((k1*k1)<ZPP_Const.EPSILON||(k2*k2)<ZPP_Const.EPSILON){
                throw "Error: Matrix is singular and cannot be "+"orthogonal"+"ised";
            }
            #end
 var k=1;
            k1=k/k1;
            k2=k/k2;
            a*=k1;
            c*=k1;
            b*=k2;
            d*=k2;
            var dot=(a*b)+(c*d);
            var ang=0.25*Math.PI-0.5*Math.acos(dot/(k*k));
            if(determinant>0){
                ang=-ang;
            }
            var sin=Math.sin(ang);
            var cos=Math.cos(ang);
            var a2=(a*cos)-(c*sin);
            var b2=(b*cos)+(d*sin);
            c=(c*cos)+(a*sin);
            a=a2;
            d=(d*cos)-(b*sin);
            b=b2;
            zpp_inner.invalidate();
        }
        return this;
    }
}
