package nape.geom;
import zpp_nape.ID;
import zpp_nape.Config;
import zpp_nape.Const;
import zpp_nape.dynamics.SpaceArbiterList;
import zpp_nape.dynamics.InteractionGroup;
import zpp_nape.dynamics.InteractionFilter;
import zpp_nape.dynamics.Contact;
import zpp_nape.space.SweepPhase;
import zpp_nape.dynamics.Arbiter;
import zpp_nape.space.DynAABBPhase;
import zpp_nape.space.Broadphase;
import zpp_nape.shape.Polygon;
import zpp_nape.shape.Circle;
import zpp_nape.shape.Edge;
import zpp_nape.shape.Shape;
import zpp_nape.util.Circular;
import zpp_nape.util.Flags;
import zpp_nape.util.Names;
import zpp_nape.space.Space;
import zpp_nape.util.HaxeMacros;
import zpp_nape.util.FastHash;
import zpp_nape.util.Array2;
import zpp_nape.util.Queue;
import zpp_nape.util.RBTree;
import zpp_nape.util.WrapLists;
import zpp_nape.util.Debug;
import zpp_nape.util.Math;
import zpp_nape.util.UserData;
import zpp_nape.util.DisjointSetForest;
import zpp_nape.util.Pool;
import zpp_nape.geom.MatMath;
import zpp_nape.geom.Vec3;
import zpp_nape.geom.Mat23;
import zpp_nape.geom.Convex;
import zpp_nape.util.Lists;
import zpp_nape.geom.Simple;
import zpp_nape.geom.Triangular;
import zpp_nape.geom.Geom;
import zpp_nape.geom.VecMath;
import zpp_nape.geom.PartitionedPoly;
import zpp_nape.geom.Cutter;
import zpp_nape.geom.Simplify;
import zpp_nape.geom.Ray;
import zpp_nape.geom.Distance;
import zpp_nape.geom.Monotone;
import zpp_nape.geom.PolyIter;
import zpp_nape.geom.AABB;
import zpp_nape.geom.MarchingSquares;
import zpp_nape.geom.Vec2;
import zpp_nape.geom.MatMN;
import zpp_nape.geom.GeomPoly;
import zpp_nape.callbacks.CbSetPair;
import zpp_nape.callbacks.CbSet;
import zpp_nape.geom.Collide;
import zpp_nape.callbacks.Callback;
import zpp_nape.callbacks.Listener;
import zpp_nape.callbacks.CbType;
import zpp_nape.phys.FluidProperties;
import zpp_nape.callbacks.OptionType;
import zpp_nape.phys.FeatureMix;
import zpp_nape.phys.Compound;
import zpp_nape.phys.Interactor;
import zpp_nape.phys.Material;
import zpp_nape.constraint.DistanceJoint;
import zpp_nape.phys.Body;
import zpp_nape.constraint.WeldJoint;
import zpp_nape.constraint.MotorJoint;
import zpp_nape.constraint.Constraint;
import zpp_nape.constraint.AngleJoint;
import zpp_nape.constraint.LinearJoint;
import zpp_nape.constraint.UserConstraint;
import zpp_nape.constraint.LineJoint;
import nape.dynamics.FluidArbiter;
import nape.dynamics.ContactList;
import zpp_nape.constraint.PivotJoint;
import nape.dynamics.Arbiter;
import nape.dynamics.InteractionGroupList;
import nape.dynamics.ArbiterType;
import nape.dynamics.ArbiterIterator;
import nape.dynamics.ContactIterator;
import nape.dynamics.InteractionGroupIterator;
import nape.dynamics.InteractionGroup;
import nape.dynamics.InteractionFilter;
import nape.dynamics.ArbiterList;
import nape.dynamics.CollisionArbiter;
import nape.dynamics.Contact;
import nape.space.Broadphase;
import nape.shape.ShapeType;
import nape.shape.ShapeList;
import nape.space.Space;
import nape.shape.Polygon;
import nape.shape.EdgeList;
import nape.shape.ShapeIterator;
import nape.shape.Circle;
import nape.shape.Edge;
import nape.shape.EdgeIterator;
import nape.shape.Shape;
import nape.util.Debug;
import nape.util.BitmapDebug;
import nape.geom.GeomPolyIterator;
import nape.util.ShapeDebug;
import nape.geom.Vec3;
import nape.geom.RayResultIterator;
import nape.geom.GeomPolyList;
import nape.geom.Winding;
import nape.geom.RayResultList;
import nape.geom.Geom;
import nape.geom.Vec2Iterator;
import nape.geom.GeomVertexIterator;
import nape.geom.Mat23;
import nape.geom.Ray;
import nape.geom.RayResult;
import nape.geom.MarchingSquares;
import nape.geom.AABB;
import nape.geom.MatMN;
import nape.geom.Vec2List;
import nape.callbacks.ListenerList;
import nape.callbacks.ListenerType;
import nape.callbacks.InteractionType;
import nape.callbacks.ConstraintCallback;
import nape.callbacks.CbTypeIterator;
import nape.callbacks.BodyCallback;
import nape.geom.GeomPoly;
import nape.callbacks.Callback;
import nape.callbacks.OptionType;
import nape.callbacks.ListenerIterator;
import nape.callbacks.PreFlag;
import nape.callbacks.Listener;
import nape.callbacks.PreCallback;
import nape.callbacks.CbType;
import nape.callbacks.ConstraintListener;
import nape.callbacks.PreListener;
import nape.callbacks.InteractionCallback;
import nape.callbacks.BodyListener;
import nape.callbacks.CbEvent;
import nape.callbacks.CbTypeList;
import nape.phys.InertiaMode;
import nape.phys.FluidProperties;
import nape.phys.CompoundIterator;
import nape.phys.BodyType;
import nape.callbacks.InteractionListener;
import nape.phys.BodyList;
import nape.phys.GravMassMode;
import nape.phys.MassMode;
import nape.phys.Interactor;
import nape.phys.Compound;
import nape.phys.CompoundList;
import nape.phys.InteractorIterator;
import nape.phys.Material;
import nape.phys.InteractorList;
import nape.phys.BodyIterator;
import nape.constraint.DistanceJoint;
import nape.constraint.WeldJoint;
import nape.constraint.MotorJoint;
import nape.constraint.Constraint;
import nape.constraint.ConstraintIterator;
import nape.constraint.AngleJoint;
import nape.constraint.ConstraintList;
import nape.constraint.LinearJoint;
import nape.constraint.UserConstraint;
import nape.phys.Body;
import nape.constraint.LineJoint;
import nape.constraint.PivotJoint;
#if nape_swc@:keep#end
 class Vec2{
    public var zpp_inner:ZPP_Vec2;
    public var zpp_pool:Vec2;
    #if(!NAPE_RELEASE_BUILD)public var zpp_disp:Bool;
    #end
#if NAPE_POOL_STATS static public var POOL_CNT:Int=0;
    static public var POOL_TOT:Int=0;
    static public var POOL_ADD:Int=0;
    static public var POOL_ADDNEW:Int=0;
    static public var POOL_SUB:Int=0;
    #end
 public static#if NAPE_NO_INLINE#else inline#end
 function weak(x:Float=0,y:Float=0):Vec2{
        return get(x,y,true);
    }
    public static function get(x:Float=0,y:Float=0,weak:Bool=false):Vec2{
        #if(!NAPE_RELEASE_BUILD)if((x!=x)||(y!=y)){
            throw "Error: Vec2 components cannot be NaN";
        }
        #end
 var ret;
        {
            if(ZPP_PubPool.poolVec2==null){
                ret=new Vec2();
                #if NAPE_POOL_STATS Vec2.POOL_TOT++;
                Vec2.POOL_ADDNEW++;
                #end

            }
            else{
                ret=ZPP_PubPool.poolVec2;
                ZPP_PubPool.poolVec2=ret.zpp_pool;
                ret.zpp_pool=null;
                #if(!NAPE_RELEASE_BUILD)ret.zpp_disp=false;
                if(ret==ZPP_PubPool.nextVec2)ZPP_PubPool.nextVec2=null;
                #end
#if NAPE_POOL_STATS Vec2.POOL_CNT--;
                Vec2.POOL_ADD++;
                #end

            }
        };
        if(ret.zpp_inner==null){
            ret.zpp_inner=ZPP_Vec2.get(x,y);
            ret.zpp_inner.outer=ret;
        }
        else{
            ret.setxy(x,y);
        }
        ret.zpp_inner.weak=weak;
        return ret;
    }
    public function dispose():Void{
        {
            #if(!NAPE_RELEASE_BUILD)if(this!=null&&this.zpp_disp)throw "Error: "+"Vec2"+" has been disposed and cannot be used!";
            #end

        };
        zpp_inner.immutable();
        #if(!NAPE_RELEASE_BUILD)if(zpp_inner._inuse){
            throw "Error: This Vec2 is not disposable";
        }
        #end
 var inner=zpp_inner;
        zpp_inner.outer=null;
        zpp_inner=null;
        {
            var o=this;
            {
                #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                    o!=null;
                };
                if(!res)throw "assert("+"o!=null"+") :: "+("PublicFree(in T: "+"Vec2"+", in obj: "+"this"+")");
                #end

            };
            #if(!NAPE_RELEASE_BUILD)o.zpp_pool=null;
            if(ZPP_PubPool.nextVec2!=null)ZPP_PubPool.nextVec2.zpp_pool=o;
            else ZPP_PubPool.poolVec2=o;
            ZPP_PubPool.nextVec2=o;
            #end
#if NAPE_RELEASE_BUILD o.zpp_pool=ZPP_PubPool.poolVec2;
            ZPP_PubPool.poolVec2=o;
            #end
#if NAPE_POOL_STATS Vec2.POOL_CNT++;
            Vec2.POOL_SUB++;
            #end
#if(!NAPE_RELEASE_BUILD)o.zpp_disp=true;
            #end

        };
        {
            var o=inner;
            {
                #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                    o!=null;
                };
                if(!res)throw "assert("+"o!=null"+") :: "+("Free(in T: "+"ZPP_Vec2"+", in obj: "+"inner"+")");
                #end

            };
            o.free();
            o.next=ZPP_Vec2.zpp_pool;
            ZPP_Vec2.zpp_pool=o;
            #if NAPE_POOL_STATS ZPP_Vec2.POOL_CNT++;
            ZPP_Vec2.POOL_SUB++;
            #end

        };
    }
    public function new(x:Float=0,y:Float=0){
        #if(!NAPE_RELEASE_BUILD)if((x!=x)||(y!=y)){
            throw "Error: Vec2 components cannot be NaN";
        }
        #end
 zpp_inner=ZPP_Vec2.get(x,y);
        zpp_inner.outer=this;
    }
    #if nape_swc@:keep#end
 public function copy(weak:Bool=false):Vec2{
        {
            #if(!NAPE_RELEASE_BUILD)if(this!=null&&this.zpp_disp)throw "Error: "+"Vec2"+" has been disposed and cannot be used!";
            #end

        };
        return Vec2.get(x,y,weak);
    }
    #if flash9#if nape_swc@:keep#end
 public static function fromPoint(point:flash.geom.Point,weak:Bool=false):Vec2{
        #if(!NAPE_RELEASE_BUILD)if(point==null){
            throw "Error: Cannot create Vec2 from null Point object";
        }
        if((point.x!=point.x)||(point.y!=point.y)){
            throw "Error: Error: Vec2 components cannot be NaN";
        }
        #end
 return Vec2.get(point.x,point.y,weak);
    }
    #end
#if nape_swc@:keep#end
 public static function fromPolar(length:Float,angle:Float,weak:Bool=false):Vec2{
        #if(!NAPE_RELEASE_BUILD)if((length!=length)){
            throw "Error: Vec2::length cannot be NaN";
        }
        if((angle!=angle)){
            throw "Error: Vec2::angle cannot be NaN";
        }
        #end
 return Vec2.get(length*Math.cos(angle),length*Math.sin(angle),weak);
    }
    public var x(get_x,set_x):Float;
    inline function get_x():Float{
        {
            #if(!NAPE_RELEASE_BUILD)if(this!=null&&this.zpp_disp)throw "Error: "+"Vec2"+" has been disposed and cannot be used!";
            #end

        };
        zpp_inner.validate();
        return zpp_inner.x;
    }
    inline function set_x(x:Float):Float{
        {
            {
                #if(!NAPE_RELEASE_BUILD)if(this!=null&&this.zpp_disp)throw "Error: "+"Vec2"+" has been disposed and cannot be used!";
                #end

            };
            zpp_inner.immutable();
            if(this.x!=x){
                #if(!NAPE_RELEASE_BUILD)if((x!=x)){
                    throw "Error: Vec2::"+"x"+" cannot be NaN";
                }
                #end
 zpp_inner.x=x;
                zpp_inner.invalidate();
            }
        }
        return this.x;
    }
    public var y(get_y,set_y):Float;
    inline function get_y():Float{
        {
            #if(!NAPE_RELEASE_BUILD)if(this!=null&&this.zpp_disp)throw "Error: "+"Vec2"+" has been disposed and cannot be used!";
            #end

        };
        zpp_inner.validate();
        return zpp_inner.y;
    }
    inline function set_y(y:Float):Float{
        {
            {
                #if(!NAPE_RELEASE_BUILD)if(this!=null&&this.zpp_disp)throw "Error: "+"Vec2"+" has been disposed and cannot be used!";
                #end

            };
            zpp_inner.immutable();
            if(this.y!=y){
                #if(!NAPE_RELEASE_BUILD)if((y!=y)){
                    throw "Error: Vec2::"+"y"+" cannot be NaN";
                }
                #end
 zpp_inner.y=y;
                zpp_inner.invalidate();
            }
        }
        return this.y;
    }
    public var length(get_length,set_length):Float;
    inline function get_length():Float{
        {
            #if(!NAPE_RELEASE_BUILD)if(this!=null&&this.zpp_disp)throw "Error: "+"Vec2"+" has been disposed and cannot be used!";
            #end

        };
        return Math.sqrt((this.x*this.x+this.y*this.y));
    }
    inline function set_length(length:Float):Float{
        {
            {
                #if(!NAPE_RELEASE_BUILD)if(this!=null&&this.zpp_disp)throw "Error: "+"Vec2"+" has been disposed and cannot be used!";
                #end

            };
            zpp_inner.immutable();
            #if(!NAPE_RELEASE_BUILD)if((length!=length)){
                throw "Error: Vec2::length cannot be NaN";
            }
            if((this.x*this.x+this.y*this.y)==0){
                throw "Error: Cannot set length of a zero vector";
            }
            #end
{
                var t=(length/Math.sqrt((this.x*this.x+this.y*this.y)));
                {
                    #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                        !((t!=t));
                    };
                    if(!res)throw "assert("+"!assert_isNaN(t)"+") :: "+("vec_muleq(in a: "+"this."+",in s: "+"length/Math.sqrt((this.x*this.x+this.y*this.y))"+")");
                    #end

                };
                this.x*=t;
                this.y*=t;
            };
            zpp_inner.invalidate();
        }
        return this.length;
    }
    #if nape_swc@:keep#end
 public function lsq():Float{
        {
            #if(!NAPE_RELEASE_BUILD)if(this!=null&&this.zpp_disp)throw "Error: "+"Vec2"+" has been disposed and cannot be used!";
            #end

        };
        return(this.x*this.x+this.y*this.y);
    }
    public#if NAPE_NO_INLINE#else inline#end
 function set(p:Vec2):Vec2{
        {
            #if(!NAPE_RELEASE_BUILD)if(this!=null&&this.zpp_disp)throw "Error: "+"Vec2"+" has been disposed and cannot be used!";
            #end

        };
        {
            #if(!NAPE_RELEASE_BUILD)if(p!=null&&p.zpp_disp)throw "Error: "+"Vec2"+" has been disposed and cannot be used!";
            #end

        };
        zpp_inner.immutable();
        #if(!NAPE_RELEASE_BUILD)if(p==null){
            throw "Error: Cannot assign null Vec2";
        }
        #end
 var ret=setxy(p.x,p.y);
        ({
            if(({
                p.zpp_inner.weak;
            })){
                p.dispose();
                true;
            }
            else{
                false;
            }
        });
        return ret;
    }
    public#if NAPE_NO_INLINE#else inline#end
 function setxy(x:Float,y:Float):Vec2{
        {
            #if(!NAPE_RELEASE_BUILD)if(this!=null&&this.zpp_disp)throw "Error: "+"Vec2"+" has been disposed and cannot be used!";
            #end

        };
        zpp_inner.immutable();
        #if(!NAPE_RELEASE_BUILD)if((x!=x)||(y!=y)){
            throw "Error: Vec2 components cannot be NaN";
        }
        #end
 if(!(this.x==x&&this.y==y)){
            {
                zpp_inner.x=x;
                zpp_inner.y=y;
                {
                    #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                        !((zpp_inner.x!=zpp_inner.x));
                    };
                    if(!res)throw "assert("+"!assert_isNaN(zpp_inner.x)"+") :: "+("vec_set(in n: "+"zpp_inner."+",in x: "+"x"+",in y: "+"y"+")");
                    #end

                };
                {
                    #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                        !((zpp_inner.y!=zpp_inner.y));
                    };
                    if(!res)throw "assert("+"!assert_isNaN(zpp_inner.y)"+") :: "+("vec_set(in n: "+"zpp_inner."+",in x: "+"x"+",in y: "+"y"+")");
                    #end

                };
            };
            zpp_inner.invalidate();
        }
        return this;
    }
    public var angle(get_angle,set_angle):Float;
    inline function get_angle():Float{
        {
            #if(!NAPE_RELEASE_BUILD)if(this!=null&&this.zpp_disp)throw "Error: "+"Vec2"+" has been disposed and cannot be used!";
            #end

        };
        if(x==y&&x==0){
            return 0.0;
        }
        else{
            return Math.atan2(y,x);
        }
    }
    inline function set_angle(angle:Float):Float{
        {
            {
                #if(!NAPE_RELEASE_BUILD)if(this!=null&&this.zpp_disp)throw "Error: "+"Vec2"+" has been disposed and cannot be used!";
                #end

            };
            zpp_inner.immutable();
            #if(!NAPE_RELEASE_BUILD)if((angle!=angle)){
                throw "Error: Vec2::angle cannot be NaN";
            }
            #end
 var l=length;
            setxy(l*Math.cos(angle),l*Math.sin(angle));
        }
        return this.angle;
    }
    #if nape_swc@:keep#end
 public function rotate(angle:Float):Vec2{
        {
            #if(!NAPE_RELEASE_BUILD)if(this!=null&&this.zpp_disp)throw "Error: "+"Vec2"+" has been disposed and cannot be used!";
            #end

        };
        zpp_inner.immutable();
        #if(!NAPE_RELEASE_BUILD)if((angle!=angle)){
            throw "Error: Cannot rotate Vec2 by NaN";
        }
        #end
 if((angle%(Math.PI*2))!=0){
            var ax=Math.sin(angle);
            var ay=Math.cos(angle);
            {
                var t=(ay*zpp_inner.x-ax*zpp_inner.y);
                zpp_inner.y=(zpp_inner.x*ax+zpp_inner.y*ay);
                zpp_inner.x=t;
            };
            zpp_inner.invalidate();
        }
        return this;
    }
    #if nape_swc@:keep#end
 public function add(a:Vec2,weak:Bool=false):Vec2{
        {
            #if(!NAPE_RELEASE_BUILD)if(this!=null&&this.zpp_disp)throw "Error: "+"Vec2"+" has been disposed and cannot be used!";
            #end

        };
        {
            #if(!NAPE_RELEASE_BUILD)if(a!=null&&a.zpp_disp)throw "Error: "+"Vec2"+" has been disposed and cannot be used!";
            #end

        };
        #if(!NAPE_RELEASE_BUILD)if(a==null){
            throw "Error: Cannot add null vectors";
        }
        #end
 var ret=Vec2.get(x+a.x,y+a.y,weak);
        ({
            if(({
                a.zpp_inner.weak;
            })){
                a.dispose();
                true;
            }
            else{
                false;
            }
        });
        return ret;
    }
    #if nape_swc@:keep#end
 public function sub(a:Vec2,weak:Bool=false):Vec2{
        {
            #if(!NAPE_RELEASE_BUILD)if(this!=null&&this.zpp_disp)throw "Error: "+"Vec2"+" has been disposed and cannot be used!";
            #end

        };
        {
            #if(!NAPE_RELEASE_BUILD)if(a!=null&&a.zpp_disp)throw "Error: "+"Vec2"+" has been disposed and cannot be used!";
            #end

        };
        #if(!NAPE_RELEASE_BUILD)if(a==null){
            throw "Error: Cannot subtract null vectors";
        }
        #end
 var ret=Vec2.get(x-a.x,y-a.y,weak);
        ({
            if(({
                a.zpp_inner.weak;
            })){
                a.dispose();
                true;
            }
            else{
                false;
            }
        });
        return ret;
    }
    #if nape_swc@:keep#end
 public function mul(s:Float,weak:Bool=false):Vec2{
        {
            #if(!NAPE_RELEASE_BUILD)if(this!=null&&this.zpp_disp)throw "Error: "+"Vec2"+" has been disposed and cannot be used!";
            #end

        };
        #if(!NAPE_RELEASE_BUILD)if((s!=s)){
            throw "Error: Cannot multiply with NaN";
        }
        #end
 return Vec2.get(x*s,y*s,weak);
    }
    #if nape_swc@:keep#end
 public function addeq(a:Vec2):Vec2{
        {
            #if(!NAPE_RELEASE_BUILD)if(this!=null&&this.zpp_disp)throw "Error: "+"Vec2"+" has been disposed and cannot be used!";
            #end

        };
        {
            #if(!NAPE_RELEASE_BUILD)if(a!=null&&a.zpp_disp)throw "Error: "+"Vec2"+" has been disposed and cannot be used!";
            #end

        };
        zpp_inner.immutable();
        #if(!NAPE_RELEASE_BUILD)if(a==null){
            throw "Error: Cannot add null vectors";
        }
        #end
 var ret=setxy(x+a.x,y+a.y);
        ({
            if(({
                a.zpp_inner.weak;
            })){
                a.dispose();
                true;
            }
            else{
                false;
            }
        });
        return ret;
    }
    #if nape_swc@:keep#end
 public function subeq(a:Vec2):Vec2{
        {
            #if(!NAPE_RELEASE_BUILD)if(this!=null&&this.zpp_disp)throw "Error: "+"Vec2"+" has been disposed and cannot be used!";
            #end

        };
        {
            #if(!NAPE_RELEASE_BUILD)if(a!=null&&a.zpp_disp)throw "Error: "+"Vec2"+" has been disposed and cannot be used!";
            #end

        };
        zpp_inner.immutable();
        #if(!NAPE_RELEASE_BUILD)if(a==null){
            throw "Error: Cannot subtract null vectors";
        }
        #end
 var ret=setxy(x-a.x,y-a.y);
        ({
            if(({
                a.zpp_inner.weak;
            })){
                a.dispose();
                true;
            }
            else{
                false;
            }
        });
        return ret;
    }
    #if nape_swc@:keep#end
 public function muleq(s:Float):Vec2{
        {
            #if(!NAPE_RELEASE_BUILD)if(this!=null&&this.zpp_disp)throw "Error: "+"Vec2"+" has been disposed and cannot be used!";
            #end

        };
        zpp_inner.immutable();
        #if(!NAPE_RELEASE_BUILD)if((s!=s)){
            throw "Error: Cannot multiply with NaN";
        }
        #end
 return setxy(x*s,y*s);
    }
    #if nape_swc@:keep#end
 public function dot(a:Vec2):Float{
        {
            #if(!NAPE_RELEASE_BUILD)if(this!=null&&this.zpp_disp)throw "Error: "+"Vec2"+" has been disposed and cannot be used!";
            #end

        };
        {
            #if(!NAPE_RELEASE_BUILD)if(a!=null&&a.zpp_disp)throw "Error: "+"Vec2"+" has been disposed and cannot be used!";
            #end

        };
        #if(!NAPE_RELEASE_BUILD)if(a==null){
            throw "Error: Cannot take dot product with null vector";
        }
        #end
 var ret=(x*a.x+y*a.y);
        ({
            if(({
                a.zpp_inner.weak;
            })){
                a.dispose();
                true;
            }
            else{
                false;
            }
        });
        return ret;
    }
    #if nape_swc@:keep#end
 public function cross(a:Vec2):Float{
        {
            #if(!NAPE_RELEASE_BUILD)if(this!=null&&this.zpp_disp)throw "Error: "+"Vec2"+" has been disposed and cannot be used!";
            #end

        };
        {
            #if(!NAPE_RELEASE_BUILD)if(a!=null&&a.zpp_disp)throw "Error: "+"Vec2"+" has been disposed and cannot be used!";
            #end

        };
        #if(!NAPE_RELEASE_BUILD)if(a==null){
            throw "Error: Cannot take cross product with null vector";
        }
        #end
 var ret=(a.y*x-a.x*y);
        ({
            if(({
                a.zpp_inner.weak;
            })){
                a.dispose();
                true;
            }
            else{
                false;
            }
        });
        return ret;
    }
    #if nape_swc@:keep#end
 public function perp(weak:Bool=false):Vec2{
        {
            #if(!NAPE_RELEASE_BUILD)if(this!=null&&this.zpp_disp)throw "Error: "+"Vec2"+" has been disposed and cannot be used!";
            #end

        };
        return Vec2.get(-y,x,weak);
    }
    @:keep public function toString():String{
        {
            #if(!NAPE_RELEASE_BUILD)if(this!=null&&this.zpp_disp)throw "Error: "+"Vec2"+" has been disposed and cannot be used!";
            #end

        };
        zpp_inner.validate();
        return zpp_inner.toString();
    }
}
