package nape.geom;
import zpp_nape.ID;
import zpp_nape.Config;
import zpp_nape.Const;
import zpp_nape.dynamics.SpaceArbiterList;
import zpp_nape.dynamics.InteractionGroup;
import zpp_nape.dynamics.InteractionFilter;
import zpp_nape.dynamics.Contact;
import zpp_nape.space.SweepPhase;
import zpp_nape.dynamics.Arbiter;
import zpp_nape.space.DynAABBPhase;
import zpp_nape.space.Broadphase;
import zpp_nape.shape.Polygon;
import zpp_nape.shape.Circle;
import zpp_nape.shape.Edge;
import zpp_nape.shape.Shape;
import zpp_nape.util.Circular;
import zpp_nape.util.Flags;
import zpp_nape.util.Names;
import zpp_nape.space.Space;
import zpp_nape.util.HaxeMacros;
import zpp_nape.util.FastHash;
import zpp_nape.util.Array2;
import zpp_nape.util.Queue;
import zpp_nape.util.RBTree;
import zpp_nape.util.WrapLists;
import zpp_nape.util.Debug;
import zpp_nape.util.Math;
import zpp_nape.util.UserData;
import zpp_nape.util.DisjointSetForest;
import zpp_nape.util.Pool;
import zpp_nape.geom.MatMath;
import zpp_nape.geom.Vec3;
import zpp_nape.geom.Mat23;
import zpp_nape.geom.Convex;
import zpp_nape.util.Lists;
import zpp_nape.geom.Simple;
import zpp_nape.geom.Triangular;
import zpp_nape.geom.Geom;
import zpp_nape.geom.VecMath;
import zpp_nape.geom.PartitionedPoly;
import zpp_nape.geom.Cutter;
import zpp_nape.geom.Simplify;
import zpp_nape.geom.Ray;
import zpp_nape.geom.Distance;
import zpp_nape.geom.Monotone;
import zpp_nape.geom.PolyIter;
import zpp_nape.geom.AABB;
import zpp_nape.geom.MarchingSquares;
import zpp_nape.geom.Vec2;
import zpp_nape.geom.MatMN;
import zpp_nape.geom.GeomPoly;
import zpp_nape.callbacks.CbSetPair;
import zpp_nape.callbacks.CbSet;
import zpp_nape.geom.Collide;
import zpp_nape.callbacks.Callback;
import zpp_nape.callbacks.Listener;
import zpp_nape.callbacks.CbType;
import zpp_nape.phys.FluidProperties;
import zpp_nape.callbacks.OptionType;
import zpp_nape.phys.FeatureMix;
import zpp_nape.phys.Compound;
import zpp_nape.phys.Interactor;
import zpp_nape.phys.Material;
import zpp_nape.constraint.DistanceJoint;
import zpp_nape.phys.Body;
import zpp_nape.constraint.WeldJoint;
import zpp_nape.constraint.MotorJoint;
import zpp_nape.constraint.Constraint;
import zpp_nape.constraint.AngleJoint;
import zpp_nape.constraint.LinearJoint;
import zpp_nape.constraint.UserConstraint;
import zpp_nape.constraint.LineJoint;
import nape.dynamics.FluidArbiter;
import nape.dynamics.ContactList;
import zpp_nape.constraint.PivotJoint;
import nape.dynamics.Arbiter;
import nape.dynamics.InteractionGroupList;
import nape.dynamics.ArbiterType;
import nape.dynamics.ArbiterIterator;
import nape.dynamics.ContactIterator;
import nape.dynamics.InteractionGroupIterator;
import nape.dynamics.InteractionGroup;
import nape.dynamics.InteractionFilter;
import nape.dynamics.ArbiterList;
import nape.dynamics.CollisionArbiter;
import nape.dynamics.Contact;
import nape.space.Broadphase;
import nape.shape.ShapeType;
import nape.shape.ShapeList;
import nape.space.Space;
import nape.shape.Polygon;
import nape.shape.EdgeList;
import nape.shape.ShapeIterator;
import nape.shape.Circle;
import nape.shape.Edge;
import nape.shape.EdgeIterator;
import nape.shape.Shape;
import nape.util.Debug;
import nape.util.BitmapDebug;
import nape.geom.GeomPolyIterator;
import nape.util.ShapeDebug;
import nape.geom.RayResultIterator;
import nape.geom.GeomPolyList;
import nape.geom.Winding;
import nape.geom.RayResultList;
import nape.geom.Geom;
import nape.geom.Vec2Iterator;
import nape.geom.GeomVertexIterator;
import nape.geom.Mat23;
import nape.geom.Ray;
import nape.geom.RayResult;
import nape.geom.MarchingSquares;
import nape.geom.AABB;
import nape.geom.MatMN;
import nape.geom.Vec2;
import nape.geom.Vec2List;
import nape.callbacks.ListenerList;
import nape.callbacks.ListenerType;
import nape.callbacks.InteractionType;
import nape.callbacks.ConstraintCallback;
import nape.callbacks.CbTypeIterator;
import nape.callbacks.BodyCallback;
import nape.geom.GeomPoly;
import nape.callbacks.Callback;
import nape.callbacks.OptionType;
import nape.callbacks.ListenerIterator;
import nape.callbacks.PreFlag;
import nape.callbacks.Listener;
import nape.callbacks.PreCallback;
import nape.callbacks.CbType;
import nape.callbacks.ConstraintListener;
import nape.callbacks.PreListener;
import nape.callbacks.InteractionCallback;
import nape.callbacks.BodyListener;
import nape.callbacks.CbEvent;
import nape.callbacks.CbTypeList;
import nape.phys.InertiaMode;
import nape.phys.FluidProperties;
import nape.phys.CompoundIterator;
import nape.phys.BodyType;
import nape.callbacks.InteractionListener;
import nape.phys.BodyList;
import nape.phys.GravMassMode;
import nape.phys.MassMode;
import nape.phys.Interactor;
import nape.phys.Compound;
import nape.phys.CompoundList;
import nape.phys.InteractorIterator;
import nape.phys.Material;
import nape.phys.InteractorList;
import nape.phys.BodyIterator;
import nape.constraint.DistanceJoint;
import nape.constraint.WeldJoint;
import nape.constraint.MotorJoint;
import nape.constraint.Constraint;
import nape.constraint.ConstraintIterator;
import nape.constraint.AngleJoint;
import nape.constraint.ConstraintList;
import nape.constraint.LinearJoint;
import nape.constraint.UserConstraint;
import nape.phys.Body;
import nape.constraint.LineJoint;
import nape.constraint.PivotJoint;
#if nape_swc@:keep#end
 class Vec3{
    public var zpp_inner:ZPP_Vec3;
    public var zpp_pool:Vec3;
    #if(!NAPE_RELEASE_BUILD)public var zpp_disp:Bool;
    #end
#if NAPE_POOL_STATS static public var POOL_CNT:Int=0;
    static public var POOL_TOT:Int=0;
    static public var POOL_ADD:Int=0;
    static public var POOL_ADDNEW:Int=0;
    static public var POOL_SUB:Int=0;
    #end
 public var x(get_x,set_x):Float;
    inline function get_x():Float{
        {
            #if(!NAPE_RELEASE_BUILD)if(this!=null&&this.zpp_disp)throw "Error: "+"Vec3"+" has been disposed and cannot be used!";
            #end

        };
        zpp_inner.validate();
        return zpp_inner.x;
    }
    inline function set_x(x:Float):Float{
        {
            {
                #if(!NAPE_RELEASE_BUILD)if(this!=null&&this.zpp_disp)throw "Error: "+"Vec3"+" has been disposed and cannot be used!";
                #end

            };
            #if(!NAPE_RELEASE_BUILD)if(zpp_inner.immutable){
                throw "Error: Vec3 is immutable";
            }
            #end
 zpp_inner.x=x;
        }
        return this.x;
    }
    public var y(get_y,set_y):Float;
    inline function get_y():Float{
        {
            #if(!NAPE_RELEASE_BUILD)if(this!=null&&this.zpp_disp)throw "Error: "+"Vec3"+" has been disposed and cannot be used!";
            #end

        };
        zpp_inner.validate();
        return zpp_inner.y;
    }
    inline function set_y(y:Float):Float{
        {
            {
                #if(!NAPE_RELEASE_BUILD)if(this!=null&&this.zpp_disp)throw "Error: "+"Vec3"+" has been disposed and cannot be used!";
                #end

            };
            #if(!NAPE_RELEASE_BUILD)if(zpp_inner.immutable){
                throw "Error: Vec3 is immutable";
            }
            #end
 zpp_inner.y=y;
        }
        return this.y;
    }
    public var z(get_z,set_z):Float;
    inline function get_z():Float{
        {
            #if(!NAPE_RELEASE_BUILD)if(this!=null&&this.zpp_disp)throw "Error: "+"Vec3"+" has been disposed and cannot be used!";
            #end

        };
        zpp_inner.validate();
        return zpp_inner.z;
    }
    inline function set_z(z:Float):Float{
        {
            {
                #if(!NAPE_RELEASE_BUILD)if(this!=null&&this.zpp_disp)throw "Error: "+"Vec3"+" has been disposed and cannot be used!";
                #end

            };
            #if(!NAPE_RELEASE_BUILD)if(zpp_inner.immutable){
                throw "Error: Vec3 is immutable";
            }
            #end
 zpp_inner.z=z;
        }
        return this.z;
    }
    public static function get(x:Float=0,y:Float=0,z:Float=0):Vec3{
        var ret;
        {
            if(ZPP_PubPool.poolVec3==null){
                ret=new Vec3();
                #if NAPE_POOL_STATS Vec3.POOL_TOT++;
                Vec3.POOL_ADDNEW++;
                #end

            }
            else{
                ret=ZPP_PubPool.poolVec3;
                ZPP_PubPool.poolVec3=ret.zpp_pool;
                ret.zpp_pool=null;
                #if(!NAPE_RELEASE_BUILD)ret.zpp_disp=false;
                if(ret==ZPP_PubPool.nextVec3)ZPP_PubPool.nextVec3=null;
                #end
#if NAPE_POOL_STATS Vec3.POOL_CNT--;
                Vec3.POOL_ADD++;
                #end

            }
        };
        ret.setxyz(x,y,z);
        ret.zpp_inner.immutable=false;
        ret.zpp_inner._validate=null;
        return ret;
    }
    public function new(x:Float=0,y:Float=0,z:Float=0){
        zpp_inner=new ZPP_Vec3();
        zpp_inner.outer=this;
        {
            {
                this.x=x;
                this.y=y;
                {
                    #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                        !((this.x!=this.x));
                    };
                    if(!res)throw "assert("+"!assert_isNaN(this.x)"+") :: "+("vec_set(in n: "+"this."+",in x: "+"x"+",in y: "+"y"+")");
                    #end

                };
                {
                    #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                        !((this.y!=this.y));
                    };
                    if(!res)throw "assert("+"!assert_isNaN(this.y)"+") :: "+("vec_set(in n: "+"this."+",in x: "+"x"+",in y: "+"y"+")");
                    #end

                };
            };
            this.z=z;
        };
    }
    public function copy():Vec3{
        {
            #if(!NAPE_RELEASE_BUILD)if(this!=null&&this.zpp_disp)throw "Error: "+"Vec3"+" has been disposed and cannot be used!";
            #end

        };
        return Vec3.get(x,y,z);
    }
    public function dispose():Void{
        {
            #if(!NAPE_RELEASE_BUILD)if(this!=null&&this.zpp_disp)throw "Error: "+"Vec3"+" has been disposed and cannot be used!";
            #end

        };
        #if(!NAPE_RELEASE_BUILD)if(zpp_inner.immutable){
            throw "Error: This Vec3 is not disposable";
        }
        #end
{
            var o=this;
            {
                #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                    o!=null;
                };
                if(!res)throw "assert("+"o!=null"+") :: "+("PublicFree(in T: "+"Vec3"+", in obj: "+"this"+")");
                #end

            };
            #if(!NAPE_RELEASE_BUILD)o.zpp_pool=null;
            if(ZPP_PubPool.nextVec3!=null)ZPP_PubPool.nextVec3.zpp_pool=o;
            else ZPP_PubPool.poolVec3=o;
            ZPP_PubPool.nextVec3=o;
            #end
#if NAPE_RELEASE_BUILD o.zpp_pool=ZPP_PubPool.poolVec3;
            ZPP_PubPool.poolVec3=o;
            #end
#if NAPE_POOL_STATS Vec3.POOL_CNT++;
            Vec3.POOL_SUB++;
            #end
#if(!NAPE_RELEASE_BUILD)o.zpp_disp=true;
            #end

        };
    }
    public var length(get_length,set_length):Float;
    inline function get_length():Float{
        {
            #if(!NAPE_RELEASE_BUILD)if(this!=null&&this.zpp_disp)throw "Error: "+"Vec3"+" has been disposed and cannot be used!";
            #end

        };
        return Math.sqrt(((this.x*this.x+this.y*this.y)+this.z*this.z));
    }
    inline function set_length(length:Float):Float{
        {
            {
                #if(!NAPE_RELEASE_BUILD)if(this!=null&&this.zpp_disp)throw "Error: "+"Vec3"+" has been disposed and cannot be used!";
                #end

            };
            #if(!NAPE_RELEASE_BUILD)if((length!=length)){
                throw "Error: Vec3::length cannot be NaN";
            }
            if(((this.x*this.x+this.y*this.y)+this.z*this.z)==0){
                throw "Error: Cannot set length of a zero vector";
            }
            #end
{
                var t=((length/this.length));
                {
                    var t=(t);
                    {
                        #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                            !((t!=t));
                        };
                        if(!res)throw "assert("+"!assert_isNaN(t)"+") :: "+("vec_muleq(in a: "+"this."+",in s: "+"t"+")");
                        #end

                    };
                    this.x*=t;
                    this.y*=t;
                };
                this.z*=t;
            };
        }
        return this.length;
    }
    #if nape_swc@:keep#end
 public function lsq():Float{
        {
            #if(!NAPE_RELEASE_BUILD)if(this!=null&&this.zpp_disp)throw "Error: "+"Vec3"+" has been disposed and cannot be used!";
            #end

        };
        return((this.x*this.x+this.y*this.y)+this.z*this.z);
    }
    public function set(p:Vec3):Vec3{
        {
            #if(!NAPE_RELEASE_BUILD)if(this!=null&&this.zpp_disp)throw "Error: "+"Vec3"+" has been disposed and cannot be used!";
            #end

        };
        {
            #if(!NAPE_RELEASE_BUILD)if(p!=null&&p.zpp_disp)throw "Error: "+"Vec3"+" has been disposed and cannot be used!";
            #end

        };
        #if(!NAPE_RELEASE_BUILD)if(p==null){
            throw "Error: Cannot assign null Vec3";
        }
        #end
 return setxyz(p.x,p.y,p.z);
    }
    public function setxyz(x:Float,y:Float,z:Float):Vec3{
        {
            #if(!NAPE_RELEASE_BUILD)if(this!=null&&this.zpp_disp)throw "Error: "+"Vec3"+" has been disposed and cannot be used!";
            #end

        };
        {
            {
                this.x=x;
                this.y=y;
                {
                    #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                        !((this.x!=this.x));
                    };
                    if(!res)throw "assert("+"!assert_isNaN(this.x)"+") :: "+("vec_set(in n: "+"this."+",in x: "+"x"+",in y: "+"y"+")");
                    #end

                };
                {
                    #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                        !((this.y!=this.y));
                    };
                    if(!res)throw "assert("+"!assert_isNaN(this.y)"+") :: "+("vec_set(in n: "+"this."+",in x: "+"x"+",in y: "+"y"+")");
                    #end

                };
            };
            this.z=z;
        };
        return this;
    }
    public function xy(weak:Bool=false):Vec2{
        {
            #if(!NAPE_RELEASE_BUILD)if(this!=null&&this.zpp_disp)throw "Error: "+"Vec3"+" has been disposed and cannot be used!";
            #end

        };
        return Vec2.get(x,y,weak);
    }
    @:keep public function toString():String{
        {
            #if(!NAPE_RELEASE_BUILD)if(this!=null&&this.zpp_disp)throw "Error: "+"Vec3"+" has been disposed and cannot be used!";
            #end

        };
        return "{ x: "+x+" y: "+y+" z: "+z+" }";
    }
}
