package nape.phys;
import zpp_nape.ID;
import zpp_nape.Config;
import zpp_nape.Const;
import zpp_nape.dynamics.SpaceArbiterList;
import zpp_nape.dynamics.InteractionGroup;
import zpp_nape.dynamics.InteractionFilter;
import zpp_nape.dynamics.Contact;
import zpp_nape.space.SweepPhase;
import zpp_nape.dynamics.Arbiter;
import zpp_nape.space.DynAABBPhase;
import zpp_nape.space.Broadphase;
import zpp_nape.shape.Polygon;
import zpp_nape.shape.Circle;
import zpp_nape.shape.Edge;
import zpp_nape.shape.Shape;
import zpp_nape.util.Circular;
import zpp_nape.util.Flags;
import zpp_nape.util.Names;
import zpp_nape.space.Space;
import zpp_nape.util.HaxeMacros;
import zpp_nape.util.FastHash;
import zpp_nape.util.Array2;
import zpp_nape.util.Queue;
import zpp_nape.util.RBTree;
import zpp_nape.util.WrapLists;
import zpp_nape.util.Debug;
import zpp_nape.util.Math;
import zpp_nape.util.UserData;
import zpp_nape.util.DisjointSetForest;
import zpp_nape.util.Pool;
import zpp_nape.geom.MatMath;
import zpp_nape.geom.Vec3;
import zpp_nape.geom.Mat23;
import zpp_nape.geom.Convex;
import zpp_nape.util.Lists;
import zpp_nape.geom.Simple;
import zpp_nape.geom.Triangular;
import zpp_nape.geom.Geom;
import zpp_nape.geom.VecMath;
import zpp_nape.geom.PartitionedPoly;
import zpp_nape.geom.Cutter;
import zpp_nape.geom.Simplify;
import zpp_nape.geom.Ray;
import zpp_nape.geom.Distance;
import zpp_nape.geom.Monotone;
import zpp_nape.geom.PolyIter;
import zpp_nape.geom.AABB;
import zpp_nape.geom.MarchingSquares;
import zpp_nape.geom.Vec2;
import zpp_nape.geom.MatMN;
import zpp_nape.geom.GeomPoly;
import zpp_nape.callbacks.CbSetPair;
import zpp_nape.callbacks.CbSet;
import zpp_nape.geom.Collide;
import zpp_nape.callbacks.Callback;
import zpp_nape.callbacks.Listener;
import zpp_nape.callbacks.CbType;
import zpp_nape.phys.FluidProperties;
import zpp_nape.callbacks.OptionType;
import zpp_nape.phys.FeatureMix;
import zpp_nape.phys.Compound;
import zpp_nape.phys.Interactor;
import zpp_nape.phys.Material;
import zpp_nape.constraint.DistanceJoint;
import zpp_nape.phys.Body;
import zpp_nape.constraint.WeldJoint;
import zpp_nape.constraint.MotorJoint;
import zpp_nape.constraint.Constraint;
import zpp_nape.constraint.AngleJoint;
import zpp_nape.constraint.LinearJoint;
import zpp_nape.constraint.UserConstraint;
import zpp_nape.constraint.LineJoint;
import nape.dynamics.FluidArbiter;
import nape.dynamics.ContactList;
import zpp_nape.constraint.PivotJoint;
import nape.dynamics.Arbiter;
import nape.dynamics.InteractionGroupList;
import nape.dynamics.ArbiterType;
import nape.dynamics.ArbiterIterator;
import nape.dynamics.ContactIterator;
import nape.dynamics.InteractionGroupIterator;
import nape.dynamics.InteractionGroup;
import nape.dynamics.InteractionFilter;
import nape.dynamics.ArbiterList;
import nape.dynamics.CollisionArbiter;
import nape.dynamics.Contact;
import nape.space.Broadphase;
import nape.shape.ShapeType;
import nape.shape.ShapeList;
import nape.space.Space;
import nape.shape.Polygon;
import nape.shape.EdgeList;
import nape.shape.ShapeIterator;
import nape.shape.Circle;
import nape.shape.Edge;
import nape.shape.EdgeIterator;
import nape.shape.Shape;
import nape.util.Debug;
import nape.util.BitmapDebug;
import nape.geom.GeomPolyIterator;
import nape.util.ShapeDebug;
import nape.geom.Vec3;
import nape.geom.RayResultIterator;
import nape.geom.GeomPolyList;
import nape.geom.Winding;
import nape.geom.RayResultList;
import nape.geom.Geom;
import nape.geom.Vec2Iterator;
import nape.geom.GeomVertexIterator;
import nape.geom.Mat23;
import nape.geom.Ray;
import nape.geom.RayResult;
import nape.geom.MarchingSquares;
import nape.geom.AABB;
import nape.geom.MatMN;
import nape.geom.Vec2;
import nape.geom.Vec2List;
import nape.callbacks.ListenerList;
import nape.callbacks.ListenerType;
import nape.callbacks.InteractionType;
import nape.callbacks.ConstraintCallback;
import nape.callbacks.CbTypeIterator;
import nape.callbacks.BodyCallback;
import nape.geom.GeomPoly;
import nape.callbacks.Callback;
import nape.callbacks.OptionType;
import nape.callbacks.ListenerIterator;
import nape.callbacks.PreFlag;
import nape.callbacks.Listener;
import nape.callbacks.PreCallback;
import nape.callbacks.CbType;
import nape.callbacks.ConstraintListener;
import nape.callbacks.PreListener;
import nape.callbacks.InteractionCallback;
import nape.callbacks.BodyListener;
import nape.callbacks.CbEvent;
import nape.callbacks.CbTypeList;
import nape.phys.InertiaMode;
import nape.phys.FluidProperties;
import nape.phys.CompoundIterator;
import nape.phys.BodyType;
import nape.callbacks.InteractionListener;
import nape.phys.BodyList;
import nape.phys.GravMassMode;
import nape.phys.MassMode;
import nape.phys.Interactor;
import nape.phys.Compound;
import nape.phys.CompoundList;
import nape.phys.InteractorIterator;
import nape.phys.Material;
import nape.phys.InteractorList;
import nape.phys.BodyIterator;
import nape.constraint.DistanceJoint;
import nape.constraint.WeldJoint;
import nape.constraint.MotorJoint;
import nape.constraint.Constraint;
import nape.constraint.ConstraintIterator;
import nape.constraint.AngleJoint;
import nape.constraint.ConstraintList;
import nape.constraint.LinearJoint;
import nape.constraint.UserConstraint;
import nape.constraint.LineJoint;
import nape.constraint.PivotJoint;
#if nape_swc@:keep#end
 class Body extends Interactor{
    public var zpp_inner:ZPP_Body;
    public var type(get_type,set_type):BodyType;
    inline function get_type():BodyType{
        return[null,BodyType.STATIC,BodyType.DYNAMIC,BodyType.KINEMATIC][zpp_inner.type];
    }
    inline function set_type(type:BodyType):BodyType{
        {
            zpp_inner.immutable_midstep("Body::type");
            #if(!NAPE_RELEASE_BUILD)if(zpp_inner.world)throw "Error: Space::world is immutable";
            #end
 if(this.type!=type){
                #if(!NAPE_RELEASE_BUILD)if(type==null)throw "Error: Cannot use null BodyType";
                #end
 var ntype=type==BodyType.DYNAMIC?ZPP_Flags.id_BodyType_DYNAMIC:type==BodyType.KINEMATIC?ZPP_Flags.id_BodyType_KINEMATIC:ZPP_Flags.id_BodyType_STATIC;
                if(ntype==ZPP_Flags.id_BodyType_STATIC&&zpp_inner.space!=null){
                    {
                        zpp_inner.velx=0;
                        zpp_inner.vely=0;
                        {
                            #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                                !((zpp_inner.velx!=zpp_inner.velx));
                            };
                            if(!res)throw "assert("+"!assert_isNaN(zpp_inner.velx)"+") :: "+("vec_set(in n: "+"zpp_inner.vel"+",in x: "+"0"+",in y: "+"0"+")");
                            #end

                        };
                        {
                            #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                                !((zpp_inner.vely!=zpp_inner.vely));
                            };
                            if(!res)throw "assert("+"!assert_isNaN(zpp_inner.vely)"+") :: "+("vec_set(in n: "+"zpp_inner.vel"+",in x: "+"0"+",in y: "+"0"+")");
                            #end

                        };
                    };
                    zpp_inner.angvel=0;
                }
                zpp_inner.invalidate_type();
                if(zpp_inner.space!=null)zpp_inner.space.transmitType(zpp_inner,ntype);
                else zpp_inner.type=ntype;
            }
        }
        return this.type;
    }
    #if nape_swc@:keep#end
 public function isStatic()return zpp_inner.isStatic()#if nape_swc@:keep#end
 public function isDynamic()return zpp_inner.isDynamic()#if nape_swc@:keep#end
 public function isKinematic()return zpp_inner.isKinematic()public function clear(){
        zpp_inner.immutable_midstep("Body::clear()");
        #if(!NAPE_RELEASE_BUILD)if(zpp_inner.world)throw "Error: Space::world is immutable";
        #end
 zpp_inner.clear();
        zpp_inner.userData=null;
        group=null;
        compound=null;
    }
    public var shapes(get_shapes,never):ShapeList;
    inline function get_shapes():ShapeList return zpp_inner.wrap_shapes public var compound(get_compound,set_compound):Compound;
    inline function get_compound():Compound{
        return if(zpp_inner.compound==null)null else zpp_inner.compound.outer;
    }
    inline function set_compound(compound:Compound):Compound{
        {
            if(this.compound!=compound){
                if(this.compound!=null)this.compound.bodies.remove(this);
                if(compound!=null)compound.bodies.add(this);
            }
        }
        return this.compound;
    }
    public var space(get_space,set_space):Space;
    inline function get_space():Space{
        return if(zpp_inner.space==null)null else zpp_inner.space.outer;
    }
    inline function set_space(space:Space):Space{
        {
            #if(!NAPE_RELEASE_BUILD)if(zpp_inner.compound!=null)throw "Error: Cannot set the space of a Body belonging to a Compound, only the root Compound space can be set";
            #end
 zpp_inner.immutable_midstep("Body::space");
            #if(!NAPE_RELEASE_BUILD)if(zpp_inner.world)throw "Error: Space::world is immutable";
            #end
 if(this.space!=space){
                if(this.space!=null)zpp_inner.component.woken=false;
                if(this.space!=null)this.space.bodies.remove(this);
                if(space!=null)space.bodies.add(this);
            }
        }
        return this.space;
    }
    public var arbiters(get_arbiters,never):ArbiterList;
    inline function get_arbiters():ArbiterList{
        if(zpp_inner.wrap_arbiters==null)zpp_inner.wrap_arbiters=ZPP_ArbiterList.get(zpp_inner.arbiters,true);
        return zpp_inner.wrap_arbiters;
    }
    public var isSleeping(get_isSleeping,never):Bool;
    inline function get_isSleeping():Bool{
        #if(!NAPE_RELEASE_BUILD)if(zpp_inner.space==null)throw "Error: isSleeping makes no sense if the object is not contained within a Space";
        #end
 return zpp_inner.component.sleeping;
    }
    public var constraints(get_constraints,never):ConstraintList;
    inline function get_constraints():ConstraintList{
        if(zpp_inner.wrap_constraints==null)zpp_inner.wrap_constraints=ZPP_ConstraintList.get(zpp_inner.constraints,true);
        return zpp_inner.wrap_constraints;
    }
    #if flib@:keep function flibopts_2(){}
    #end
 public function new(type:BodyType=null,position:Vec2=null){
        #if(!NAPE_RELEASE_BUILD)try{
            super();
        }
        catch(e:Dynamic){}
        #end
#if NAPE_RELEASE_BUILD super();
        #end
 zpp_inner=new ZPP_Body();
        zpp_inner.outer=this;
        zpp_inner.outer_i=this;
        zpp_inner_i=zpp_inner;
        if(position!=null){
            {
                #if(!NAPE_RELEASE_BUILD)if(position!=null&&position.zpp_disp)throw "Error: "+"Vec2"+" has been disposed and cannot be used!";
                #end

            };
            {
                zpp_inner.posx=position.x;
                zpp_inner.posy=position.y;
                {
                    #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                        !((zpp_inner.posx!=zpp_inner.posx));
                    };
                    if(!res)throw "assert("+"!assert_isNaN(zpp_inner.posx)"+") :: "+("vec_set(in n: "+"zpp_inner.pos"+",in x: "+"position.x"+",in y: "+"position.y"+")");
                    #end

                };
                {
                    #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                        !((zpp_inner.posy!=zpp_inner.posy));
                    };
                    if(!res)throw "assert("+"!assert_isNaN(zpp_inner.posy)"+") :: "+("vec_set(in n: "+"zpp_inner.pos"+",in x: "+"position.x"+",in y: "+"position.y"+")");
                    #end

                };
            };
        }
        else{
            zpp_inner.posx=0;
            zpp_inner.posy=0;
            {
                #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                    !((zpp_inner.posx!=zpp_inner.posx));
                };
                if(!res)throw "assert("+"!assert_isNaN(zpp_inner.posx)"+") :: "+("vec_set(in n: "+"zpp_inner.pos"+",in x: "+"0"+",in y: "+"0"+")");
                #end

            };
            {
                #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                    !((zpp_inner.posy!=zpp_inner.posy));
                };
                if(!res)throw "assert("+"!assert_isNaN(zpp_inner.posy)"+") :: "+("vec_set(in n: "+"zpp_inner.pos"+",in x: "+"0"+",in y: "+"0"+")");
                #end

            };
        };
        this.type=type==null?BodyType.DYNAMIC:type;
        if(position!=null)({
            if(({
                position.zpp_inner.weak;
            })){
                position.dispose();
                true;
            }
            else{
                false;
            }
        });
        graphicAngleOffset=0.0;
        zpp_inner_i.insert_cbtype(CbType.ANY_BODY.zpp_inner);
    }
    #if nape_swc@:keep#end
 public function copy(){
        #if(!NAPE_RELEASE_BUILD)if(zpp_inner.world)throw "Error: Space::world cannot be copied";
        #end
 var ret=zpp_inner.copy();
        ret.zpp_inner.userData=zpp_inner.userData;
        return ret;
    }
    public var position(get_position,set_position):Vec2;
    inline function get_position():Vec2{
        if(zpp_inner.wrap_pos==null)zpp_inner.setupPosition();
        return zpp_inner.wrap_pos;
    }
    inline function set_position(position:Vec2):Vec2{
        {
            {
                #if(!NAPE_RELEASE_BUILD)if(position!=null&&position.zpp_disp)throw "Error: "+"Vec2"+" has been disposed and cannot be used!";
                #end

            };
            #if(!NAPE_RELEASE_BUILD)if(position==null)throw "Error: Body::"+"position"+" cannot be null";
            #end
 this.position.set(position);
        }
        return this.position;
    }
    public var velocity(get_velocity,set_velocity):Vec2;
    inline function get_velocity():Vec2{
        if(zpp_inner.wrap_vel==null)zpp_inner.setupVelocity();
        return zpp_inner.wrap_vel;
    }
    inline function set_velocity(velocity:Vec2):Vec2{
        {
            {
                #if(!NAPE_RELEASE_BUILD)if(velocity!=null&&velocity.zpp_disp)throw "Error: "+"Vec2"+" has been disposed and cannot be used!";
                #end

            };
            #if(!NAPE_RELEASE_BUILD)if(velocity==null)throw "Error: Body::"+"velocity"+" cannot be null";
            #end
 this.velocity.set(velocity);
        }
        return this.velocity;
    }
    public var kinematicVel(get_kinematicVel,set_kinematicVel):Vec2;
    inline function get_kinematicVel():Vec2{
        if(zpp_inner.wrap_kinvel==null)zpp_inner.setupkinvel();
        return zpp_inner.wrap_kinvel;
    }
    inline function set_kinematicVel(kinematicVel:Vec2):Vec2{
        {
            {
                #if(!NAPE_RELEASE_BUILD)if(kinematicVel!=null&&kinematicVel.zpp_disp)throw "Error: "+"Vec2"+" has been disposed and cannot be used!";
                #end

            };
            #if(!NAPE_RELEASE_BUILD)if(kinematicVel==null)throw "Error: Body::"+"kinematicVel"+" cannot be null";
            #end
 this.kinematicVel.set(kinematicVel);
        }
        return this.kinematicVel;
    }
    public var surfaceVel(get_surfaceVel,set_surfaceVel):Vec2;
    inline function get_surfaceVel():Vec2{
        if(zpp_inner.wrap_svel==null)zpp_inner.setupsvel();
        return zpp_inner.wrap_svel;
    }
    inline function set_surfaceVel(surfaceVel:Vec2):Vec2{
        {
            {
                #if(!NAPE_RELEASE_BUILD)if(surfaceVel!=null&&surfaceVel.zpp_disp)throw "Error: "+"Vec2"+" has been disposed and cannot be used!";
                #end

            };
            #if(!NAPE_RELEASE_BUILD)if(surfaceVel==null)throw "Error: Body::"+"surfaceVel"+" cannot be null";
            #end
 this.surfaceVel.set(surfaceVel);
        }
        return this.surfaceVel;
    }
    public var force(get_force,set_force):Vec2;
    inline function get_force():Vec2{
        if(zpp_inner.wrap_force==null)zpp_inner.setupForce();
        return zpp_inner.wrap_force;
    }
    inline function set_force(force:Vec2):Vec2{
        {
            {
                #if(!NAPE_RELEASE_BUILD)if(force!=null&&force.zpp_disp)throw "Error: "+"Vec2"+" has been disposed and cannot be used!";
                #end

            };
            #if(!NAPE_RELEASE_BUILD)if(force==null)throw "Error: Body::"+"force"+" cannot be null";
            #end
 this.force.set(force);
        }
        return this.force;
    }
    public var constraintVelocity(get_constraintVelocity,never):Vec3;
    inline function get_constraintVelocity():Vec3{
        if(zpp_inner.wrapcvel==null)zpp_inner.setup_cvel();
        return zpp_inner.wrapcvel;
    }
    public var rotation(get_rotation,set_rotation):Float;
    inline function get_rotation():Float{
        return zpp_inner.rot;
    }
    inline function set_rotation(rotation:Float):Float{
        {
            zpp_inner.immutable_midstep("Body::rotation");
            #if(!NAPE_RELEASE_BUILD)if(zpp_inner.world)throw "Error: Space::world is immutable";
            #end
#if(!NAPE_RELEASE_BUILD)if(isStatic()&&zpp_inner.space!=null)throw "Error: Static objects cannot be rotated once inside a Space";
            #end
 if(this.rotation!=rotation){
                #if(!NAPE_RELEASE_BUILD)if((rotation!=rotation))throw "Error: Body::rotation cannot be NaN";
                #end
 zpp_inner.rot=rotation;
                zpp_inner.invalidate_rot();
                zpp_inner.wake();
            }
        }
        return this.rotation;
    }
    public var angularVel(get_angularVel,set_angularVel):Float;
    inline function get_angularVel():Float{
        return zpp_inner.angvel;
    }
    inline function set_angularVel(angularVel:Float):Float{
        {
            #if(!NAPE_RELEASE_BUILD)if(zpp_inner.world)throw "Error: Space::world is immutable";
            #end
 if(this.angularVel!=angularVel){
                #if(!NAPE_RELEASE_BUILD)if((angularVel!=angularVel))throw "Error: Body::angularVel cannot be NaN";
                #end
#if(!NAPE_RELEASE_BUILD)if(zpp_inner.isStatic()&&zpp_inner.space!=null)throw "Error: A static object within a space cannot be given a velocity";
                #end
 zpp_inner.angvel=angularVel;
                zpp_inner.invalidate_wake();
            }
        }
        return this.angularVel;
    }
    public var kinAngVel(get_kinAngVel,set_kinAngVel):Float;
    inline function get_kinAngVel():Float{
        return zpp_inner.kinangvel;
    }
    inline function set_kinAngVel(kinAngVel:Float):Float{
        {
            #if(!NAPE_RELEASE_BUILD)if(zpp_inner.world)throw "Error: Space::world is immutable";
            #end
 if(this.kinAngVel!=kinAngVel){
                #if(!NAPE_RELEASE_BUILD)if((kinAngVel!=kinAngVel))throw "Error: Body::kinAngVel cannot be NaN";
                #end
 zpp_inner.kinangvel=kinAngVel;
                zpp_inner.invalidate_wake();
            }
        }
        return this.kinAngVel;
    }
    public var torque(get_torque,set_torque):Float;
    inline function get_torque():Float{
        return zpp_inner.torque;
    }
    inline function set_torque(torque:Float):Float{
        {
            #if(!NAPE_RELEASE_BUILD)if(zpp_inner.world)throw "Error: Space::world is immutable";
            #end
#if(!NAPE_RELEASE_BUILD)if((torque!=torque))throw "Error: Body::torqur cannot be NaN";
            #end
 if(this.torque!=torque){
                zpp_inner.torque=torque;
                zpp_inner.invalidate_wake();
            }
        }
        return this.torque;
    }
    public var bounds(get_bounds,never):AABB;
    inline function get_bounds():AABB{
        #if(!NAPE_RELEASE_BUILD)if(zpp_inner.world)throw "Error: Space::world has no bounds";
        #end
#if(!NAPE_RELEASE_BUILD)if(zpp_inner.shapes.empty())throw "Error: Body bounds only makes sense if it contains shapes";
        #end
 return zpp_inner.aabb.wrapper();
    }
    public var allowMovement(get_allowMovement,set_allowMovement):Bool;
    inline function get_allowMovement():Bool{
        return!zpp_inner.nomove;
    }
    inline function set_allowMovement(allowMovement:Bool):Bool{
        {
            zpp_inner.immutable_midstep("Body::"+allowMovement);
            if(this.allowMovement!=allowMovement){
                zpp_inner.nomove=!allowMovement;
                zpp_inner.invalidate_mass();
            }
        }
        return this.allowMovement;
    }
    public var allowRotation(get_allowRotation,set_allowRotation):Bool;
    inline function get_allowRotation():Bool{
        return!zpp_inner.norotate;
    }
    inline function set_allowRotation(allowRotation:Bool):Bool{
        {
            zpp_inner.immutable_midstep("Body::"+allowRotation);
            if(this.allowRotation!=allowRotation){
                zpp_inner.norotate=!allowRotation;
                zpp_inner.invalidate_inertia();
            }
        }
        return this.allowRotation;
    }
    public var massMode(get_massMode,set_massMode):MassMode;
    inline function get_massMode():MassMode{
        return[MassMode.DEFAULT,MassMode.FIXED][zpp_inner.massMode];
    }
    inline function set_massMode(massMode:MassMode):MassMode{
        {
            zpp_inner.immutable_midstep("Body::massMode");
            #if(!NAPE_RELEASE_BUILD)if(zpp_inner.world)throw "Error: Space::world is immutable";
            #end
#if(!NAPE_RELEASE_BUILD)if(massMode==null)throw "Error: cannot use null massMode";
            #end
 zpp_inner.massMode=massMode==MassMode.DEFAULT?ZPP_Flags.id_MassMode_DEFAULT:ZPP_Flags.id_MassMode_FIXED;
            zpp_inner.invalidate_mass();
        }
        return this.massMode;
    }
    public var constraintMass(get_constraintMass,never):Float;
    inline function get_constraintMass():Float{
        if(!zpp_inner.world)zpp_inner.validate_mass();
        return zpp_inner.smass;
    }
    public var mass(get_mass,set_mass):Float;
    inline function get_mass():Float{
        #if(!NAPE_RELEASE_BUILD)if(zpp_inner.world)throw "Error: Space::world has no mass";
        #end
 zpp_inner.validate_mass();
        #if(!NAPE_RELEASE_BUILD)if(zpp_inner.massMode==ZPP_Flags.id_MassMode_DEFAULT&&zpp_inner.shapes.empty())throw "Error: Given current mass mode, Body::mass only makes sense if it contains shapes";
        #end
 return zpp_inner.cmass;
    }
    inline function set_mass(mass:Float):Float{
        {
            zpp_inner.immutable_midstep("Body::mass");
            #if(!NAPE_RELEASE_BUILD)if(zpp_inner.world)throw "Error: Space::world is immutable";
            #end
#if(!NAPE_RELEASE_BUILD)if((mass!=mass))throw "Error: Mass cannot be NaN";
            if(mass<=0)throw "Error: Mass must be strictly positive";
            if(mass>=ZPP_Const.POSINF())throw "Error: Mass cannot be infinite, use allowMovement = false instead";
            #end
 zpp_inner.massMode=ZPP_Flags.id_MassMode_FIXED;
            zpp_inner.cmass=mass;
            zpp_inner.invalidate_mass();
        }
        return this.mass;
    }
    public var gravMassMode(get_gravMassMode,set_gravMassMode):GravMassMode;
    inline function get_gravMassMode():GravMassMode{
        return[GravMassMode.DEFAULT,GravMassMode.FIXED,GravMassMode.SCALED][zpp_inner.massMode];
    }
    inline function set_gravMassMode(gravMassMode:GravMassMode):GravMassMode{
        {
            zpp_inner.immutable_midstep("Body::gravMassMode");
            #if(!NAPE_RELEASE_BUILD)if(zpp_inner.world)throw "Error: Space::world is immutable";
            #end
#if(!NAPE_RELEASE_BUILD)if(gravMassMode==null)throw "Error: Cannot use null gravMassMode";
            #end
 zpp_inner.gravMassMode=gravMassMode==GravMassMode.SCALED?ZPP_Flags.id_GravMassMode_SCALED:gravMassMode==GravMassMode.DEFAULT?ZPP_Flags.id_GravMassMode_DEFAULT:ZPP_Flags.id_GravMassMode_FIXED;
            zpp_inner.invalidate_gravMass();
        }
        return this.gravMassMode;
    }
    public var gravMass(get_gravMass,set_gravMass):Float;
    inline function get_gravMass():Float{
        #if(!NAPE_RELEASE_BUILD)if(zpp_inner.world)throw "Error: Space::world has no gravMass";
        #end
 zpp_inner.validate_gravMass();
        #if(!NAPE_RELEASE_BUILD)if(zpp_inner.shapes.empty()){
            if(zpp_inner.massMode==ZPP_Flags.id_MassMode_DEFAULT&&zpp_inner.gravMassMode!=ZPP_Flags.id_GravMassMode_FIXED)throw "Error: Given current mass/gravMass modes; Body::gravMass only makes sense if it contains Shapes";
        }
        #end
 return zpp_inner.gravMass;
    }
    inline function set_gravMass(gravMass:Float):Float{
        {
            zpp_inner.immutable_midstep("Body::gravMass");
            #if(!NAPE_RELEASE_BUILD)if(zpp_inner.world)throw "Error: Space::world is immutable";
            #end
#if(!NAPE_RELEASE_BUILD)if((gravMass!=gravMass))throw "Error: gravMass cannot be NaN";
            #end
 zpp_inner.gravMassMode=ZPP_Flags.id_GravMassMode_FIXED;
            zpp_inner.gravMass=gravMass;
            zpp_inner.invalidate_gravMass();
        }
        return this.gravMass;
    }
    public var gravMassScale(get_gravMassScale,set_gravMassScale):Float;
    inline function get_gravMassScale():Float{
        zpp_inner.validate_gravMassScale();
        #if(!NAPE_RELEASE_BUILD)if(zpp_inner.shapes.empty()){
            if(zpp_inner.massMode==ZPP_Flags.id_MassMode_DEFAULT&&zpp_inner.gravMassMode!=ZPP_Flags.id_GravMassMode_SCALED)throw "Error: Given current mass/gravMass modes; Body::gravMassScale only makes sense if it contains Shapes";
        }
        #end
 return zpp_inner.gravMassScale;
    }
    inline function set_gravMassScale(gravMassScale:Float):Float{
        {
            zpp_inner.immutable_midstep("Body::gravMassScale");
            #if(!NAPE_RELEASE_BUILD)if(zpp_inner.world)throw "Error: Space::world is immutable";
            #end
#if(!NAPE_RELEASE_BUILD)if((gravMassScale!=gravMassScale))throw "Error: gravMassScale cannot be NaN";
            #end
 zpp_inner.gravMassMode=ZPP_Flags.id_GravMassMode_SCALED;
            zpp_inner.gravMassScale=gravMassScale;
            zpp_inner.invalidate_gravMassScale();
        }
        return this.gravMassScale;
    }
    public var inertiaMode(get_inertiaMode,set_inertiaMode):InertiaMode;
    inline function get_inertiaMode():InertiaMode{
        return[InertiaMode.DEFAULT,InertiaMode.FIXED][zpp_inner.inertiaMode];
    }
    inline function set_inertiaMode(inertiaMode:InertiaMode):InertiaMode{
        {
            zpp_inner.immutable_midstep("Body::inertiaMode");
            #if(!NAPE_RELEASE_BUILD)if(zpp_inner.world)throw "Error: Space::world is immutable";
            #end
#if(!NAPE_RELEASE_BUILD)if(inertiaMode==null)throw "Error: Cannot use null InertiaMode";
            #end
 zpp_inner.inertiaMode=inertiaMode==InertiaMode.FIXED?ZPP_Flags.id_InertiaMode_FIXED:ZPP_Flags.id_InertiaMode_DEFAULT;
            zpp_inner.invalidate_inertia();
        }
        return this.inertiaMode;
    }
    public var constraintInertia(get_constraintInertia,never):Float;
    inline function get_constraintInertia():Float{
        if(!zpp_inner.world)zpp_inner.validate_inertia();
        return zpp_inner.sinertia;
    }
    public var inertia(get_inertia,set_inertia):Float;
    inline function get_inertia():Float{
        #if(!NAPE_RELEASE_BUILD)if(zpp_inner.world)throw "Error: Space::world has no inertia";
        #end
 zpp_inner.validate_inertia();
        #if(!NAPE_RELEASE_BUILD)if(zpp_inner.inertiaMode==ZPP_Flags.id_InertiaMode_DEFAULT&&shapes.empty())throw "Error: Given current inertia mode flag, Body::inertia only makes sense if Body contains Shapes";
        #end
 return zpp_inner.cinertia;
    }
    inline function set_inertia(inertia:Float):Float{
        {
            zpp_inner.immutable_midstep("Body::inertia");
            #if(!NAPE_RELEASE_BUILD)if(zpp_inner.world)throw "Error: Space::world is immutable";
            #end
#if(!NAPE_RELEASE_BUILD)if((inertia!=inertia))throw "Error: Inertia cannot be NaN";
            if(inertia<=0)throw "Error: Inertia must be strictly positive";
            if(inertia>=ZPP_Const.POSINF())throw "Error: Inertia cannot be infinite, use allowRotation = false instead";
            #end
 zpp_inner.inertiaMode=ZPP_Flags.id_InertiaMode_FIXED;
            zpp_inner.cinertia=inertia;
            zpp_inner.invalidate_inertia();
        }
        return this.inertia;
    }
    public var graphicOffset(get_graphicOffset,set_graphicOffset):Vec2;
    inline function get_graphicOffset():Vec2{
        return zpp_inner.graphicOffset;
    }
    inline function set_graphicOffset(graphicOffset:Vec2):Vec2{
        {
            {
                #if(!NAPE_RELEASE_BUILD)if(graphicOffset!=null&&graphicOffset.zpp_disp)throw "Error: "+"Vec2"+" has been disposed and cannot be used!";
                #end

            };
            #if(!NAPE_RELEASE_BUILD)if(graphicOffset==null)throw "Error: Body::graphicOffset cannot be null";
            #end
 this.graphicOffset.set(graphicOffset);
        }
        return this.graphicOffset;
    }
    public var graphicAngleOffset:Float;
    public var graphic(get_graphic,set_graphic):Dynamic;
    inline function get_graphic():Dynamic{
        return zpp_inner.graphic;
    }
    inline function set_graphic(graphic:Dynamic):Dynamic{
        {
            #if(!NAPE_RELEASE_BUILD)if(zpp_inner.world)throw "Error: Space::world is immutable";
            #end
 if(graphic!=this.graphic){
                if(graphic==null){
                    zpp_inner.graphic=null;
                }
                else{
                    #if(flash9||nme)zpp_inner.graphic=graphic;
                    zpp_inner.flashgraphic=Std.is(graphic,flash.display.DisplayObject);
                    zpp_inner.validate_graphic();
                    #end

                }
            }
        }
        return this.graphic;
    }
    public var graphicUpdate(get_graphicUpdate,set_graphicUpdate):Body->Void;
    inline function get_graphicUpdate():Body->Void{
        return zpp_inner.graphicUpdate;
    }
    inline function set_graphicUpdate(graphicUpdate:Body->Void):Body->Void{
        {
            zpp_inner.graphicUpdate=graphicUpdate;
            if(graphicUpdate!=null)zpp_inner.validate_graphic();
        }
        return this.graphicUpdate;
    }
    #if nape_swc@:keep#end
 public function connectedBodies(depth:Int=-1):BodyList{
        return zpp_inner.connectedBodies(depth);
    }
    #if nape_swc@:keep#end
 public function interactingBodies(type:InteractionType=null,depth:Int=-1){
        var arbiter_type=if(type==null){
            ZPP_Arbiter.COL|ZPP_Arbiter.SENSOR|ZPP_Arbiter.FLUID;
        }
        else if(type==InteractionType.COLLISION)ZPP_Arbiter.COL else if(type==InteractionType.SENSOR)ZPP_Arbiter.SENSOR else ZPP_Arbiter.FLUID;
        return zpp_inner.interactingBodies(arbiter_type,depth);
    }
    #if nape_swc@:keep#end
 public function crushFactor():Float{
        #if(!NAPE_RELEASE_BUILD)if(space==null)throw "Error: Makes no sense to see how much an object not taking part in a simulation is being crushed";
        #end
 var msum=0.0;
        var jsum=Vec2.get();
        for(arb in arbiters){
            var imp3=arb.totalImpulse(this);
            var imp=imp3.xy();
            jsum.addeq(imp);
            msum+=imp.length;
            imp.dispose();
            imp3.dispose();
        }
        for(con in constraints){
            var imp3=con.bodyImpulse(this);
            var imp=imp3.xy();
            jsum.addeq(imp);
            msum+=imp.length;
            imp.dispose();
            imp3.dispose();
        }
        var ret=(msum-jsum.length)*space.zpp_inner.pre_dt;
        jsum.dispose();
        return ret;
    }
    #if nape_swc@:keep#end
 public function localToWorld(v:Vec2,weak:Bool=false)return relativeToWorld(localToRelative(v,true),weak)#if nape_swc@:keep#end
 public function worldToLocal(v:Vec2,weak:Bool=false)return relativeToLocal(worldToRelative(v,true),weak)#if nape_swc@:keep#end
 public function relativeToWorld(v:Vec2,weak:Bool=false){
        {
            #if(!NAPE_RELEASE_BUILD)if(v!=null&&v.zpp_disp)throw "Error: "+"Vec2"+" has been disposed and cannot be used!";
            #end

        };
        #if(!NAPE_RELEASE_BUILD)if(v==null)throw "Error: Cannot transform null Vec2";
        #end
 var ret=Vec2.get(v.x+zpp_inner.posx,v.y+zpp_inner.posy,weak);
        ({
            if(({
                v.zpp_inner.weak;
            })){
                v.dispose();
                true;
            }
            else{
                false;
            }
        });
        return ret;
    }
    #if nape_swc@:keep#end
 public function worldToRelative(v:Vec2,weak:Bool=false){
        {
            #if(!NAPE_RELEASE_BUILD)if(v!=null&&v.zpp_disp)throw "Error: "+"Vec2"+" has been disposed and cannot be used!";
            #end

        };
        #if(!NAPE_RELEASE_BUILD)if(v==null)throw "Error: Cannot transform null Vec2";
        #end
 var ret=Vec2.get(v.x-zpp_inner.posx,v.y-zpp_inner.posy,weak);
        ({
            if(({
                v.zpp_inner.weak;
            })){
                v.dispose();
                true;
            }
            else{
                false;
            }
        });
        return ret;
    }
    #if nape_swc@:keep#end
 public function localToRelative(v:Vec2,weak:Bool=false){
        {
            #if(!NAPE_RELEASE_BUILD)if(v!=null&&v.zpp_disp)throw "Error: "+"Vec2"+" has been disposed and cannot be used!";
            #end

        };
        #if(!NAPE_RELEASE_BUILD)if(v==null)throw "Error: Cannot transform null Vec2";
        #end
 zpp_inner.validate_axis();
        var tempx:Float;
        var tempy:Float;
        {
            tempx=(zpp_inner.axisy*v.x-zpp_inner.axisx*v.y);
            tempy=(v.x*zpp_inner.axisx+v.y*zpp_inner.axisy);
        };
        ({
            if(({
                v.zpp_inner.weak;
            })){
                v.dispose();
                true;
            }
            else{
                false;
            }
        });
        return Vec2.get(tempx,tempy,weak);
    }
    #if nape_swc@:keep#end
 public function relativeToLocal(v:Vec2,weak:Bool=false){
        {
            #if(!NAPE_RELEASE_BUILD)if(v!=null&&v.zpp_disp)throw "Error: "+"Vec2"+" has been disposed and cannot be used!";
            #end

        };
        #if(!NAPE_RELEASE_BUILD)if(v==null)throw "Error: Cannot transform null Vec2";
        #end
 zpp_inner.validate_axis();
        var tempx:Float;
        var tempy:Float;
        {
            tempx=v.x*zpp_inner.axisy+v.y*zpp_inner.axisx;
            tempy=v.y*zpp_inner.axisy-v.x*zpp_inner.axisx;
        };
        ({
            if(({
                v.zpp_inner.weak;
            })){
                v.dispose();
                true;
            }
            else{
                false;
            }
        });
        return Vec2.get(tempx,tempy,weak);
    }
    #if nape_swc@:keep#end
 public function applyLocalForce(force:Vec2,pos:Vec2=null){
        {
            #if(!NAPE_RELEASE_BUILD)if(force!=null&&force.zpp_disp)throw "Error: "+"Vec2"+" has been disposed and cannot be used!";
            #end

        };
        {
            #if(!NAPE_RELEASE_BUILD)if(pos!=null&&pos.zpp_disp)throw "Error: "+"Vec2"+" has been disposed and cannot be used!";
            #end

        };
        #if(!NAPE_RELEASE_BUILD)if(zpp_inner.world)throw "Error: Space::world is immutable";
        #end
{
            var t=(1.0);
            {
                #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                    !((t!=t));
                };
                if(!res)throw "assert("+"!assert_isNaN(t)"+") :: "+("vec_addeq(in a: "+"zpp_inner.force"+",in b: "+"force."+",in s: "+"1.0"+")");
                #end

            };
            zpp_inner.forcex+=force.x*t;
            zpp_inner.forcey+=force.y*t;
        };
        if(pos!=null){
            zpp_inner.validate_axis();
            var rx:Float;
            var ry:Float;
            {
                rx=(zpp_inner.axisy*pos.x-zpp_inner.axisx*pos.y);
                ry=(pos.x*zpp_inner.axisx+pos.y*zpp_inner.axisy);
            };
            zpp_inner.torque+=(force.y*rx-force.x*ry);
            ({
                if(({
                    pos.zpp_inner.weak;
                })){
                    pos.dispose();
                    true;
                }
                else{
                    false;
                }
            });
        }
        if(isDynamic())zpp_inner.invalidate_wake();
        ({
            if(({
                force.zpp_inner.weak;
            })){
                force.dispose();
                true;
            }
            else{
                false;
            }
        });
    }
    #if nape_swc@:keep#end
 public function applyRelativeForce(force:Vec2,pos:Vec2=null){
        {
            #if(!NAPE_RELEASE_BUILD)if(force!=null&&force.zpp_disp)throw "Error: "+"Vec2"+" has been disposed and cannot be used!";
            #end

        };
        {
            #if(!NAPE_RELEASE_BUILD)if(pos!=null&&pos.zpp_disp)throw "Error: "+"Vec2"+" has been disposed and cannot be used!";
            #end

        };
        #if(!NAPE_RELEASE_BUILD)if(zpp_inner.world)throw "Error: Space::world is immutable";
        #end
{
            var t=(1.0);
            {
                #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                    !((t!=t));
                };
                if(!res)throw "assert("+"!assert_isNaN(t)"+") :: "+("vec_addeq(in a: "+"zpp_inner.force"+",in b: "+"force."+",in s: "+"1.0"+")");
                #end

            };
            zpp_inner.forcex+=force.x*t;
            zpp_inner.forcey+=force.y*t;
        };
        if(pos!=null){
            zpp_inner.torque+=(force.y*pos.x-force.x*pos.y);
            ({
                if(({
                    pos.zpp_inner.weak;
                })){
                    pos.dispose();
                    true;
                }
                else{
                    false;
                }
            });
        }
        if(isDynamic())zpp_inner.invalidate_wake();
        ({
            if(({
                force.zpp_inner.weak;
            })){
                force.dispose();
                true;
            }
            else{
                false;
            }
        });
    }
    #if nape_swc@:keep#end
 public function applyWorldForce(force:Vec2,pos:Vec2=null){
        {
            #if(!NAPE_RELEASE_BUILD)if(force!=null&&force.zpp_disp)throw "Error: "+"Vec2"+" has been disposed and cannot be used!";
            #end

        };
        {
            #if(!NAPE_RELEASE_BUILD)if(pos!=null&&pos.zpp_disp)throw "Error: "+"Vec2"+" has been disposed and cannot be used!";
            #end

        };
        #if(!NAPE_RELEASE_BUILD)if(zpp_inner.world)throw "Error: Space::world is immutable";
        #end
{
            var t=(1.0);
            {
                #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                    !((t!=t));
                };
                if(!res)throw "assert("+"!assert_isNaN(t)"+") :: "+("vec_addeq(in a: "+"zpp_inner.force"+",in b: "+"force."+",in s: "+"1.0"+")");
                #end

            };
            zpp_inner.forcex+=force.x*t;
            zpp_inner.forcey+=force.y*t;
        };
        if(pos!=null){
            var rx:Float;
            var ry:Float;
            {
                rx=pos.x-zpp_inner.posx;
                ry=pos.y-zpp_inner.posy;
            };
            zpp_inner.torque+=(force.y*rx-force.x*ry);
            ({
                if(({
                    pos.zpp_inner.weak;
                })){
                    pos.dispose();
                    true;
                }
                else{
                    false;
                }
            });
        }
        if(isDynamic())zpp_inner.invalidate_wake();
        ({
            if(({
                force.zpp_inner.weak;
            })){
                force.dispose();
                true;
            }
            else{
                false;
            }
        });
    }
    #if nape_swc@:keep#end
 public function applyLocalImpulse(impulse:Vec2,pos:Vec2=null){
        {
            #if(!NAPE_RELEASE_BUILD)if(impulse!=null&&impulse.zpp_disp)throw "Error: "+"Vec2"+" has been disposed and cannot be used!";
            #end

        };
        {
            #if(!NAPE_RELEASE_BUILD)if(pos!=null&&pos.zpp_disp)throw "Error: "+"Vec2"+" has been disposed and cannot be used!";
            #end

        };
        #if(!NAPE_RELEASE_BUILD)if(zpp_inner.world)throw "Error: Space::world is immutable";
        #end
 zpp_inner.validate_mass();
        {
            var t=(zpp_inner.imass);
            {
                #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                    !((t!=t));
                };
                if(!res)throw "assert("+"!assert_isNaN(t)"+") :: "+("vec_addeq(in a: "+"zpp_inner.vel"+",in b: "+"impulse."+",in s: "+"zpp_inner.imass"+")");
                #end

            };
            zpp_inner.velx+=impulse.x*t;
            zpp_inner.vely+=impulse.y*t;
        };
        if(pos!=null){
            zpp_inner.validate_axis();
            var rx:Float;
            var ry:Float;
            {
                rx=(zpp_inner.axisy*pos.x-zpp_inner.axisx*pos.y);
                ry=(pos.x*zpp_inner.axisx+pos.y*zpp_inner.axisy);
            };
            zpp_inner.validate_inertia();
            zpp_inner.angvel+=(impulse.y*rx-impulse.x*ry)*zpp_inner.iinertia;
            ({
                if(({
                    pos.zpp_inner.weak;
                })){
                    pos.dispose();
                    true;
                }
                else{
                    false;
                }
            });
        }
        if(isDynamic())zpp_inner.invalidate_wake();
        ({
            if(({
                impulse.zpp_inner.weak;
            })){
                impulse.dispose();
                true;
            }
            else{
                false;
            }
        });
    }
    #if nape_swc@:keep#end
 public function applyRelativeImpulse(impulse:Vec2,pos:Vec2=null){
        {
            #if(!NAPE_RELEASE_BUILD)if(impulse!=null&&impulse.zpp_disp)throw "Error: "+"Vec2"+" has been disposed and cannot be used!";
            #end

        };
        {
            #if(!NAPE_RELEASE_BUILD)if(pos!=null&&pos.zpp_disp)throw "Error: "+"Vec2"+" has been disposed and cannot be used!";
            #end

        };
        #if(!NAPE_RELEASE_BUILD)if(zpp_inner.world)throw "Error: Space::world is immutable";
        #end
 zpp_inner.validate_mass();
        {
            var t=(zpp_inner.imass);
            {
                #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                    !((t!=t));
                };
                if(!res)throw "assert("+"!assert_isNaN(t)"+") :: "+("vec_addeq(in a: "+"zpp_inner.vel"+",in b: "+"impulse."+",in s: "+"zpp_inner.imass"+")");
                #end

            };
            zpp_inner.velx+=impulse.x*t;
            zpp_inner.vely+=impulse.y*t;
        };
        if(pos!=null){
            zpp_inner.validate_inertia();
            zpp_inner.angvel+=(impulse.y*pos.x-impulse.x*pos.y)*zpp_inner.iinertia;
            ({
                if(({
                    pos.zpp_inner.weak;
                })){
                    pos.dispose();
                    true;
                }
                else{
                    false;
                }
            });
        }
        if(isDynamic())zpp_inner.invalidate_wake();
        ({
            if(({
                impulse.zpp_inner.weak;
            })){
                impulse.dispose();
                true;
            }
            else{
                false;
            }
        });
    }
    #if nape_swc@:keep#end
 public function applyWorldImpulse(impulse:Vec2,pos:Vec2=null){
        {
            #if(!NAPE_RELEASE_BUILD)if(impulse!=null&&impulse.zpp_disp)throw "Error: "+"Vec2"+" has been disposed and cannot be used!";
            #end

        };
        {
            #if(!NAPE_RELEASE_BUILD)if(pos!=null&&pos.zpp_disp)throw "Error: "+"Vec2"+" has been disposed and cannot be used!";
            #end

        };
        #if(!NAPE_RELEASE_BUILD)if(zpp_inner.world)throw "Error: Space::world is immutable";
        #end
 zpp_inner.validate_mass();
        {
            var t=(zpp_inner.imass);
            {
                #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                    !((t!=t));
                };
                if(!res)throw "assert("+"!assert_isNaN(t)"+") :: "+("vec_addeq(in a: "+"zpp_inner.vel"+",in b: "+"impulse."+",in s: "+"zpp_inner.imass"+")");
                #end

            };
            zpp_inner.velx+=impulse.x*t;
            zpp_inner.vely+=impulse.y*t;
        };
        if(pos!=null){
            var rx:Float;
            var ry:Float;
            {
                rx=pos.x-zpp_inner.posx;
                ry=pos.y-zpp_inner.posy;
            };
            zpp_inner.validate_inertia();
            zpp_inner.angvel+=(impulse.y*rx-impulse.x*ry)*zpp_inner.iinertia;
            ({
                if(({
                    pos.zpp_inner.weak;
                })){
                    pos.dispose();
                    true;
                }
                else{
                    false;
                }
            });
        }
        if(isDynamic())zpp_inner.invalidate_wake();
        ({
            if(({
                impulse.zpp_inner.weak;
            })){
                impulse.dispose();
                true;
            }
            else{
                false;
            }
        });
    }
    #if nape_swc@:keep#end
 public function translateShapes(displacement:Vec2){
        zpp_inner.immutable_midstep("Body::translateShapes()");
        {
            #if(!NAPE_RELEASE_BUILD)if(displacement!=null&&displacement.zpp_disp)throw "Error: "+"Vec2"+" has been disposed and cannot be used!";
            #end

        };
        #if(!NAPE_RELEASE_BUILD)if(zpp_inner.world)throw "Error: Space::world is immutable";
        #end
#if(!NAPE_RELEASE_BUILD)if(displacement==null)throw "Error: Cannot displace by null Vec2";
        #end
 var weak=displacement.zpp_inner.weak;
        displacement.zpp_inner.weak=false;
        {
            var cx_ite=zpp_inner.shapes.begin();
            while(cx_ite!=null){
                var s=cx_ite.elem();
                s.outer.translate(displacement);
                cx_ite=cx_ite.next;
            }
        };
        displacement.zpp_inner.weak=weak;
        ({
            if(({
                displacement.zpp_inner.weak;
            })){
                displacement.dispose();
                true;
            }
            else{
                false;
            }
        });
    }
    #if nape_swc@:keep#end
 public function rotateShapes(angle:Float){
        zpp_inner.immutable_midstep("Body::rotateShapes()");
        #if(!NAPE_RELEASE_BUILD)if(zpp_inner.world)throw "Error: Space::world is immutable";
        #end
{
            var cx_ite=zpp_inner.shapes.begin();
            while(cx_ite!=null){
                var s=cx_ite.elem();
                s.outer.rotate(angle);
                cx_ite=cx_ite.next;
            }
        };
    }
    #if nape_swc@:keep#end
 public function scaleShapes(scalex:Float,scaley:Float){
        zpp_inner.immutable_midstep("Body::scaleShapes()");
        #if(!NAPE_RELEASE_BUILD)if(zpp_inner.world)throw "Error: Space::world is immutable";
        #end
{
            var cx_ite=zpp_inner.shapes.begin();
            while(cx_ite!=null){
                var s=cx_ite.elem();
                s.outer.scale(scalex,scaley);
                cx_ite=cx_ite.next;
            }
        };
    }
    #if nape_swc@:keep#end
 public function transformShapes(matrix:Mat23){
        zpp_inner.immutable_midstep("Body::transformShapes()");
        #if(!NAPE_RELEASE_BUILD)if(zpp_inner.world)throw "Error: Space::world is immutable";
        #end
{
            var cx_ite=zpp_inner.shapes.begin();
            while(cx_ite!=null){
                var s=cx_ite.elem();
                s.outer.transform(matrix);
                cx_ite=cx_ite.next;
            }
        };
    }
    #if nape_swc@:keep#end
 public function align(){
        zpp_inner.immutable_midstep("Body::align()");
        #if(!NAPE_RELEASE_BUILD)if(zpp_inner.world)throw "Error: Space::world is immutable";
        #end
#if(!NAPE_RELEASE_BUILD)if(zpp_inner.shapes.empty())throw "Error: Cannot align empty Body";
        #end
 zpp_inner.validate_localCOM();
        var dx=Vec2.get(-zpp_inner.localCOMx,-zpp_inner.localCOMy);
        translateShapes(dx);
        var dx2=localToRelative(dx);
        position.subeq(dx2);
        if(zpp_inner.pre_posx<ZPP_Const.POSINF()){
            var t=(1.0);
            {
                #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                    !((t!=t));
                };
                if(!res)throw "assert("+"!assert_isNaN(t)"+") :: "+("vec_subeq(in a: "+"zpp_inner.pre_pos"+",in b: "+"dx2."+",in s: "+"1.0"+")");
                #end

            };
            zpp_inner.pre_posx-=dx2.x*t;
            zpp_inner.pre_posy-=dx2.y*t;
        };
        dx.dispose();
        dx2.dispose();
    }
    #if nape_swc@:keep#end
 public function rotate(centre:Vec2,angle:Float){
        {
            #if(!NAPE_RELEASE_BUILD)if(centre!=null&&centre.zpp_disp)throw "Error: "+"Vec2"+" has been disposed and cannot be used!";
            #end

        };
        #if(!NAPE_RELEASE_BUILD)if(centre==null)throw "Error: Cannot rotate about a null Vec2";
        #end
#if(!NAPE_RELEASE_BUILD)if((angle!=angle))throw "Error: Cannot rotate by NaN radians";
        #end
 var weak=centre.zpp_inner.weak;
        centre.zpp_inner.weak=false;
        var del=position.sub(centre);
        del.rotate(angle);
        position=centre.add(del,true);
        del.dispose();
        rotation+=angle;
        centre.zpp_inner.weak=weak;
        ({
            if(({
                centre.zpp_inner.weak;
            })){
                centre.dispose();
                true;
            }
            else{
                false;
            }
        });
    }
    #if nape_swc@:keep#end
 public function setShapeMaterials(material:Material){
        zpp_inner.immutable_midstep("Body::setShapeMaterials()");
        #if(!NAPE_RELEASE_BUILD)if(zpp_inner.world)throw "Error: Space::world is immutable";
        #end
{
            var cx_ite=zpp_inner.shapes.begin();
            while(cx_ite!=null){
                var s=cx_ite.elem();
                s.outer.material=material;
                cx_ite=cx_ite.next;
            }
        };
    }
    #if nape_swc@:keep#end
 public function setShapeFilters(filter:InteractionFilter){
        zpp_inner.immutable_midstep("Body::setShapeFilters()");
        #if(!NAPE_RELEASE_BUILD)if(zpp_inner.world)throw "Error: Space::world is immutable";
        #end
{
            var cx_ite=zpp_inner.shapes.begin();
            while(cx_ite!=null){
                var s=cx_ite.elem();
                s.outer.filter=filter;
                cx_ite=cx_ite.next;
            }
        };
    }
    #if nape_swc@:keep#end
 public function setShapeFluidProperties(fluidProperties:FluidProperties){
        zpp_inner.immutable_midstep("Body::setShapeFluidProperties()");
        #if(!NAPE_RELEASE_BUILD)if(zpp_inner.world)throw "Error: Space::world is immutable";
        #end
{
            var cx_ite=zpp_inner.shapes.begin();
            while(cx_ite!=null){
                var s=cx_ite.elem();
                s.outer.fluidProperties=fluidProperties;
                cx_ite=cx_ite.next;
            }
        };
    }
    public var localCOM(get_localCOM,never):Vec2;
    inline function get_localCOM():Vec2{
        #if(!NAPE_RELEASE_BUILD)if(zpp_inner.world)throw "Error: Space::world has no "+"localCOM";
        #end
 if(zpp_inner.wrap_localCOM==null){
            zpp_inner.wrap_localCOM=Vec2.get(zpp_inner.localCOMx,zpp_inner.localCOMy);
            zpp_inner.wrap_localCOM.zpp_inner._inuse=true;
            zpp_inner.wrap_localCOM.zpp_inner._immutable=true;
            zpp_inner.wrap_localCOM.zpp_inner._validate=zpp_inner.getlocalCOM;
        }
        return zpp_inner.wrap_localCOM;
    }
    public var worldCOM(get_worldCOM,never):Vec2;
    inline function get_worldCOM():Vec2{
        #if(!NAPE_RELEASE_BUILD)if(zpp_inner.world)throw "Error: Space::world has no "+"worldCOM";
        #end
 if(zpp_inner.wrap_worldCOM==null){
            zpp_inner.wrap_worldCOM=Vec2.get(zpp_inner.worldCOMx,zpp_inner.worldCOMy);
            zpp_inner.wrap_worldCOM.zpp_inner._inuse=true;
            zpp_inner.wrap_worldCOM.zpp_inner._immutable=true;
            zpp_inner.wrap_worldCOM.zpp_inner._validate=zpp_inner.getworldCOM;
        }
        return zpp_inner.wrap_worldCOM;
    }
    #if nape_swc@:keep#end
 public function normalImpulse(body:Body=null,freshOnly:Bool=false,weak:Bool=false){
        var retx:Float=0;
        var rety:Float=0;
        {
            #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                !((retx!=retx));
            };
            if(!res)throw "assert("+"!assert_isNaN(retx)"+") :: "+("vec_new(in n: "+"ret"+",in x: "+"0"+",in y: "+"0"+")");
            #end

        };
        {
            #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                !((rety!=rety));
            };
            if(!res)throw "assert("+"!assert_isNaN(rety)"+") :: "+("vec_new(in n: "+"ret"+",in x: "+"0"+",in y: "+"0"+")");
            #end

        };
        var retz:Float=0;
        {
            var arbs=zpp_inner.arbiters;
            for(oarb in arbiters){
                var arb=oarb.zpp_inner;
                if(arb.type!=ZPP_Arbiter.COL)continue;
                if(body!=null&&arb.b2!=body.zpp_inner&&arb.b1!=body.zpp_inner)continue;
                {
                    var imp=arb.wrapper().collisionArbiter.normalImpulse(this,freshOnly);
                    {
                        var t=(1);
                        {
                            var t=(t);
                            {
                                #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                                    !((t!=t));
                                };
                                if(!res)throw "assert("+"!assert_isNaN(t)"+") :: "+("vec_addeq(in a: "+"ret"+",in b: "+"imp."+",in s: "+"t"+")");
                                #end

                            };
                            retx+=imp.x*t;
                            rety+=imp.y*t;
                        };
                        retz+=imp.z*t;
                    };
                    imp.dispose();
                };
            }
        };
        return Vec2.get(retx,rety,false);
    }
    #if nape_swc@:keep#end
 public function tangentImpulse(body:Body=null,freshOnly:Bool=false,weak:Bool=false){
        var retx:Float=0;
        var rety:Float=0;
        {
            #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                !((retx!=retx));
            };
            if(!res)throw "assert("+"!assert_isNaN(retx)"+") :: "+("vec_new(in n: "+"ret"+",in x: "+"0"+",in y: "+"0"+")");
            #end

        };
        {
            #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                !((rety!=rety));
            };
            if(!res)throw "assert("+"!assert_isNaN(rety)"+") :: "+("vec_new(in n: "+"ret"+",in x: "+"0"+",in y: "+"0"+")");
            #end

        };
        var retz:Float=0;
        {
            var arbs=zpp_inner.arbiters;
            for(oarb in arbiters){
                var arb=oarb.zpp_inner;
                if(arb.type!=ZPP_Arbiter.COL)continue;
                if(body!=null&&arb.b2!=body.zpp_inner&&arb.b1!=body.zpp_inner)continue;
                {
                    var imp=arb.wrapper().collisionArbiter.tangentImpulse(this,freshOnly);
                    {
                        var t=(1);
                        {
                            var t=(t);
                            {
                                #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                                    !((t!=t));
                                };
                                if(!res)throw "assert("+"!assert_isNaN(t)"+") :: "+("vec_addeq(in a: "+"ret"+",in b: "+"imp."+",in s: "+"t"+")");
                                #end

                            };
                            retx+=imp.x*t;
                            rety+=imp.y*t;
                        };
                        retz+=imp.z*t;
                    };
                    imp.dispose();
                };
            }
        };
        return Vec2.get(retx,rety,weak);
    }
    #if nape_swc@:keep#end
 public function totalContactsImpulse(body:Body=null,freshOnly:Bool=false){
        var retx:Float=0;
        var rety:Float=0;
        {
            #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                !((retx!=retx));
            };
            if(!res)throw "assert("+"!assert_isNaN(retx)"+") :: "+("vec_new(in n: "+"ret"+",in x: "+"0"+",in y: "+"0"+")");
            #end

        };
        {
            #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                !((rety!=rety));
            };
            if(!res)throw "assert("+"!assert_isNaN(rety)"+") :: "+("vec_new(in n: "+"ret"+",in x: "+"0"+",in y: "+"0"+")");
            #end

        };
        var retz:Float=0;
        {
            var arbs=zpp_inner.arbiters;
            for(oarb in arbiters){
                var arb=oarb.zpp_inner;
                if(arb.type!=ZPP_Arbiter.COL)continue;
                if(body!=null&&arb.b2!=body.zpp_inner&&arb.b1!=body.zpp_inner)continue;
                {
                    var imp=arb.wrapper().collisionArbiter.totalImpulse(this,freshOnly);
                    {
                        var t=(1);
                        {
                            var t=(t);
                            {
                                #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                                    !((t!=t));
                                };
                                if(!res)throw "assert("+"!assert_isNaN(t)"+") :: "+("vec_addeq(in a: "+"ret"+",in b: "+"imp."+",in s: "+"t"+")");
                                #end

                            };
                            retx+=imp.x*t;
                            rety+=imp.y*t;
                        };
                        retz+=imp.z*t;
                    };
                    imp.dispose();
                };
            }
        };
        return Vec3.get(retx,rety,retz);
    }
    #if nape_swc@:keep#end
 public function rollingImpulse(body:Body=null,freshOnly:Bool=false){
        var ret=0.0;
        {
            var arbs=zpp_inner.arbiters;
            for(oarb in arbiters){
                var arb=oarb.zpp_inner;
                if(arb.type!=ZPP_Arbiter.COL)continue;
                if(body!=null&&arb.b2!=body.zpp_inner&&arb.b1!=body.zpp_inner)continue;
                {
                    ret+=arb.wrapper().collisionArbiter.rollingImpulse(this,freshOnly);
                };
            }
        };
        return ret;
    }
    #if nape_swc@:keep#end
 public function buoyancyImpulse(body:Body=null){
        var retx:Float=0;
        var rety:Float=0;
        {
            #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                !((retx!=retx));
            };
            if(!res)throw "assert("+"!assert_isNaN(retx)"+") :: "+("vec_new(in n: "+"ret"+",in x: "+"0"+",in y: "+"0"+")");
            #end

        };
        {
            #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                !((rety!=rety));
            };
            if(!res)throw "assert("+"!assert_isNaN(rety)"+") :: "+("vec_new(in n: "+"ret"+",in x: "+"0"+",in y: "+"0"+")");
            #end

        };
        var retz:Float=0;
        {
            var arbs=zpp_inner.arbiters;
            for(oarb in arbiters){
                var arb=oarb.zpp_inner;
                if(arb.type!=ZPP_Arbiter.FLUID)continue;
                if(body!=null&&arb.b2!=body.zpp_inner&&arb.b1!=body.zpp_inner)continue;
                {
                    var imp=arb.wrapper().fluidArbiter.buoyancyImpulse(this);
                    {
                        var t=(1);
                        {
                            var t=(t);
                            {
                                #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                                    !((t!=t));
                                };
                                if(!res)throw "assert("+"!assert_isNaN(t)"+") :: "+("vec_addeq(in a: "+"ret"+",in b: "+"imp."+",in s: "+"t"+")");
                                #end

                            };
                            retx+=imp.x*t;
                            rety+=imp.y*t;
                        };
                        retz+=imp.z*t;
                    };
                    imp.dispose();
                };
            }
        };
        return Vec3.get(retx,rety,retz);
    }
    #if nape_swc@:keep#end
 public function dragImpulse(body:Body=null){
        var retx:Float=0;
        var rety:Float=0;
        {
            #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                !((retx!=retx));
            };
            if(!res)throw "assert("+"!assert_isNaN(retx)"+") :: "+("vec_new(in n: "+"ret"+",in x: "+"0"+",in y: "+"0"+")");
            #end

        };
        {
            #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                !((rety!=rety));
            };
            if(!res)throw "assert("+"!assert_isNaN(rety)"+") :: "+("vec_new(in n: "+"ret"+",in x: "+"0"+",in y: "+"0"+")");
            #end

        };
        var retz:Float=0;
        {
            var arbs=zpp_inner.arbiters;
            for(oarb in arbiters){
                var arb=oarb.zpp_inner;
                if(arb.type!=ZPP_Arbiter.FLUID)continue;
                if(body!=null&&arb.b2!=body.zpp_inner&&arb.b1!=body.zpp_inner)continue;
                {
                    var imp=arb.wrapper().fluidArbiter.dragImpulse(this);
                    {
                        var t=(1);
                        {
                            var t=(t);
                            {
                                #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                                    !((t!=t));
                                };
                                if(!res)throw "assert("+"!assert_isNaN(t)"+") :: "+("vec_addeq(in a: "+"ret"+",in b: "+"imp."+",in s: "+"t"+")");
                                #end

                            };
                            retx+=imp.x*t;
                            rety+=imp.y*t;
                        };
                        retz+=imp.z*t;
                    };
                    imp.dispose();
                };
            }
        };
        return Vec3.get(retx,rety,retz);
    }
    #if nape_swc@:keep#end
 public function totalFluidImpulse(body:Body=null){
        var retx:Float=0;
        var rety:Float=0;
        {
            #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                !((retx!=retx));
            };
            if(!res)throw "assert("+"!assert_isNaN(retx)"+") :: "+("vec_new(in n: "+"ret"+",in x: "+"0"+",in y: "+"0"+")");
            #end

        };
        {
            #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                !((rety!=rety));
            };
            if(!res)throw "assert("+"!assert_isNaN(rety)"+") :: "+("vec_new(in n: "+"ret"+",in x: "+"0"+",in y: "+"0"+")");
            #end

        };
        var retz:Float=0;
        {
            var arbs=zpp_inner.arbiters;
            for(oarb in arbiters){
                var arb=oarb.zpp_inner;
                if(arb.type!=ZPP_Arbiter.FLUID)continue;
                if(body!=null&&arb.b2!=body.zpp_inner&&arb.b1!=body.zpp_inner)continue;
                {
                    var imp=arb.wrapper().fluidArbiter.totalImpulse(this);
                    {
                        var t=(1);
                        {
                            var t=(t);
                            {
                                #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                                    !((t!=t));
                                };
                                if(!res)throw "assert("+"!assert_isNaN(t)"+") :: "+("vec_addeq(in a: "+"ret"+",in b: "+"imp."+",in s: "+"t"+")");
                                #end

                            };
                            retx+=imp.x*t;
                            rety+=imp.y*t;
                        };
                        retz+=imp.z*t;
                    };
                    imp.dispose();
                };
            }
        };
        return Vec3.get(retx,rety,retz);
    }
    #if nape_swc@:keep#end
 public function constraintsImpulse(){
        var retx:Float=0;
        var rety:Float=0;
        {
            #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                !((retx!=retx));
            };
            if(!res)throw "assert("+"!assert_isNaN(retx)"+") :: "+("vec_new(in n: "+"ret"+",in x: "+"0"+",in y: "+"0"+")");
            #end

        };
        {
            #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                !((rety!=rety));
            };
            if(!res)throw "assert("+"!assert_isNaN(rety)"+") :: "+("vec_new(in n: "+"ret"+",in x: "+"0"+",in y: "+"0"+")");
            #end

        };
        var retz:Float=0;
        {
            var cx_ite=zpp_inner.constraints.begin();
            while(cx_ite!=null){
                var con=cx_ite.elem();
                {
                    var imp=con.outer.bodyImpulse(this);
                    {
                        var t=(1);
                        {
                            var t=(t);
                            {
                                #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                                    !((t!=t));
                                };
                                if(!res)throw "assert("+"!assert_isNaN(t)"+") :: "+("vec_addeq(in a: "+"ret"+",in b: "+"imp."+",in s: "+"t"+")");
                                #end

                            };
                            retx+=imp.x*t;
                            rety+=imp.y*t;
                        };
                        retz+=imp.z*t;
                    };
                    imp.dispose();
                };
                cx_ite=cx_ite.next;
            }
        };
        return Vec3.get(retx,rety,retz);
    }
    #if nape_swc@:keep#end
 public function totalImpulse(body:Body=null,freshOnly:Bool=false){
        var retx:Float=0;
        var rety:Float=0;
        {
            #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                !((retx!=retx));
            };
            if(!res)throw "assert("+"!assert_isNaN(retx)"+") :: "+("vec_new(in n: "+"ret"+",in x: "+"0"+",in y: "+"0"+")");
            #end

        };
        {
            #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                !((rety!=rety));
            };
            if(!res)throw "assert("+"!assert_isNaN(rety)"+") :: "+("vec_new(in n: "+"ret"+",in x: "+"0"+",in y: "+"0"+")");
            #end

        };
        var retz:Float=0;
        var arbs=zpp_inner.arbiters;
        for(oarb in arbiters){
            var arb=oarb.zpp_inner;
            if(arb.type==ZPP_Arbiter.SENSOR)continue;
            if(body!=null&&arb.b2!=body.zpp_inner&&arb.b1!=body.zpp_inner)continue;
            var imp=arb.wrapper().totalImpulse(this,freshOnly);
            {
                var t=(1);
                {
                    var t=(t);
                    {
                        #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                            !((t!=t));
                        };
                        if(!res)throw "assert("+"!assert_isNaN(t)"+") :: "+("vec_addeq(in a: "+"ret"+",in b: "+"imp."+",in s: "+"t"+")");
                        #end

                    };
                    retx+=imp.x*t;
                    rety+=imp.y*t;
                };
                retz+=imp.z*t;
            };
            imp.dispose();
        }
        {
            var cx_ite=zpp_inner.constraints.begin();
            while(cx_ite!=null){
                var con=cx_ite.elem();
                {
                    if(con.active){
                        var imp=con.outer.bodyImpulse(this);
                        {
                            var t=(1);
                            {
                                var t=(t);
                                {
                                    #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                                        !((t!=t));
                                    };
                                    if(!res)throw "assert("+"!assert_isNaN(t)"+") :: "+("vec_addeq(in a: "+"ret"+",in b: "+"imp."+",in s: "+"t"+")");
                                    #end

                                };
                                retx+=imp.x*t;
                                rety+=imp.y*t;
                            };
                            retz+=imp.z*t;
                        };
                        imp.dispose();
                    }
                };
                cx_ite=cx_ite.next;
            }
        };
        return Vec3.get(retx,rety,retz);
    }
    #if nape_swc@:keep#end
 public function contains(point:Vec2){
        {
            #if(!NAPE_RELEASE_BUILD)if(point!=null&&point.zpp_disp)throw "Error: "+"Vec2"+" has been disposed and cannot be used!";
            #end

        };
        #if(!NAPE_RELEASE_BUILD)if(point==null)throw "Error: Cannot check containment of null point";
        #end
 var retvar;
        {
            retvar=false;
            {
                var cx_ite=zpp_inner.shapes.begin();
                while(cx_ite!=null){
                    var s=cx_ite.elem();
                    {
                        if(s.outer.contains(point)){
                            retvar=true;
                            break;
                        }
                    };
                    cx_ite=cx_ite.next;
                }
            };
        };
        return retvar;
    }
    @:keep public override function toString(){
        return(zpp_inner.world?"(space::world":("("+(isDynamic()?"dynamic":isStatic()?"static":"kinematic")))+")#"+id;
    }
}
