package nape.shape;
import zpp_nape.ID;
import zpp_nape.Config;
import zpp_nape.Const;
import zpp_nape.dynamics.SpaceArbiterList;
import zpp_nape.dynamics.InteractionGroup;
import zpp_nape.dynamics.InteractionFilter;
import zpp_nape.dynamics.Contact;
import zpp_nape.space.SweepPhase;
import zpp_nape.dynamics.Arbiter;
import zpp_nape.space.DynAABBPhase;
import zpp_nape.space.Broadphase;
import zpp_nape.shape.Polygon;
import zpp_nape.shape.Circle;
import zpp_nape.shape.Edge;
import zpp_nape.shape.Shape;
import zpp_nape.util.Circular;
import zpp_nape.util.Flags;
import zpp_nape.util.Names;
import zpp_nape.space.Space;
import zpp_nape.util.HaxeMacros;
import zpp_nape.util.FastHash;
import zpp_nape.util.Array2;
import zpp_nape.util.Queue;
import zpp_nape.util.RBTree;
import zpp_nape.util.WrapLists;
import zpp_nape.util.Debug;
import zpp_nape.util.Math;
import zpp_nape.util.UserData;
import zpp_nape.util.DisjointSetForest;
import zpp_nape.util.Pool;
import zpp_nape.geom.MatMath;
import zpp_nape.geom.Vec3;
import zpp_nape.geom.Mat23;
import zpp_nape.geom.Convex;
import zpp_nape.util.Lists;
import zpp_nape.geom.Simple;
import zpp_nape.geom.Triangular;
import zpp_nape.geom.Geom;
import zpp_nape.geom.VecMath;
import zpp_nape.geom.PartitionedPoly;
import zpp_nape.geom.Cutter;
import zpp_nape.geom.Simplify;
import zpp_nape.geom.Ray;
import zpp_nape.geom.Distance;
import zpp_nape.geom.Monotone;
import zpp_nape.geom.PolyIter;
import zpp_nape.geom.AABB;
import zpp_nape.geom.MarchingSquares;
import zpp_nape.geom.Vec2;
import zpp_nape.geom.MatMN;
import zpp_nape.geom.GeomPoly;
import zpp_nape.callbacks.CbSetPair;
import zpp_nape.callbacks.CbSet;
import zpp_nape.geom.Collide;
import zpp_nape.callbacks.Callback;
import zpp_nape.callbacks.Listener;
import zpp_nape.callbacks.CbType;
import zpp_nape.phys.FluidProperties;
import zpp_nape.callbacks.OptionType;
import zpp_nape.phys.FeatureMix;
import zpp_nape.phys.Compound;
import zpp_nape.phys.Interactor;
import zpp_nape.phys.Material;
import zpp_nape.constraint.DistanceJoint;
import zpp_nape.phys.Body;
import zpp_nape.constraint.WeldJoint;
import zpp_nape.constraint.MotorJoint;
import zpp_nape.constraint.Constraint;
import zpp_nape.constraint.AngleJoint;
import zpp_nape.constraint.LinearJoint;
import zpp_nape.constraint.UserConstraint;
import zpp_nape.constraint.LineJoint;
import nape.dynamics.FluidArbiter;
import nape.dynamics.ContactList;
import zpp_nape.constraint.PivotJoint;
import nape.dynamics.Arbiter;
import nape.dynamics.InteractionGroupList;
import nape.dynamics.ArbiterType;
import nape.dynamics.ArbiterIterator;
import nape.dynamics.ContactIterator;
import nape.dynamics.InteractionGroupIterator;
import nape.dynamics.InteractionGroup;
import nape.dynamics.InteractionFilter;
import nape.dynamics.ArbiterList;
import nape.dynamics.CollisionArbiter;
import nape.dynamics.Contact;
import nape.space.Broadphase;
import nape.shape.ShapeType;
import nape.shape.ShapeList;
import nape.space.Space;
import nape.shape.Polygon;
import nape.shape.EdgeList;
import nape.shape.ShapeIterator;
import nape.shape.Circle;
import nape.shape.Edge;
import nape.shape.EdgeIterator;
import nape.util.Debug;
import nape.util.BitmapDebug;
import nape.geom.GeomPolyIterator;
import nape.util.ShapeDebug;
import nape.geom.Vec3;
import nape.geom.RayResultIterator;
import nape.geom.GeomPolyList;
import nape.geom.Winding;
import nape.geom.RayResultList;
import nape.geom.Geom;
import nape.geom.Vec2Iterator;
import nape.geom.GeomVertexIterator;
import nape.geom.Mat23;
import nape.geom.Ray;
import nape.geom.RayResult;
import nape.geom.MarchingSquares;
import nape.geom.AABB;
import nape.geom.MatMN;
import nape.geom.Vec2;
import nape.geom.Vec2List;
import nape.callbacks.ListenerList;
import nape.callbacks.ListenerType;
import nape.callbacks.InteractionType;
import nape.callbacks.ConstraintCallback;
import nape.callbacks.CbTypeIterator;
import nape.callbacks.BodyCallback;
import nape.geom.GeomPoly;
import nape.callbacks.Callback;
import nape.callbacks.OptionType;
import nape.callbacks.ListenerIterator;
import nape.callbacks.PreFlag;
import nape.callbacks.Listener;
import nape.callbacks.PreCallback;
import nape.callbacks.CbType;
import nape.callbacks.ConstraintListener;
import nape.callbacks.PreListener;
import nape.callbacks.InteractionCallback;
import nape.callbacks.BodyListener;
import nape.callbacks.CbEvent;
import nape.callbacks.CbTypeList;
import nape.phys.InertiaMode;
import nape.phys.FluidProperties;
import nape.phys.CompoundIterator;
import nape.phys.BodyType;
import nape.callbacks.InteractionListener;
import nape.phys.BodyList;
import nape.phys.GravMassMode;
import nape.phys.MassMode;
import nape.phys.Interactor;
import nape.phys.Compound;
import nape.phys.CompoundList;
import nape.phys.InteractorIterator;
import nape.phys.Material;
import nape.phys.InteractorList;
import nape.phys.BodyIterator;
import nape.constraint.DistanceJoint;
import nape.constraint.WeldJoint;
import nape.constraint.MotorJoint;
import nape.constraint.Constraint;
import nape.constraint.ConstraintIterator;
import nape.constraint.AngleJoint;
import nape.constraint.ConstraintList;
import nape.constraint.LinearJoint;
import nape.constraint.UserConstraint;
import nape.phys.Body;
import nape.constraint.LineJoint;
import nape.constraint.PivotJoint;
#if nape_swc@:keep#end
 class Shape extends Interactor{
    public var zpp_inner:ZPP_Shape;
    public var type(get_type,never):ShapeType;
    inline function get_type():ShapeType{
        return[ShapeType.CIRCLE,ShapeType.POLYGON][zpp_inner.type];
    }
    #if nape_swc@:keep#end
 public function isCircle()return zpp_inner.isCircle()#if nape_swc@:keep#end
 public function isPolygon()return zpp_inner.isPolygon()function new(){
        #if(!NAPE_RELEASE_BUILD)try{
            super();
        }
        catch(e:Dynamic){}
        #end
#if NAPE_RELEASE_BUILD super();
        #end
#if(!NAPE_RELEASE_BUILD)throw "Error: Shape cannot be instantiated derp!";
        #end

    }
    public var body(get_body,set_body):Body;
    inline function get_body():Body{
        return if(zpp_inner.body!=null)zpp_inner.body.outer else null;
    }
    inline function set_body(body:Body):Body{
        {
            zpp_inner.immutable_midstep("Shape::body");
            if(this.body!=body){
                if(zpp_inner.body!=null)this.body.shapes.remove(this);
                if(body!=null)body.shapes.add(this);
            }
        }
        return this.body;
    }
    public var castCircle(get_castCircle,never):Circle;
    inline function get_castCircle():Circle return if(isCircle())zpp_inner.circle.outer_zn else null public var castPolygon(get_castPolygon,never):Polygon;
    inline function get_castPolygon():Polygon return if(isPolygon())zpp_inner.polygon.outer_zn else null public var worldCOM(get_worldCOM,never):Vec2;
    inline function get_worldCOM():Vec2{
        if(zpp_inner.wrap_worldCOM==null){
            zpp_inner.wrap_worldCOM=Vec2.get(zpp_inner.worldCOMx,zpp_inner.worldCOMy);
            zpp_inner.wrap_worldCOM.zpp_inner._inuse=true;
            zpp_inner.wrap_worldCOM.zpp_inner._immutable=true;
            zpp_inner.wrap_worldCOM.zpp_inner._validate=zpp_inner.getworldCOM;
        }
        return zpp_inner.wrap_worldCOM;
    }
    public var localCOM(get_localCOM,set_localCOM):Vec2;
    inline function get_localCOM():Vec2{
        if(zpp_inner.wrap_localCOM==null){
            if(isCircle())zpp_inner.circle.setupLocalCOM();
            else zpp_inner.polygon.setupLocalCOM();
        }
        return zpp_inner.wrap_localCOM;
    }
    inline function set_localCOM(localCOM:Vec2):Vec2{
        {
            zpp_inner.immutable_midstep("Body::localCOM");
            {
                #if(!NAPE_RELEASE_BUILD)if(localCOM!=null&&localCOM.zpp_disp)throw "Error: "+"Vec2"+" has been disposed and cannot be used!";
                #end

            };
            #if(!NAPE_RELEASE_BUILD)if(localCOM==null)throw "Error: Shape::localCOM cannot be null";
            #end
 this.localCOM.set(localCOM);
        }
        return this.localCOM;
    }
    public var area(get_area,never):Float;
    inline function get_area():Float{
        zpp_inner.validate_area_inertia();
        return zpp_inner.area;
    }
    public var inertia(get_inertia,never):Float;
    inline function get_inertia():Float{
        zpp_inner.validate_area_inertia();
        return zpp_inner.inertia;
    }
    public var angDrag(get_angDrag,never):Float;
    inline function get_angDrag():Float{
        zpp_inner.validate_angDrag();
        return zpp_inner.angDrag;
    }
    public var material(get_material,set_material):Material;
    inline function get_material():Material{
        return zpp_inner.material.wrapper();
    }
    inline function set_material(material:Material):Material{
        {
            zpp_inner.immutable_midstep("Shape::material");
            #if(!NAPE_RELEASE_BUILD)if(material==null)throw "Error: Cannot assign null as Shape material";
            #end
 zpp_inner.setMaterial(material.zpp_inner);
        }
        return this.material;
    }
    public var filter(get_filter,set_filter):InteractionFilter;
    inline function get_filter():InteractionFilter{
        return zpp_inner.filter.wrapper();
    }
    inline function set_filter(filter:InteractionFilter):InteractionFilter{
        {
            zpp_inner.immutable_midstep("Shape::filter");
            #if(!NAPE_RELEASE_BUILD)if(filter==null)throw "Error: Cannot assign null as Shape filter";
            #end
 zpp_inner.setFilter(filter.zpp_inner);
        }
        return this.filter;
    }
    public var fluidProperties(get_fluidProperties,set_fluidProperties):FluidProperties;
    inline function get_fluidProperties():FluidProperties{
        zpp_inner.immutable_midstep("Shape::fluidProperties");
        if(zpp_inner.fluidProperties==null)zpp_inner.setFluid(new FluidProperties().zpp_inner);
        return zpp_inner.fluidProperties.wrapper();
    }
    inline function set_fluidProperties(fluidProperties:FluidProperties):FluidProperties{
        {
            #if(!NAPE_RELEASE_BUILD)if(fluidProperties==null)throw "Error: Cannot assign null as Shape fluidProperties, disable fluids by setting fluidEnabled to false";
            #end
 zpp_inner.setFluid(fluidProperties.zpp_inner);
        }
        return this.fluidProperties;
    }
    public var fluidEnabled(get_fluidEnabled,set_fluidEnabled):Bool;
    inline function get_fluidEnabled():Bool{
        return zpp_inner.fluidEnabled;
    }
    inline function set_fluidEnabled(fluidEnabled:Bool):Bool{
        {
            zpp_inner.immutable_midstep("Shape::fluidEnabled");
            zpp_inner.fluidEnabled=fluidEnabled;
            if(fluidEnabled&&zpp_inner.fluidProperties==null)this.fluidProperties=new FluidProperties();
            zpp_inner.wake();
        }
        return this.fluidEnabled;
    }
    public var bounds(get_bounds,never):AABB;
    inline function get_bounds():AABB return zpp_inner.aabb.wrapper()#if nape_swc@:keep#end
 public function translate(displacement:Vec2){
        zpp_inner.immutable_midstep("Shape::translate()");
        {
            #if(!NAPE_RELEASE_BUILD)if(displacement!=null&&displacement.zpp_disp)throw "Error: "+"Vec2"+" has been disposed and cannot be used!";
            #end

        };
        #if(!NAPE_RELEASE_BUILD)if(zpp_inner.body!=null&&zpp_inner.body.space!=null&&zpp_inner.body.isStatic())throw "Error: Cannot modify Shape belonging to a static Object once inside a Space";
        if(displacement==null)throw "Error: Cannot displace Shape by null Vec2";
        #end
 if(displacement.lsq()>0){
            if(isCircle())zpp_inner.circle.__translate(displacement.x,displacement.y);
            else zpp_inner.polygon.__translate(displacement.x,displacement.y);
        }
        ({
            if(({
                displacement.zpp_inner.weak;
            })){
                displacement.dispose();
                true;
            }
            else{
                false;
            }
        });
    }
    #if nape_swc@:keep#end
 public function scale(scalex:Float,scaley:Float){
        zpp_inner.immutable_midstep("Shape::scale()");
        #if(!NAPE_RELEASE_BUILD)if(zpp_inner.body!=null&&zpp_inner.body.space!=null&&zpp_inner.body.isStatic())throw "Error: Cannot modify Shape belonging to a static Object once inside a Space";
        if((scalex!=scalex)||(scaley!=scaley))throw "Error: Cannot scale Shape by NaN";
        #end
 if(scalex!=0&&scaley!=0){
            if(isCircle()){
                var d=scalex*scalex-scaley*scaley;
                if(d*d<ZPP_Const.EPSILON){
                    zpp_inner.circle.__scale(scalex,scaley);
                }
                else{
                    #if(!NAPE_RELEASE_BUILD)throw "Error: Cannot perform a non equal scaling on a Circle";
                    #end

                }
            }
            else zpp_inner.polygon.__scale(scalex,scaley);
        }
    }
    #if nape_swc@:keep#end
 public function rotate(angle:Float){
        zpp_inner.immutable_midstep("Shape::rotate()");
        #if(!NAPE_RELEASE_BUILD)if(zpp_inner.body!=null&&zpp_inner.body.space!=null&&zpp_inner.body.isStatic())throw "Error: Cannot modify Shape belonging to a static Object once inside a Space";
        if((angle!=angle))throw "Error: Cannot rotate Shape by NaN";
        #end
 var dr=angle%(2*Math.PI);
        if(dr!=0.0){
            var cos=Math.cos(angle);
            var sin=Math.sin(angle);
            if(isCircle())zpp_inner.circle.__rotate(sin,cos);
            else zpp_inner.polygon.__rotate(sin,cos);
        }
    }
    #if nape_swc@:keep#end
 public function transform(matrix:Mat23){
        zpp_inner.immutable_midstep("Shape::transform()");
        #if(!NAPE_RELEASE_BUILD)if(zpp_inner.body!=null&&zpp_inner.body.space!=null&&zpp_inner.body.isStatic())throw "Error: Cannot modify Shape belonging to a static Object once inside a Space";
        if(matrix==null)throw "Error: Cannot transform Shape by null matrix";
        if(matrix.singular())throw "Error: Cannot transform Shape by a singular matrix";
        #end
 if(isCircle()){
            if(matrix.equiorthogonal()){
                zpp_inner.circle.__transform(matrix);
            }
            else{
                #if(!NAPE_RELEASE_BUILD)throw "Error: Cannot transform Circle by a non equiorthogonal matrix";
                #end

            }
        }
        else zpp_inner.polygon.__transform(matrix);
    }
    #if nape_swc@:keep#end
 public function contains(point:Vec2){
        {
            #if(!NAPE_RELEASE_BUILD)if(point!=null&&point.zpp_disp)throw "Error: "+"Vec2"+" has been disposed and cannot be used!";
            #end

        };
        #if(!NAPE_RELEASE_BUILD)if(point==null)throw "Cannot check null point for containment";
        #end
#if(!NAPE_RELEASE_BUILD)if(body==null)throw "Error: Shape is not well defined without a Body";
        #end
 ZPP_Geom.validateShape(zpp_inner);
        return ZPP_Collide.shapeContains(zpp_inner,point.zpp_inner);
    }
    #if nape_swc@:keep#end
 public static function copy(shape:Shape){
        #if(!NAPE_RELEASE_BUILD)if(shape==null)throw "Error: Cannot copy null Shape";
        #end
 var ret=shape.zpp_inner.copy();
        ret.zpp_inner.userData=shape.zpp_inner.userData;
        return ret;
    }
    @:keep public override function toString(){
        var ret=isCircle()?"Circle":"Polygon";
        return ret+"#"+id;
    }
}
