package nape.space;
import zpp_nape.ID;
import zpp_nape.Config;
import zpp_nape.Const;
import zpp_nape.dynamics.SpaceArbiterList;
import zpp_nape.dynamics.InteractionGroup;
import zpp_nape.dynamics.InteractionFilter;
import zpp_nape.dynamics.Contact;
import zpp_nape.space.SweepPhase;
import zpp_nape.dynamics.Arbiter;
import zpp_nape.space.DynAABBPhase;
import zpp_nape.space.Broadphase;
import zpp_nape.shape.Polygon;
import zpp_nape.shape.Circle;
import zpp_nape.shape.Edge;
import zpp_nape.shape.Shape;
import zpp_nape.util.Circular;
import zpp_nape.util.Flags;
import zpp_nape.util.Names;
import zpp_nape.space.Space;
import zpp_nape.util.HaxeMacros;
import zpp_nape.util.FastHash;
import zpp_nape.util.Array2;
import zpp_nape.util.Queue;
import zpp_nape.util.RBTree;
import zpp_nape.util.WrapLists;
import zpp_nape.util.Debug;
import zpp_nape.util.Math;
import zpp_nape.util.UserData;
import zpp_nape.util.DisjointSetForest;
import zpp_nape.util.Pool;
import zpp_nape.geom.MatMath;
import zpp_nape.geom.Vec3;
import zpp_nape.geom.Mat23;
import zpp_nape.geom.Convex;
import zpp_nape.util.Lists;
import zpp_nape.geom.Simple;
import zpp_nape.geom.Triangular;
import zpp_nape.geom.Geom;
import zpp_nape.geom.VecMath;
import zpp_nape.geom.PartitionedPoly;
import zpp_nape.geom.Cutter;
import zpp_nape.geom.Simplify;
import zpp_nape.geom.Ray;
import zpp_nape.geom.Distance;
import zpp_nape.geom.Monotone;
import zpp_nape.geom.PolyIter;
import zpp_nape.geom.AABB;
import zpp_nape.geom.MarchingSquares;
import zpp_nape.geom.Vec2;
import zpp_nape.geom.MatMN;
import zpp_nape.geom.GeomPoly;
import zpp_nape.callbacks.CbSetPair;
import zpp_nape.callbacks.CbSet;
import zpp_nape.geom.Collide;
import zpp_nape.callbacks.Callback;
import zpp_nape.callbacks.Listener;
import zpp_nape.callbacks.CbType;
import zpp_nape.phys.FluidProperties;
import zpp_nape.callbacks.OptionType;
import zpp_nape.phys.FeatureMix;
import zpp_nape.phys.Compound;
import zpp_nape.phys.Interactor;
import zpp_nape.phys.Material;
import zpp_nape.constraint.DistanceJoint;
import zpp_nape.phys.Body;
import zpp_nape.constraint.WeldJoint;
import zpp_nape.constraint.MotorJoint;
import zpp_nape.constraint.Constraint;
import zpp_nape.constraint.AngleJoint;
import zpp_nape.constraint.LinearJoint;
import zpp_nape.constraint.UserConstraint;
import zpp_nape.constraint.LineJoint;
import nape.dynamics.FluidArbiter;
import nape.dynamics.ContactList;
import zpp_nape.constraint.PivotJoint;
import nape.dynamics.Arbiter;
import nape.dynamics.InteractionGroupList;
import nape.dynamics.ArbiterType;
import nape.dynamics.ArbiterIterator;
import nape.dynamics.ContactIterator;
import nape.dynamics.InteractionGroupIterator;
import nape.dynamics.InteractionGroup;
import nape.dynamics.InteractionFilter;
import nape.dynamics.ArbiterList;
import nape.dynamics.CollisionArbiter;
import nape.dynamics.Contact;
import nape.space.Broadphase;
import nape.shape.ShapeType;
import nape.shape.ShapeList;
import nape.shape.Polygon;
import nape.shape.EdgeList;
import nape.shape.ShapeIterator;
import nape.shape.Circle;
import nape.shape.Edge;
import nape.shape.EdgeIterator;
import nape.shape.Shape;
import nape.util.Debug;
import nape.util.BitmapDebug;
import nape.geom.GeomPolyIterator;
import nape.util.ShapeDebug;
import nape.geom.Vec3;
import nape.geom.RayResultIterator;
import nape.geom.GeomPolyList;
import nape.geom.Winding;
import nape.geom.RayResultList;
import nape.geom.Geom;
import nape.geom.Vec2Iterator;
import nape.geom.GeomVertexIterator;
import nape.geom.Mat23;
import nape.geom.Ray;
import nape.geom.RayResult;
import nape.geom.MarchingSquares;
import nape.geom.AABB;
import nape.geom.MatMN;
import nape.geom.Vec2;
import nape.geom.Vec2List;
import nape.callbacks.ListenerList;
import nape.callbacks.ListenerType;
import nape.callbacks.InteractionType;
import nape.callbacks.ConstraintCallback;
import nape.callbacks.CbTypeIterator;
import nape.callbacks.BodyCallback;
import nape.geom.GeomPoly;
import nape.callbacks.Callback;
import nape.callbacks.OptionType;
import nape.callbacks.ListenerIterator;
import nape.callbacks.PreFlag;
import nape.callbacks.Listener;
import nape.callbacks.PreCallback;
import nape.callbacks.CbType;
import nape.callbacks.ConstraintListener;
import nape.callbacks.PreListener;
import nape.callbacks.InteractionCallback;
import nape.callbacks.BodyListener;
import nape.callbacks.CbEvent;
import nape.callbacks.CbTypeList;
import nape.phys.InertiaMode;
import nape.phys.FluidProperties;
import nape.phys.CompoundIterator;
import nape.phys.BodyType;
import nape.callbacks.InteractionListener;
import nape.phys.BodyList;
import nape.phys.GravMassMode;
import nape.phys.MassMode;
import nape.phys.Interactor;
import nape.phys.Compound;
import nape.phys.CompoundList;
import nape.phys.InteractorIterator;
import nape.phys.Material;
import nape.phys.InteractorList;
import nape.phys.BodyIterator;
import nape.constraint.DistanceJoint;
import nape.constraint.WeldJoint;
import nape.constraint.MotorJoint;
import nape.constraint.Constraint;
import nape.constraint.ConstraintIterator;
import nape.constraint.AngleJoint;
import nape.constraint.ConstraintList;
import nape.constraint.LinearJoint;
import nape.constraint.UserConstraint;
import nape.phys.Body;
import nape.constraint.LineJoint;
import nape.constraint.PivotJoint;
#if nape_swc@:keep#end
 class Space{
    public var zpp_inner:ZPP_Space;
    public var id(get_id,never):Int;
    inline function get_id():Int return zpp_inner.id public var userData(get_userData,never):Dynamic<Dynamic>;
    inline function get_userData():Dynamic<Dynamic>{
        if(zpp_inner.userData==null){
            zpp_inner.userData=cast{};
        }
        return zpp_inner.userData;
    }
    public var gravity(get_gravity,set_gravity):Vec2;
    inline function get_gravity():Vec2{
        if(zpp_inner.wrap_gravity==null)zpp_inner.getgravity();
        return zpp_inner.wrap_gravity;
    }
    inline function set_gravity(gravity:Vec2):Vec2{
        {
            {
                #if(!NAPE_RELEASE_BUILD)if(gravity!=null&&gravity.zpp_disp)throw "Error: "+"Vec2"+" has been disposed and cannot be used!";
                #end

            };
            #if(!NAPE_RELEASE_BUILD)if(gravity==null)throw "Error: Space::gravity cannot be null";
            #end
 this.gravity.set(gravity);
        }
        return this.gravity;
    }
    public var broadphase(get_broadphase,never):Broadphase;
    inline function get_broadphase():Broadphase{
        return zpp_inner.bphase.is_sweep?Broadphase.SWEEP_AND_PRUNE:Broadphase.DYNAMIC_AABB_TREE;
    }
    public var sortContacts(get_sortContacts,set_sortContacts):Bool;
    inline function get_sortContacts():Bool{
        return zpp_inner.sortcontacts;
    }
    inline function set_sortContacts(sortContacts:Bool):Bool{
        {
            zpp_inner.sortcontacts=sortContacts;
        }
        return this.sortContacts;
    }
    public var worldAngularDrag(get_worldAngularDrag,set_worldAngularDrag):Float;
    inline function get_worldAngularDrag():Float{
        return zpp_inner.global_ang_drag;
    }
    inline function set_worldAngularDrag(worldAngularDrag:Float):Float{
        {
            var d=worldAngularDrag;
            #if(!NAPE_RELEASE_BUILD)if((d!=d))throw "Error: Space::worldAngularDrag cannot be NaN";
            #end
 zpp_inner.global_ang_drag=d;
        }
        return this.worldAngularDrag;
    }
    public var worldLinearDrag(get_worldLinearDrag,set_worldLinearDrag):Float;
    inline function get_worldLinearDrag():Float{
        return zpp_inner.global_lin_drag;
    }
    inline function set_worldLinearDrag(worldLinearDrag:Float):Float{
        {
            var d=worldLinearDrag;
            #if(!NAPE_RELEASE_BUILD)if((d!=d))throw "Error: Space::worldLinearDrag cannot be NaN";
            #end
 zpp_inner.global_lin_drag=d;
        }
        return this.worldLinearDrag;
    }
    public var compounds(get_compounds,never):CompoundList;
    inline function get_compounds():CompoundList return zpp_inner.wrap_compounds public var bodies(get_bodies,never):BodyList;
    inline function get_bodies():BodyList return zpp_inner.wrap_bodies public var liveBodies(get_liveBodies,never):BodyList;
    inline function get_liveBodies():BodyList return zpp_inner.wrap_live public var constraints(get_constraints,never):ConstraintList;
    inline function get_constraints():ConstraintList return zpp_inner.wrap_constraints public var liveConstraints(get_liveConstraints,never):ConstraintList;
    inline function get_liveConstraints():ConstraintList return zpp_inner.wrap_livecon public function visitBodies(lambda:Body->Void){
        #if(!NAPE_RELEASE_BUILD)if(lambda==null)throw "Error: lambda cannot be null for Space::visitBodies";
        #end
 for(b in bodies)lambda(b);
        for(c in compounds)c.visitBodies(lambda);
    }
    public function visitConstraints(lambda:Constraint->Void){
        #if(!NAPE_RELEASE_BUILD)if(lambda==null)throw "Error: lambda cannot be null for Space::visitConstraints";
        #end
 for(c in constraints)lambda(c);
        for(c in compounds)c.visitConstraints(lambda);
    }
    public function visitCompounds(lambda:Compound->Void){
        #if(!NAPE_RELEASE_BUILD)if(lambda==null)throw "Error: lambda cannot be null for Space::visitCompounds";
        #end
 for(c in compounds){
            lambda(c);
            c.visitCompounds(lambda);
        }
    }
    public var world(get_world,never):Body;
    inline function get_world():Body return zpp_inner.__static public var arbiters(get_arbiters,never):ArbiterList;
    inline function get_arbiters():ArbiterList{
        if(zpp_inner.wrap_arbiters==null){
            var ret=new ZPP_SpaceArbiterList();
            ret.space=zpp_inner;
            zpp_inner.wrap_arbiters=ret;
        }
        return zpp_inner.wrap_arbiters;
    }
    public var listeners(get_listeners,never):ListenerList;
    inline function get_listeners():ListenerList return zpp_inner.wrap_listeners#if nape_swc@:keep#end
 public function clear(){
        #if(!NAPE_RELEASE_BUILD)if(zpp_inner.midstep)throw "Error: Space::clear() cannot be called during space step()";
        #end
 zpp_inner.clear();
    }
    #if nape_swc@:keep#end
 public function step(deltaTime:Float,velocityIterations:Int=10,positionIterations:Int=10){
        #if(!NAPE_RELEASE_BUILD)if((deltaTime!=deltaTime))throw "Error: deltaTime cannot be NaN";
        if(deltaTime<=0)throw "Error: deltaTime must be strictly positive";
        if(velocityIterations<=0)throw "Error: must use atleast one velocity iteration";
        if(positionIterations<=0)throw "Error: must use atleast one position iteration";
        #end
 zpp_inner.step(deltaTime,velocityIterations,positionIterations);
    }
    public var timeStamp(get_timeStamp,never):Int;
    inline function get_timeStamp():Int return zpp_inner.stamp public var elapsedTime(get_elapsedTime,never):Float;
    inline function get_elapsedTime():Float return zpp_inner.time public function new(gravity:Vec2=null,broadphase:Broadphase=null){
        {
            #if(!NAPE_RELEASE_BUILD)if(gravity!=null&&gravity.zpp_disp)throw "Error: "+"Vec2"+" has been disposed and cannot be used!";
            #end

        };
        zpp_inner=new ZPP_Space(gravity==null?null:gravity.zpp_inner,broadphase);
        zpp_inner.outer=this;
        if(gravity!=null)({
            if(({
                gravity.zpp_inner.weak;
            })){
                gravity.dispose();
                true;
            }
            else{
                false;
            }
        });
    }
    #if nape_swc@:keep#end
 public function interactionType(shape1:Shape,shape2:Shape):InteractionType{
        #if(!NAPE_RELEASE_BUILD)if(shape1==null||shape2==null)throw "Error: Cannot evaluate interaction type for null shapes";
        #end
#if(!NAPE_RELEASE_BUILD)if(shape1.body==null||shape2.body==null)throw "Error: Cannot evaluate interaction type for shapes not part of a Body";
        #end
#if(!NAPE_RELEASE_BUILD)if((shape1.body.space!=null&&shape1.body.space!=this)||(shape2.body.space!=null&&shape2.body.space!=this))throw "Error: Either the Shape's Bodys' space's should be null, or equal to 'this' Space";
        #end
 if(shape1.body.isStatic()&&shape2.body.isStatic())return null;
        if(shape1.body==shape2.body)return null;
        var s1=shape1.zpp_inner;
        var s2=shape2.zpp_inner;
        return switch(zpp_inner.interactionType(s1,s2,s1.body,s2.body)){
            case 0:InteractionType.FLUID;
            case 1:InteractionType.COLLISION;
            case 2:InteractionType.SENSOR;
            default:null;
        }
    }
    #if nape_swc@:keep#end
 public function shapesUnderPoint(point:Vec2,filter:InteractionFilter=null){
        {
            #if(!NAPE_RELEASE_BUILD)if(point!=null&&point.zpp_disp)throw "Error: "+"Vec2"+" has been disposed and cannot be used!";
            #end

        };
        #if(!NAPE_RELEASE_BUILD)if(point==null)throw "Error: Cannot evaluate shapes under a null point :)";
        #end
 var ret=zpp_inner.shapesUnderPoint(point.x,point.y,filter==null?null:filter.zpp_inner);
        ({
            if(({
                point.zpp_inner.weak;
            })){
                point.dispose();
                true;
            }
            else{
                false;
            }
        });
        return ret;
    }
    #if nape_swc@:keep#end
 public function bodiesUnderPoint(point:Vec2,filter:InteractionFilter=null){
        {
            #if(!NAPE_RELEASE_BUILD)if(point!=null&&point.zpp_disp)throw "Error: "+"Vec2"+" has been disposed and cannot be used!";
            #end

        };
        #if(!NAPE_RELEASE_BUILD)if(point==null)throw "Error: Cannot evaluate objects under a null point :)";
        #end
 var ret=zpp_inner.bodiesUnderPoint(point.x,point.y,filter==null?null:filter.zpp_inner);
        ({
            if(({
                point.zpp_inner.weak;
            })){
                point.dispose();
                true;
            }
            else{
                false;
            }
        });
        return ret;
    }
    #if nape_swc@:keep#end
 public function shapesInAABB(aabb:AABB,containment:Bool=false,strict:Bool=true,filter:InteractionFilter=null){
        #if(!NAPE_RELEASE_BUILD)if(aabb==null)throw "Error: Cannot evaluate shapes in a null AABB :)";
        if(aabb.width==0||aabb.height==0)throw "Error: Cannot evaluate shapes in degenerate AABB :/";
        #end
 return zpp_inner.shapesInAABB(aabb,strict,containment,filter==null?null:filter.zpp_inner);
    }
    #if nape_swc@:keep#end
 public function bodiesInAABB(aabb:AABB,containment:Bool=false,strict:Bool=true,filter:InteractionFilter=null){
        #if(!NAPE_RELEASE_BUILD)if(aabb==null)throw "Error: Cannot evaluate objects in a null AABB :)";
        if(aabb.width==0||aabb.height==0)throw "Error: Cannot evaluate objects in degenerate AABB :/";
        #end
 return zpp_inner.bodiesInAABB(aabb,strict,containment,filter==null?null:filter.zpp_inner);
    }
    #if nape_swc@:keep#end
 public function shapesInCircle(position:Vec2,radius:Float,containment:Bool=false,filter:InteractionFilter=null){
        {
            #if(!NAPE_RELEASE_BUILD)if(position!=null&&position.zpp_disp)throw "Error: "+"Vec2"+" has been disposed and cannot be used!";
            #end

        };
        #if(!NAPE_RELEASE_BUILD)if(position==null)throw "Error: Cannot evaluate shapes at null circle :)";
        if((radius!=radius))throw "Error: Circle radius cannot be NaN";
        if(radius<=0)throw "Error: Circle radius must be strictly positive";
        #end
 var ret=zpp_inner.shapesInCircle(position,radius,containment,filter==null?null:filter.zpp_inner);
        ({
            if(({
                position.zpp_inner.weak;
            })){
                position.dispose();
                true;
            }
            else{
                false;
            }
        });
        return ret;
    }
    #if nape_swc@:keep#end
 public function bodiesInCircle(position:Vec2,radius:Float,containment:Bool=false,filter:InteractionFilter=null){
        {
            #if(!NAPE_RELEASE_BUILD)if(position!=null&&position.zpp_disp)throw "Error: "+"Vec2"+" has been disposed and cannot be used!";
            #end

        };
        #if(!NAPE_RELEASE_BUILD)if(position==null)throw "Error: Cannot evaluate objects at null circle :)";
        if((radius!=radius))throw "Error: Circle radius cannot be NaN";
        if(radius<=0)throw "Error: Circle radius must be strictly positive";
        #end
 var ret=zpp_inner.bodiesInCircle(position,radius,containment,filter==null?null:filter.zpp_inner);
        ({
            if(({
                position.zpp_inner.weak;
            })){
                position.dispose();
                true;
            }
            else{
                false;
            }
        });
        return ret;
    }
    #if nape_swc@:keep#end
 public function shapesInShape(shape:Shape,containment:Bool=false,filter:InteractionFilter=null){
        #if(!NAPE_RELEASE_BUILD)if(shape==null)throw "Error: Cannot evaluate shapes in a null shapes :)";
        if(shape.body==null)throw "Error: Query shape needs to be inside a Body to be well defined :)";
        if(shape.isPolygon()){
            var res=shape.zpp_inner.polygon.valid();
            if(res!=ValidationResult.VALID)throw "Error: Polygon query shape is invalid : "+res.toString();
        }
        #end
 return zpp_inner.shapesInShape(shape.zpp_inner,containment,filter==null?null:filter.zpp_inner);
    }
    #if nape_swc@:keep#end
 public function bodiesInShape(shape:Shape,containment:Bool=false,filter:InteractionFilter=null){
        #if(!NAPE_RELEASE_BUILD)if(shape==null)throw "Error: Cannot evaluate bodies in a null shapes :)";
        if(shape.body==null)throw "Error: Query shape needs to be inside a Body to be well defined :)";
        if(shape.isPolygon()){
            var res=shape.zpp_inner.polygon.valid();
            if(res!=ValidationResult.VALID)throw "Error: Polygon query shape is invalid : "+res.toString();
        }
        #end
 return zpp_inner.bodiesInShape(shape.zpp_inner,containment,filter==null?null:filter.zpp_inner);
    }
    #if nape_swc@:keep#end
 public function shapesInBody(body:Body,filter:InteractionFilter=null){
        #if(!NAPE_RELEASE_BUILD)if(body==null)throw "Error: Cannot evaluate shapes in null body";
        #end
 var ret=null;
        for(shape in body.shapes){
            var cur=shapesInShape(shape,false,filter);
            if(ret==null)ret=cur;
            else ret.merge(cur);
        }
        return if(ret==null)new ShapeList()else ret;
    }
    #if nape_swc@:keep#end
 public function bodiesInBody(body:Body,filter:InteractionFilter=null){
        #if(!NAPE_RELEASE_BUILD)if(body==null)throw "Error: Cannot evaluate shapes in null body";
        #end
 var ret=null;
        for(shape in body.shapes){
            var cur=bodiesInShape(shape,false,filter);
            if(ret==null)ret=cur;
            else ret.merge(cur);
        }
        return if(ret==null)new BodyList()else ret;
    }
    #if nape_swc@:keep#end
 public function rayCast(ray:Ray,inner:Bool=false,filter:InteractionFilter=null){
        #if(!NAPE_RELEASE_BUILD)if(ray==null)throw "Error: Cannot cast null ray :)";
        #end
 return zpp_inner.rayCast(ray,inner,filter);
    }
    #if nape_swc@:keep#end
 public function rayMultiCast(ray:Ray,inner:Bool=false,filter:InteractionFilter=null){
        #if(!NAPE_RELEASE_BUILD)if(ray==null)throw "Error: Cannot cast null ray :)";
        #end
 return zpp_inner.rayMultiCast(ray,inner,filter);
    }
}
