package zpp_nape.callbacks;
import zpp_nape.ID;
import zpp_nape.Config;
import zpp_nape.Const;
import zpp_nape.dynamics.SpaceArbiterList;
import zpp_nape.dynamics.InteractionGroup;
import zpp_nape.dynamics.InteractionFilter;
import zpp_nape.dynamics.Contact;
import zpp_nape.space.SweepPhase;
import zpp_nape.dynamics.Arbiter;
import zpp_nape.space.DynAABBPhase;
import zpp_nape.space.Broadphase;
import zpp_nape.shape.Polygon;
import zpp_nape.shape.Circle;
import zpp_nape.shape.Edge;
import zpp_nape.shape.Shape;
import zpp_nape.util.Circular;
import zpp_nape.util.Flags;
import zpp_nape.util.Names;
import zpp_nape.space.Space;
import zpp_nape.util.HaxeMacros;
import zpp_nape.util.FastHash;
import zpp_nape.util.Array2;
import zpp_nape.util.Queue;
import zpp_nape.util.RBTree;
import zpp_nape.util.WrapLists;
import zpp_nape.util.Debug;
import zpp_nape.util.Math;
import zpp_nape.util.UserData;
import zpp_nape.util.DisjointSetForest;
import zpp_nape.util.Pool;
import zpp_nape.geom.MatMath;
import zpp_nape.geom.Vec3;
import zpp_nape.geom.Mat23;
import zpp_nape.geom.Convex;
import zpp_nape.util.Lists;
import zpp_nape.geom.Simple;
import zpp_nape.geom.Triangular;
import zpp_nape.geom.Geom;
import zpp_nape.geom.VecMath;
import zpp_nape.geom.PartitionedPoly;
import zpp_nape.geom.Cutter;
import zpp_nape.geom.Simplify;
import zpp_nape.geom.Ray;
import zpp_nape.geom.Distance;
import zpp_nape.geom.Monotone;
import zpp_nape.geom.PolyIter;
import zpp_nape.geom.AABB;
import zpp_nape.geom.MarchingSquares;
import zpp_nape.geom.Vec2;
import zpp_nape.geom.MatMN;
import zpp_nape.geom.GeomPoly;
import zpp_nape.callbacks.CbSetPair;
import zpp_nape.callbacks.CbSet;
import zpp_nape.geom.Collide;
import zpp_nape.callbacks.Callback;
import zpp_nape.callbacks.Listener;
import zpp_nape.phys.FluidProperties;
import zpp_nape.callbacks.OptionType;
import zpp_nape.phys.FeatureMix;
import zpp_nape.phys.Compound;
import zpp_nape.phys.Interactor;
import zpp_nape.phys.Material;
import zpp_nape.constraint.DistanceJoint;
import zpp_nape.phys.Body;
import zpp_nape.constraint.WeldJoint;
import zpp_nape.constraint.MotorJoint;
import zpp_nape.constraint.Constraint;
import zpp_nape.constraint.AngleJoint;
import zpp_nape.constraint.LinearJoint;
import zpp_nape.constraint.UserConstraint;
import zpp_nape.constraint.LineJoint;
import nape.dynamics.FluidArbiter;
import nape.dynamics.ContactList;
import zpp_nape.constraint.PivotJoint;
import nape.dynamics.Arbiter;
import nape.dynamics.InteractionGroupList;
import nape.dynamics.ArbiterType;
import nape.dynamics.ArbiterIterator;
import nape.dynamics.ContactIterator;
import nape.dynamics.InteractionGroupIterator;
import nape.dynamics.InteractionGroup;
import nape.dynamics.InteractionFilter;
import nape.dynamics.ArbiterList;
import nape.dynamics.CollisionArbiter;
import nape.dynamics.Contact;
import nape.space.Broadphase;
import nape.shape.ShapeType;
import nape.shape.ShapeList;
import nape.space.Space;
import nape.shape.Polygon;
import nape.shape.EdgeList;
import nape.shape.ShapeIterator;
import nape.shape.Circle;
import nape.shape.Edge;
import nape.shape.EdgeIterator;
import nape.shape.Shape;
import nape.util.Debug;
import nape.util.BitmapDebug;
import nape.geom.GeomPolyIterator;
import nape.util.ShapeDebug;
import nape.geom.Vec3;
import nape.geom.RayResultIterator;
import nape.geom.GeomPolyList;
import nape.geom.Winding;
import nape.geom.RayResultList;
import nape.geom.Geom;
import nape.geom.Vec2Iterator;
import nape.geom.GeomVertexIterator;
import nape.geom.Mat23;
import nape.geom.Ray;
import nape.geom.RayResult;
import nape.geom.MarchingSquares;
import nape.geom.AABB;
import nape.geom.MatMN;
import nape.geom.Vec2;
import nape.geom.Vec2List;
import nape.callbacks.ListenerList;
import nape.callbacks.ListenerType;
import nape.callbacks.InteractionType;
import nape.callbacks.ConstraintCallback;
import nape.callbacks.CbTypeIterator;
import nape.callbacks.BodyCallback;
import nape.geom.GeomPoly;
import nape.callbacks.Callback;
import nape.callbacks.OptionType;
import nape.callbacks.ListenerIterator;
import nape.callbacks.PreFlag;
import nape.callbacks.Listener;
import nape.callbacks.PreCallback;
import nape.callbacks.CbType;
import nape.callbacks.ConstraintListener;
import nape.callbacks.PreListener;
import nape.callbacks.InteractionCallback;
import nape.callbacks.BodyListener;
import nape.callbacks.CbEvent;
import nape.callbacks.CbTypeList;
import nape.phys.InertiaMode;
import nape.phys.FluidProperties;
import nape.phys.CompoundIterator;
import nape.phys.BodyType;
import nape.callbacks.InteractionListener;
import nape.phys.BodyList;
import nape.phys.GravMassMode;
import nape.phys.MassMode;
import nape.phys.Interactor;
import nape.phys.Compound;
import nape.phys.CompoundList;
import nape.phys.InteractorIterator;
import nape.phys.Material;
import nape.phys.InteractorList;
import nape.phys.BodyIterator;
import nape.constraint.DistanceJoint;
import nape.constraint.WeldJoint;
import nape.constraint.MotorJoint;
import nape.constraint.Constraint;
import nape.constraint.ConstraintIterator;
import nape.constraint.AngleJoint;
import nape.constraint.ConstraintList;
import nape.constraint.LinearJoint;
import nape.constraint.UserConstraint;
import nape.phys.Body;
import nape.constraint.LineJoint;
import nape.constraint.PivotJoint;
#if nape_swc@:keep#end
 class ZPP_CbType{
    public var outer:CbType;
    public var userData:Dynamic<Dynamic>;
    public var id:Int;
    public var cbsets:ZNPList_ZPP_CbSet;
    public#if NAPE_NO_INLINE#else inline#end
 static function setlt(a:ZPP_CbType,b:ZPP_CbType):Bool{
        return a.id<b.id;
    }
    public var interactors:ZNPList_ZPP_Interactor;
    public var wrap_interactors:InteractorList;
    public var constraints:ZNPList_ZPP_Constraint;
    public var wrap_constraints:ConstraintList;
    #if NAPE_NO_INLINE#elseif(flash9&&flib)@:ns("flibdel")#end
 public#if NAPE_NO_INLINE#else inline#end
 function addConstraint(con:ZPP_Constraint)constraints.add(con)#if NAPE_NO_INLINE#elseif(flash9&&flib)@:ns("flibdel")#end
 public#if NAPE_NO_INLINE#else inline#end
 function addInteractor(intx:ZPP_Interactor)interactors.add(intx)#if NAPE_NO_INLINE#elseif(flash9&&flib)@:ns("flibdel")#end
 public#if NAPE_NO_INLINE#else inline#end
 function remConstraint(con:ZPP_Constraint)constraints.remove(con)#if NAPE_NO_INLINE#elseif(flash9&&flib)@:ns("flibdel")#end
 public#if NAPE_NO_INLINE#else inline#end
 function remInteractor(intx:ZPP_Interactor)interactors.remove(intx)public var listeners:ZNPList_ZPP_InteractionListener;
    #if NAPE_NO_INLINE#elseif(flash9&&flib)@:ns("flibdel")#end
 public#if NAPE_NO_INLINE#else inline#end
 function addint(x:ZPP_InteractionListener):Void{
        {
            #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                !listeners.has(x);
            };
            if(!res)throw "assert("+"!listeners.has(x)"+") :: "+("listener already in list");
            #end

        };
        {
            var pre=null;
            {
                var cx_ite=listeners.begin();
                while(cx_ite!=null){
                    var j=cx_ite.elem();
                    {
                        if(ZPP_Listener.setlt(x,j))break;
                        pre=cx_ite;
                    };
                    cx_ite=cx_ite.next;
                }
            };
            listeners.inlined_insert(pre,x);
        };
        invalidateint();
    }
    #if NAPE_NO_INLINE#elseif(flash9&&flib)@:ns("flibdel")#end
 public#if NAPE_NO_INLINE#else inline#end
 function removeint(x:ZPP_InteractionListener):Void{
        listeners.remove(x);
        invalidateint();
    }
    #if NAPE_NO_INLINE#elseif(flash9&&flib)@:ns("flibdel")#end
 public#if NAPE_NO_INLINE#else inline#end
 function invalidateint():Void{
        {
            var cx_ite=cbsets.begin();
            while(cx_ite!=null){
                var cb=cx_ite.elem();
                cb.invalidate_listeners();
                cx_ite=cx_ite.next;
            }
        };
    }
    public var bodylisteners:ZNPList_ZPP_BodyListener;
    #if NAPE_NO_INLINE#elseif(flash9&&flib)@:ns("flibdel")#end
 public#if NAPE_NO_INLINE#else inline#end
 function addbody(x:ZPP_BodyListener):Void{
        {
            #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                !bodylisteners.has(x);
            };
            if(!res)throw "assert("+"!bodylisteners.has(x)"+") :: "+("listener already in list");
            #end

        };
        {
            var pre=null;
            {
                var cx_ite=bodylisteners.begin();
                while(cx_ite!=null){
                    var j=cx_ite.elem();
                    {
                        if(ZPP_Listener.setlt(x,j))break;
                        pre=cx_ite;
                    };
                    cx_ite=cx_ite.next;
                }
            };
            bodylisteners.inlined_insert(pre,x);
        };
        invalidatebody();
    }
    #if NAPE_NO_INLINE#elseif(flash9&&flib)@:ns("flibdel")#end
 public#if NAPE_NO_INLINE#else inline#end
 function removebody(x:ZPP_BodyListener):Void{
        bodylisteners.remove(x);
        invalidatebody();
    }
    #if NAPE_NO_INLINE#elseif(flash9&&flib)@:ns("flibdel")#end
 public#if NAPE_NO_INLINE#else inline#end
 function invalidatebody():Void{
        {
            var cx_ite=cbsets.begin();
            while(cx_ite!=null){
                var cb=cx_ite.elem();
                cb.invalidate_bodylisteners();
                cx_ite=cx_ite.next;
            }
        };
    }
    public var conlisteners:ZNPList_ZPP_ConstraintListener;
    #if NAPE_NO_INLINE#elseif(flash9&&flib)@:ns("flibdel")#end
 public#if NAPE_NO_INLINE#else inline#end
 function addconstraint(x:ZPP_ConstraintListener):Void{
        {
            #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                !conlisteners.has(x);
            };
            if(!res)throw "assert("+"!conlisteners.has(x)"+") :: "+("listener already in list");
            #end

        };
        {
            var pre=null;
            {
                var cx_ite=conlisteners.begin();
                while(cx_ite!=null){
                    var j=cx_ite.elem();
                    {
                        if(ZPP_Listener.setlt(x,j))break;
                        pre=cx_ite;
                    };
                    cx_ite=cx_ite.next;
                }
            };
            conlisteners.inlined_insert(pre,x);
        };
        invalidateconstraint();
    }
    #if NAPE_NO_INLINE#elseif(flash9&&flib)@:ns("flibdel")#end
 public#if NAPE_NO_INLINE#else inline#end
 function removeconstraint(x:ZPP_ConstraintListener):Void{
        conlisteners.remove(x);
        invalidateconstraint();
    }
    #if NAPE_NO_INLINE#elseif(flash9&&flib)@:ns("flibdel")#end
 public#if NAPE_NO_INLINE#else inline#end
 function invalidateconstraint():Void{
        {
            var cx_ite=cbsets.begin();
            while(cx_ite!=null){
                var cb=cx_ite.elem();
                cb.invalidate_conlisteners();
                cx_ite=cx_ite.next;
            }
        };
    }
    public static var ANY_SHAPE=new CbType();
    public static var ANY_BODY=new CbType();
    public static var ANY_COMPOUND=new CbType();
    public static var ANY_CONSTRAINT=new CbType();
    public function new(){
        id=ZPP_ID.CbType();
        
        listeners=new ZNPList_ZPP_InteractionListener();
        bodylisteners=new ZNPList_ZPP_BodyListener();
        conlisteners=new ZNPList_ZPP_ConstraintListener();
        constraints=new ZNPList_ZPP_Constraint();
        interactors=new ZNPList_ZPP_Interactor();
        cbsets=new ZNPList_ZPP_CbSet();
    }
}
