package zpp_nape.space;
import zpp_nape.ID;
import zpp_nape.Config;
import zpp_nape.Const;
import zpp_nape.dynamics.SpaceArbiterList;
import zpp_nape.dynamics.InteractionGroup;
import zpp_nape.dynamics.InteractionFilter;
import zpp_nape.dynamics.Contact;
import zpp_nape.space.SweepPhase;
import zpp_nape.dynamics.Arbiter;
import zpp_nape.space.DynAABBPhase;
import zpp_nape.shape.Polygon;
import zpp_nape.shape.Circle;
import zpp_nape.shape.Edge;
import zpp_nape.shape.Shape;
import zpp_nape.util.Circular;
import zpp_nape.util.Flags;
import zpp_nape.util.Names;
import zpp_nape.space.Space;
import zpp_nape.util.HaxeMacros;
import zpp_nape.util.FastHash;
import zpp_nape.util.Array2;
import zpp_nape.util.Queue;
import zpp_nape.util.RBTree;
import zpp_nape.util.WrapLists;
import zpp_nape.util.Debug;
import zpp_nape.util.Math;
import zpp_nape.util.UserData;
import zpp_nape.util.DisjointSetForest;
import zpp_nape.util.Pool;
import zpp_nape.geom.MatMath;
import zpp_nape.geom.Vec3;
import zpp_nape.geom.Mat23;
import zpp_nape.geom.Convex;
import zpp_nape.util.Lists;
import zpp_nape.geom.Simple;
import zpp_nape.geom.Triangular;
import zpp_nape.geom.Geom;
import zpp_nape.geom.VecMath;
import zpp_nape.geom.PartitionedPoly;
import zpp_nape.geom.Cutter;
import zpp_nape.geom.Simplify;
import zpp_nape.geom.Ray;
import zpp_nape.geom.Distance;
import zpp_nape.geom.Monotone;
import zpp_nape.geom.PolyIter;
import zpp_nape.geom.AABB;
import zpp_nape.geom.MarchingSquares;
import zpp_nape.geom.Vec2;
import zpp_nape.geom.MatMN;
import zpp_nape.geom.GeomPoly;
import zpp_nape.callbacks.CbSetPair;
import zpp_nape.callbacks.CbSet;
import zpp_nape.geom.Collide;
import zpp_nape.callbacks.Callback;
import zpp_nape.callbacks.Listener;
import zpp_nape.callbacks.CbType;
import zpp_nape.phys.FluidProperties;
import zpp_nape.callbacks.OptionType;
import zpp_nape.phys.FeatureMix;
import zpp_nape.phys.Compound;
import zpp_nape.phys.Interactor;
import zpp_nape.phys.Material;
import zpp_nape.constraint.DistanceJoint;
import zpp_nape.phys.Body;
import zpp_nape.constraint.WeldJoint;
import zpp_nape.constraint.MotorJoint;
import zpp_nape.constraint.Constraint;
import zpp_nape.constraint.AngleJoint;
import zpp_nape.constraint.LinearJoint;
import zpp_nape.constraint.UserConstraint;
import zpp_nape.constraint.LineJoint;
import nape.dynamics.FluidArbiter;
import nape.dynamics.ContactList;
import zpp_nape.constraint.PivotJoint;
import nape.dynamics.Arbiter;
import nape.dynamics.InteractionGroupList;
import nape.dynamics.ArbiterType;
import nape.dynamics.ArbiterIterator;
import nape.dynamics.ContactIterator;
import nape.dynamics.InteractionGroupIterator;
import nape.dynamics.InteractionGroup;
import nape.dynamics.InteractionFilter;
import nape.dynamics.ArbiterList;
import nape.dynamics.CollisionArbiter;
import nape.dynamics.Contact;
import nape.space.Broadphase;
import nape.shape.ShapeType;
import nape.shape.ShapeList;
import nape.space.Space;
import nape.shape.Polygon;
import nape.shape.EdgeList;
import nape.shape.ShapeIterator;
import nape.shape.Circle;
import nape.shape.Edge;
import nape.shape.EdgeIterator;
import nape.shape.Shape;
import nape.util.Debug;
import nape.util.BitmapDebug;
import nape.geom.GeomPolyIterator;
import nape.util.ShapeDebug;
import nape.geom.Vec3;
import nape.geom.RayResultIterator;
import nape.geom.GeomPolyList;
import nape.geom.Winding;
import nape.geom.RayResultList;
import nape.geom.Geom;
import nape.geom.Vec2Iterator;
import nape.geom.GeomVertexIterator;
import nape.geom.Mat23;
import nape.geom.Ray;
import nape.geom.RayResult;
import nape.geom.MarchingSquares;
import nape.geom.AABB;
import nape.geom.MatMN;
import nape.geom.Vec2;
import nape.geom.Vec2List;
import nape.callbacks.ListenerList;
import nape.callbacks.ListenerType;
import nape.callbacks.InteractionType;
import nape.callbacks.ConstraintCallback;
import nape.callbacks.CbTypeIterator;
import nape.callbacks.BodyCallback;
import nape.geom.GeomPoly;
import nape.callbacks.Callback;
import nape.callbacks.OptionType;
import nape.callbacks.ListenerIterator;
import nape.callbacks.PreFlag;
import nape.callbacks.Listener;
import nape.callbacks.PreCallback;
import nape.callbacks.CbType;
import nape.callbacks.ConstraintListener;
import nape.callbacks.PreListener;
import nape.callbacks.InteractionCallback;
import nape.callbacks.BodyListener;
import nape.callbacks.CbEvent;
import nape.callbacks.CbTypeList;
import nape.phys.InertiaMode;
import nape.phys.FluidProperties;
import nape.phys.CompoundIterator;
import nape.phys.BodyType;
import nape.callbacks.InteractionListener;
import nape.phys.BodyList;
import nape.phys.GravMassMode;
import nape.phys.MassMode;
import nape.phys.Interactor;
import nape.phys.Compound;
import nape.phys.CompoundList;
import nape.phys.InteractorIterator;
import nape.phys.Material;
import nape.phys.InteractorList;
import nape.phys.BodyIterator;
import nape.constraint.DistanceJoint;
import nape.constraint.WeldJoint;
import nape.constraint.MotorJoint;
import nape.constraint.Constraint;
import nape.constraint.ConstraintIterator;
import nape.constraint.AngleJoint;
import nape.constraint.ConstraintList;
import nape.constraint.LinearJoint;
import nape.constraint.UserConstraint;
import nape.phys.Body;
import nape.constraint.LineJoint;
import nape.constraint.PivotJoint;
#if nape_swc@:keep#end
 class ZPP_Broadphase{
    public var space:ZPP_Space;
    public var is_sweep:Bool;
    public var sweep:ZPP_SweepPhase;
    public var dynab:ZPP_DynAABBPhase;
    public function insert(shape:ZPP_Shape){
        if(is_sweep)sweep.__insert(shape);
        else dynab.__insert(shape);
    }
    public function remove(shape:ZPP_Shape){
        if(is_sweep)sweep.__remove(shape);
        else dynab.__remove(shape);
    }
    public function sync(shape:ZPP_Shape){
        if(!is_sweep)dynab.__sync(shape);
    }
    public function broadphase(){
        {
            #if(NAPE_ASSERT&&!NAPE_RELEASE_BUILD)var res={
                false;
            };
            if(!res)throw "assert("+"false"+") :: "+("not implemented");
            #end

        };
    }
    public function clear(){}
    public function shapesUnderPoint(x:Float,y:Float,filter:ZPP_InteractionFilter):ShapeList return null public function bodiesUnderPoint(x:Float,y:Float,filter:ZPP_InteractionFilter):BodyList return null public var aabbShape:Shape;
    public function updateAABBShape(aabb:ZPP_AABB){
        if(aabbShape==null){
            var body=new Body(BodyType.STATIC);
            body.shapes.add(aabbShape=new Polygon(Polygon.rect(aabb.minx,aabb.miny,aabb.width(),aabb.height())));
        }
        else{
            var ab=aabbShape.zpp_inner.aabb;
            var sx=aabb.width()/ab.width();
            var sy=aabb.height()/ab.height();
            aabbShape.transform(new Mat23(sx,0,0,sy,aabb.minx-sx*ab.minx,aabb.miny-sy*ab.miny));
        }
        aabbShape.zpp_inner.validate_aabb();
        aabbShape.zpp_inner.polygon.validate_gaxi();
    }
    public function shapesInAABB(aabb:ZPP_AABB,strict:Bool,containment:Bool,filter:ZPP_InteractionFilter):ShapeList return null public function bodiesInAABB(aabb:ZPP_AABB,strict:Bool,containment:Bool,filter:ZPP_InteractionFilter):BodyList return null public var circShape:Shape;
    public function updateCircShape(x:Float,y:Float,r:Float){
        if(circShape==null){
            var body=new Body(BodyType.STATIC);
            body.shapes.add(circShape=new Circle(r,Vec2.get(x,y)));
        }
        else{
            var ci=circShape.zpp_inner.circle;
            var ss=r/ci.radius;
            circShape.transform(new Mat23(ss,0,0,ss,x-ss*ci.localCOMx,y-ss*ci.localCOMy));
        }
        circShape.zpp_inner.validate_aabb();
    }
    public function shapesInCircle(x:Float,y:Float,r:Float,containment:Bool,filter:ZPP_InteractionFilter):ShapeList return null public function bodiesInCircle(x:Float,y:Float,r:Float,containment:Bool,filter:ZPP_InteractionFilter):BodyList return null public function validateShape(s:ZPP_Shape){
        if(s.isPolygon())s.polygon.validate_gaxi();
        s.validate_aabb();
        s.validate_worldCOM();
    }
    public function shapesInShape(shape:ZPP_Shape,containment:Bool,filter:ZPP_InteractionFilter):ShapeList return null public function bodiesInShape(shape:ZPP_Shape,containment:Bool,filter:ZPP_InteractionFilter):BodyList return null public function rayCast(ray:ZPP_Ray,inner:Bool,filter:ZPP_InteractionFilter):RayResult return null public function rayMultiCast(ray:ZPP_Ray,inner:Bool,filter:ZPP_InteractionFilter):RayResultList return null
}
