package zpp_nape.util;
import zpp_nape.ID;
import zpp_nape.Config;
import zpp_nape.Const;
import zpp_nape.dynamics.SpaceArbiterList;
import zpp_nape.dynamics.InteractionGroup;
import zpp_nape.dynamics.InteractionFilter;
import zpp_nape.dynamics.Contact;
import zpp_nape.space.SweepPhase;
import zpp_nape.dynamics.Arbiter;
import zpp_nape.space.DynAABBPhase;
import zpp_nape.space.Broadphase;
import zpp_nape.shape.Polygon;
import zpp_nape.shape.Circle;
import zpp_nape.shape.Edge;
import zpp_nape.shape.Shape;
import zpp_nape.util.Circular;
import zpp_nape.util.Names;
import zpp_nape.space.Space;
import zpp_nape.util.HaxeMacros;
import zpp_nape.util.FastHash;
import zpp_nape.util.Array2;
import zpp_nape.util.Queue;
import zpp_nape.util.RBTree;
import zpp_nape.util.WrapLists;
import zpp_nape.util.Debug;
import zpp_nape.util.Math;
import zpp_nape.util.UserData;
import zpp_nape.util.DisjointSetForest;
import zpp_nape.util.Pool;
import zpp_nape.geom.MatMath;
import zpp_nape.geom.Vec3;
import zpp_nape.geom.Mat23;
import zpp_nape.geom.Convex;
import zpp_nape.util.Lists;
import zpp_nape.geom.Simple;
import zpp_nape.geom.Triangular;
import zpp_nape.geom.Geom;
import zpp_nape.geom.VecMath;
import zpp_nape.geom.PartitionedPoly;
import zpp_nape.geom.Cutter;
import zpp_nape.geom.Simplify;
import zpp_nape.geom.Ray;
import zpp_nape.geom.Distance;
import zpp_nape.geom.Monotone;
import zpp_nape.geom.PolyIter;
import zpp_nape.geom.AABB;
import zpp_nape.geom.MarchingSquares;
import zpp_nape.geom.Vec2;
import zpp_nape.geom.MatMN;
import zpp_nape.geom.GeomPoly;
import zpp_nape.callbacks.CbSetPair;
import zpp_nape.callbacks.CbSet;
import zpp_nape.geom.Collide;
import zpp_nape.callbacks.Callback;
import zpp_nape.callbacks.Listener;
import zpp_nape.callbacks.CbType;
import zpp_nape.phys.FluidProperties;
import zpp_nape.callbacks.OptionType;
import zpp_nape.phys.FeatureMix;
import zpp_nape.phys.Compound;
import zpp_nape.phys.Interactor;
import zpp_nape.phys.Material;
import zpp_nape.constraint.DistanceJoint;
import zpp_nape.phys.Body;
import zpp_nape.constraint.WeldJoint;
import zpp_nape.constraint.MotorJoint;
import zpp_nape.constraint.Constraint;
import zpp_nape.constraint.AngleJoint;
import zpp_nape.constraint.LinearJoint;
import zpp_nape.constraint.UserConstraint;
import zpp_nape.constraint.LineJoint;
import nape.dynamics.FluidArbiter;
import nape.dynamics.ContactList;
import zpp_nape.constraint.PivotJoint;
import nape.dynamics.Arbiter;
import nape.dynamics.InteractionGroupList;
import nape.dynamics.ArbiterType;
import nape.dynamics.ArbiterIterator;
import nape.dynamics.ContactIterator;
import nape.dynamics.InteractionGroupIterator;
import nape.dynamics.InteractionGroup;
import nape.dynamics.InteractionFilter;
import nape.dynamics.ArbiterList;
import nape.dynamics.CollisionArbiter;
import nape.dynamics.Contact;
import nape.space.Broadphase;
import nape.shape.ShapeType;
import nape.shape.ShapeList;
import nape.space.Space;
import nape.shape.Polygon;
import nape.shape.EdgeList;
import nape.shape.ShapeIterator;
import nape.shape.Circle;
import nape.shape.Edge;
import nape.shape.EdgeIterator;
import nape.shape.Shape;
import nape.util.Debug;
import nape.util.BitmapDebug;
import nape.geom.GeomPolyIterator;
import nape.util.ShapeDebug;
import nape.geom.Vec3;
import nape.geom.RayResultIterator;
import nape.geom.GeomPolyList;
import nape.geom.Winding;
import nape.geom.RayResultList;
import nape.geom.Geom;
import nape.geom.Vec2Iterator;
import nape.geom.GeomVertexIterator;
import nape.geom.Mat23;
import nape.geom.Ray;
import nape.geom.RayResult;
import nape.geom.MarchingSquares;
import nape.geom.AABB;
import nape.geom.MatMN;
import nape.geom.Vec2;
import nape.geom.Vec2List;
import nape.callbacks.ListenerList;
import nape.callbacks.ListenerType;
import nape.callbacks.InteractionType;
import nape.callbacks.ConstraintCallback;
import nape.callbacks.CbTypeIterator;
import nape.callbacks.BodyCallback;
import nape.geom.GeomPoly;
import nape.callbacks.Callback;
import nape.callbacks.OptionType;
import nape.callbacks.ListenerIterator;
import nape.callbacks.PreFlag;
import nape.callbacks.Listener;
import nape.callbacks.PreCallback;
import nape.callbacks.CbType;
import nape.callbacks.ConstraintListener;
import nape.callbacks.PreListener;
import nape.callbacks.InteractionCallback;
import nape.callbacks.BodyListener;
import nape.callbacks.CbEvent;
import nape.callbacks.CbTypeList;
import nape.phys.InertiaMode;
import nape.phys.FluidProperties;
import nape.phys.CompoundIterator;
import nape.phys.BodyType;
import nape.callbacks.InteractionListener;
import nape.phys.BodyList;
import nape.phys.GravMassMode;
import nape.phys.MassMode;
import nape.phys.Interactor;
import nape.phys.Compound;
import nape.phys.CompoundList;
import nape.phys.InteractorIterator;
import nape.phys.Material;
import nape.phys.InteractorList;
import nape.phys.BodyIterator;
import nape.constraint.DistanceJoint;
import nape.constraint.WeldJoint;
import nape.constraint.MotorJoint;
import nape.constraint.Constraint;
import nape.constraint.ConstraintIterator;
import nape.constraint.AngleJoint;
import nape.constraint.ConstraintList;
import nape.constraint.LinearJoint;
import nape.constraint.UserConstraint;
import nape.phys.Body;
import nape.constraint.LineJoint;
import nape.constraint.PivotJoint;
#if nape_swc@:keep#end
 class ZPP_Flags{
    public static var internal:Bool=false;
    
    public static var id_ImmState_ACCEPT=1;
    public static var id_ImmState_IGNORE=2;
    public static var id_ImmState_ALWAYS=4;
    public static var id_ArbiterType_COLLISION=1;
    public static var id_ArbiterType_SENSOR=2;
    public static var id_ArbiterType_FLUID=4;
    public static var id_Broadphase_DYNAMIC_AABB_TREE=0;
    public static var id_Broadphase_SWEEP_AND_PRUNE=1;
    public static var id_ShapeType_CIRCLE=0;
    public static var id_ShapeType_POLYGON=1;
    public static var id_ValidationResult_VALID=0;
    public static var id_ValidationResult_DEGENERATE=1;
    public static var id_ValidationResult_DEGENERATE_EDGES=2;
    public static var id_ValidationResult_CONCAVE=3;
    public static var id_ValidationResult_SELF_INTERSECTING=4;
    public static var id_Winding_UNDEFINED=0;
    public static var id_Winding_CLOCKWISE=1;
    public static var id_Winding_ANTICLOCKWISE=2;
    public static var id_ListenerType_BODY=0;
    public static var id_ListenerType_CONSTRAINT=1;
    public static var id_ListenerType_INTERACTION=2;
    public static var id_ListenerType_PRE=3;
    public static var id_InteractionType_COLLISION=1;
    public static var id_InteractionType_SENSOR=2;
    public static var id_InteractionType_FLUID=4;
    public static var id_InteractionType_ANY=7;
    public static var id_PreFlag_ACCEPT=1;
    public static var id_PreFlag_IGNORE=2;
    public static var id_PreFlag_ACCEPT_ONCE=3;
    public static var id_PreFlag_IGNORE_ONCE=4;
    public static var id_CbEvent_BEGIN=0;
    public static var id_CbEvent_ONGOING=6;
    public static var id_CbEvent_END=1;
    public static var id_CbEvent_WAKE=2;
    public static var id_CbEvent_SLEEP=3;
    public static var id_CbEvent_BREAK=4;
    public static var id_CbEvent_PRE=5;
    public static var id_InertiaMode_DEFAULT=0;
    public static var id_InertiaMode_FIXED=1;
    public static var id_BodyType_STATIC=1;
    public static var id_BodyType_DYNAMIC=2;
    public static var id_BodyType_KINEMATIC=3;
    public static var id_GravMassMode_DEFAULT=0;
    public static var id_GravMassMode_FIXED=1;
    public static var id_GravMassMode_SCALED=2;
    public static var id_MassMode_DEFAULT=0;
    public static var id_MassMode_FIXED=1;
    
    public static var ArbiterType_COLLISION:ArbiterType;
    public static var ArbiterType_SENSOR:ArbiterType;
    public static var ArbiterType_FLUID:ArbiterType;
    public static var Broadphase_DYNAMIC_AABB_TREE:Broadphase;
    public static var Broadphase_SWEEP_AND_PRUNE:Broadphase;
    public static var ShapeType_CIRCLE:ShapeType;
    public static var ShapeType_POLYGON:ShapeType;
    public static var ValidationResult_VALID:ValidationResult;
    public static var ValidationResult_DEGENERATE:ValidationResult;
    public static var ValidationResult_DEGENERATE_EDGES:ValidationResult;
    public static var ValidationResult_CONCAVE:ValidationResult;
    public static var ValidationResult_SELF_INTERSECTING:ValidationResult;
    public static var Winding_UNDEFINED:Winding;
    public static var Winding_CLOCKWISE:Winding;
    public static var Winding_ANTICLOCKWISE:Winding;
    public static var ListenerType_BODY:ListenerType;
    public static var ListenerType_CONSTRAINT:ListenerType;
    public static var ListenerType_INTERACTION:ListenerType;
    public static var ListenerType_PRE:ListenerType;
    public static var InteractionType_COLLISION:InteractionType;
    public static var InteractionType_SENSOR:InteractionType;
    public static var InteractionType_FLUID:InteractionType;
    public static var InteractionType_ANY:InteractionType;
    public static var PreFlag_ACCEPT:PreFlag;
    public static var PreFlag_IGNORE:PreFlag;
    public static var PreFlag_ACCEPT_ONCE:PreFlag;
    public static var PreFlag_IGNORE_ONCE:PreFlag;
    public static var CbEvent_BEGIN:CbEvent;
    public static var CbEvent_ONGOING:CbEvent;
    public static var CbEvent_END:CbEvent;
    public static var CbEvent_WAKE:CbEvent;
    public static var CbEvent_SLEEP:CbEvent;
    public static var CbEvent_BREAK:CbEvent;
    public static var CbEvent_PRE:CbEvent;
    public static var InertiaMode_DEFAULT:InertiaMode;
    public static var InertiaMode_FIXED:InertiaMode;
    public static var BodyType_STATIC:BodyType;
    public static var BodyType_DYNAMIC:BodyType;
    public static var BodyType_KINEMATIC:BodyType;
    public static var GravMassMode_DEFAULT:GravMassMode;
    public static var GravMassMode_FIXED:GravMassMode;
    public static var GravMassMode_SCALED:GravMassMode;
    public static var MassMode_DEFAULT:MassMode;
    public static var MassMode_FIXED:MassMode;
}
