package triga.halfedge;
import nme.Vector;
using nme.Vector;
import nme.events.Event;
/**
 * ...
 * @author Nicolas Barradeau
 * http://en.nicoptere.net
 */
class HEEvent extends Event 
{
	static public var ON_CONTIGUOUS_FACE_UPDATE:String = 'onContiguousFaceUpdate';
	static public var ON_CONTIGUOUS_FACE_COMPLETE:String = 'onContiguousFaceComplete';
	static public var ON_PATCH_FINDING_UPDATE:String = "onPatchFindingUpdate";
	static public var ON_PATCH_FINDING_COMPLETE:String = "onPatchFindingComplete";
	private var _face:HEFace;
	private var _patch:HEPatch;
	private var _patches:Vector<HEPatch>;
	public function new(type:String, face:HEFace = null, patch:HEPatch = null, patches:Vector<HEPatch> = null, bubbles:Bool=false, cancelable:Bool=false) 
	{ 
		super( type, bubbles, cancelable);
		this.patches = patches;
		this.face = face;
		this.patch = patch;
	} 
	public override function clone():Event 
	{ 
		return new HEEvent(type, face, patch, patches, bubbles, cancelable);
	} 
	public override function toString():String 
	{ 
		return formatToString("HEEvent", "type", face, patch, patches, "bubbles", "cancelable", "eventPhase"); 
	}
	public var face( get_face, set_face ):HEFace;
	public function get_face():HEFace 
	{
		return _face;
	}
	public function set_face(value:HEFace):HEFace 
	{
		_face = value;
		return face;
	}
	public var patch( get_patch, set_patch ):HEPatch;
	public function get_patch():HEPatch 
	{
		return _patch;
	}
	public function set_patch(value:HEPatch):HEPatch 
	{
		_patch = value;
		return patch;
	}
	public var patches( get_patches, set_patches ):Vector;
	public function get_patches():Vector<HEPatch> 
	{
		return _patches;
	}
	public function set_patches(value:Vector<HEPatch>):Vector 
	{
		_patches = value;
		return patches;
	}
}