package triga.halfedge;
import nme.Vector;
using nme.Vector;
import nme.display.Graphics;
import nme.display.TriangleCulling;
import nme.geom.Point;
/**
 * @author Nicolas Barradeau
 * http://en.nicoptere.net
 */
class HEFace 
{
	public var id:Int;
	public var visited:Bool;
	public var edges:Vector<HEEdge>;
	public var edge0:HEEdge, edge1:HEEdge, edge2:HEEdge;
	public var contiguous:Vector<HEFace> = new Vector<HEFace>();
	public function new( i0:Int, i1:Int, i2:Int ) 
	{
		edge0 = new HEEdge( i0, i1 );
		edge1 = new HEEdge( i1, i2 );
		edge2 = new HEEdge( i2, i0 );
		edge0.next = edge1;
		edge1.next = edge2;
		edge2.next = edge0;
		edge0.face = edge1.face = edge2.face = this;
		edges = Vector.ofArray( [ edge0, edge1, edge2 ] );
	}
	public function flipNormals():Void
	{
		var i0:Int = edge0.origin;
		var i1:Int = edge0.end;
		edge0.origin = edge2.end = i1;
		edge0.end = edge1.origin = i0;
	}
	public function toString():String
	{
		return edge0.origin + ' ' + edge1.origin + ' ' + edge2.origin;
	}
}