package triga.halfedge;
import nme.Vector;
using nme.Vector;
import nme.geom.Vector3D;
/**
 * @author Nicolas Barradeau
 * http://en.nicoptere.net
 */
class HEPatch 
{
	private var mesh:HEMesh;
	public var faces:Vector<HEFace> = new Vector<HEFace>();
	public function new( mesh:HEMesh, faces:Vector<HEFace> = null ) 
	{ 
		this.mesh = mesh;
		if ( faces != null ) 
		{
			this.faces = faces; 
		}
	}
	public var centroid( get_centroid, null ):Vector3D;
	public function get_centroid():Vector3D
	{
		var v:Vector3D = new Vector3D();
		var vertices:Vector<Float> = HEMesh.getVertices( mesh );
		for( var f:HEFace in faces )
		{
			v.x += ( vertices[ f.edge0.origin ] + vertices[ f.edge1.origin ] + vertices[ f.edge2.origin ] ) / 3;
			v.y += ( vertices[ f.edge0.origin + 1 ] + vertices[ f.edge1.origin + 1 ] + vertices[ f.edge2.origin + 1 ] ) / 3;
			v.z += ( vertices[ f.edge0.origin + 2 ] + vertices[ f.edge1.origin + 2 ] + vertices[ f.edge2.origin + 2 ] ) / 3;
		}
		var scale:Float = 1 / faces.length;
		v.scaleBy( scale );
		return v;
	}
}