package triga.lathe;
import nme.Vector;
using nme.Vector;
import nme.geom.Point;
import nme.geom.Vector3D;
/**
 * @author Nicolas Barradeau
 * http://en.nicoptere.net
 */
class Profile 
{
	private var _path:Vector<Vector3D>;
	public function new( path:Vector<Vector3D> = null ) 
	{
		this.path = path || new Vector<Vector3D>();
	}
	public function fromPoints( points:Vector<Point> ):Void
	{
		this.path = new Vector<Vector3D>();
		for( var p:Point in points ) 
		{
			path.push( new Vector3D( p.x, p.y, 0 ) );
		}
	}
	public function offset( vector:Vector3D ):Void
	{
		var tmp:Vector<Vector3D> = new Vector<Vector3D>();
		for( var v:Vector3D in path )
		{
			tmp.push( v.add( vector ) );
		}
		path = path.concat( tmp.copy().reverse() );
	}
	public var path( get_path, set_path ):Vector;
	public function get_path():Vector<Vector3D> 
	{
		return _path;
	}
	public function set_path(value:Vector<Vector3D>):Vector 
	{
		_path = value;
		return path;
	}
}