package triga.maths;
/**
 * @author Nicolas Barradeau
 * http://en.nicoptere.net
 */
class PRNG 
{
	static private var a:Int = 16807; /* multiplier */
	static private var m:Int = 0x7FFFFFFF; /* 2**31 - 1 */
	static private var q:Int = 127773; /* m div a */
	static private var r:Int = 2836; /* m mod a */
	static private var randomnum:Int = 1;
	static private var div:Float = ( 1 / m );
	static private function nextlongrand( seed:Int ):Int
	{
		var lo:Int, hi:Int;
		lo = a * (seed & 0xFFFF);
		hi = a * (seed >> 16);
		lo += (hi & 0x7FFF) << 16;
		if (lo > m)
		{
			lo &= m;
			++lo;
		}
		lo += hi >> 15;
		if (lo > m)
		{
			lo &= m;
			++lo;
		}
		return lo;
	}
 /* return next random long */
	static public function random():Float 
	{
		randomnum = nextlongrand( randomnum );
		return randomnum * div;
	}
	public var seed( null, set_seed ):Int;
	static public function set_seed( value:Int ):Int
	{
		randomnum = value == 0 ? 1 : value;
		return seed;
	}
}