package triga.render;
import away3d.materials.BitmapMaterial;
import nme.display.BitmapData;
import nme.geom.Matrix;
import nme.text.Font;
import nme.text.TextField;
import nme.text.TextFieldAutoSize;
import nme.text.TextFormat;
/**
 * @author Nicolas Barradeau
 * http://en.nicoptere.net
 */
class TextMaterial extends BitmapMaterial 
{
	private var _text:String;
	private var _font:String = "Verdana";
	private var _size:Float = 12;
	private var _color:Int = 0x808080;
	public function new( text:String, size:Float = 12, color:Int = 0x808080, font:String = "Verdana" ) 
	{
		super();
		_text = text;
		_font = font;
		_size = size;
		_color = color;
		reset();
	}
	private function reset( textFormat:TextFormat = null ):Void
	{
		var tf:TextField = new TextField();
		tf.htmlText = text;
		if( textFormat  == null ) textFormat = new TextFormat( font, size, color )
		tf.setTextFormat( textFormat );
		tf.autoSize = TextFieldAutoSize.LEFT;
		var x:Int = 1;
		while ( x < Math.max( tf.width, tf.height ) ) x <<= 1;
		var m:Matrix = new Matrix( 1, 0, 0, 1, ( x - tf.width ) * .5, ( x - tf.height ) * .5 );
		bitmapData = new BitmapData( x, x, true, 0x00000000 );
		bitmapData.draw( tf, m );
		this.alphaBlending = true;
		smooth = false;
	}
	public var text( get_text, set_text ):String;
	public function get_text():String 
	{
		return _text;
	}
	public function set_text(value:String):String 
	{
		_text = value;
		reset();
		return text;
	}
	public var font( get_font, set_font ):String;
	public function get_font():String 
	{
		return _font;
	}
	public function set_font(value:String):String 
	{
		_font = value;
		reset();
		return font;
	}
	public var size( get_size, set_size ):Float;
	public function get_size():Float 
	{
		return _size;
	}
	public function set_size(value:Float):Float 
	{
		_size = value;
		reset();
		return size;
	}
	public var color( get_color, set_color ):Int;
	public function get_color():Int 
	{
		return _color;
	}
	public function set_color(value:Int):Int 
	{
		_color = value;
		reset();
		return color;
	}
}