package triga.render;
import away3d.containers.View3D;
import nme.display.BitmapData;
import nme.display.GradientType;
import nme.display.Shape;
import nme.geom.Matrix;
/**
 * @author Nicolas Barradeau
 * http://en.nicoptere.net
 */
class ViewHelper 
{
	static private var shape:Shape = new Shape();
	static public function grainyBackground( view:View3D, size:Int = 256, stretch:Bool = true, low:Int = 0, high:Int = 16 ):Void 
	{
		var bg:BitmapData = new BitmapData( size, size, false, 0 );
		bg.noise( Math.random() * 0xFFFFFFFF, low, high, 7, true);
		view.backgroundImage = bg;
		view.backgroundImageFitToViewPort = stretch;
	}
	static public function vignette( view:View3D, size:Int = 256, stretch:Bool = false, color:Int = 0, alpha:Float = 1, ratio:Int = 128 ):Void 
	{
		view.backgroundColor = color;
		var bg:BitmapData = new BitmapData( size, size, true, 0xFFFFFFFF );
		if ( view.backgroundImage == null )
		{ 
			view.backgroundImage = new BitmapData( size, size, true, 0xFFFFFFFF );
		}
		bg = view.backgroundImage;
		var m:Matrix = new Matrix();
		m.createGradientBox( bg.width, bg.height );
		shape.graphics.beginGradientFill( GradientType.RADIAL, [ color, color ], [0, alpha], [ ratio, 0xFF ], m );
		shape.graphics.drawRect( 0, 0, bg.width, bg.height );
		bg.draw( shape );
		shape.graphics.clear();
		view.backgroundImage = bg;
		view.backgroundImageFitToViewPort = stretch;
	}
	static public function verticalGradient( view:View3D, topColor:Int = 0xFFFFFF, bottomColor:Int = 0, stretch:Bool = true ):Void 
	{
		var bg:BitmapData = new BitmapData( 2, 2, false, topColor );
		bg.setPixel(0, 1, bottomColor );
		bg.setPixel(1, 1, bottomColor );
		view.backgroundImage = bg;
		view.backgroundImageFitToViewPort = true;
	}
}