package triga.shapes;
import away3d.entities.Mesh;
import away3d.materials.ColorMaterial;
import away3d.materials.MaterialBase;
import away3d.primitives.Cylinder;
import nme.geom.Vector3D;
/**
 * @author Nicolas Barradeau
 * http://en.nicoptere.net
 */
class Axis extends Mesh
{
	private var _origin:Vector3D;
	private var _direction:Vector3D;
	public function new( origin:Vector3D, direction:Vector3D, radius:Float = 1, material:MaterialBase = null ) 
	{
		if( super( material  == null ) super( material = new ColorMaterial( 0xFFFFFF, 1 ) );
		_direction = direction;
		_origin = origin;
		var length:Float = Vector3D.distance( origin, direction );
		var cyl:Cylinder = new Cylinder( null, radius, radius, length, 3, 1, false );
		cyl.y += length * .5;
		cyl.bakeTransformations();
		geometry.addSubGeometry( cyl.geometry.subGeometries[ 0 ] );
		transform.appendTranslation( origin.x, origin.y, origin.z );
		transform.pointAt( direction, Vector3D.Y_AXIS );
	}
	public var origin( get_origin, set_origin ):Vector3D;
	public function get_origin():Vector3D 
	{
		return _origin;
	}
	public function set_origin(value:Vector3D):Vector3D 
	{
		_origin = value;
		transform.identity();
		transform.appendTranslation( origin.x, origin.y, origin.z );
		transform.pointAt( direction, Vector3D.Y_AXIS );
		return origin;
	}
	public var direction( get_direction, set_direction ):Vector3D;
	public function get_direction():Vector3D 
	{
		return _direction;
	}
	public function set_direction( value:Vector3D ):Vector3D 
	{
		_direction = value;
		transform.identity();
		transform.appendTranslation( origin.x, origin.y, origin.z );
		transform.pointAt( direction, Vector3D.Y_AXIS );
		return direction;
	}
}