package triga.shapes;
import away3d.core.base.data.Vertex;
import nme.geom.Vector3D;
/**
 * @author Nicolas Barradeau
 * http://en.nicoptere.net
 */
class TrigaPlane extends Vector3D
{
	static public var EPSILON:Float = .0001;
	public var a:Float, b:Float, c:Float, d:Float, abc:Float;
	public function new( a:Float = 0, b:Float = 0, c:Float = 0, d:Float = 0 ) 
	{
		this.a = a;
		this.b = b;
		this.c = c;
		this.d = d;
	}
	public function normalizePlane():Void
	{
		var len : Number = 1 / Math.sqrt(a*a + b*b + c*c);
		a *= len;
		b *= len;
		c *= len;
		d *= len;
	}
	public function determinant( _x:Float, _y:Float, _z:Float ):Float
	{
		return ( a * _x + b * _y + c * _z - d );
	}
	public function determinantVertex( v:Vertex ):Float
	{
		return ( a * v.x + b * v.y + c * v.z - d );
	}
	public function determinantVector3D( v:Vector3D ):Float
	{
		return ( a * v.x + b * v.y + c * v.z - d );
	}
	public function isFaceCoplanar(f:TrigaFace):Bool 
	{
		if ( a == f.plane.a && b == f.plane.b && c == f.plane.c && d == f.plane.d ) return true;
		if ( a == -f.plane.a && b == -f.plane.b && c == -f.plane.c && d == -f.plane.d ) return true;
		if ( isPointCoplanar( f.plane ) ) return true;
		return false;
	}
	public function isPointCoplanar( p:Vector3D ):Bool 
	{
		var det:Float = a * p.x + b * p.y + c * p.z - d;
		return ( det >= -EPSILON && det <= EPSILON );
	}
}