﻿package triga.spline.curves 
import nme.Vector;
using nme.Vector;
{
import nme.geom.Vector3D;
package triga.spline.curves;
 */
class Cubic implements ICurve3D
{
	private var _precision:Float = .1;
	private var _loop:Bool = false;
	public function new( precision:Float = .1, loop:Bool = false )
	{
		_precision = precision;
		_loop = loop;
	}
	static public function compute( vertices:Vector<Vector3D>, precision:Float = .1, loop:Bool = false, target:Vector<Vector3D> = null ):Vector<Vector3D>
	{
		precision = Math.max( .01, Math.min( 1, precision ) );
		//output values
		if( target  == null ) target = new Vector<Vector3D>();
		var p0:Vector3D = new Vector3D();
		var p1:Vector3D = new Vector3D();
		var p2:Vector3D = new Vector3D();
		var i:Int = 0;
		var j:Float, t:Float, t2:Float, t3:Float, t4:Float;
		var X:Float, Y:Float, Z:Float;
		while( i < vertices.length )
		{
			//p0
			if( i == 0 )
			{
				if ( loop == true ){
					p0.x = (vertices[vertices.length-1].x+vertices[i].x)/2;
					p0.y = (vertices[vertices.length-1].y+vertices[i].y)/2;
					p0.z = (vertices[vertices.length-1].z+vertices[i].z)/2;
				}else{
					p0.x = vertices[ i ].x;
					p0.y = vertices[ i ].y;
					p0.z = vertices[ i ].z;
				}
			}
			else
			{
				p0.x = ( vertices[ i - 1 ].x + vertices[ i ].x ) / 2;
				p0.y = ( vertices[ i - 1 ].y + vertices[ i ].y ) / 2;
				p0.z = ( vertices[ i - 1 ].z + vertices[ i ].z ) / 2;
			}
			//p1
			p1.x = vertices[ i ].x;
			p1.y = vertices[ i ].y;
			p1.z = vertices[ i ].z;
			//p2	
			if( i == vertices.length - 1 )
			{
				if (loop == true){
					p2.x=(vertices[i].x+vertices[0].x)/2;
					p2.y=(vertices[i].y+vertices[0].y)/2;
					p2.z=(vertices[i].z+vertices[0].z)/2;
				}else{
					p2.x = vertices[ i ].x;
					p2.y = vertices[ i ].y;
					p2.z = vertices[ i ].z;
				}
			}
			else
			{
				p2.x = ( vertices[ i + 1 ].x + vertices[ i ].x ) / 2;
				p2.y = ( vertices[ i + 1 ].y + vertices[ i ].y ) / 2;
				p2.z = ( vertices[ i + 1 ].z + vertices[ i ].z ) / 2;
			}
			j = precision;
			while( j < 1 )
			{
				t = 1 - j;
				t2 = t * t;
				t3 = 2 * j * t;
				t4 = j * j;
				X = t2 * p0.x + t3 * p1.x + t4 * p2.x;
				Y = t2 * p0.y + t3 * p1.y + t4 * p2.y;
				Z = t2 * p0.z + t3 * p1.z + t4 * p2.z;
				target.push( new Vector3D( X, Y, Z ) );
				j += precision;
			}
			i++;
		}
		if ( loop )
		{
			target.push( target[0] );
		}
		else
		{
			//target.push( vertices[vertices.length -1 ] );
		}
		return target;
	}
	/* INTERFACE triga.curves.shapes.ICurve3D */
	public function set_precision(value:Float):Float 
	{
		_precision = value;
		return precision;
	}
	public var precision( get_precision, set_precision ):Float;
	public function get_precision():Float 
	{
		return _precision;
	}
	public function set_loop(value:Bool):Bool 
	{
		_loop = value;
		return loop;
	}
	public var loop( get_loop, set_loop ):Bool;
	public function get_loop():Bool 
	{
		return _loop;
	}
	public function compute( vertices:Vector<Vector3D>, target:Vector<Vector3D> = null ):Vector<Vector3D> 
	{
		return Cubic.compute( vertices, precision, loop, target );
	}
}