package triga.spline.shapes.path;
import nme.Vector;
using nme.Vector;
import nme.geom.Vector3D;
/**
 * @author Nicolas Barradeau
 * http://en.nicoptere.net
 */
class Helix 
{
	private var turns:Float = 1;
	private var height:Float = 0;
	private var radiusTop:Float = 1;
	private var radiusBottom:Float = 1;
	private var sides:Int = 12;
	private var _path:Vector<Vector3D> = new Vector<Vector3D>();
	private var upAxis:Vector3D;
	public function new( turns:Float = 1, height:Float = 0, radiusBottom:Float = 1, radiusTop:Float = 1, sides:Int = 12, upAxis:Vector3D = null ) 
	{
		this.turns = turns;
		this.height = height;
		this.radiusBottom = radiusBottom;
		this.radiusTop = radiusTop;
		this.sides = sides;
		this.upAxis = upAxis || Vector3D.Y_AXIS;
		reset();
	}
	private function reset():Void 
	{
		var v:Vector3D;
		var i:Float = 0;
		var step:Float = ( Math.PI * 2 ) / ( sides * turns );
		var total:Float = ( Math.PI * 2 ) * turns + step;
		for ( i in 0... total; i+=step )
		{
			var n:Float = i / total;
			var radius:Float = ( radiusBottom * ( 1 - n ) + radiusTop * n );
			if ( upAxis == Vector3D.X_AXIS ) v = new Vector3D( 	height * n, Math.cos( i ) * radius, Math.sin( i ) * radius );
			if ( upAxis == Vector3D.Y_AXIS ) v = new Vector3D( 	Math.cos( i ) * radius, height * n, Math.sin( i ) * radius );
			if ( upAxis == Vector3D.Z_AXIS ) v = new Vector3D( 	Math.cos( i ) * radius, Math.sin( i ) * radius, height * n );
			path.push( v );
		}
	}
	public var path( get_path, set_path ):Vector;
	public function get_path():Vector<Vector3D> 
	{
		return _path;
	}
	public function set_path(value:Vector<Vector3D>):Vector 
	{
		_path = value;
		return path;
	}
}