package triga.spline.shapes.path;
import nme.Vector;
using nme.Vector;
import nme.geom.Vector3D;
/**
 * @author Nicolas Barradeau
 * http://en.nicoptere.net
 */
class Knot 
{
	private var _P:Float;
	private var _Q:Float;
	private var _radius:Float;
	private var _sides:Int;
	private var _path:Vector<Vector3D> = new Vector<Vector3D>();
	private var upAxis:Vector3D;
	public function new( P:Int = 3, Q:Int = 2, radius:Float = 1, sides:Int = 32 ) 
	{
		_P = P;
		_Q = Q;
		_radius = radius;
		_sides = sides;
		reset();
	}
	private function reset():Void 
	{
		var sides:Int = this.sides * P * Q;
		var i:Float = 0;
		var step:Float = ( Math.PI * 2 ) / sides;
		var total:Float = ( Math.PI * 2 ) + step;
		for ( i in 0... total; i+=step )
		{
			var r:Float = radius * ( 2 + Math.sin( Q * i ) );
			path.push( 	new Vector3D( 	r * Math.cos( P * i ),
										r * Math.cos( Q * i ),
										r * Math.sin( P * i )		)	);
		}
	}
	public var path( get_path, null ):Vector;
	public function get_path():Vector<Vector3D> 
	{
		return _path;
	}
	public var P( get_P, set_P ):Float;
	public function get_P():Float 
	{
		return _P;
	}
	public function set_P(value:Float):Float 
	{
		_P = value;
		reset();
		return P;
	}
	public var Q( get_Q, set_Q ):Float;
	public function get_Q():Float 
	{
		return _Q;
	}
	public function set_Q(value:Float):Float 
	{
		_Q = value;
		reset();
		return Q;
	}
	public var radius( get_radius, set_radius ):Float;
	public function get_radius():Float 
	{
		return _radius;
	}
	public function set_radius(value:Float):Float 
	{
		_radius = value;
		reset();
		return radius;
	}
	public var sides( get_sides, set_sides ):Int;
	public function get_sides():Int 
	{
		return _sides;
	}
	public function set_sides(value:Int):Int 
	{
		_sides = value;
		reset();
		return sides;
	}
}