package triga.spline.shapes.sections;
import nme.Vector;
using nme.Vector;
import away3d.materials.ColorMaterial;
import away3d.materials.MaterialBase;
import nme.geom.Point;
import triga.spline.shapes.Section;
/**
 * @author Nicolas Barradeau
 * http://en.nicoptere.net
 */
class Star extends Section 
{
	public function new( branchCount:Int, innerRadius:Float, outerRadius:Float, material:MaterialBase = null ) 
	{
		var points:Vector<Point> = new Vector<Point>();
		branchCount = Math.max( 3, branchCount );
		var delta:Float = ( Math.PI * 2 ) / ( branchCount * 2 )
		for ( i in 0 ... branchCount * 2; i+=2 )
		{
			var a0:Float = i * delta;
			points.push( new Point( Math.cos( a0 ) * innerRadius, Math.sin( a0 ) * innerRadius ) );
			var a1:Float = ( i+1 ) * delta;
			points.push( new Point( Math.cos( a1 ) * outerRadius, Math.sin( a1 ) * outerRadius ) );
		}
		super( points, material );
	}
}