package triga.spline.utils;
import nme.Vector;
using nme.Vector;
import nme.geom.Point;
/**
 * @author Nicolas Barradeau
 * http://en.nicoptere.net
 */
class ComplexPolygon 
{
	static private var ip:Point = new Point();
	static public function makeSimple( points:Vector<Point> ):Vector<Vector<Point>>
	{
		if ( points.length < 4 ) return Vector<Vector<Point>>( [points] );
		var shapes:Vector<Vector<Point>> = new Vector<Vector<Point>>();
		var shape:Vector<Point> = new Vector<Point>();
		var origin:Point = points[ 0 ];
		shape.push( origin );
		shapes.push( shape );
		var i:Int = 1, count:Int = points.length;
		var next:Point = points[ i ];
		while ( !next.equals( origin ) )
		{
			shape.push( next );
			if ( ++i >= count ) 
			{
				break;
			}
			//if the point being processed is the origin
			//and that there are some points remaining, create new shape
			if ( points[ i ].equals( origin ) && i < count )
			{
				shape = new Vector<Point>();
				shapes.push( shape );
				origin = points[ i ];
				shape.push( origin );
				if ( ++i >= count ) //it was an isolated point
				{
					break;
				}
				else
				{
					next = points[ i ];
				}
			}
			else
			{
				//keep searching
				next = points[ i ];
			}
		}
		var output:Vector<Vector<Point>> = new Vector<Vector<Point>>();
		for( shape in shapes )
		{
			var tmpShapes:Vector<Vector<Point>> = splitPolygons( shape );
			for( var tmpShape:Vector<Point> in tmpShapes )
			{
				output.push( tmpShape );
			}
		}
		return output;
	}
	static private function splitPolygons( shape:Vector<Point> ):Vector<Vector<Point>>
	{
		Edge.buffer = shape;
		shape.fixed = false;
		//create an edges list
		for (i in 0 ... shape.length) 
		{
			var edge:Edge = new Edge( i, ( i + 1 ) % shape.length );
		}
		var selfIntersect:Bool = false;
		for( edge in Edge.edges )	
		{
			for( var _e:Edge in Edge.edges )
			{
				if ( edge != _e )
				{
					var ip:Point = edge.intersect( _e );
					if ( ip != null )
					{
						edge.subdivide( ip, edge.start, _e.end );
						_e.subdivide( ip, _e.start, edge.end );
						//new Edge( shape.length - 2, shape.length - 1);
						selfIntersect = true;
					}
				}
			}
		}
		//no self intersection: shape is simple
		if ( !selfIntersect ) return Vector<Vector<Point>>([shape]);
		//store valid edges
		var edges:Vector<Edge> = new Vector<Edge>();
		for( edge in Edge.edges )
		{
			if ( edge.active )
			{
				if ( 	!shape[ edge.start ].equals( shape[ edge.end ] ) 
				&& 		!shape[ edge.end ].equals( shape[ edge.start ] ) ) edges.push( edge );
			}
		}
		var shapes:Vector<Vector<Point>> = new Vector<Vector<Point>>();
		var newShape:Vector<Point> = new Vector<Point>();
		var tmp:Vector<Edge> = new Vector<Edge>();
		for ( i in 0... edges.length ) 
		{
			edge = edges[ i ];
			if ( !edges[ i ].active ) continue;
			var start:Int 	= edge.start;
			var end:Int 	= edge.end;
			tmp = Vector.ofArray( [ edge ] );
			var max:Int = 0;
			while ( start != end )
			{
				var te:Vector<Edge> = new Vector<Edge>();
				for( edge in edges )
				{
					if ( edge.start == end )
					{
						te.push( edge );
					}
				}
				if ( te.length == 1 )
				{
					edge = te[ 0 ];
					end = edge.end;
					tmp.push( edge );
				}
				else
				{
					//for( _e in te )
					//{
						//if ( _e.isLeft( edge ) ) edge = _e;
					//}
					//end = edge.end;
					//tmp.push( edge );
				}
			}
			//single edge
			if ( tmp.length <= 2 ) continue;
			newShape = new Vector<Point>();
			newShape.push( shape[ start ].clone() );
			for( edge in tmp )
			{
				edge.active = false;
				newShape.push( shape[ edge.end ].clone() );
			}
			shapes.push( newShape );
		}
		return shapes;
	}
}