package triga.spline.utils;
import nme.Vector;
using nme.Vector;
import nme.geom.Vector3D;
/**
 * @author Nicolas Barradeau
 * http://en.nicoptere.net
 */
class SimplifyLang 
{
	//function by Andreas Weber to simplify the path
	//http://www.motiondraw.com/blog/?p=50
	static public function compute( vertices:Vector<Vector3D>, distance:Int = 10, tolerance:Float = 4 ):Vector<Vector3D>
	{
		if ( vertices.length == 0 ) return vertices;
		if (distance <= 1)
		{
			return vertices;
		};
		var offset:Float, len:Float, count:Float;
		var PL:Int = vertices.length;
		var i:Int;
		var tmp:Vector<Vector3D> = new Vector<Vector3D>();
		tmp.push( vertices[0] );
		count = 1;
		if (distance > PL - 1)
		{
			distance = PL - 1;
		};
		for ( i in 0... PL)
		{
			if (i + distance > PL) 
			{ 
				distance = PL - i -1 
			};
			offset = recursiveToleranceBar(vertices, i, distance, tolerance);
			if (offset > 0)
			{
				tmp.push( vertices[i + offset] );
				i += offset-1;
				count++;
			}
		}
		//tmp.push( vertices[0] );
		return tmp;
	}
	// this function is called by simplifyLang
	static private function recursiveToleranceBar(vertices:Vector<Vector3D>, c:Int, distance:Int, tolerance:Float):Int
	{
		var n:Int = distance;
		var cp:Vector3D = vertices[c];
		var cLP:Vector3D = new Vector3D();
		var v1:Vector3D = new Vector3D();
		var v2:Vector3D = new Vector3D(); 
		var angle:Float, dx:Float, dy:Float, dz:Float;
		var id:Int 
		if ( c + n > vertices.length - 1 ) 
		{
			id = vertices.length - 1;
			n = vertices.length - 1 - c;
		}
		else
		{
			id = ( c + n );
		}
		v1 = new Vector3D( vertices[ id ].x - cp.x, vertices[id].y - cp.y, vertices[id].z - cp.z );
		var dist:Float;
		var j:Int;
		for ( j = 1; j <= n)
		{
			cLP = vertices[c+j]; 
			v2 = cLP.subtract( cp );
			var dir:Vector3D = v2.subtract( v1 );
			var pos:Vector3D = cLP.subtract( v1 );
			dir.normalize();
			dir.scaleBy( dir.dotProduct( pos ) );
			dist = Vector3D.distance( cLP, v1.add( dir ) );
			/*
			v2.x = cLP.x - cp.x;
			v2.y = cLP.y - cp.y;
			angle = Math.acos((v1.x * v2.x + v1.y * v2.y)/(Math.sqrt(v1.y * v1.y + v1.x * v1.x)*Math.sqrt(v2.y * v2.y + v2.x * v2.x)));
			if(Math.isNaN(angle)){angle = 0;}
			dx = cp.x - cLP.x; 
			dy = cp.y - cLP.y;
			dist = Math.sqrt(dx*dx+dy*dy);
			if ( Math.sin(angle) * dist >= tolerance)
			*/
			if( dist >= tolerance )
			{
				n--;
				if (n > 0)
				{	
					return recursiveToleranceBar(vertices, c, n, tolerance);
				}else{
					return 0;
				}
			}
		}
		return n;
	}
}