package triga.spline.utils;
import nme.Vector;
using nme.Vector;
import away3d.containers.View3D;
import away3d.core.base.SubGeometry;
import away3d.entities.Mesh;
import away3d.materials.ColorMaterial;
import away3d.primitives.Cube;
import away3d.primitives.RegularPolygon;
import nme.geom.Matrix3D;
import nme.geom.Vector3D;
import triga.spline.shapes.Section;
import triga.utils.MeshUtils;
/**
 * @author Nicolas Barradeau
 * http://en.nicoptere.net
 */
class SplineUtils
{
	//http://www.ogre3d.org/forums/viewtopic.php?p=224334
	static public function getEqualDistanceSpline( splineSrc:Vector<Vector3D>, wantedDistance:Float ):Vector<Vector3D>
	{
	 var lastInterpPoint:Float = 0.0; 
	 var end:Vector3D;
		var splineDest:Vector<Vector3D> = new Vector<Vector3D>();
	 var j:Int = 0, k:Int = 0;
	 var accLength:Float, prevAccLength:Float;
	 var start:Vector3D = splineSrc[ 0 ];
	 splineDest.push(start);
	 var DIVISOR:Int = 10;
	 var fineGrainDistance:Float = wantedDistance/DIVISOR;
	 for ( j = 1; j < splineSrc.length; )
	 {
		 // first find the points where the length exceed wanted length..
		 end = splineSrc[ j ];
		 prevAccLength = 0;
		 accLength = end.subtract( start ).length;
		 while (accLength < fineGrainDistance && j < splineSrc.length - 1)
		 {
			 // okay 'end' is extended
			 ++j;
			 end = splineSrc[ j ];
			 prevAccLength = accLength;
			 accLength += end.subtract( splineSrc[ j-1 ] ).length;
			 // if enter the loops then we have to reset lastInterPoint..
			 lastInterpPoint = 0;
		 }
		 if (j == splineSrc.length -1) break;
		 var t:Vector3D = splineSrc[ j ].subtract( splineSrc[ j - 1 ] );
		 t.scaleBy( lastInterpPoint );
		 var refPoint:Vector3D = splineSrc[ j - 1 ].add( t );
		 var distanceAll:Float = Vector3D.distance( splineSrc[ j ], splineSrc[ j - 1 ] );
		 var wantedSubDistance:Float = fineGrainDistance - prevAccLength;
		 lastInterpPoint += wantedSubDistance / distanceAll;
		 t = splineSrc[ j ].subtract( splineSrc[ j - 1 ] );
		 t.scaleBy( lastInterpPoint );
		 start = splineSrc[ j - 1 ].add( t );
		 ++k;
		 if ((k % DIVISOR) == 0)
		 {
			 splineDest.push(start);
		 }
	 }
	 return splineDest;
	}
}