package triga.spline.utils;
import nme.Vector;
using nme.Vector;
import nme.geom.Point;
class Triangulator2D
{
	//http://forum.unity3d.com/threads/27223-Polygon-triangulation-code
	//http://www.unifycommunity.com/wiki/index.php?title=Triangulator
	static private var m_points:Vector<Point>;
	static public function compute( points:Vector<Point>):Vector<Int>
	{
		m_points = points.copy();
		var indices:Vector<Int> = new Vector<Int>();
		var n:Int = m_points.length;
		if (n <= 3)	return Vector<Int>([1,0,2]);
		var v:Int;
		var V:Vector<Int> = new Vector<Int>();
		if (Area() > 0) 
		{
			for ( v = 0; v < n; v++) V.push( v );
		}
		else
		{
			for ( v = 0; v < n; v++) V.push( (n - 1) - v );
		}
		var nv:Int = n;
		var count:Int = 2 * nv;
		var m:Int 
		for ( m = 0, v = nv - 1; nv > 2; ) 
		{
			if ((count--) <= 0) return indices;
			var u:Int = v;
			if (nv <= u)	u = 0;
			v = u + 1;
			if (nv <= v)	v = 0;
			var w:Int = v + 1;
			if (nv <= w)	w = 0;
			if ( Snip(u, v, w, nv, V)) 
			{
				var a:Int, b:Int, c:Int, s:Int, t:Int;
				a = V[u];
				b = V[v];
				c = V[w];
				indices.push(a);
				indices.push(b);
				indices.push(c);
				m++;
				for (s = v, t = v + 1; t < nv; s++, t++)
				{
					V[s] = V[t];
				}
				nv--;
				count = 2 * nv;
			}
		}
		indices.reverse();
		return indices;
	}
	static private function Area():Float
	{
		var n:Int = m_points.length;
		var A:Float = 0;
		var p:Int, q:Int;
		for ( p = n - 1, q = 0; q < n; p = q++ ) 
		{
			var pval:Point = m_points[p];
			var qval:Point = m_points[q];
			A += pval.x * qval.y - qval.x * pval.y;
		}
		return (A * 0.5);
	}
	static private function Snip ( u:Int, v:Int, w:Int, n:Int, V:Vector<Int> ):Bool
	{
		var p:Int;
		var A:Point = m_points[ V[u] ];
		var B:Point = m_points[ V[v] ];
		var C:Point = m_points[ V[w] ];
		if ( .000000001 > (((B.x - A.x) * (C.y - A.y)) - ((B.y - A.y) * (C.x - A.x)))) return false;
		for (p = 0; p < n; p++) 
		{
			if ((p == u) || (p == v) || (p == w)) continue;
			var P:Point = m_points[V[p]];
			if (InsideTriangle(A, B, C, P))	return false;
		}
		return true;
	}
	static private function InsideTriangle( A:Point, B:Point, C:Point, P:Point ):Bool
	{
		var ax:Float, ay:Float, bx:Float, by:Float, cx:Float, cy:Float, apx:Float, apy:Float, bpx:Float, bpy:Float, cpx:Float, cpy:Float;
		var cCROSSap:Float, bCROSScp:Float, aCROSSbp:Float;
		ax = C.x - B.x; ay = C.y - B.y;
		bx = A.x - C.x; by = A.y - C.y;
		cx = B.x - A.x; cy = B.y - A.y;
		apx = P.x - A.x; apy = P.y - A.y;
		bpx = P.x - B.x; bpy = P.y - B.y;
		cpx = P.x - C.x; cpy = P.y - C.y;
		aCROSSbp = ax * bpy - ay * bpx;
		cCROSSap = cx * apy - cy * apx;
		bCROSScp = bx * cpy - by * cpx;
		return ((aCROSSbp >= 0.0) && (bCROSScp >= 0.0) && (cCROSSap >= 0.0));
	}
    }