﻿package systems.traer 
{
class Attraction implements Force
package systems.traer;
	private var _p1:Particle;
	private var _strength:Float;
	private var _on:Bool;
	private var _distanceMin:Float;
	private var distanceMinSquared:Float;
	/**
	 * 
	 * @param	p0
	 * @param	p1
	 * @param	strength
	 * @param	distanceMin
	 */
	public function new( p0:Particle, p1:Particle, strength:Float, distanceMin:Float )
	{
		_p0 = p0;
		_p1 = p1;
		_on = true;
		_strength = strength;
		_distanceMin = distanceMin;
		distanceMinSquared = _distanceMin * _distanceMin;
	}
	public function getMinimumDistance( d:Float ):Float
	{
		distanceMin = d;
		distanceMinSquared = d * d;
		return distanceMinSquared;
	}
	//public function turnOff():Void {
		//on = false;
	//}
	//public function turnOn():Void {
		//on = true;
	//}
	//
	//public function setStrength(_k:Float):Void {
		//k = _k;
	//}
	//public function getOneEnd():Particle {
		//return a;
	//}
	//public function getTheOtherEnd():Particle {
		//return p1;
	//}
	//public function getStrength():Float {
		//return k;
	//}
	public function apply():Void
	{
		if ( on && ( !p0.fixed || !p1.fixed ) )
		{
			var a2bX:Float = p0.position.x - p1.position.x;
			var a2bY:Float = p0.position.y - p1.position.y;
			var a2bZ:Float = p0.position.z - p1.position.z;
			var a2bDistanceSquared:Float = a2bX * a2bX + a2bY * a2bY + a2bZ * a2bZ;
			if ( a2bDistanceSquared < distanceMinSquared )
			{
				a2bDistanceSquared = distanceMinSquared;
			}
			var force:Float = strength * p0.mass * p1.mass / a2bDistanceSquared;
			var length:Float = Math.sqrt( a2bDistanceSquared );
			// make unit vector
			a2bX /= length;
			a2bY /= length;
			a2bZ /= length;
			// multiply by force 
			a2bX *= force;
			a2bY *= force;
			a2bZ *= force;
			// apply
			if ( !p0.fixed )
			{
				//p0.force.addFromValues( -a2bX, -a2bY, -a2bZ );
				p0.force.x += -a2bX;
				p0.force.y += -a2bY;
				p0.force.z += -a2bZ;
			}
			if ( !p1.fixed )
			{
				//p1.force.addFromValues( a2bX, a2bY, a2bZ );
				p1.force.x += a2bX;
				p1.force.y += a2bY;
				p1.force.z += a2bZ;
			}
		}
	}
	public var on( get_on, set_on ):Bool;
	public function get_on():Bool { return _on; }
	public function set_on(value:Bool):Bool 
	{
		_on = value;
		return on;
	}
	public var p0( get_p0, set_p0 ):Particle;
	public function get_p0():Particle { return _p0; }
	public function set_p0(value:Particle):Particle 
	{
		_p0 = value;
		return p0;
	}
	public var p1( get_p1, set_p1 ):Particle;
	public function get_p1():Particle { return _p1; }
	public function set_p1(value:Particle):Particle 
	{
		_p1 = value;
		return p1;
	}
	public var strength( get_strength, set_strength ):Float;
	public function get_strength():Float { return _strength; }
	public function set_strength(value:Float):Float 
	{
		_strength = value;
		return strength;
	}
	public var distanceMin( get_distanceMin, set_distanceMin ):Float;
	public function get_distanceMin():Float { return _distanceMin; }
	public function set_distanceMin(value:Float):Float 
	{
		_distanceMin = value;
		return distanceMin;
	}
}