﻿package systems.traer 
{
/**
package systems.traer;
 */
class ModifiedEulerIntegrator implements Integrator
{
	private var s:ParticleSystem;
	public function new(_s:ParticleSystem) 
	{
		s = _s;
	}
	public function step(t:Float):Void {
		s.clearForces();
		s.applyForces();
		var halftt:Float = 0.5*t*t;
		var i:Int;
		var len:Int = s.numberOfParticles();
		var p:Particle;
		var ax:Float,ay:Float,az:Float
		for ( i in 0...len )
		{
			p = s.getParticleById( i ) as Particle;
			if ( p.isFree() )
			{
				ax = p.getForce().x/p.getMass();
				ay = p.getForce().y/p.getMass();
				az = p.getForce().z/p.getMass();
				p.getPosition().addFromValues( p.getVelocity().x/t, p.getVelocity().y/t, p.getVelocity().z/t );
				p.getPosition().addFromValues( ax*halftt, ay*halftt, az*halftt );
				p.getPosition().addFromValues( ax/t, ay/t, az/t );
			}
		}
	}
}