﻿package systems.traer 
{
import nme.display.Graphics;
package systems.traer;
{
	static private var idCount:Int = 0;
	private var _id:Int;
	private var _position:Vector3D;
	private var _velocity:Vector3D;
	private var _force:Vector3D;
	private var _mass:Float;
	private var _age:Float;
	private var _dead:Bool;
	private var _fixed:Bool; 
	private var _color:Int = 0xFF0000;
	public function Particle(_mass:Float) 
	{
		position = new Vector3D();
		velocity = new Vector3D();
		force = new Vector3D();
		mass = _mass;
		age = 0;
		fixed = false;
		id = idCount++;
	}
	public function distance(p:Particle):Float
	{
		return Math.sqrt( squareDistance( p ) );
	}
	public function squareDistance(p:Particle):Float
	{
		var dx:Float, dy:Float, dz:Float;
		dx = position.x - p.position.x;
		dy = position.y - p.position.y;
		dz = position.z - p.position.z;
		return (dx * dx + dy * dy + dz * dz);
	}
	private function reset():Void {
		age = 0;
		dead = false;
		position.x = position.y = position.z = 0;
		clearVelocity();
		clearForce();
		mass = 1;
	}
	public function clearVelocity():Void
	{
		velocity.x = velocity.y = velocity.z = 0;
	}
	public function clearForce():Void
	{
		force.x = force.y = force.z = 0;
	}
	public var mass( get_mass, set_mass ):Float;
	public function get_mass():Float { return _mass; }
	public function set_mass(value:Float):Float 
	{
		_mass = value;
		return mass;
	}
	public var force( get_force, set_force ):Vector3D;
	public function get_force():Vector3D { return _force; }
	public function set_force(value:Vector3D):Vector3D 
	{
		_force = value;
		return force;
	}
	public var position( get_position, set_position ):Vector3D;
	public function get_position():Vector3D { return _position; }
	public function set_position(value:Vector3D):Vector3D 
	{
		_position = value;
		return position;
	}
	public var velocity( get_velocity, set_velocity ):Vector3D;
	public function get_velocity():Vector3D { return _velocity; }
	public function set_velocity(value:Vector3D):Vector3D 
	{
		_velocity = value;
		return velocity;
	}
	public var age( get_age, set_age ):Float;
	public function get_age():Float { return _age; }
	public function set_age(value:Float):Float 
	{
		_age = value;
		return age;
	}
	public var dead( get_dead, set_dead ):Bool;
	public function get_dead():Bool { return _dead; }
	public function set_dead(value:Bool):Bool 
	{
		_dead = value;
		return dead;
	}
	public var fixed( get_fixed, set_fixed ):Bool;
	public function get_fixed():Bool { return _fixed; }
	public function set_fixed(value:Bool):Bool 
	{
		_fixed = value;
		if( value ) velocity.x = velocity.y = velocity.z = 0;
		return fixed;
	}
	public var color( get_color, set_color ):Int;
	public function get_color():Int { return _color; }
	public function set_color(value:Int):Int 
	{
		_color = value;
		return color;
	}
	public var id( get_id, set_id ):Int;
	public function get_id():Int { return _id; }
	public function set_id(value:Int):Int 
	{
		//_id = value;
		return id;
	}
	public function draw( g:Graphics, size:Float = 2 ):Void
	{
		//g.lineStyle( 0, color );
		g.drawCircle( position.x, position.y, size );
	}
}