﻿package systems.traer 
{
import nme.display.Graphics;
package systems.traer;
	private var _p0:Particle;
	private var _p1:Particle;
	private var _color:Int = 0xCC0000;
	private var _springConstant:Float;
	private var _damping:Float;
	private var _restLength:Float
	private var _on:Bool;
	public function Spring( p0:Particle, p1:Particle, springConstant:Float, damping:Float, restlength:Float) 
	{
		_p0 = p0;
		_p1 = p1;
		_restLength = restlength;
		_springConstant = springConstant;
		_damping = damping;
		on = true;
	}
	public function length():Float
	{
		return p0.distance( p1 );
	}
	public function apply():Void 
	{
		if ( on && ( !p0.fixed || !p1.fixed ) )
		{
			var a2bX:Float = p0.position.x - p1.position.x;
			var a2bY:Float = p0.position.y - p1.position.y;
			var a2bZ:Float = p0.position.z - p1.position.z;
			var a2bDistance:Float = Math.sqrt( a2bX * a2bX + a2bY * a2bY + a2bZ * a2bZ );
			if ( a2bDistance == 0 )
			{
				a2bX = 0;
				a2bY = 0;
				a2bZ = 0;
			}
			else
			{
				a2bX /= a2bDistance;
				a2bY /= a2bDistance;
				a2bZ /= a2bDistance;
			}
			// spring force is proportional to how much it stretched 
			var springForce:Float = -( a2bDistance - restLength ) * springConstant; 
			// want velocity along line b/w a & b, damping force is proportional to this
			var Va2bX:Float = p0.velocity.x - p1.velocity.x;
			var Va2bY:Float = p0.velocity.y - p1.velocity.y;
			var Va2bZ:Float = p0.velocity.z - p1.velocity.z;
			var dampingForce:Float = -damping * ( a2bX * Va2bX + a2bY * Va2bY + a2bZ * Va2bZ );
			// forceB is same as forceA in opposite direction
			var r:Float = springForce + dampingForce;
			a2bX *= r;
			a2bY *= r;
			a2bZ *= r;
			if ( !p0.fixed )
			{
				//p0.force.addFromValues( a2bX, a2bY, a2bZ );
				p0.force.x += a2bX;
				p0.force.y += a2bY;
				p0.force.z += a2bZ;
			}
			if ( !p1.fixed )
			{
				//p1.force.addFromValues( -a2bX, -a2bY, -a2bZ );
				p1.force.x += -a2bX;
				p1.force.y += -a2bY;
				p1.force.z += -a2bZ;
			}
		}
	}
	public var on( get_on, set_on ):Bool;
	public function get_on():Bool { return _on; }
	public function set_on(value:Bool):Bool 
	{
		_on = value;
		return on;
	}
	public function draw( g:Graphics, size:Float = 2 ):Void
	{
		//g.lineStyle( 0, color );
		g.moveTo( p0.position.x, p0.position.y );
		g.lineTo( p1.position.x, p1.position.y );
	}
	public var p0( get_p0, set_p0 ):Particle;
	public function get_p0():Particle { return _p0; }
	public function set_p0(value:Particle):Particle 
	{
		_p0 = value;
		return p0;
	}
	public var p1( get_p1, set_p1 ):Particle;
	public function get_p1():Particle { return _p1; }
	public function set_p1(value:Particle):Particle 
	{
		_p1 = value;
		return p1;
	}
	public var color( get_color, set_color ):Int;
	public function get_color():Int { return _color; }
	public function set_color(value:Int):Int 
	{
		_color = value;
		return color;
	}
	public var restLength( get_restLength, set_restLength ):Float;
	public function get_restLength():Float { return _restLength; }
	public function set_restLength(value:Float):Float 
	{
		_restLength = value;
		return restLength;
	}
	public var damping( get_damping, set_damping ):Float;
	public function get_damping():Float { return _damping; }
	public function set_damping(value:Float):Float 
	{
		_damping = value;
		return damping;
	}
	public var springConstant( get_springConstant, set_springConstant ):Float;
	public function get_springConstant():Float { return _springConstant; }
	public function set_springConstant(value:Float):Float 
	{
		_springConstant = value;
		return springConstant;
	}
}