package triga.systems.verlet3d;
import nme.Vector;
using nme.Vector;
import nme.geom.Vector3D;
/**
 * ...
 * @author Nicolas Barradeau
 * http://en.nicoptere.net
 */
class VerletChain 
{
	private var points:Vector<VerletPoint3d>;
	private var sticks:Vector<VerletStick3d>;
	public function new( sticks:Vector<VerletStick3d> ) 
	{
		this.sticks = sticks;
	}
	public function compute( vectors:Vector<Vector3D>, fixed:Bool = false ):Void
	{
		points = new Vector<VerletPoint3d>();
		sticks = new Vector<VerletStick3d>();
		for( var v:Vector3D in vectors )
		{
			points.push( new VerletPoint3d( v.x, v.y, v.z ) );
		}
		if ( fixed ) points[ 0 ].fixed = true;
		var p0:VerletPoint3d, p1:VerletPoint3d;
		for (i in 0 ... points.length - 1) 
		{
			p0 = points[ i ];
			p1 = points[ i + 1 ];
			sticks.push( new VerletStick3d( p0, p1 ) );
		}
	}
	public function update():Void
	{
		for( var s:VerletStick3d in sticks )
		{
			s.p0.update();
			s.p1.update();
			s.update();
		}
	}
}