﻿package triga.systems.verlet3d
{
import nme.geom.Matrix;
package triga.systems.verlet3d;
import nme.geom.Vector3D;
class VerletPoint3d extends Vector3D
{
	public var mass:Float = 1;
	public var friction:Float = .9;
	public var vx:Float = 0;
	public var vy:Float = 0;
	public var vz:Float = 0;
	public var ax:Float = 0;
	public var ay:Float = 0;
	public var az:Float = 0;
	public var fixed:Bool = false;
	public function new( x:Float = 0, y:Float = 0, z:Float = 0, fixed:Bool = false )
	{
		this.x = x;
		this.y = y;
		this.z = z;
		vx = vy = vz = 0;
		this.fixed = fixed;
	}
	public function update():Void
	{
		if( fixed ) return;
		vx *= friction;
		vy *= friction;
		vz *= friction;
		vx += ( ax * mass );
		vy += ( ay * mass );
		vz += ( az * mass );
		x += vx;
		y += vy;
		z += vz;
		ax = ay = az = 0;
	}
}