﻿package triga.systems.verlet3d
{
import nme.display.Graphics;
package triga.systems.verlet3d;
	public var p0:VerletPoint3d;
	public var p1:VerletPoint3d;
	public var length:Float;
	//utils
	private var dx:Float;
	private var dy:Float;
	private var dz:Float;
	private var dist:Float;
	public var diff:Float = 0;
	private var offsetX:Float = 0;
	private var offsetY:Float = 0;
	private var offsetZ:Float = 0;
	public function VerletStick3d( p0:VerletPoint3d, p1:VerletPoint3d, length:Float = -1, radius:Float = 1, sides:Int = 3 )
	{
		if ( sides < 3 ) sides = 3;
		this.p0 = p0;
		this.p1 = p1;
		if( length == -1 )
		{
			setLength();
		}
		else
		{
			this.length = length;
		}
	}
	public function setLength():Void 
	{
		dx = p0.x - p1.x;
		dy = p0.y - p1.y;
		dz = p0.z - p1.z;
		length = Math.sqrt( dx*dx + dy*dy + dz*dz );
	}
	public function update():Void
	{
		dx = p1.x - p0.x;
		dy = p1.y - p0.y;
		dz = p1.z - p0.z;
		dist = Math.sqrt( dx*dx + dy*dy + dz*dz );
		diff = length - dist;
		offsetX = ( diff * dx / dist ) * .5;
		offsetY = ( diff * dy / dist ) * .5;
		offsetZ = ( diff * dz / dist ) * .5;
		if( p0.fixed == false)
		{
			p0.x -= offsetX;
			p0.y -= offsetY;
			p0.z -= offsetZ;
		}
		if( p1.fixed == false )
		{
			p1.x += offsetX;
			p1.y += offsetY;
			p1.z += offsetZ;
		}
	}
}