package triga.systems.verlet3d.deflectors;
import nme.Vector;
using nme.Vector;
import away3d.entities.Mesh;
/**
 * @author Nicolas Barradeau
 * http://en.nicoptere.net
 */
class Deflector implements IDeflector
{
	public var positions_x:Vector<Float>;
	public var positions_y:Vector<Float>;
	public var positions_z:Vector<Float>;
	public var velocities_x:Vector<Float>;
	public var velocities_y:Vector<Float>;
	public var velocities_z:Vector<Float>;
	private var _friction:Float = 1;
	private var _damping:Float = 1;
	public function new( damping:Float, friction:Float )
	{
		_damping = damping;
		_friction = friction;
	}
	public function apply( id:Int ):Bool { return false; }
	public var friction( get_friction, set_friction ):Float;
	public function get_friction():Float {	return _friction;	}
	public function set_friction(value:Float):Float
	{	
		_friction = Math.max( 0.01, Math.min( value, 1 ) );
		return friction;
	}
	public var damping( get_damping, set_damping ):Float;
	public function get_damping():Float {	return _damping;	}
	public function set_damping(value:Float):Float 
	{	
		_damping = Math.max( 0, value );	
		return damping;
	}
}