package triga.systems.verlet3d.deflectors;
import nme.Vector;
using nme.Vector;
import nme.geom.Vector3D;
/**
 * @author Nicolas Barradeau
 * http://en.nicoptere.net
 */
class FaceDeflector extends PlaneDeflector 
{
	private var tvs:Vector<Float> = new Vector<Float>( 22 );
	private var dir:Vector3D = new Vector3D();
	public function new( damping:Float = .9, friction:Float = 1, v0:Vector3D = null, v1:Vector3D = null, v2:Vector3D = null )
	{
		super( damping, friction, v0, v1, v2 );
	}
	override public function apply( id:Int ):Bool
	{
		//is point hitting the triangle
		if ( !pointIntriangle( id, true ) ) return false;
		return super.apply( id );
	}
	private function pointIntriangle( id:Int, asSegment:Bool = false ):Bool
	{
		//-> face varants: computed after geometry invalidation
			//var ab:Vector3D = v1.subtract( v0 );
				//tvs[ 0 ] = vectors[ 3 ] - vectors[ 0 ];
				//tvs[ 1 ] = vectors[ 4 ] - vectors[ 1 ];
				//tvs[ 2 ] = vectors[ 5 ] - vectors[ 2 ];
			//var ac:Vector3D = v2.subtract( v0 );
				//tvs[ 3 ] = vectors[ 6 ] - vectors[ 0 ];
				//tvs[ 4 ] = vectors[ 7 ] - vectors[ 1 ];
				//tvs[ 5 ] = vectors[ 8 ] - vectors[ 2 ];
		//var qp:Vector3D = p.subtract( q );
		tvs[ 6 ] = -velocities_x[ id ];
		tvs[ 7 ] = -velocities_y[ id ];
		tvs[ 8 ] = -velocities_z[ id ];
		//var n:Vector3D = ab.crossProduct( ac );
		tvs[ 9 ] = tvs[ 1 ] * tvs[ 5 ] - tvs[ 2 ] * tvs[ 4 ]; 
		tvs[ 10 ] = tvs[ 2 ] * tvs[ 3 ] - tvs[ 0 ] * tvs[ 5 ]; 
		tvs[ 11 ] = tvs[ 0 ] * tvs[ 4 ] - tvs[ 1 ] * tvs[ 3 ];
		//var d:Float = qp.dotProduct( n );
		//if ( d <= 0 ) return false;
		tvs[ 12 ] = tvs[ 6 ] * tvs[ 9 ] + tvs[ 7 ] * tvs[ 10 ] + tvs[ 8 ] * tvs[ 11 ];
		if ( tvs[ 12 ] <= 0 ) return false;
		//var ap:Vector3D = p.subtract( v0 );
		tvs[ 13 ] = positions_x[ id ] - vectors[ 0 ];
		tvs[ 14 ] = positions_y[ id ] - vectors[ 1 ];
		tvs[ 15 ] = positions_z[ id ] - vectors[ 2 ];
		//var t:Float = ap.dotProduct( n );
		//if ( t < 0 ) return false;
		//if ( asSegment && t > d ) return false;
		tvs[ 16 ] = tvs[ 13 ] * tvs[ 9 ] + tvs[ 14 ] * tvs[ 10 ] + tvs[ 15 ] * tvs[ 11 ];
		if ( tvs[ 16 ] < 0 ) return false;
		if ( asSegment && tvs[ 16 ] > tvs[ 12 ] ) return false;
		//var e:Vector3D = qp.crossProduct( ap );
		tvs[ 17 ] = tvs[ 7 ] * tvs[ 15 ] - tvs[ 8 ] * tvs[ 14 ];
		tvs[ 18 ] = tvs[ 8 ] * tvs[ 13 ] - tvs[ 6 ] * tvs[ 15 ];
		tvs[ 19 ] = tvs[ 6 ] * tvs[ 14 ] - tvs[ 7 ] * tvs[ 13 ];
		//var v:Float = ac.dotProduct( e );
		//if ( v < 0 || v > d ) return false;
		tvs[ 20 ] = tvs[ 3 ] * tvs[ 17 ] + tvs[ 4 ] * tvs[ 18 ] + tvs[ 5 ] * tvs[ 19 ];
		if ( tvs[ 20 ] < 0 || tvs[ 20 ] > tvs[ 12 ] ) return false;
		//var w:Float = -ab.dotProduct( e );
		//if ( w < 0 || v + w > d ) return false;
		tvs[ 21 ] = -( tvs[ 0 ] * tvs[ 17 ] + tvs[ 1 ] * tvs[ 18 ] + tvs[ 2 ] * tvs[ 19 ] );
		if ( tvs[ 21 ] < 0 || tvs[ 20 ] + tvs[ 21 ] > tvs[ 12 ] ) return false;
		return true;
	}
	override public function invalidateGeometry():Void
	{
		//var ab:Vector3D = v1.subtract( v0 );
		tvs[ 0 ] = vectors[ 3 ] - vectors[ 0 ];
		tvs[ 1 ] = vectors[ 4 ] - vectors[ 1 ];
		tvs[ 2 ] = vectors[ 5 ] - vectors[ 2 ];
		//var ac:Vector3D = v2.subtract( v0 );
		tvs[ 3 ] = vectors[ 6 ] - vectors[ 0 ];
		tvs[ 4 ] = vectors[ 7 ] - vectors[ 1 ];
		tvs[ 5 ] = vectors[ 8 ] - vectors[ 2 ];
	}
}