package triga.utils;
import away3d.core.base.data.Vertex;
/**
 * @author Nicolas Barradeau
 * http://en.nicoptere.net
 */
class VertexUtils 
{
	public function new(){}
	public function add( vertex:Vertex, toAdd:Vertex ):Void
	{
		vertex.x += toAdd.x;
		vertex.y += toAdd.y;
		vertex.z += toAdd.z;
	}
	public function sum( v0:Vertex, v1:Vertex ):Vertex
	{
		return new Vertex( v0.x + v1.x, v0.y + v1.y, v0.z + v1.z );
	}
	public function subtract( vertex:Vertex, toSubtract:Vertex ):Void
	{
		vertex.x -= toSubtract.x;
		vertex.y -= toSubtract.y;
		vertex.z -= toSubtract.z;
	}
	public function sub( v0:Vertex, v1:Vertex ):Vertex
	{
		return new Vertex( v0.x - v1.x, v0.y - v1.y, v0.z - v1.z );
	}
	public function multiply( vertex:Vertex, toMultiply:Vertex ):Void
	{
		vertex.x *= toMultiply.x;
		vertex.y *= toMultiply.y;
		vertex.z *= toMultiply.z;
	}
	public function mult( v0:Vertex, v1:Vertex ):Vertex
	{
		return new Vertex( v0.x * v1.x, v0.y * v1.y, v0.z * v1.z );
	}
	public function normalize( v:Vertex ):Void
	{
		var l:Float = Math.sqrt( x * x + y * y + z * z );
		v.x /= l;
		v.y /= l;
		v.z /= l;
	}
	public function dot( v0:Vertex, v1:Vertex ):Float
	{
		return v0.x * v1.x + v0.y * v1.y + v0.z * v1.z;
	}
	public function cross( v0:Vertex, v1:Vertex ):Vertex
	{ 
		return new Vertex( 	v0.y * v1.z - v0.z * v1.y, 
							v0.z * v1.x - v0.x * v1.z, 
							v0.x * v1.y - v0.y * v1.x	);
	}
}