package net.nicoptere.ca.ca;
import haxe.Timer;
import nme.display.Bitmap;
import nme.display.BitmapData;
import nme.display.Sprite;

/**
 * @author Nicolas Barradeau 
 */

class CellularAutomata_0 extends Sprite
{
	private var w:Float;
	private var h:Float;
	
	private var bd:BitmapData;
	
	public function new( w:Float, h:Float ) 
	{
		super();
		this.w = w;
		this.h = h;
		
		
		addChild( new Bitmap( bd = new BitmapData( Std.int( w ), Std.int( h ), false, 0 ) ) );
		
		//place un point
		bd.setPixel( Std.int( bd.width / 2 ), 0, 0xFFFFFF );
		
		//applique la règle 30 sur toute l'image
		for ( i in 0...bd.height ) scanLine( i );
		
		var timer:Timer = new Timer( 1 );
		timer.run = update;
		
	}
	
	private function update() 
	{
		
		scanLine( bd.height - 2 );
		bd.scroll( 0, -1 );
		
	}
	
	private function scanLine( line:Int ):Void
	{
		
		for ( i in 1...bd.width-1 )
		{
			
			//collecte les valeurs des 3 pixels au dessus de celui qu'on cherche
			var c0:Int = bd.getPixel( i - 1, 	line );
			var c1:Int = bd.getPixel( i, 		line );
			var c2:Int = bd.getPixel( i + 1, 	line );
			
			//applique la regle et obtient la valeur du nouveau pixel
			var output:Int = applyRule( c0, c1, c2 );
			
			//dessine le pixel
			bd.setPixel( i, line + 1, output );
			
		}
		
	}
	
	private function applyRule( c0:Int, c1:Int, c2:Int ) :Int
	{
		/*
			
			rule 30 retourne
			
			bin		7 		 6		 5		 4 		 3 		 2		 1 		 0		
			
			val		111		110		101		100		011		010		001		000		8 combianisons possible de 3 valeurs
			
			out		 0 		 0		 0		 1 		 1 		 1		 1 		 0		soit 30 en hexadecimal
			
			d'ou le nom "rule 30"
			
			soit:
			
			111	-> blanc	blanc	blanc		-> noir
			110	-> blanc	blanc	noir		-> noir	
			101	-> blanc	noir	blanc		-> noir	
			100	-> blanc	noir	noir		-> blanc		
			011	-> noir		blanc	blanc		-> blanc		
			010	-> noir		blanc	noir		-> blanc		
			001	-> noir		noir	blanc		-> blanc		
			000	-> noir		noir	noir		-> noir	
			
		*/
			
		if ( c0 != 0 && c1 == 0 && c2 == 0 ) return 0xFFFFFF;
		
		if ( c0 == 0 && c1 != 0 && c2 != 0 ) return 0xFFFFFF;
		
		if ( c0 == 0 && c1 != 0 && c2 == 0 ) return 0xFFFFFF;
		
		if ( c0 == 0 && c1 == 0 && c2 != 0 ) return 0xFFFFFF;
		
		return 0;
		
	}
	
}