package net.nicoptere.ca.ca;
import com.bit101.components.HUISlider;
import nme.display.Bitmap;
import nme.display.PixelSnapping;
import nme.events.Event;
import nme.geom.Point;
import nme.geom.Rectangle;
import nme.Lib;

#if flash
import flash.display.BitmapData;
#else
import nme.display.BitmapData;
#end

import nme.display.Sprite;

/**
 * @author Nicolas Barradeau 
 */

class CellularAutomata_2 extends Sprite
{
	private var w:Float;
	private var h:Float;
	
	private var bd:BitmapData;
	private var bmp:Bitmap;
	
	private var rules:Array<Array<Int>>;
	private var ruleset:Array<Int>;
	private var ruleId:Int = 0;
	private var ruleSlider:HUISlider;
	
	public function new( w:Float, h:Float ) 
	{
		super();
		
		this.w = w;
		this.h = h;
		var scale:Float = 2;
		bd = new BitmapData( Std.int( w / scale ), Std.int( h / scale ), false, 0 );
		bmp = new Bitmap( bd );// , PixelSnapping.AUTO, true );
		bmp.scaleX = bmp.scaleY = scale;
		addChild( bmp );
		
		rules = new Array<Array<Int>>();
		ruleset = new Array<Int>();
		
		for ( i in 0...8 )
		{
			
			ruleset = new Array<Int>();
			rules.push( ruleset );
			
		}
		
		for ( i in 0...0xFF + 1  )
		{
			
			var binaryValues:Array<Int> = int_to_bin( i, 8 );
			
			for ( i in 0...8 )
			{
				rules[ i ].push( binaryValues[ i ] );
			}
			
		}
		
		ruleSlider = new HUISlider( this, 10, 20, 'rule ID', onChangeRuleId );
		ruleSlider.minimum = 0;
		ruleSlider.maximum = 0xFF;
		ruleSlider.width = w - 20;
		onChangeRuleId( null );
	}
	
	private function onChangeRuleId(e:Event) 
	{
		ruleId = Std.int( Math.round( ruleSlider.value ) );
		
		bd.fillRect( bd.rect, 0 );
		
		bd.setPixel( Std.int( bd.width / 2 ), 0, 0xFFFFFF );
		
		//#if flash
			//bd.noise( 123, 0, 255, 7, true );
			//bd.threshold( bd, bd.rect, new Point(), '<', 0xFF808080, 0 );  
			//bd.threshold( bd, bd.rect, new Point(), '!=', 0, 0xFFFFFFFF );  
		//#end
		
		bd.lock();
		for ( i in 0...bd.height ) 
		{
			scanLine( ruleId, i );
		}
		bd.unlock();
		//ruleId++;
		//ruleId %= 0xFF;
		
	}
	
	private function int_to_bin( k:Int, base:Int = 3 ):Array<Int>
	{
		
		var bin:Array<Int> = [];
		
		while ( k > 0 )
		{
			
			bin.push( k % 2 );
			k = Std.int( k / 2 );
			
		}
		
		while ( bin.length < base ) bin.push( 0 );
		
		bin.reverse();
		return bin;
		
	}
	
	private inline function bool_to_int( a:Bool, b:Bool, c:Bool ):Int
	{
		
		return Std.int( a ? 1 : 0 ) << 2 | Std.int( b ? 1 : 0 ) << 1 | Std.int( c ? 1 : 0 );
		
	}
	
	private function scanLine( ruleId:Int, line:Int ):Void
	{
		
		
		for ( i in 1...bd.width-1 )
		{
			
			var output:Int = applyRule( i, line, ruleId );
			
			if( Math.random() > .2 )	bd.setPixel( i, line + 1, output );
			
		}
		
	}
	
	private function applyRule( x:Int, y:Int, ruleId:Int ) :Int
	{
		
		var id:Int = bool_to_int( 	bd.getPixel( x - 1	, y ) == 0,
									bd.getPixel( x		, y ) == 0,
									bd.getPixel( x + 1 	, y ) == 0	);
		
		return rules[ id ][ ruleId ] * 0xFFFFFF; 
		
	}
	
}