package net.nicoptere.ca.gol;
import flash.display.BitmapData;

/**
 * @author Nicolas Barradeau 
 */

class NeuronCell extends Cell
{

	/**
		rule: 3 state Cellular automaton
		
		- If the state is firing, the next state is resting.
		- If the state is resting, the next state is off.
		- If the state is off, and exactly two neighbors are firing, the state becomes firing.
		
	 */
	
	public function new( x:Int, y:Int, state:Int = 0 ) 
	{
		super( x, y, state );
	}
	
	override public function evaluate():Void 
	{
		
		//is cell dead or alive?
		if ( state == 0 )
		{
			//count the alive neighbors around the cell
			
			var count:Int = 0;
			
			for ( c in neighbors ) 
			{
				if ( c.state == 1 )	count++;
			}
			
			if ( count == 2)
			{	
				nextState = 1;
			} 
			else 
			{
				nextState = state;
			}
		}
		else if (state == 1) 
		{
			nextState = 2;
		}
		else if (state == 2) 
		{
			nextState = 0;
		}
		
	}
	
	override public function render(bd:BitmapData):Void 
	{
		
		state = nextState;
		
		var color:Int = 0;
		switch( state )
		{
			case 0:
				color = 0xFFFFFF;
				
			case 1:
				color = 0x808080;
				
			case 2:
				color = 0;
				
			default:
				
		}
		//= ( state == 1 ) ? 0 : 0xFFFFFF;
		bd.setPixel( x, y, color );
		
	}
}