package net.nicoptere.ca.gol;
import flash.display.BitmapData;

/**
 * @author Nicolas Barradeau 
 */

class VichiniacCell extends Cell
{

	/**
		rule:
		if a majority of cells is alive, stays alive, otherwise dies.
	 */
	
	public function new( x:Int, y:Int, state:Int = 0 ) 
	{
		super( x, y, state );
	}
	
	override public function evaluate():Void 
	{
		
		//is cell dead or alive?
		
		var count:Int = 0;
		
		//what is the cell state 
		count += state == 1 ? 1 : 0; 
		
		//count the alive neighbors around the cell
		
		for ( c in neighbors ) 
		{
			if ( c.state == 1 )	count++;
		}
		
		//cell is in the minority
		if (count <= 4)
		{   
			nextState = 0;   
		}
		//cell is in the majority
		else if (count > 4) 
		{   
			nextState = 1;    
		}   
		//swap
		if ( count == 4 || count == 5 )
		{   
			nextState = nextState == 0 ? 1 : 0;   
		}
	}
	
	override public function render(bd:BitmapData):Void 
	{
		
		state = nextState;
		var color:Int = ( state == 1 ) ? 0 : 0xFFFFFF;
		bd.setPixel( x, y, color );
		
	}
}