package net.nicoptere.ca.gol;
import flash.display.BitmapData;

/**
 * @author Nicolas Barradeau 
 */

class WaveCell 
{

	public var x:Int;
	public var y:Int;
	
	public var state:Float = 0;
	private var lastState:Float = 0;
	private var nextState:Float = 0;
	
	private var neighbors:Array<WaveCell>;
	
	public function new( x:Int, y:Int, state:Float = 0 ) 
	{
		
		this.x = x;
		this.y = y;
		
		this.state = nextState = state;
		lastState = 0;
		
		neighbors = new Array<WaveCell>();
		
	}
	
	public function addNeighbor( c:WaveCell ):Void
	{
		neighbors.push( c );
	}
	
	public function evaluate():Void 
	{
		
		var count:Float = 0;
		for ( c in neighbors ) 
		{
			count+= c.state;
		}
		
		var average:Float = ( count / neighbors.length ) % 0xFF;
		if ( average < 0 ) nextState += 0xFF;
		
		nextState = state + average - lastState;
		
		nextState = Math.min ( 0xFF, Math.max( 0, nextState ) );
		
		
	}
	
	public function render(bd:BitmapData):Void 
	{
		
		lastState = state;
		state = nextState;
		
		var color:Int = Std.int( state ) << 16 | Std.int( state ) << 8 | Std.int( state );
		bd.setPixel( x, y, color );
		
	}
}