package net.nicoptere.geometry;
import nme.display.Bitmap;
import nme.display.BitmapData;
import nme.display.Shape;
import nme.display.Sprite;
import nme.events.Event;
import nme.geom.Point;

/**
 * @author Nicolas Barradeau 
 */

class Circle_2 extends Sprite
{
	private var w:Float;
	private var h:Float;
	
	private var circle:Circle;
	private var c_0:Circle;
	private var c_1:Circle;

	//garder la trace de C_1
	private var canvas:Shape;
	private var bd:BitmapData;
	private var bmp:Bitmap;
	private var started:Bool;
	
	public function new( w:Float, h:Float ) 
	{
		super();
		
		this.w = w;
		this.h = h;
		
		canvas = new Shape();
		started = false;
		bd = new BitmapData( Std.int( w ), Std.int( h ), true, 0 ); 
		bmp = new Bitmap( bd );
		addChild( bmp );
		
		circle = new Circle( w * .5, h * .5, Math.min( w, h ) * .5 - 50 );
		
		c_0 = new Circle( 0, 0, circle.radius * .25 );
		
		c_1 = new Circle( 0, 0, 10 );
		
		addEventListener( Event.ENTER_FRAME, oef );
		
	}
	
	private function oef(e:Event):Void 
	{
		graphics.clear();
		
		circle.angle += Math.PI / 180;
		
		circle.render( graphics );
		
		
		var radius:Float = circle.radius - c_0.radius;
		var angle:Float = circle.angle;
		
		//cercle sur le cercle
		c_0.x = circle.x + Math.cos( angle ) * radius;
		c_0.y = circle.y + Math.sin( angle ) * radius;
		c_0.render( graphics, 0xFF0000 );
		
		
		//garde une trace
		canvas.graphics.clear();
		canvas.graphics.lineStyle( 0, 0xFFCC00 );
		canvas.graphics.moveTo( c_1.x, c_1.y );
		
		//astroid
		c_1.x = c_0.x + Math.cos( angle * - 3 ) * c_0.radius;
		c_1.y = c_0.y + Math.sin( angle * - 3 ) * c_0.radius;
		                                    
		//oeuf
		//c_1.x = c_0.x + Math.cos( -angle ) * Math.sin( angle ) * c_0.radius;
		//c_1.y = c_0.y + Math.sin( angle ) * c_0.radius;

		//bidule
		//c_1.x = c_0.x + Math.sin( angle ) * Math.cos( angle * -3 ) * c_0.radius;
		//c_1.y = c_0.y + Math.cos( angle ) * Math.sin( angle * -3 ) * c_0.radius;
		
		//bidule
		//c_1.x = c_0.x + Math.cos( angle ) * Math.cos( angle * 5 ) * c_0.radius;
		//c_1.y = c_0.y + Math.sin( angle ) * Math.sin( angle ) * c_0.radius;
		
		c_1.render( graphics, 0xFFCC00 );
		
		if ( started ) 	canvas.graphics.lineTo( c_1.x, c_1.y );
		else	started = true;
		
		bd.draw( canvas );
		
	}
	
}