package net.nicoptere.geometry;
import haxe.Timer;
import nme.display.Bitmap;
import nme.display.BitmapData;
import nme.display.Shape;
import nme.display.Sprite;
import nme.events.Event;
import nme.geom.Point;

/**
 * @author Nicolas Barradeau 
 */

class Circle_3 extends Sprite
{
	private var w:Float;
	private var h:Float;
	
	private var circle:Circle;
	private var c_0:Circle;
	private var c_1:Circle;
	private var c_2:Circle;

	//garder la trace de C_1
	private var canvas:Shape;
	private var bd:BitmapData;
	private var bmp:Bitmap;
	private var started:Bool;
	
	public function new( w:Float, h:Float ) 
	{
		super();
		
		this.w = w;
		this.h = h;
		
		canvas = new Shape();
		started = false;
		bd = new BitmapData( Std.int( w ), Std.int( h ), true, 0 ); 
		bmp = new Bitmap( bd );
		addChild( bmp );
		
		circle = new Circle( w * .5, h * .5, Math.min( w, h ) * .5 - 50 );
		
		c_0 = new Circle( 0, 0, circle.radius * .25 );
		
		c_1 = new Circle( 0, 0, c_0.radius * .25 );
		
		c_2 = new Circle( 0, 0, c_1.radius * .25 );
		
		
		
		//addEventListener( Event.ENTER_FRAME, oef );
		var t:Timer = new Timer( 1 );
		t.run = update;
		
	}
	
	private function oef(e:Event = null):Void 
	{
		update();
	}
	
	private function update():Void 
	{
		
		graphics.clear();
		
		circle.angle += Math.PI / 180;
		c_0.angle -= Math.PI / 120;
		c_1.angle += Math.PI / 60;
		c_2.angle -= Math.PI / 30;
		
		
		circle.render( graphics );
		graphics.moveTo( circle.x, circle.y );
		graphics.lineTo( c_0.x, c_0.y );
		
		
		var radius:Float = ( circle.radius - c_0.radius );
		
		//variation linéaire du rayon initial
		
		//radius *=  Math.abs(  Math.sin( circle.angle ) );
		
		//radius *= Math.sin( circle.angle ) * Math.cos( circle.angle ) * 2;
		
		//var t:Float = Timer.stamp();
		//radius *= Math.abs(  Math.sin( t ) );
		
		
		c_0.x = circle.x + Math.cos( c_0.angle ) * radius;
		c_0.y = circle.y + Math.sin( c_0.angle ) * radius;
		
			c_0.render( graphics, 0xFF0000 );
			graphics.moveTo( c_0.x, c_0.y );
			graphics.lineTo( c_1.x, c_1.y );
		
		
		radius = c_0.radius - c_1.radius;
		
		c_1.x = c_0.x + Math.cos( c_1.angle ) * radius;
		c_1.y = c_0.y + Math.sin( c_1.angle ) * radius;
		
			c_1.render( graphics, 0xFFCC00 );
			graphics.moveTo( c_1.x, c_1.y );
			graphics.lineTo( c_2.x, c_2.y );
		
		
		
		radius = c_1.radius - c_2.radius;
		
		//garde une trace
		canvas.graphics.clear();
		canvas.graphics.lineStyle( 0, 0x0099CC );
		canvas.graphics.moveTo( c_2.x, c_2.y );
		
		c_2.x = c_1.x + Math.cos( c_2.angle ) * radius;
		c_2.y = c_1.y + Math.sin( c_2.angle ) * radius;
		
		c_2.render( graphics, 0x0099CC );
		
		
		if ( started ) 	canvas.graphics.lineTo( c_2.x, c_2.y );
		else	started = true;
		
		bd.draw( canvas );
		
	}
	
}