package net.nicoptere.geometry.distribution;
import biga.distribution.Circular;
import nme.display.Sprite;
import nme.geom.Point;
import nme.Vector;

/**
 * @author Nicolas Barradeau 
 */

class CircularDistribution extends Sprite
{

	public function new( w:Float, h:Float ) 
	{
		super();
		
		var center:Point = new Point( w * .5, h * .5 );
		
		var radius:Float = Math.min( w, h ) * .5 - 50;
		
		var distribution:Circular = new Circular( center, radius, radius );
		
		var points:Vector<Point> = distribution.distribute( 100 );
		
		graphics.lineStyle( 0, 0xFFFFFF );
		for ( p in points )
		{
			graphics.drawCircle( p.x, p.y, 1 );
		}
		
	}
	
}