package net.nicoptere.geometry.distribution;
import biga.distribution.Distribution;
import biga.distribution.PRNGDistribution;
import biga.distribution.RandomDistribution;
import nme.display.Sprite;
import nme.geom.Point;
import nme.geom.Rectangle;
import nme.Vector;

/**
 * @author Nicolas Barradeau 
 */

class RandomDistributions extends Sprite
{
	public function new( w:Float, h:Float ) 
	{
		super();
		
		var points:Vector<Point>;
		var rect:Rectangle = new Rectangle( 0, 0, w, h ) ;
		
		graphics.lineStyle( 0, 0xFFCC00 );
		points = new RandomDistribution().distribute( rect, 100 );
		
		renderPoints( points );
			
			points = new RandomDistribution().distribute( rect, 100 );
			
			renderPoints( points, 4 );
		
		
		
		graphics.lineStyle( 0, 0x0099CC );
		points = new PRNGDistribution().distribute( rect, 100, 1 );
		
		renderPoints( points );
			
			points = new PRNGDistribution().distribute( rect, 100, 1 );
			
			renderPoints( points, 4 );
		
		
		
	}
	
	private function renderPoints( points:Vector<Point>, radius:Float = 1 ):Void 
	{
		for ( p in points )
		{
			graphics.drawCircle( p.x, p.y, radius );
		}
	}
	
}