package net.nicoptere.geometry.distribution;
import biga.distribution.Star;
import nme.display.Sprite;
import nme.geom.Point;
import nme.Vector;

/**
 * @author Nicolas Barradeau 
 */

class StarDistribution extends Sprite
{

	public function new( w:Float, h:Float ) 
	{
		super();
		
		var center:Point = new Point( w * .5, h * .5 );
		
		var radius:Float = Math.min( w, h ) * .5 - 50;
		
		var innerRadius:Float = radius - 100;
		
		var distribution:Star = new Star( center, innerRadius,  radius );
		
		var points:Vector<Point> = distribution.distribute( 5 );
		
		graphics.lineStyle( 0, 0xFFFFFF );
		graphics.moveTo( points[0].x, points[0].y );
		for ( p in points )
		{
			
			graphics.lineTo( p.x, p.y );
			graphics.drawCircle( p.x, p.y, 1 );
			graphics.moveTo( p.x, p.y );
		
		}
		graphics.lineTo( points[0].x, points[0].y );
		
	}
	
}