package net.nicoptere.geometry.interpolation;
import haxe.Timer;
import net.nicoptere.utils.Colors;
import nme.display.Sprite;
import nme.geom.Point;
import nme.Vector;

/**
 * @author Nicolas Barradeau 
 */

class InterpolationTest extends Sprite
{
	private var w:Float;
	private var h:Float;
	private var points:Vector<Point>;
	private var p:Point;
	private var T:Float;
	
	public function new(  w:Float, h:Float ) 
	{
		super();
		
		this.w = w;
		this.h = h;
		
		
		T = 0;
		
		points = new Vector<Point>();
		
		points.push( new Point( 100, h *.33 ) );
		points.push( new Point( w-100, h *.33 ) );
		
		p = new Point( 0, h * .33 );
		
		var timer:Timer = new Timer( 10 );
		timer.run = update;
		
	}
	
	private function update() 
	{
		
		graphics.clear();
		
		graphics.lineStyle( 0, Colors.BLUE );
		graphics.moveTo( points[0].x, points[0].y );
		graphics.lineTo( points[1].x, points[1].y );
		
		//valeur qui oscille entr 0 et 1
		T = .5 + Math.sin( Timer.stamp() ) * .5;
		
		//interpolation linéaire de T entra p0 et p1
		p.x = lerp( T, points[0].x, points[1].x );
		
		graphics.drawCircle( p.x, p.y, 4 );
		
	}
	
	static public function lerp( t:Float, a:Float, b:Float ):Float
	{
		return a + ( b - a ) * t;
	}
	
}