package net.nicoptere.geometry.motion;
import haxe.Timer;
import nme.display.Bitmap;
import nme.display.BitmapData;
import nme.display.Sprite;
import nme.geom.ColorTransform;
import nme.geom.Point;

/**
 * @author Nicolas Barradeau 
 */

class NoiseMotion extends Sprite
{

	private var w:Float;
	private var h:Float;
	
	private var bd:BitmapData;
	private var bmp:Bitmap;
	
	private var noise:Float = 0;
	private var factor:Float = 1;
	
	private var positionX:Float;
	private var positionY:Float;
	
	public function new( w:Float, h:Float ) 
	{
		
		super();
		
		this.w = w;
		this.h = h;
		
		positionX = 0;
		positionY = h * .5;
		
		bd = new BitmapData( Std.int( w ), Std.int( h ), true, 0 ); 
		addChild( bmp = new Bitmap( bd ) );
		
		var t:Timer = new Timer( 1 );
		t.run = update;
		
	}
	
	private function update():Void 
	{
		
		for ( i in 0...10 )
		{
			//accumule le deplacement
			
			// ça ( 2 * ( Math.random() - .5 ) ) tire un chiffre aléatoire entre -1 > N > 1
			noise += ( 2 * ( Math.random() - .5 ) ) * factor;
			
			// ça garde le noise entre -1 et 1
			noise =  ( noise > 1 ) ? 1 : ( noise < - 1 ) ? -1 : noise;
			
			//deplace le point
			positionX++;
			
			positionY += noise;
			
			//dessine
			
			bd.setPixel32( Std.int( positionX ), Std.int( positionY ), 0xFFFF0000 );
			
			//recadre X
			positionX %= w;
			
			//recadre Y
			if ( positionY < 0 ) positionY = 0;
			if ( positionY > h ) positionY = h;
		}
		
		//bd.colorTransform( bd.rect, new ColorTransform( 1, 1, 1, .98 ) );
	}
	
}