package net.nicoptere.geometry.motion;
import haxe.Timer;
import nme.display.Bitmap;
import nme.display.BitmapData;
import nme.display.Sprite;
import nme.geom.Point;

/**
 * @author Nicolas Barradeau 
 */

class NoiseMotion2D extends Sprite
{

	private var w:Float;
	private var h:Float;
	
	private var bd:BitmapData;
	private var bmp:Bitmap;
	
	private var noise:Point;
	private var factor:Float = 1;
	
	private var position:Point;
	
	public function new( w:Float, h:Float ) 
	{
		
		super();
		
		this.w = w;
		this.h = h;
		
		position = new Point( w * .5, h * .5 );
		
		noise = new Point( Math.random(), Math.random() );
		
		bd = new BitmapData( Std.int( w ), Std.int( h ), true, 0 ); 
		addChild( bmp = new Bitmap( bd ) );
		
		var t:Timer = new Timer( 1 );
		t.run = update;
		
	}
	
	private function update():Void 
	{
		
		for ( i in 0...10 )
		{
			//accumule le deplacement
			
			noise.x += ( 2 * ( Math.random() - .5 ) ) * factor;
			noise.y += ( 2 * ( Math.random() - .5 ) ) * factor;
			
			noise.normalize( 1 );
			
			//deplace le point
			position.x += noise.x;
			position.y += noise.y;
			
			//maintient le point dans le cadre
			boundPosition();
			
			//dessine
			
			bd.setPixel32( Std.int( position.x ), Std.int( position.y ), 0xFFFFCC00 );
		}
	}
	
	private function boundPosition() 
	{
		
		if( position.x < 0 ) position.x += w;
		if( position.y < 0 ) position.y += h;
		if ( position.x > w ) position.x = 0;
		if ( position.y > h	) position.y = 0;
		
	}
	
}