package net.nicoptere.geometry.motion;
import haxe.Timer;
import nme.display.Bitmap;
import nme.display.BitmapData;
import nme.display.Sprite;
import nme.geom.Point;

/**
 * @author Nicolas Barradeau 
 */

class RandomMotion2D extends Sprite
{

	private var w:Float;
	private var h:Float;
	
	private var bd:BitmapData;
	private var bmp:Bitmap;
	private var position:Point;
	
	public function new( w:Float, h:Float ) 
	{
		
		super();
		
		this.w = w;
		this.h = h;
		
		position = new Point( w * .5, h * .5 );
		
		bd = new BitmapData( Std.int( w ), Std.int( h ), true, 0 ); 
		addChild( bmp = new Bitmap( bd ) );
		
		var t:Timer = new Timer( 1 );
		t.run = update;
		
	}
	
	private function update():Void 
	{
		for ( i in 0...10 )
		{
			
			//deplace le point
			position.x += ( Math.random() - .5 ) * 2;
			position.y += ( Math.random() - .5 ) * 2;
			
			//dessine
			bd.setPixel32( Std.int( position.x ), Std.int( position.y ), 0xFF00CC00 );
			
			//recadre
			boundPosition();
		
		}
	}
	
	private function boundPosition() 
	{
		
		if( position.x < 0 ) position.x += w;
		if( position.y < 0 ) position.y += h;
		if ( position.x > w ) position.x = 0;
		if ( position.y > h	) position.y = 0;
		
	}
	
}