package net.nicoptere.geometry.oscillation;

/**
 * @author Nicolas Barradeau 
 */

class Harmonic
{
	static private var PI2:Float = ( Math.PI * 2 );
	
	private var _angle:Float;
	private var components:Array<Float>;
	private var increments:Array<Float>;
	
	public function new( octaves:Int = 3, maxIncrement:Float = .01 )
	{
		
		components = new Array<Float>();
		increments = new Array<Float>();
		
		for ( i in 0...octaves )
		{
			
			components.push( Math.random() * PI2 );
			increments.push( Math.random() * maxIncrement );
			
		}
	}
	
	public function update():Void
	{
		
		components[ 0 ] += increments[ 0 ];
		_angle = components[ 0 ];
		
		for ( i in 1...components.length )
		{
			
			components[ i ] += increments[ i ] / i;
			_angle *= Math.sin( components[ i ] );
			
		}
	}
	
	private function get_angle():Float 
	{
		return _angle;
	}
	
	public var angle( get_angle, null ):Float;
	
}