package net.nicoptere.geometry.oscillation;
import haxe.Timer;
import jeash.geom.Point;
import net.nicoptere.utils.Constants;
import nme.display.Bitmap;
import nme.display.BitmapData;
import nme.display.Shape;
import nme.display.Sprite;

/**
 * @author Nicolas Barradeau 
 */

class Oscillation_0 extends Sprite
{

	private var w:Float;
	private var h:Float;
	
	private var canvas:Shape;
	private var bd:BitmapData;
	private var bmp:Bitmap;
	
	private var circle:Circle;
	private var cos:Circle;
	private var sin:Circle;
	private var radius:Float;
	
	private var angle:Float = 0;
	private var angleIterator:Float = 0;
	
	public function new( w:Float, h:Float ) 
	{
		super();
		
		this.w = w;
		this.h = h;
		
		canvas = new Shape();
		
		//amplitude 
		radius = Math.min( w, h ) * .5 - 100;
		
		circle = new Circle( w * .75, h * .5, radius );
		
		cos = new Circle( 	circle.x + radius, 
							circle.y, 
							10 );
		
		sin = new Circle( 	circle.x, 
							circle.y + radius, 
							10 );
		
		
		bd = new BitmapData( Std.int( w ), Std.int( h ), true, 0 ); 
		bmp = new Bitmap( bd );
		addChild( bmp );
		
		var t:Timer = new Timer( 10 );
		t.run = update;
		
	}
	
	private function update():Void 
	{
		
		
		angle = ( angleIterator * Constants.DEGREES_TO_RADIANS );
		
		cos.x = circle.x + Math.cos( angle ) * radius;
		sin.y = circle.y + Math.sin( angle ) * radius;
		
		
		graphics.clear();
		
		graphics.lineStyle( 0, 0x666666 );
		graphics.moveTo( 0, circle.y - radius );
		graphics.lineTo( circle.x, circle.y - radius );
		graphics.moveTo( 0, circle.y );
		graphics.lineTo( circle.x, circle.y );
		graphics.moveTo( 0, circle.y + radius );
		graphics.lineTo( circle.x, circle.y + radius );
		var a:Point = new Point( Math.cos( angle ), Math.sin( angle ) );
		graphics.moveTo( circle.x + a.x * radius, circle.y + a.y * radius );
		
		
		circle.render( graphics, 0x666666 );
		graphics.drawCircle( cos.x, sin.y, 25 );
		
		graphics.lineStyle( 0, 0xFF0000 );
		graphics.moveTo( cos.x, cos.y );
		graphics.lineTo( cos.x, sin.y );
		
		graphics.lineStyle( 0, 0x00FF00 );
		graphics.moveTo( sin.x, sin.y );
		graphics.lineTo( cos.x, sin.y );
		
		canvas.graphics.clear();
		
		cos.render( graphics, 0xFF0000, 1 );
		sin.render( graphics, 0x00FF00, 1 );
		
		canvas.graphics.beginFill( 0x00FF00, .25 );
		canvas.graphics.drawCircle( sin.x, sin.y, 2 );
		canvas.graphics.endFill();
		
		
		//dessine la periode
		if ( angleIterator % 90 == 0 )
		{
			canvas.graphics.lineStyle( 0, 0x666666 );
			if( angleIterator % 360 == 0 ) canvas.graphics.lineStyle( 2, 0x999999 );
			canvas.graphics.moveTo( circle.x, circle.y - radius );
			canvas.graphics.lineTo( circle.x, circle.y + radius );
		}
		
		bd.draw( canvas );
		bd.scroll( -1, 0 );
		
		
		angleIterator += .5;
		
	}
	
}