package net.nicoptere.geometry.oscillation;
import haxe.Timer;
import net.nicoptere.utils.Constants;
import nme.display.Bitmap;
import nme.display.BitmapData;
import nme.display.Shape;
import nme.display.Sprite;

/**
 * @author Nicolas Barradeau 
 */

class Oscillation_1 extends Sprite
{

	private var w:Float;
	private var h:Float;
	
	private var canvas:Shape;
	private var bd:BitmapData;
	private var bmp:Bitmap;
	
	private var circle:Circle;
	private var cos:Circle;
	private var sin:Circle;
	private var radius:Float;
	
	
	
	private var angle:Float = 0;
	
	private var angle_0:Float = 0;
	private var angleIterator_0:Float = 0;
	
	private var angle_1:Float = 0;
	private var angleIterator_1:Float = 0;
	
	public function new( w:Float, h:Float ) 
	{
		super();
		
		this.w = w;
		this.h = h;
		
		canvas = new Shape();
		
		//amplitude 
		radius = Math.min( w, h ) * .5 - 100;
		
		circle = new Circle( w * .75, h * .5, radius );
		
		cos = new Circle( 	circle.x + radius, 
							circle.y, 
							10 );
		
		sin = new Circle( 	circle.x, 
							circle.y + radius, 
							10 );
		
		
		angleIterator_0 = Math.PI / 180;
		angleIterator_1 = Math.PI / 90;
		
		
		bd = new BitmapData( Std.int( w ), Std.int( h ), true, 0 ); 
		bmp = new Bitmap( bd );
		addChild( bmp );
		
		var t:Timer = new Timer( 1 );
		t.run = update;
		
		
	}
	
	private function update():Void 
	{
		//signal porteur
		angle_0 += angleIterator_0;
		
		//signal d'information
		angle_1 += angleIterator_1;
		
		angle = ( Math.sin( angle_0 ) * Math.sin( angle_1 ) );
		
		cos.x = circle.x + Math.cos( angle ) * radius;
		sin.y = circle.y + Math.sin( angle ) * radius;
		
		
		graphics.clear();
		
		graphics.lineStyle( 0, 0x666666 );
		graphics.moveTo( 0, circle.y - radius );
		graphics.lineTo( circle.x, circle.y - radius );
		graphics.moveTo( 0, circle.y );
		graphics.lineTo( circle.x, circle.y );
		graphics.moveTo( 0, circle.y + radius );
		graphics.lineTo( circle.x, circle.y + radius );
		
		circle.render( graphics, 0x666666 );
		
		graphics.drawCircle( cos.x, sin.y, 25 );
		
		graphics.moveTo( cos.x, cos.y );
		graphics.lineTo( cos.x, sin.y );
		graphics.moveTo( sin.x, sin.y );
		graphics.lineTo( cos.x, sin.y );
		
		cos.render( graphics, 0xFF0000, 1 );
		sin.render( graphics, 0x00FF00, 1 );
		
		canvas.graphics.clear();
		
		canvas.graphics.beginFill( 0x00FF00, .25 );
		canvas.graphics.drawCircle( sin.x, sin.y, 2 );
		canvas.graphics.endFill();
		
		bd.draw( canvas );
		bd.scroll( -1, 0 );
		
		
		
	}
	
}