package net.nicoptere.geometry.oscillation;
import haxe.Timer;
import net.nicoptere.utils.Constants;
import nme.display.Bitmap;
import nme.display.BitmapData;
import nme.display.Shape;
import nme.display.Sprite;
import nme.geom.Point;

/**
 * @author Nicolas Barradeau 
 */

class Oscillation_2 extends Sprite
{

	private var w:Float;
	private var h:Float;
	
	private var canvas:Shape;
	private var bd:BitmapData;
	private var bmp:Bitmap;
	
	private var circle:Circle;
	private var cos:Circle;
	private var sin:Circle;
	private var radius:Float;
	
	
	
	private var angle:Float = 0;
	
	private var angle_0:Float = 0;
	private var angleIterator_0:Float = 0;
	
	private var angle_1:Float = 0;
	private var angleIterator_1:Float = 0;
	
	private var angle_2:Float = 0;
	private var angleIterator_2:Float = 0;
	
	private var positionY:Float = 0;
	
	public function new( w:Float, h:Float ) 
	{
		super();
		
		this.w = w;
		this.h = h;
		
		//amplitude 
		radius = Math.min( w, h ) * .5 - 100;
		circle = new Circle( w * .75, h * .5, radius );
		
		angleIterator_0 = Math.PI / 180;
		angleIterator_1 = Math.PI / 360;
		angleIterator_2 = Math.PI / 720;
		positionY = circle.y;
		
		graphics.clear();
		
		graphics.lineStyle( 0, 0x666666 );
		graphics.moveTo( 0, circle.y - radius );
		graphics.lineTo( circle.x, circle.y - radius );
		graphics.moveTo( 0, circle.y );
		graphics.lineTo( circle.x, circle.y );
		graphics.moveTo( 0, circle.y + radius );
		graphics.lineTo( circle.x, circle.y + radius );
		
		circle.render( graphics, 0x666666 );
		
		canvas = new Shape();
		bd = new BitmapData( Std.int( w ), Std.int( h ), true, 0 ); 
		bmp = new Bitmap( bd );
		addChild( bmp );
		
		var t:Timer = new Timer( 1 );
		t.run = update;
		
		
	}
	
	private function update():Void 
	{
		canvas.graphics.clear();
		
		//signal porteur
		angle_0 += angleIterator_0;
		
		//signal d'information
		angle_1 += angleIterator_1;
		
		//signal d'information
		angle_2 += angleIterator_2;
		
		angle = ( Math.sin( angle_0 ) * Math.sin( angle_1 ) * Math.sin( angle_2 ) );
		
		var nx:Float, ny:Float;
		
		//dessin la porteuse en bleu
		
		ny = Math.sin( angle_0 ) * radius;
		
		canvas.graphics.lineStyle( 0, 0x0099CC, .5 );
		canvas.graphics.moveTo( circle.x, circle.y );
		canvas.graphics.lineTo( circle.x, circle.y + ny );
		
		//dessine l'info en jaune
		
		ny = Math.sin( angle_1 ) * radius;
		
		canvas.graphics.lineStyle( 0, 0xFFCC00, .5 );
		canvas.graphics.moveTo( circle.x, circle.y );
		canvas.graphics.lineTo( circle.x, circle.y + ny );
		
		
		//dessine l'info 2 en vert
		
		ny = Math.sin( angle_2 ) * radius;
		
		canvas.graphics.lineStyle( 0, 0x00CC66, .5 );
		canvas.graphics.moveTo( circle.x, circle.y );
		canvas.graphics.lineTo( circle.x, circle.y + ny );
		
		
		//dessine le resultat en blanc
		
		ny = Math.sin( angle ) * radius;
		
		canvas.graphics.lineStyle( 0,0,0 );
		canvas.graphics.beginFill( 0xFFFFFF );
		canvas.graphics.drawCircle( circle.x, circle.y + ny, 2 );
		
		
		bd.draw( canvas );
		bd.scroll( -1, 0 );
		
	}
	
}