package net.nicoptere.geometry.oscillation;
import haxe.Timer;
import net.nicoptere.utils.Colors;
import nme.display.Bitmap;
import nme.display.BitmapData;
import nme.display.Shape;
import nme.display.Sprite;
import nme.events.MouseEvent;
import nme.geom.ColorTransform;
import nme.geom.Point;
import nme.Lib;

/**
 * @author Nicolas Barradeau 
 */

class Oscillation_3 extends Sprite
{

	private var w:Float;
	private var h:Float;
	
	private var canvas:Shape;
	private var bd:BitmapData;
	private var bmp:Bitmap;
	
	private var circle:Circle;
	private var radius:Float;
	
	private var angle_0:Float = 0;
	private var angleIterator_0:Float = 0;
	
	private var angle_1:Float = 0;
	private var angleIterator_1:Float = 0;
	
	private var position:Point;
	
	public function new( w:Float, h:Float ) 
	{
		super();
		
		this.w = w;
		this.h = h;
		
		
		radius = Math.min( w, h ) * .5 - 100;
		circle = new Circle( w * .5, h * .5, radius );
		
		angleIterator_0 = Math.PI / 180;
		angleIterator_1 = Math.PI / 180;
		
		position = new Point( circle.x + radius, circle.y );
		
		
		canvas = new Shape();
		bd = new BitmapData( Std.int( w ), Std.int( h ), true, 0 ); 
		bmp = new Bitmap( bd );
		addChild( bmp );
		
		var t:Timer = new Timer( 1 );
		t.run = update;
		
		Lib.stage.addEventListener( MouseEvent.MOUSE_DOWN, onMouseDown );
	}
	
	private function onMouseDown(e:MouseEvent):Void 
	{
		angleIterator_0 = Math.random() * Math.PI * .1;
		angleIterator_1 = Math.random() * Math.PI * .1;
	}
	
	private function update():Void 
	{
		graphics.clear();
		canvas.graphics.clear();
		
		angle_0 += angleIterator_0;
		angle_1 += angleIterator_1;
		
		canvas.graphics.lineStyle( 0, Colors.BLUE, .5 );
		canvas.graphics.moveTo( position.x, position.y );
		
			position.x = circle.x + Math.cos( angle_0 ) * radius;
			position.y = circle.y + Math.sin( angle_1 ) * radius;
		
		canvas.graphics.lineTo( position.x, position.y );
		
		graphics.beginFill( Colors.WHITE );
		graphics.drawCircle( position.x, position.y, 3 );
		
		bd.draw( canvas );
		bd.colorTransform( bd.rect, new ColorTransform( 1, 1, 1, ( 1 - ( 1 / 0xFF ) ) ) );
	}
	
}