package net.nicoptere.particles.app;
import net.nicoptere.particles.forces.Force;
import net.nicoptere.utils.Constants;
import nme.display.Sprite;
import net.nicoptere.particles.bodies.Body;
import nme.events.MouseEvent;
import nme.Lib;

/**
 * @author Nicolas Barradeau 
 */

class BaseScene extends Sprite
{

	private var w:Float;
	private var h:Float;
	
	private var bodies:Array<Body>;
	private var body:Body;
	
	private var forces:Array<Force>;
	private var force:Force;
	
	private var mouseDown:Bool;
	public var angle:Float;

	public function new( width:Float = 800, height:Float = 480 ) 
	{
		super();
		
		w = width;
		h = height;
		
		bodies = new Array<Body>();
		forces = new Array<Force>();
		angle = 0;
		
		Lib.stage.addEventListener( MouseEvent.MOUSE_DOWN, mouseHandler );
		Lib.stage.addEventListener( MouseEvent.MOUSE_UP, mouseHandler );
		
	}
	
	private function mouseHandler(e:MouseEvent):Void 
	{
		
		mouseDown = e.type == MouseEvent.MOUSE_DOWN ? true : false;
		
	}
	
	public function updateBodies():Void
	{
		
		for( body in bodies )
		{
			body.update( Constants.TIME_STEP );
		}
		
	}
	
	public function render():Void
	{
		graphics.clear();
		for( body in bodies )
		{
			
			body.render( graphics );
			
		}
		
		for( force in forces )
		{
			
			force.render( graphics, 0xFFCC00 );
			
		}
		
	}
	
}