package net.nicoptere.particles.app;
import net.nicoptere.particles.bodies.Body;
import net.nicoptere.particles.forces.Elastic;
import net.nicoptere.particles.forces.Gravity;
import nme.events.Event;
import nme.events.MouseEvent;
import nme.Lib;

/**
 * @author Nicolas Barradeau 
 */

class ClusterFuck extends BaseScene
{
	private var minWeight:Float;
	private var maxWeight:Float;
	private var gravity:Gravity;

	public function new( w:Float, h:Float ) 
	{
		
		super( w, h );
		
		minWeight = 1;
		maxWeight = 10;
		
		gravity = new Gravity( 10 );
		
		init();
		
		Lib.stage.addEventListener( MouseEvent.MOUSE_DOWN, reset );
		addEventListener( Event.ENTER_FRAME, oef );
		
	}
	
	private function init( e:MouseEvent = null ):Void 
	{
		var elastic:Elastic;
		for ( i in 0...50 )
		{
			body = new Body( 	Math.random() * w,
								Math.random() * h,
								minWeight + ( Math.random() * ( maxWeight - minWeight ) ) );
			
			if ( Math.random() < .1 ) body.mass = 0;
			
			if ( i > 25 ) 
			{
				for ( j in 0...5 )
				{
					elastic = new Elastic( body, bodies[ Std.int( bodies.length * Math.random() ) ], 10+ Math.random() * 100, .1 + Math.random() * .9 );
					forces.push( elastic ); 
				}
			}
			
			body.addForce( gravity );
			
			body.friction = .95;
			
			
			bodies.push( body );
			
		}
	}
	
	private function reset( e:MouseEvent = null ):Void 
	{
		for ( body in bodies )
		{
			body.x = Math.random() * w;
			body.y = Math.random() * h;
			body.vx = body.vy = body.ax = body.ay = 0;
		}	
	}
	
	private function oef(e:Event):Void 
	{
		updateBodies();
		render();
	}
	
}