package net.nicoptere.particles.app;
import net.nicoptere.particles.bodies.Body;
import net.nicoptere.particles.forces.Attractor;
import net.nicoptere.utils.Constants;
import nme.events.Event;
import nme.events.MouseEvent;
import nme.Lib;

/**
 * ...
 * @author Nicolas Barradeau 
 */

class GravityMadness extends BaseScene
{
	private var attractors:Array<Attractor>;
	private var attractor:Attractor;
	public function new( w:Float, h:Float ) 
	{
		super( w, h );
		
		attractors = new Array<Attractor>();
		
		init();
		
		Lib.stage.addEventListener( MouseEvent.MOUSE_DOWN, reset );
		
		addEventListener( Event.ENTER_FRAME, oef );
	}
	
	private function reset(e:MouseEvent):Void 
	{
		for ( attractor in attractors )
		{
			attractor.position.x = Math.random() * w;
			attractor.position.y = Math.random() * h;
		}
		for ( body in bodies )
		{
			body.vx = body.vy = body.ax = body.ay = 0;
		}
	}
	
	private function init() 
	{
		//cree des attracteurs
		for ( i in 0...10 )
		{
			attractor = new Attractor( 	Math.random() * w, 
										Math.random() * h,
										250 + Math.random() * 250,
										( Math.random() < .5 ? 1 : -1 ) * 10 );
			attractors.push( attractor );
		}
		//cree des particules
		for ( i in 0...100 )
		{
			body = new Body( 	Math.random() * w, 
								Math.random() * h,
								1 + Math.random() * 5 );
			bodies.push( body );
			
			for ( attractor in attractors )
			{
				body.addForce( attractor );
			}
			
		}
	}
	
	private function oef(e:Event):Void 
	{
		checkBounds();
		
		updateBodies();
		
		render();
		
		for ( attractor in attractors )
		{
			if( attractor.strength < 0 ) attractor.render( graphics, 0xFF0000, 0.05 );
			else attractor.render( graphics, 0x0000FF, 0.05 );
		}
	}
	
	private function checkBounds() 
	{
		for( body in bodies )
		{
			if( body.x < 0 ) body.x += w;
			if( body.y < 0 ) body.y += h;
			if( body.x > w ) body.x = 0;
			if( body.y > h	) body.y = 0;
		}
	}
	
}