package net.nicoptere.particles.bodies;
import nme.display.Graphics;

/**
 * @author Nicolas Barradeau 
 */

class Acceleration extends Velocity
{

	public var ax:Float;
	public var ay:Float;
	
	public function new( x:Float = 0, y:Float = 0, radius:Float = 1 ) 
	{
		super( x, y, radius );
		
		//acceleration
		ax = 0;
		ay = 0;
		
	}
	
	override public function update( dt:Float = 1 ):Void
	{
		
		vx += ax * dt;
		vy += ay * dt;
		
		super.update( dt );
		
	}
	
	public function drawAcceleratioVector( graphics:Graphics, scale:Float = 1 ):Void
	{
		
		graphics.lineStyle( 3, 0xFFCC00 );
		
		graphics.moveTo( x, y );
		graphics.lineTo( x + ax * scale, y + ay * scale );
		
		graphics.lineStyle( 0, 0, 0 );
		
	}
}