package net.nicoptere.particles.forces;
import net.nicoptere.particles.bodies.Body;
import nme.display.Graphics;
import nme.geom.Point;
import nme.Lib;

/**
 * @author Nicolas Barradeau 
 */

class Force extends Point
{
	
	private var dx:Float;
	private var dy:Float;
	private var dist:Float;
	private var force:Float;
	private var angle:Float;
	private var bodies:Array<Body>;
	
	public function new( x:Float = 0, y:Float = 0 ) 
	{
		
		super( x, y );
		bodies = new Array<Body>();
		
	}
	
	public function evaluate( b:Body = null ):Void
	{
		
	}
	
	public function addBody( b:Body ):Void
	{
		
		for( _b in bodies )
		{
			if( b == _b )
			{
				return;
			}
		}
		bodies.push( b );
		
	}
	
	public function removeBody( b:Body ):Void
	{
		var i:Int = 0;
		while ( i < Std.int ( bodies.length ) )
		{
			if( b == bodies[ i ] )
			{
				bodies.splice( i, 1 );
				return;
			}
		}
		
	}
	
	public function render(graphics:Graphics, color:Int = 0xFF0000, alpha:Float = 1 ):Void 
	{
		
		graphics.beginFill( color, alpha );
		
		var w2:Float = Lib.stage.stageWidth	 * .5;
		var h2:Float = Lib.stage.stageHeight * .5;
		
		var r:Float = 30;
		var angle:Float = Math.atan2( y, x );
		var angle1:Float = angle - Math.PI / 10;
		var angle2:Float = angle + Math.PI / 10;
		
		graphics.moveTo( w2 + Math.cos( angle ) * r, h2 + Math.sin( angle ) * r );
		graphics.lineTo( w2 + Math.cos( angle1 ) * -r, h2 + Math.sin( angle1 ) * -r );
		graphics.lineTo( w2 + Math.cos( angle ) * -r * .5, h2 + Math.sin( angle ) * -r * .5 );
		graphics.lineTo( w2 + Math.cos( angle2 ) * -r, h2 + Math.sin( angle2 ) * -r );
		graphics.lineTo( w2 + Math.cos( angle ) * r, h2 + Math.sin( angle ) * r );
		
		graphics.endFill();
		
	}
	
	
}