package net.nicoptere.particles.forces;
import biga.utils.GeomUtils;
import net.nicoptere.particles.bodies.Body;
import nme.display.Graphics;
import nme.geom.Point;

/**
 * @author Nicolas Barradeau 
 */

class Motor extends Force
{
	
	public var radius:Float;
	public var speed:Float;
	public var position:Point;

	public function new( position:Point, radius:Float = 1, speed:Float = 1, force:Float = 1 ) 
	{
		super( 0,0 );
		this.position = position;
		this.radius = radius;
		this.speed = speed;
		this.force = force;
		angle = 0;
	}
	override public function evaluate(b:Body = null):Void 
	{
		
		angle += speed;
		
		var a:Float = GeomUtils.angle( position, b );
		x = Math.cos( angle + Math.PI * .5 ) * force;
		y = Math.sin( angle + Math.PI * .5 ) * force;
		
		
	}
	override public function render(graphics:Graphics, color:Int = 0xFF0000, alpha:Float = 1):Void 
	{
		graphics.lineStyle( 0, color, alpha );
		graphics.drawCircle( position.x, position.y, radius );
		graphics.moveTo( position.x, position.y );
		graphics.lineTo( 	position.x + Math.cos( angle ) * radius, 
							position.y + Math.sin( angle ) * radius );
		graphics.lineStyle( 0, 0, 0 );
	}
	
}