package net.nicoptere.particles.test;
import biga.utils.GeomUtils;
import nme.display.Sprite;
import nme.events.Event;
import nme.events.MouseEvent;
import nme.geom.Point;
import nme.Lib;

/**
 * ...
 * @author Nicolas Barradeau 
 */

class MonPetitPhysicien extends Sprite
{

	private var c:Float = 9;
	private var v:Float = 150;
	private var dt:Float = 1 / 30;
	private var x0:Float = 270;
	private var a:Float = 0;
	private var s:Sprite;
	private var rest:Float;
	private var p0:Point;
	private var p1:Point;
	private var v2:Point;
	private var v1:Point;
	public function new() 
	{
		super();
		x = 0;
		/*
		var poids:Float = 500;
		var gravity:Float =  .1;// 10 m / s²;
		//var gravity:Float =  N * K;
		
		
		var dist:Float = 91;
		
		//	91 - 75
		var delta:Float = dist - rest;
		
		var force:Float = poids * gravity;
		
		var K:Float = -force / delta;
		
		//*/
		addChild( s = new Sprite() );
		s.graphics.beginFill( 0xFF0000 );
		s.graphics.drawCircle( 0, 0, 5 );
		s.graphics.endFill();
		s.graphics.beginFill( 0xFF0000 );
		s.graphics.drawRect( -1, 0, 2, 10 );
		s.graphics.endFill();
		
		rest = 75;
		
		graphics.beginFill( 0x00FF00 );
		graphics.drawRect( 0, 0, rest * 2, 10 );
		graphics.drawRect( rest, 0, 2, 10 );
		
		c = 100;
		v = 0;
		dt = 1 / 30;
		x0 = 50;
		s.x = x0;
		a = 0;
		
		addEventListener( Event.ENTER_FRAME, oef );
		
		//x = 250;
		//y = 250;
		
		p0 = new Point( 100, 300 );
		p1 = new Point( 500, 300 );
		v1 = new Point( 200, 200 );
		
		Lib.stage.addEventListener( MouseEvent.MOUSE_DOWN, omd );
	}
	
	private function omd(e:MouseEvent):Void 
	{
		p0.x = Math.random() * 800;
		p0.y = Math.random() * 480;
		p1.x = Math.random() * 800;
		p1.y = Math.random() * 480;
		v1.x = mouseX;
		v1.y = mouseY;
	}
	
	private function oef(e:Event):Void 
	{
		
		
		a = -c * ( s.x - rest );
		
		v += a * dt;
		
		s.x += v * dt;
		
		v *= .95;
		
		
		graphics.clear();
		
		
		v2 = new Point( mouseX, mouseY );
		
		trace( GeomUtils.pointLineDistance( v2, p0, p1 ) );
		
		
		graphics.lineStyle( 2, 0x00FF00 );
		graphics.moveTo( p0.x, p0.y );
		graphics.lineTo( p1.x, p1.y );
		
		graphics.lineStyle( 2, 0xFF0000 );
		graphics.moveTo( v1.x, v1.y );
		graphics.lineTo( v2.x, v2.y );
		/*
		var pp:Point = GeomUtils.lineIntersectLine( p0, p1, v1, v2 );
		if ( pp != null )
		{
			var n:Point = GeomUtils.normal( p0, p1 ).add( pp );
			var m:Point = GeomUtils.reflect( pp.subtract( v1 ), pp, n ).add( pp );
			
			graphics.lineStyle( 3, 0xFFCC00 );
			graphics.moveTo( pp.x, pp.y );
			graphics.lineTo( m.x, m.y );
			//graphics.drawCircle( m.x, m.y, 2 );
			
		}
		//*/
		var bv:Array<Point> = GeomUtils.bounceVector( v1, v2, p0, p1 );
		if ( bv != null )
		{
			graphics.lineStyle( 3, 0x0066DD );
			graphics.moveTo( bv[ 0 ].x, bv[ 0 ].y );
			graphics.lineTo( bv[ 1 ].x, bv[ 1 ].y );
		}
		
		var cp:Point = perpendicularProjection( v2, p0, p1, false );
		if ( cp != null )
		{
			graphics.lineStyle( 3, 0x6600DD );
			graphics.drawCircle( cp.x, cp.y, 10 );
		}
		cp = GeomUtils.project( v2, p0, p1 );
		
		if ( cp != null )
		{
			graphics.lineStyle( 3, 0xFFCCDD );
			graphics.drawCircle( cp.x, cp.y, 2 );
		}
	}
	
	private function perpendicularProjection( p:Point, a:Point, b:Point, asSegment:Bool = true ):Point
	{
		
		var dx:Float = b.x - a.x;
		var dy:Float = b.y - a.y;
		
		if ( (dx == 0) && (dy == 0) )
		{
			return a;
		}
		
		var t:Float = ( ( p.x - a.x ) * dx + ( p.y - a.y ) * dy) / ( dx * dx + dy * dy );
		
		if ( asSegment && t < 0) 
		{
			return a;
		} 
		else if ( asSegment && t > 1) 
		{
			return b;
		}
		else 
		{
			return new Point( a.x + t * dx, a.y + t * dy );
		}
		return null;
	}
	
	private function reflect( p:Point, p0:Point, p1:Point) :Point
	{
		var normal:Point = GeomUtils.normal( p0, p1 );
		
		normal.normalize(1);

		var dot2:Float = 2 * GeomUtils.dotProduct( p, normal );
		p.x -= dot2 * normal.x;
		p.y -= dot2 * normal.y;
		
		return p;
	}

}