package net.nicoptere.particles.test;
import nme.display.Sprite;
import nme.events.Event;
import nme.Lib;

/**
 * ...
 * @author Nicolas Barradeau 
 */

class NormalVectors extends Sprite
{
	private var circle:Sprite;
	private var circle_radius:Float;
	private var toRad:Float;
	private var dotRadius:Int;
	private var frameRateAdjust:Float;
	private var t1:Sprite;
	private var t1_radians:Float;
	private var t1_speed:Float;
	private var t2:Sprite;
	private var t2_radians:Float;
	private var t2_speed:Float;
	private var c:Sprite;
	private var p:Sprite;

	public function new() 
	{
		super();
		frameRateAdjust = Lib.stage.frameRate/60;

		dotRadius = 3;

		toRad = Math.PI/180;

		circle_radius = 100;
		circle = newCircle(circle_radius);
			circle.x = Lib.stage.stageWidth/2;
			circle.y = Lib.stage.stageHeight/2;

		t1 = newCircle(dotRadius, true);
		t1_radians = 0;
		t1_speed = 2 / frameRateAdjust;

		t2 = newCircle(dotRadius, true);
		t2_radians = 0;
		t2_speed = 3 / frameRateAdjust;

		c = newCircle(dotRadius, true);
		p = newCircle(dotRadius, true);

		addChild(circle);
		addChild(c);
		addChild(t1);
		addChild(t2);
		addChild(p);

		addEventListener(Event.ENTER_FRAME, mainLoop);

	}
	private function mainLoop( event:Event = null):Void
	{
		c.x = circle.x;
		c.y = circle.y;
		
		t1_radians += t1_speed * toRad;
		t1.x = Math.sin(t1_radians)*circle_radius + circle.x;
		t1.y = Math.cos(t1_radians)*circle_radius*-1 + circle.y;
		
		t2_radians += t2_speed * toRad;
		
		t2.x = Math.sin(t2_radians) * circle_radius + circle.x;
		
		t2.y = Math.cos(t2_radians) * circle_radius * -1 + circle.y;
		
		
		var p_radians:Float = (t2_radians - t1_radians) * .5;
		
		var p_distance:Float = circle_radius / Math.cos(p_radians) * -1;
		
		
		p_radians -= t2_radians;
		
		p.x = Math.sin(p_radians) * p_distance + circle.x;
		
		p.y = Math.cos(p_radians) * p_distance + circle.y;
		
	}

	private function newCircle( radius:Float, fill:Bool = false):Sprite
	{
		var circle:Sprite = new Sprite();
		
			circle.graphics.lineStyle(0);
				
				if(fill)
				circle.graphics.beginFill(0);
				
			circle.graphics.drawCircle(0, 0, radius);
		
		return circle;
	}
	
}