package net.nicoptere.particles.test;
import net.nicoptere.particles.bodies.Acceleration;
import net.nicoptere.particles.bodies.Velocity;
import nme.display.Sprite;
import nme.events.Event;

/**
 * @author Nicolas Barradeau 
 */

class TestAcceleration extends Sprite
{
	
	private var w:Float;
	private var h:Float;
	
	private var ac:Acceleration;

	public function new( width:Float = 800, height:Float = 480 ) 
	{
		
		super();
		
		w = width;
		h = height;
		
		ac = new Acceleration( w * .5, h * .5, 20 );
		
		ac.ax = ( Math.random() - .5 );
		ac.ay = ( Math.random() - .5 );
		
		addEventListener( Event.ENTER_FRAME, update );
		
	}
	
	private function update(e:Event):Void 
	{
		
		graphics.clear();
		
		ac.update();
		
		ac.render( graphics );
		
		//dessine le vecteur de la velocite en rouge
		
		ac.drawVelocityVector( graphics );
		
		//dessine le vecteur de l'acceleration en jaune
		
		ac.drawAcceleratioVector( graphics, 100 );
		
		
		// controle l'acceleration en fonction de la souris
		
		ac.ax = ( ( mouseX - w * .5 ) / w );
		ac.ay = ( ( mouseY - h * .5 ) / h );
		
		//remettre le cercle dans le cadre
		
		if( ac.x < 0 ) ac.x += w;
		if( ac.y < 0 ) ac.y += h;
		
		ac.x %= w;
		ac.y %= h;
		
	}
	
}