package net.nicoptere.particles.test;
import net.nicoptere.particles.bodies.Body;
import net.nicoptere.particles.forces.Gravity;
import net.nicoptere.particles.forces.Field;
import nme.display.Sprite;
import nme.events.Event;
import nme.events.MouseEvent;
import nme.Lib;

/**
 * @author Nicolas Barradeau 
 */

class TestBody extends Sprite
{
	
	private var w:Float;
	private var h:Float;
	
	private var wind:Field;
	
	private var bodies:Array<Body>;
	private var body:Body;
	private var mouseDown:Bool;
	private var angle:Float;

	public function new( width:Float = 800, height:Float = 480 ) 
	{
		
		super();
		
		w = width;
		h = height;
		
		wind = new Field();
		angle = 0;
		
		bodies = new Array<Body>();
		
		Lib.stage.addEventListener( MouseEvent.MOUSE_DOWN, onMouseDown );
		Lib.stage.addEventListener( MouseEvent.MOUSE_UP, onMouseDown );
		addEventListener( Event.ENTER_FRAME, update );
		
	}
	
	private function onMouseDown(e:MouseEvent):Void 
	{
		
		mouseDown = e.type == MouseEvent.MOUSE_DOWN ? true : false;
		
	}
	
	private function update(e:Event):Void 
	{
		graphics.clear();
		
		
		//update la force
		
		//randomise la direction du vent
		angle += ( Math.random() - .5 ) * Math.PI / 10;
		
		wind.direction.x += ( Math.cos( angle ) - wind.x ) * .1;
		wind.direction.y += ( Math.sin( angle ) - wind.y ) * .1;
		
		wind.render( graphics, 0x00FF00 );
		
		
		if ( mouseDown )
		{
			
			body = new Body( Math.random() * w, Math.random() * h, 1 + Math.random() * 20 );
			
			body.addForce( wind );//ajoute la force, on peut en mettre plein!
			
			bodies.push( body );
			
		}
		
		for( body in bodies )
		{
			
			//met a jour
			body.update();
			
			//rendu
			body.render( graphics );
			
			//dessine le vecteur de la velocite en rouge
			body.drawVelocityVector( graphics );
			
			//dessine le vecteur de l'acceleration en jaune
			body.drawAcceleratioVector( graphics, 50 );
			
			graphics.lineStyle( 0, 0, 0 );
			
		}
		
		var i:Int = 0;
		while ( i < Std.int ( bodies.length ) )
		{
			
			var body:Body = bodies[ i ];
			
			//si la particule est sortie, on l'enleve du tableau
			if( body.x < 0 
			||	body.y < 0 
			||	body.x > w
			||	body.y > h	)
			{
				bodies.splice( i, 1 );
				if( i > 0 )i--;
			}
			
			i++;
			
		}
		
	}
	
}