package net.nicoptere.particles.test;
import net.nicoptere.particles.bodies.Friction;
import nme.display.Sprite;
import nme.events.Event;
import nme.events.MouseEvent;
import nme.Lib;

/**
 * @author Nicolas Barradeau 
 */

class TestFriction extends Sprite
{
	
	private var w:Float;
	private var h:Float;
	
	private var particles:Array<Friction>;
	private var ac:Friction;

	public function new( width:Float = 800, height:Float = 480 ) 
	{
		
		super();
		
		w = width;
		h = height;
		
		particles = new Array<Friction>();
		
		Lib.stage.addEventListener( MouseEvent.MOUSE_DOWN, onMouseDown );
		addEventListener( Event.ENTER_FRAME, update );
		
	}
	
	private function onMouseDown(e:MouseEvent):Void 
	{
		
		
		ac = new Friction( mouseX, mouseY, 10 );
		ac.ax = ( Math.random() - .5 );
		ac.ay = - .5 - Math.random() ;
		
		//ici !
		
		ac.friction = .1 + Math.random() * .9;			//ici !
		
		//ici !
		
		particles.push( ac );
		
	}
	
	private function update(e:Event):Void 
	{
		
		graphics.clear();
		
		var i:Int = 0;
		while( i < Std.int( particles.length ) )
		{
			
			var ac:Friction = particles[ i ];
			
			//ajoute la gravite
			ac.ay += .1;
			
			//met a jour
			ac.update();
			
			//rendu
			ac.render( graphics );
			
			//dessine le vecteur de la velocite en rouge
			ac.drawVelocityVector( graphics );
			
			//dessine le vecteur de l'acceleration en jaune
			ac.drawAcceleratioVector( graphics, 50 );
			
			//si la particule est sortie, on l'enleve du tableau
			if( ac.x < 0 
			||	ac.x > w
			||	ac.y > h	)
			{
				particles.splice( i, 1 );
				if( i > 0 )i--;
			}
			
			i++;
		}
		
	}
	
}