package net.nicoptere.particles.test;
import haxe.Timer;
import net.nicoptere.particles.bodies.Body;
import net.nicoptere.particles.forces.Elastic;
import net.nicoptere.particles.forces.Gravity;
import net.nicoptere.particles.forces.Spring;
import net.nicoptere.particles.forces.Field;
import nme.display.Shape;
import nme.display.Sprite;
import nme.events.Event;
import nme.events.MouseEvent;
import nme.geom.Point;
import nme.Lib;
import nme.text.TextField;

/**
 * @author Nicolas Barradeau 
 */

class TestSpring extends Sprite
{
	
	private var w:Float;
	private var h:Float;
	
	private var wind:Field;
	private var spring0:Spring;
	private var spring1:Spring;
	private var spring2:Spring;
	
	private var bodies:Array<Body>;
	private var elas:Array<Elastic>;
	private var body:Body;
	private var mouseDown:Bool;
	private var angle:Float;

	private var canvas:Shape;
	private var tf:TextField;
	private var ela:Elastic;
	public function new( width:Float = 800, height:Float = 480 ) 
	{
		
		super();
		tf = new TextField();
		addChild( tf );
		
		canvas = new Shape();
		addChild( canvas );
		
		
		w = width;
		h = height;
		
		wind = new Field();
		wind.strength = 1;
		spring0 = new Spring( new Point( w * .5, h * .5 - 50 		), 50, .1 );
		spring1 = new Spring( new Point( w * .5 - 100, h * .5 + 100 ), 50, 0.2 );
		spring2 = new Spring( new Point( w * .5 + 100, h * .5 + 100 ), 50, .1 );
		
		var gravity:Gravity = new Gravity( 1 );
		angle = 0;
		
		bodies = new Array<Body>();
		elas = new Array<Elastic>();
		
		
		for ( i in 0...3 )
		{
			
			var b:Body = new Body( w * Math.random(), h * Math.random(), 10 );
			
			b.addForce( wind );
			b.addForce( gravity );
			b.friction = .9;
			bodies.push( b );
		
		}
		bodies[ 0 ].mass = 0;
		bodies[ 0 ].x = w * .5;
		bodies[ 0 ].y = h * .5;
		//bodies[1].addForce( spring0 );
		
		var el:Elastic = new Elastic( bodies[ 0 ], bodies[ 1 ], 50, .100 );
		elas.push( el );
		
		var el:Elastic = new Elastic( bodies[ 1 ], bodies[ 2 ], 50, .100 );
		elas.push( el );
		
		bodies[2].addForce( spring1 );
		bodies[2].addForce( spring2 );
		
		//var el:Elastic = new Elastic( bodies[ 2 ], bodies[ 0 ], 10, 1 );
		//elas.push( el );
		
		Lib.stage.addEventListener( MouseEvent.MOUSE_DOWN, onMouseDown );
		Lib.stage.addEventListener( MouseEvent.MOUSE_UP, onMouseDown );
		addEventListener( Event.ENTER_FRAME, update );
		
	}
	
	private function onMouseDown(e:MouseEvent):Void 
	{
		
		mouseDown = e.type == MouseEvent.MOUSE_DOWN ? true : false;
		
	}
	private var go:Bool;
	private function update(e:Event):Void 
	{
		graphics.clear();
		
		if ( !go ) go = true;
		//update la force
		
		//randomise la direction du vent
		angle += ( Math.random() - .5 ) * Math.PI / 10;//Math.PI / 180;//
		
		wind.direction.x = 1;
		wind.direction.y = -.5;
		
		wind.direction.x += ( Math.cos( angle ) - wind.direction.x ) * .1;
		wind.direction.y += ( Math.sin( angle ) - wind.direction.y ) * .1;
		
		//wind.strength = ( Math.random() * 5 );
		
		tf.text = 'WF ' + wind.strength;
		wind.render( graphics, 0x00FF00 );
		
		
		for( body in bodies )
		{
			//met a jour
			body.update( 10 );// / 30 );
		}
		
		
		bodies[ 0 ].x = spring0.anchor.x = w * .5 + Math.cos( Timer.stamp() ) * 150;
		//spring2.anchor.y = 300 + Math.sin( angle ) * 150;
		for ( e in elas ) e.render( graphics, 0xFFCC00 );
		
		spring0.render( graphics, 0x00FF00 );
		spring1.render( graphics, 0x00FF00 );
		spring2.render( graphics, 0x00FF00 );
		
		for( body in bodies )
		{
			
			//rendu
			body.render( graphics );
			
			//dessine le vecteur de la velocite en rouge
			body.drawVelocityVector( graphics );
			
			//dessine le vecteur de l'acceleration en jaune
			body.drawAcceleratioVector( graphics );
			
			graphics.lineStyle( 0, 0, 0 );
			
		}
		
	}
	
}