package net.nicoptere.particles.test;
import net.nicoptere.particles.bodies.Velocity;
import nme.display.Sprite;
import nme.events.Event;

/**
 * @author Nicolas Barradeau 
 */

class TestVelocity extends Sprite
{
	
	private var w:Float;
	private var h:Float;
	
	private var vc:Velocity;

	public function new( width:Float = 800, height:Float = 480 ) 
	{
		
		super();
		
		w = width;
		h = height;
		
		vc = new Velocity( w * .5, h * .5, 20 );
		
		vc.vx = ( Math.random() - .5 ) * 10;
		vc.vy = ( Math.random() - .5 ) * 10;
		
		addEventListener( Event.ENTER_FRAME, update );
		
	}
	
	private function update(e:Event):Void 
	{
		
		graphics.clear();
		
		vc.update();
		
		vc.render( graphics );
		
		///*
		//dessine le vecteur de la velocite en rouge
		
		vc.drawVelocityVector( graphics, 10 );
		
		//*/
		
		///*
		// controle la velocite en fonction de la souris
		
		vc.vx = ( ( mouseX - w * .5 ) / w ) * 1;
		vc.vy = ( ( mouseY - h * .5 ) / h ) * 1;
		
		//*/
		
		///*
		//remettre le cercle dans le cadre
		
		if( vc.x < 0 ) vc.x += w;
		if( vc.y < 0 ) vc.y += h;
		
		vc.x %= w;
		vc.y %= h;
		
		//*/
		
		
		
		
	}
	
}