package net.nicoptere.planets;
import biga.utils.GeomUtils;
import nme.display.Bitmap;
import nme.display.BitmapData;
import nme.display.BlendMode;
import nme.display.Shape;
import nme.display.Sprite;
import nme.events.Event;
import nme.geom.Point;

/**
 * @author Nicolas Barradeau
 */

class Background extends Sprite 
{

	public function new( width:Float, height:Float, circleSize:Float ) 
	{
		
		super();
		
		var bd:BitmapData = new BitmapData( Std.int( width ), Std.int( height ), true, 0 );
		bd.noise( 123, 0, 16, 7, true );
		
		var p:Point = new Point();
		var center:Point = new Point( width * .5, height * .5 );
		var minDist:Float = Math.pow( ( circleSize * .5 - 2 ), 2 );
		
		bd.lock();
		for ( i in 0...bd.width )
		{
			for ( j in 0...bd.height )
			{
				if ( GeomUtils.squareDistance( i, j, center.x, center.y ) > minDist )
				{
					bd.setPixel32( i, j, 0 );
				}
				else
				{
					if( Math.random() < 0.001 ) bd.setPixel32( i, j, Std.int( 0xDD * ( Math.random() ) )<<24 | 0x999999  );
				}
			}
		}
		bd.unlock();
		
		var disc:Bitmap = new Bitmap( bd );
		disc.x = -width * .5;
		disc.y = -height * .5;
		addChild( disc );
		
	}
}