package net.nicoptere.planets;
import haxe.Timer;
import net.nicoptere.planets.AsteroidBelt;
import net.nicoptere.planets.descriptor.Info;
import net.nicoptere.planets.descriptor.PlanetDescription;
import nme.events.MouseEvent;
import nme.Lib;

import net.nicoptere.planets.Planet;
import nme.display.Sprite;
import nme.events.Event;
import nme.text.TextField;
import nme.text.TextFieldAutoSize;

/**
 * @author Nicolas Barradeau
 */

class Planets extends Sprite
{
	private var p:Planet;
	private var tf:TextField;
	
	private var planets:Hash<Planet>;
	private var asteroids:AsteroidBelt;
	private var calendar:Calendar;
	private var background:Background;
	
	public function new( width:Float, height:Float ) 
	{
		
		super();
		
		x = width * .5;
		y = height * .5;
		
		var desc:PlanetDescription;
		var size:Float = Math.min( width, height ) * .1;
		
		background =  new Background( width, height, Math.min( width, height )  );
		addChild( background );
		
		planets = new Hash<Planet>();
		
		desc = new PlanetDescription( 'Soleil', 0, 0, 20, 0xFFFCC00 );
		p = new Planet( desc );
		p.isSun = true;
		addChild( p.canvas );
		planets.set( desc.name, p );
		
		
		var descriptions:Array<PlanetDescription> = new Array<PlanetDescription>();
		descriptions.push( new PlanetDescription( 	'mercury'	, 0.38710	,0.2408	, 4.876 		, 	0x999999	)	);
		descriptions.push( new PlanetDescription( 	'venus'		, 0.72333	,0.6152	, 12.107		, 	0xFE9834	)	);
		descriptions.push( new PlanetDescription( 	'earth'		, 1.00000	,1.0000	, 12.755		, 	0x3552B5	)	);
		descriptions.push( new PlanetDescription( 	'mars'		, 1.52366	,1.8808	, 6.794		, 	0xBA753E	)	);
		//descriptions.push( new PlanetDescription( 	'ceres' 	, 2.7665	,4.601	, 10			, 	0x666666	)	);
		
		var outerOffset:Float = 2.75;
		
		descriptions.push( new PlanetDescription( 	'jupiter'	, /*5.20336*/	outerOffset ,		11.862	, 142.983		, 	0x949E95	)	);
		descriptions.push( new PlanetDescription( 	'saturn'	, /*9.53707*/	outerOffset += .3,		29.457	, 120.536		, 	0xD0C961	)	);
		descriptions.push( new PlanetDescription( 	'uranus'	, /*19.1913*/	outerOffset += .3,		84.018	, 51.117		, 	0x8AA2A6	)	);
		descriptions.push( new PlanetDescription( 	'neptune'	, /*30.0690*/	outerOffset += .3,		164.78	, 49.527		, 	0x5983BD	)	);
		descriptions.push( new PlanetDescription( 	'pluto' 	, /*39.4817*/	outerOffset += .3,		248.4	, 2.390		, 	0x717171	)	);
		descriptions.push( new PlanetDescription( 	'eris' 		, /*68.1461*/	outerOffset += .3,		562.55	, 10		, 	0x666666	)	);
		
		var s:Planet;
		for ( desc in descriptions )
		{
			
			desc.distance *= size;
			s = p.addSatelite( desc );
			planets.set( desc.name, s );
			addChild( s.canvas );
			
		}
		
		planets.get( "earth" ).addSatelite( new PlanetDescription( "moon",12.9,0.036600541688016984,3.476, 0xCCCCCC ) );
		planets.get( "mars" ).addSatelite( new PlanetDescription( "deimos",13.3,0.7917656373713381,1, 0xCCCCCC ) );
		planets.get( "mars" ).addSatelite( new PlanetDescription( "phobos",13.3,3.134796238244514,1, 0xCCCCCC ) );
		planets.get( "jupiter" ).addSatelite( new PlanetDescription( "adrastea",62.9,3.3557046979865772,1, 0xCCCCCC ) );
		planets.get( "jupiter" ).addSatelite( new PlanetDescription( "aitne",60.2,0.001358695652173913,1, 0xCCCCCC ) );
		planets.get( "jupiter" ).addSatelite( new PlanetDescription( "amalthea",22.5,2.0080321285140563,4, 0xCCCCCC ) );
		planets.get( "jupiter" ).addSatelite( new PlanetDescription( "ananke",61.4,0.001584786053882726,1, 0xCCCCCC ) );
		planets.get( "jupiter" ).addSatelite( new PlanetDescription( "aoede",47.2,0.0013354700854700855,1, 0xCCCCCC ) );
		planets.get( "jupiter" ).addSatelite( new PlanetDescription( "arche",17.0,0.001397428731134712,1, 0xCCCCCC ) );
		planets.get( "jupiter" ).addSatelite( new PlanetDescription( "autonoe",43.3,0.0013280212483399733,1, 0xCCCCCC ) );
		planets.get( "jupiter" ).addSatelite( new PlanetDescription( "callisto",17.2,0.05991970759182695,4, 0xCCCCCC ) );
		planets.get( "jupiter" ).addSatelite( new PlanetDescription( "carme",50.0,0.001445086705202312,1, 0xCCCCCC ) );
		planets.get( "jupiter" ).addSatelite( new PlanetDescription( "callirrhoe",37.2,0.0012919896640826874,1, 0xCCCCCC ) );
		planets.get( "saturn" ).addSatelite( new PlanetDescription( "aegir",58.9,0.0008956560680698612,1, 0xCCCCCC ) );
		planets.get( "saturn" ).addSatelite( new PlanetDescription( "albiorix",55.9,0.001277139208173691,1, 0xCCCCCC ) );
		planets.get( "saturn" ).addSatelite( new PlanetDescription( "anthe",18.5,0.9615384615384615,1, 0xCCCCCC ) );
		planets.get( "saturn" ).addSatelite( new PlanetDescription( "atlas",20.6,1.6611295681063123,1, 0xCCCCCC ) );
		planets.get( "saturn" ).addSatelite( new PlanetDescription( "bebhionn",51.2,0.0011978917105893627,1, 0xCCCCCC ) );
		planets.get( "saturn" ).addSatelite( new PlanetDescription( "bergelmir",61.1,0.0009941346058256288,1, 0xCCCCCC ) );
		planets.get( "saturn" ).addSatelite( new PlanetDescription( "bestla",49.3,0.0009228497600590625,1, 0xCCCCCC ) );
		planets.get( "saturn" ).addSatelite( new PlanetDescription( "calypso",41.2,0.5296610169491526,1, 0xCCCCCC ) );
		planets.get( "saturn" ).addSatelite( new PlanetDescription( "daphnis",59.4,1.6835016835016836,1, 0xCCCCCC ) );
		planets.get( "saturn" ).addSatelite( new PlanetDescription( "dione",63.0,0.36536353671903543,1.12, 0xCCCCCC ) );
		planets.get( "uranus" ).addSatelite( new PlanetDescription( "ariel",25.9,0.3968253968253968,1.16, 0xCCCCCC ) );
		planets.get( "uranus" ).addSatelite( new PlanetDescription( "belinda",18.6,1.6025641025641026,1, 0xCCCCCC ) );
		planets.get( "uranus" ).addSatelite( new PlanetDescription( "bianca",30.7,2.3094688221709005,1, 0xCCCCCC ) );
		planets.get( "uranus" ).addSatelite( new PlanetDescription( "caliban",34.8,0.001725625539257981,1, 0xCCCCCC ) );
		planets.get( "uranus" ).addSatelite( new PlanetDescription( "cordelia",17.6,2.9850746268656714,1, 0xCCCCCC ) );
		planets.get( "uranus" ).addSatelite( new PlanetDescription( "cressida",15.3,2.155172413793103,1, 0xCCCCCC ) );
		planets.get( "uranus" ).addSatelite( new PlanetDescription( "cupid",17.5,1.6181229773462784,1, 0xCCCCCC ) );
		planets.get( "uranus" ).addSatelite( new PlanetDescription( "desdemona",15.9,2.109704641350211,1, 0xCCCCCC ) );
		planets.get( "uranus" ).addSatelite( new PlanetDescription( "ferdinand",29.9,0.0003541829000495856,1, 0xCCCCCC ) );
		planets.get( "uranus" ).addSatelite( new PlanetDescription( "francisco",37.2,0.003750937734433608,1, 0xCCCCCC ) );
		planets.get( "neptune" ).addSatelite( new PlanetDescription( "despina",15.4,2.5,1, 0xCCCCCC ) );
		planets.get( "neptune" ).addSatelite( new PlanetDescription( "galatea",24.4,3.0303030303030303,1, 0xCCCCCC ) );
		planets.get( "neptune" ).addSatelite( new PlanetDescription( "halimede",19.8,0.0005333816932735235,1, 0xCCCCCC ) );
		planets.get( "neptune" ).addSatelite( new PlanetDescription( "larissa",18.2,1.7857142857142856,1, 0xCCCCCC ) );
		planets.get( "neptune" ).addSatelite( new PlanetDescription( "laomedeia",20.5,0.00033552543282780835,1, 0xCCCCCC ) );
		planets.get( "neptune" ).addSatelite( new PlanetDescription( "naiad",15.1,3.3333333333333335,1, 0xCCCCCC ) );
		planets.get( "neptune" ).addSatelite( new PlanetDescription( "nereid",24.4,0.002776543758329631,1, 0xCCCCCC ) );
		planets.get( "neptune" ).addSatelite( new PlanetDescription( "neso",19.9,0.00011102352588513505,1, 0xCCCCCC ) );
		planets.get( "neptune" ).addSatelite( new PlanetDescription( "proteus",23.9,0.8928571428571428,1, 0xCCCCCC ) );
		planets.get( "neptune" ).addSatelite( new PlanetDescription( "psamathe",18.2,0.00010945577494141379,1, 0xCCCCCC ) );
		planets.get( "pluto" ).addSatelite( new PlanetDescription( "charon",15.0,0.1565680288085173,1, 0xCCCCCC ) );
		planets.get( "pluto" ).addSatelite( new PlanetDescription( "nix",12.6,0.040231734792404245,1, 0xCCCCCC ) );
		planets.get( "pluto" ).addSatelite( new PlanetDescription( "hydra",12.8,0.02617389938753075,1, 0xCCCCCC ) );
		
		
		for ( p in planets )
		{
			for ( s in p.satelites )
			{
				if ( !contains( s.canvas ) )
				{
					addChild( s.canvas );
				}
			}
		}
		
		
		calendar = new Calendar( Math.min( width, height ) );
		calendar.referencePlanet = planets.get( "earth" );
		addChild( calendar );
		
		
		asteroids = new AsteroidBelt( 1000, 1.85 * size, 2.5 * size );
		addChild( asteroids );
		
		
		tf = new TextField();
		tf.x = tf.y = -250;
		tf.textColor = 0xFFFFFF;
		tf.autoSize = TextFieldAutoSize.LEFT;
		addChild( tf );
		
		
		addEventListener( Event.ADDED_TO_STAGE, onAdded );
		addEventListener( Event.ENTER_FRAME, update );
		
	}
	
	private function onAdded(e:Event):Void 
	{
		removeEventListener(Event.ADDED_TO_STAGE, onAdded);
		Lib.stage.addEventListener( Event.RESIZE, onResize );
		onResize(null);
	}
	
	private function onResize(e:Event):Void 
	{
		
		x = stage.stageWidth * .5;
		y = stage.stageHeight * .5;
		
	}
	
	private function update(e:Event):Void 
	{
		var t:Float = Timer.stamp();
		
		calendar.update( t );
		calendar.render( graphics );
		
		asteroids.update( t );
		asteroids.render();
		
		p.update( t );
		
		background.rotation += .01;
	}
	
}