package net.nicoptere.planets.descriptor;

import nme.display.Sprite;
import nme.text.TextField;
import nme.text.TextFieldAutoSize;
import nme.utils.Timer;

/**
 * @author Nicolas Barradeau
 */

class Info extends Sprite
{
	private var tf:TextField;
	private var timer:Timer;
	private var alphaIncrement:Float;
	private var destAlpha:Float;
	private var margin:Float = 5;

	public function new() 
	{
		
		super();
		
		tf = new TextField();
		tf.autoSize = TextFieldAutoSize.LEFT;
		tf.textColor = 0xFFFFFF;
		
		addChild( tf );
		
		timer = new Timer(100);
		alpha = 0;
		
	}
	
	public function setText( txt:String ):Void
	{
		
		tf.text = txt;
		resizeBg();
		show();
		
	}
	
	private function resizeBg() 
	{
		graphics.clear();
		graphics.lineStyle( 0, 0x202020 );
		graphics.beginFill( 0, 0x303030 );
		graphics.drawRect( -margin, -margin, tf.width + margin * 2, tf.height + margin * 2 );
		
	}
	
	public function show():Void
	{
		
		alphaIncrement = .01;
		destAlpha = 1;
		timer.stop();
		//timer.run = update;
		
	}
	public function hide():Void
	{
		alphaIncrement = -.01;
		destAlpha = 1;
		timer.stop();
		//timer.run = update;
		
	}
	
	public function update():Void
	{
		alpha += alphaIncrement;
		if ( alpha == destAlpha )
		{
			timer.stop();
			if ( alpha == 0 ) show();
			else hide();
		}
	}
	
	
	
}