package net.nicoptere.dna;

/**
 * @author Nicolas Barradeau 
 */

class DNA 
{
	
	private var _genes:Array<Dynamic>;
	
	public function new() 
	{
		
		genes = new Array<Dynamic>();
		
	}
	
	public function addGene( g:Dynamic ):Void
	{
		
		genes.push( g );
		
	}
	
	public function getGeneAt( id:Int ):Dynamic
	{
		
		return genes[ id ];
		
	}
	
	public function setGeneAt( id:Int, g:Dynamic ):Void
	{
		
		genes[ id ] = g;
		
	}
	
	public function setGenes( genome:Array<Dynamic> ):DNA
	{
		
		genes = [];
		for ( i in 0...genome.length )
		{
			genes[ i ] = genome[ i ];
		}
		return this;
		
	}
	
	public function cross( other:DNA ):DNA
	{
		
		for ( i in 0...length )
		{
			if ( Math.random() > .5 ) 
			{
				genes[ i ] = other.genes[ i ];
			}
		}
		return this;
		
	}
	
	public function compare( other:DNA ):Float
	{
		
		var score:Float = 0;
		for ( i in 0...genes.length )
		{
			if ( genes[ i ] == other.genes[ i ] )
			{
				score++;
			}
		}
		return score;
		
	}
	
	public function clone():DNA
	{
		
		return new DNA().setGenes( genes );
		
	}
	
	
	private function get_genes():Array<Dynamic> 
	{
		return _genes;
	}
	private function set_genes(value:Array<Dynamic>):Array<Dynamic> 
	{
		return _genes = value;
	}
	public var genes(get_genes, set_genes):Array<Dynamic>;
	
	
	private function get_length():Int 
	{
		return genes.length;
	}
	public var length(get_length, null):Int;
	
	
}