package net.nicoptere.dna.items;
import net.nicoptere.dna.DNA;
import nme.display.Graphics;
import nme.geom.Point;

/**
 * @author Nicolas Barradeau 
 */

class ColorItem extends DnaHolder
{
	public var position:Point;
	public var radius:Float;

	public function new( position:Point, radius:Float ) 
	{
		this.position = position;
		this.radius = radius;
		
		super( 3 );// 3 : R, G, B
	}
	
	override public function randomGene():Dynamic 
	{
		
		return Math.round( Math.random() * 0xFF );
		
	}
	
	override public function computeFitness(target:DNA):Float 
	{
		
		var dr:Float = dna.genes[ 0 ] - target.genes[ 0 ];//diff red
		var dg:Float = dna.genes[ 1 ] - target.genes[ 1 ];//diff green
		var db:Float = dna.genes[ 2 ] - target.genes[ 2 ];//diff blue
		
		_fitness = Math.sqrt( dr * dr + dg * dg + db * db );
		
		return _fitness;
		
	}
	
	override public function express(context:Dynamic):Void 
	{
		
		var g:Graphics = cast( context, Graphics );
		g.beginFill( dna.genes[ 0 ] << 16 | dna.genes[ 1 ] << 8 | dna.genes[ 2 ] ); 
		g.drawCircle( position.x, position.y, radius );
		g.endFill();
		
	}
	
}