package net.nicoptere.dna.items;
import net.nicoptere.dna.DNA;
import net.nicoptere.dna.IDNAHolder;
import nme.text.TextField;

/**
 * @author Nicolas Barradeau 
 */

class DnaHolder implements IDNAHolder
{

	private var _dna:DNA;
	
	private var _fitness:Float;
	
	private var _mutationRate:Float = .02;
	
	public function new( length:Int ) 
	{
		
		dna = new DNA();
		
		for ( i in 0...length )
		{
			
			dna.addGene( randomGene() );
			
		}
		
	}
	
	/* INTERFACE net.nicoptere.dna.IGenotype */
	
	public function randomGene():Dynamic
	{
		
		return null;
		
	}
	
	public function computeFitness( target:DNA ):Float 
	{
		
		_fitness = dna.compare( target ) / target.length;
		return _fitness;
		
	}
	
	public function mutate():Void 
	{
		
		for ( i in 0...dna.length )
		{
			if ( Math.random() < mutationRate )
			{
				dna.setGeneAt( 	i, randomGene() );
			}
		}
		
	}
	
	public function cross( other:DNA ):DNA
	{
		
		return dna.cross( other );
		
	}
	
	public function clone():IDNAHolder
	{
		
		var tmp:DnaHolder = new DnaHolder( dna.length );
		tmp.dna.setGenes( dna.genes );
		tmp.mutationRate = this.mutationRate;
		tmp.fitness = this.fitness;
		return tmp;
		
	}
	
	//override in children
	public function express( context:Dynamic ):Void
	{
		
	}
	
	
	
	private function get_fitness():Float 
	{
		return _fitness;
	}
	public var fitness(get_fitness, null ):Float;
	
	
	private function get_mutationRate():Float 
	{
		return _mutationRate;
	}
	private function set_mutationRate(value:Float):Float 
	{
		return _mutationRate = value;
	}
	public var mutationRate(get_mutationRate, set_mutationRate):Float;
	
	
	private function get_dna():DNA 
	{
		return _dna;
	}
	private function set_dna(value:DNA):DNA 
	{
		return _dna = value;
	}
	public var dna(get_dna, set_dna):DNA;
	
}