package net.nicoptere.dna.tests;
import biga.distribution.Circular;
import biga.distribution.Star;
import biga.utils.GeomUtils;
import haxe.Timer;
import net.nicoptere.dna.DNA;
import net.nicoptere.dna.IDNAHolder;
import net.nicoptere.dna.items.ShapeItem;
import nme.display.Sprite;
import nme.geom.Point;
import nme.geom.Rectangle;
import nme.Vector;

/**
 * @author Nicolas Barradeau 
 */

class MonoShapeDna extends Sprite
{

	private var candidate:ShapeItem;
	
	private var temp:ShapeItem;
	
	private var target:ShapeItem;
	
	private var timer:Timer;
	private var lastFitness:Float;
	
	public function new( w:Float, h:Float ) 
	{
		
		super();
		
		
		var rect:Rectangle = new Rectangle( w * .5 - 250, 40, 100, 100 );
		target = new ShapeItem( 0, rect );
		
		var positions:Vector<Point> = new Star( new Point( 50, 50 ), 20, 40 ).distribute( 5 );
		target.dna.setGenes([]);
		for( p in positions ) target.dna.addGene( p );
		
		
		//un candidat
		rect.x = w * .5 - 125;
		candidate = new ShapeItem( positions.length, rect );
		addChild( candidate.tf );
			
			//initialise le fitness minimum qui servira de reference pour voir si temp fait mieux
			lastFitness = candidate.computeFitness( target.dna );
		
		//un objet temporaire qui va muter
		rect.x = w * .5;
		temp = new ShapeItem( positions.length, rect );
		addChild( temp.tf );
		
		//loop
		timer = new Timer( 1 );
		timer.run = update;
		
	}
	
	private function update() 
	{
		graphics.clear();
		
		graphics.beginFill( 0x0099CC );
		target.express( graphics );
		graphics.endFill();
		
			//tente une mutation
			temp.dna = candidate.dna.clone();
			temp.mutate();
			
			//si elle est bénéfique
			if ( temp.computeFitness( target.dna ) <= lastFitness )
			{
				//on conserve cet ADN en le copiant dans le candidat
				candidate.dna = temp.dna.clone();
				lastFitness = candidate.computeFitness( target.dna );
				
			}
		
		temp.express( graphics );
		candidate.express( graphics );
		
	}
	
}