package net.nicoptere.dna.tests;
import haxe.Timer;
import net.nicoptere.dna.items.NumberItem;
import nme.display.Sprite;
import nme.text.TextField;
import nme.text.TextFieldAutoSize;
import nme.text.TextFormat;
import nme.Vector;

/**
 * @author Nicolas Barradeau 
 */

class NumberDna extends Sprite
{

	private var pool:Vector<NumberItem>;
	
	private var target:NumberItem;
	
	private var tf:TextField;
	private var iteration:Int = 0;
	private var timer:Timer;
	
	public function new() 
	{
		
		super();
		var numberTofind:Float = 1;
		var length:Int = 1;
		
		pool = new Vector<NumberItem>();
		
		for ( i in 0...10 )
		{
			
			var item:NumberItem = new NumberItem( length );
			pool.push( item );
			
		}
		
		target = new NumberItem( length );
		target.dna.setGenes( [ target.randomGene() ] );
		target.computeFitness( target.dna );
		
		
		
		//results
		timer = new Timer(1);
		timer.run = update;
		addChild( tf = new TextField() ); 
		tf.multiline = true;
		tf.autoSize = TextFieldAutoSize.LEFT;
		tf.defaultTextFormat = new TextFormat( "Verdana", 24, 0xFFFFFF );
		
		
	}
	
	private function update() 
	{
		
		tf.text = '' + iteration++ + '';
		for ( item in pool )
		{
			
			item.computeFitness( target.dna );
			
			item.express( tf );
			
			if ( item.fitness == 1 )
			{
				
				tf.text += ' -> perfect';
				
			}
		}
		tf.text += '\n-------------------------';
		target.express( tf );
		
		//selection naturelle
		pool.sort( fitnessSort );
		
		//accouplement
		for ( i in 0...pool.length-1 )
		{
			
			pool[ i ].cross( pool[ i + 1 ].dna );
			
			pool[ i ].mutate();
			
		}
		
	}
	
	private function fitnessSort( a:NumberItem, b:NumberItem ) :Int
	{
		
		return a.fitness < b.fitness ? -1 : 1;
		
	}
	
	
	
}