package net.nicoptere.dna.tests;
import haxe.Timer;
import net.nicoptere.dna.items.WordItem;
import nme.display.Sprite;
import nme.text.TextField;
import nme.text.TextFieldAutoSize;
import nme.text.TextFormat;
import nme.Vector;

/**
 * @author Nicolas Barradeau 
 */

class WordDna extends Sprite
{

	private var pool:Vector<WordItem>;
	
	private var target:WordItem;
	
	private var tf:TextField;
	private var iteration:Int = 0;
	private var timer:Timer;
	
	public function new() 
	{
		
		super();
		var word:String = "abcdefghi";
		var wordlength:Int = word.length;
		
		pool = new Vector<WordItem>();
		
		for ( i in 0...10 )
		{
			
			var item:WordItem = new WordItem( wordlength );
			pool.push( item );
			
		}
		
		target = new WordItem( wordlength );
		target.dna.setGenes( word.split( '' ) );
		target.computeFitness( target.dna );
		
		
		
		//results
		timer = new Timer(1);
		timer.run = update;
		addChild( tf = new TextField() ); 
		tf.multiline = true;
		tf.autoSize = TextFieldAutoSize.LEFT;
		tf.defaultTextFormat = new TextFormat( "Verdana", 24, 0xFFFFFF );
		
		
	}
	
	private function update() 
	{
		
		tf.text = '' + iteration++ + '';
		for ( item in pool )
		{
			
			item.computeFitness( target.dna );
			//tf.text += '\n - ' + item.dna.genes + ' - score: ' + Std.int( item.fitness * 10 ) + '';
			
			item.express( tf );
			
			if ( item.fitness == 1 )
			{
				
				tf.text += ' -> perfect';
				
			}
		}
		tf.text += '\n-------------------------';
		target.express( tf );
		
		
		//selection naturelle
		pool.sort( fitnessSort );
		
		//accouplement
		for ( i in 0...pool.length-1 )
		{
			
			pool[ i ].cross( pool[ i + 1 ].dna );
			
			pool[ i ].mutate();
			
		}
		
	}
	
	private function fitnessSort( a:WordItem, b:WordItem ) :Int
	{
		
		return a.fitness < b.fitness ? -1 : 1;
		
	}
	
	
	
}